package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelGUIModelFrame.java
//    System: VModel
//   Version: 4.0
//  Abstract: VModel is a visual representation system developed to provide 
//            computer support to students learning how to create, articulate,
//            and reason with scientific models.  There is a special emphasis on
//            supporting the reuse and integration of previously modeled
//            material in the course of making new models. 
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModelGUIModelFrame represents the top-level VModel window.  
//            The event driven nature of this system gives this class a great 
//            deal of control over the flow and interpretation of data.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Friday, June 22, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;

// -----------------------------------------------------------------------------
// Class: ProblemPane
// -----------------------------------------------------------------------------
public class ModelFrameMenuItem extends JRadioButtonMenuItem {
	// Properties & Accessors
	// --------------------------------------------------------------------------
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return( gui ); }
	public VModelGUI gui ( VModelGUI g ) { return( gui = g ); }

	protected VModelFrame frame = null;
	public VModelFrame frame ( ) { return( frame ); }
	public VModelFrame frame ( VModelFrame f ) { return( frame = f ); }

	// Methods
	// --------------------------------------------------------------------------
	public void close ( ) {
		gui().menuWindowModelsGroup.remove(this);
		gui().menuWindowModels.remove(this);
	} // method close

	// Constructors
	// --------------------------------------------------------------------------
	public ModelFrameMenuItem (VModelGUI gui, VModelFrame frame, String label, ImageIcon image) {
		super(label, image);
		frame(frame);
		gui(gui);
		addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) { 
				gui().select(frame()); 
			} // method actionPerformed
		}); // Anonymous Class ActionListener
		gui().menuWindowModelsGroup().add(this);
		gui().menuWindowModels().add(this);
	} // constructor
} // innerclass ModelFrameMenuItem

// -----------------------------------------------------------------------------
// End of File: VModelGUIModelFrame.java        (c) 2001 Northwestern University
