package edu.qrg.vmodel.controllers.classic;
import java.applet.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.UIManager.*;
import java.io.*;
import javax.swing.filechooser.*;
import java.awt.image.*;
import edu.qrg.vmodel.controllers.common.*;

public class ModelOverviewDialog extends JDialog implements VModelConstants, ActionListener, KeyListener {
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return( gui ); }
	public VModelGUI gui ( VModelGUI g ) { return( gui = g ); }

	protected Image pageImage = null;
	public Image pageImage ( ) { return( pageImage ); }
	public Image pageImage ( Image i ) { return( pageImage = i ); }

	protected JButton done = null;
	public JButton done ( ) { return( done ); }
	public JButton done ( JButton b ) { return( done = b ); }

	protected QRGpanel canvas = null;
	public QRGpanel canvas ( ) { return( canvas ); }
	public QRGpanel canvas ( QRGpanel c ) { return( canvas = c ); }

// Be ashamed to die until you have won some victory for humanity.  -Horace Mann?
// ... I would be brave for there is much to dare. -Walter?

	// Methods
	// -----------------------------------------------------------------------
	public void show ( ) {
		Dimension size = ((VModelPeerModel) gui().selectedModel().modelElement().peer()).cadPane().modelPane().getSize();
		int width = size.width, height = size.height;
//		pageImage(((VModelPeerElement) gui().selectedModel().modelElement().peer()).createImage(PAGE_WIDTH + 64, PAGE_HEIGHT + 64));
//		pageImage(((JFrame) gui().frame()).createImage(PAGE_WIDTH + 64, PAGE_HEIGHT + 64));
		pageImage(((JFrame) gui().frame()).createImage(width + 64, height + 64));
		setModal(true);
		setTitle("Model Overview: " + gui().selectedModel().label());
		drawPage(pageImage().getGraphics(), 0);
		super.show();
	} // method show

	public void drawPage ( Graphics pg, int pageNumber ) {
		if (gui().selectedModel() != null) {
	  		ImageFilter filter = new RotateFilter(Math.PI / 2);
	  		ImageProducer producer = null;
	  		Image rotatedImage = null;
			Dimension size = ((VModelPeerModel) gui().selectedModel().modelElement().peer()).cadPane().modelPane().getSize();
			int width = size.width, height = size.height;
			Rectangle clipbounds = pg.getClipBounds();
			int r = (pageNumber % (1));
			int f = (int) Math.floor((pageNumber / (1)));
			int h = f * height;
			int w = r * width;
			int totalPages = 1;
			if (clipbounds == null) clipbounds = new Rectangle(0,0,pageImage().getWidth(null),pageImage().getHeight(null));
/*
					pg.setColor(WHITE);
					pg.fillRect(-5,-5,width + 5,height + 32 + 5);
					pg.translate(-w,-h);
					pg.setClip(w,h,width,height);
					((VModelFrame) gui().selectedModel().peer()).print(pg);
*/
	   			pg.setColor(WHITE);
					pg.fillRect(0,0,clipbounds.width + 5,clipbounds.height + 5);
					pg.setColor(BLACK);
					pg.drawString("VModel: " + gui().selectedModel().label(), 10,8);
					pg.drawString("Student: " + gui().preferences().getString("NAME"), 10,20);
					pg.translate(44,44);
					pg.drawLine(0,0,0,32);
					pg.drawLine(0,0,32,0);
					pg.drawLine(width + 4,0,width + 4,32);
					pg.drawLine(width + 4,0,width + 4 - 32,0);
					pg.drawLine(0,height + 4,0,height + 4 - 32);
					pg.drawLine(0,height + 4,32,height + 4);
					pg.drawLine(width + 4,height + 4,width + 4,height + 4 - 32);
					pg.drawLine(width + 4,height + 4,width + 4 - 32,height + 4);
					pg.setColor(WHITE);
					pg.translate(2,2);
					pg.setClip(0,0,width,height);
//					pg.drawImage(rotatedImage,0,0,null);
//					pg.drawImage(img,0,0,null);
					((VModelFrame) gui().selectedModel().peer()).print(pg);

	   } // end if selectedModel
	} // end method drawPage

	public void printPage ( ) {
		if (gui().selectedModel() != null) {
			PrintJob pjob = Toolkit.getDefaultToolkit().getPrintJob((JFrame) gui().frame(), gui().selectedModel().label(), null);
			if (pjob != null) {
	     		ImageFilter filter = new RotateFilter(Math.PI / 2);
	     		ImageProducer producer = null;
	     		Image rotatedImage = null;
	     		Graphics pj = null;				
	     		producer = new FilteredImageSource(pageImage().getSource(), filter);
				rotatedImage = gui().system().createImage(producer);
				pj = pjob.getGraphics();
				pj.drawImage(rotatedImage,0,0,null);
				pjob.end();
			} // end if pjob
	   } // end if selectedModel
	} // method printPage

	// ActionListener methods
	// -----------------------------------------------------------------------
   public void actionPerformed(ActionEvent event) {
      Object source = event.getSource();
      if (source == done()) hide();
   } // method actionPerformed
   
	// KeyListener methods
	// -----------------------------------------------------------------------
	public void keyTyped(KeyEvent e) {
	} // method keyTyped
	
	public void keyPressed(KeyEvent e) {
		int kcode = e.getKeyCode();
		int kmod = e.getModifiers();
		// Window
		if ((kcode == KeyEvent.VK_W) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			hide();
	} // Method keyPressed
	
	public void keyReleased(KeyEvent e) {
	} // Method keyReleased

	public ModelOverviewDialog(VModelGUI gui) {
		gui(gui);
		
		addKeyListener(this);
		JPanel buttons = new JPanel(new GridLayout(1,8));
		buttons.addKeyListener(this);
		done(new JButton("Done"));
		done().addActionListener(this);
		done().setEnabled(true);
		done().addKeyListener(this);
		buttons.add(done());
		getContentPane().add(buttons, BorderLayout.SOUTH);
		getContentPane().addKeyListener(this);
		
		canvas(new QRGpanel() {
			public void paint (Graphics g) {
				double xoff; // x offset of page start in window
				double yoff; // y offset of page start in window
				double scale; // scale factor to fit page in window
				double px = pageImage().getWidth(null);
				double py = pageImage().getHeight(null);
				double sx = canvas().getWidth() - 1;
				double sy = canvas().getHeight() - 1;
				g.setColor(WHITE);
				g.fillRect(0,0,g.getClipBounds().width,g.getClipBounds().height);
				if (px / py < sx / sy) { // center horizontally
					scale = sy / py;
					xoff = 0.5 * (sx - scale * px);
					yoff = 0;
				} else {// center vertically
					scale = sx / px;
					xoff = 0;
					yoff = 0.5 * (sy - scale * py);
				} // end if center
				g.translate((int) xoff, (int) yoff);
				g.drawImage(pageImage(), 0,0, (int) (px * scale), (int) (py * scale), null);
			} // method paint
		}); // canvas
		canvas.addKeyListener(this);
		getContentPane().add(canvas, "Center");
		setSize(640,480);
	} // constructor ModelOverviewDialog
	
} // class ModelOverviewDialog
