package edu.qrg.vmodel.controllers.classic;
import java.applet.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.UIManager.*;
import java.io.*;
import javax.swing.filechooser.*;
import java.awt.image.*;
import edu.qrg.vmodel.controllers.common.*;

public class PrintPreviewDialog extends JDialog implements VModelConstants, ActionListener, KeyListener {
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return( gui ); }
	public VModelGUI gui ( VModelGUI g ) { return( gui = g ); }

	protected int pageNumber = 0;
	public int pageNumber ( ) { return( pageNumber ); }
	public int pageNumber ( int i ) { return( pageNumber = i ); }

	protected int pageMax = 1;
	public int pageMax ( ) { return( pageMax ); }
	public int pageMax ( int i ) { return( pageMax = i ); }

	protected Image pageImage = null;
	public Image pageImage ( ) { return( pageImage ); }
	public Image pageImage ( Image i ) { return( pageImage = i ); }

	protected JButton back = null;
	public JButton back ( ) { return( back ); }
	public JButton back ( JButton b ) { return( back = b ); }

	protected JButton forward = null;
	public JButton forward ( ) { return( forward ); }
	public JButton forward ( JButton b ) { return( forward = b ); }

	protected JLabel info = null;
	public JLabel info ( ) { return( info ); }
	public JLabel info ( JLabel l ) { return( info = l ); }

	protected JButton printPageButton = null;
	public JButton printPageButton ( ) { return( printPageButton ); }
	public JButton printPageButton ( JButton b ) { return( printPageButton = b ); }

	protected JButton printAllButton = null;
	public JButton printAllButton ( ) { return( printAllButton ); }
	public JButton printAllButton ( JButton b ) { return( printAllButton = b ); }

	protected JButton done = null;
	public JButton done ( ) { return( done ); }
	public JButton done ( JButton b ) { return( done = b ); }

	protected QRGpanel canvas = null;
	public QRGpanel canvas ( ) { return( canvas ); }
	public QRGpanel canvas ( QRGpanel c ) { return( canvas = c ); }

	// Methods
	// -----------------------------------------------------------------------
	public void show ( ) {
		Dimension size = ((VModelPeerModel) gui().selectedModel().modelElement().peer()).cadPane().modelPane().getSize();
		int width = size.width, height = size.height;
//		pageImage(((VModelPeerElement) gui().selectedModel().modelElement().peer()).createImage(PAGE_WIDTH + 64, PAGE_HEIGHT + 64));
		pageImage(((JFrame) gui().frame()).createImage(PAGE_WIDTH + 64, PAGE_HEIGHT + 64));
		setModal(true);
		setTitle("Print Preview: " + gui().selectedModel().label());
		pageNumber(0);
		pageMax((width/PAGE_WIDTH) * (height/PAGE_HEIGHT));
		info().setText("Page " + (pageNumber() + 1) + " of " + pageMax());
		back().setEnabled(false);
		forward().setEnabled(true);
		drawPage(pageImage().getGraphics(), pageNumber());
		super.show();
	} // method show

	public void drawPage ( Graphics pg, int pageNumber ) {
		if (gui().selectedModel() != null) {
	  		ImageFilter filter = new RotateFilter(Math.PI / 2);
	  		ImageProducer producer = null;
	  		Image rotatedImage = null;
			Dimension size = ((VModelPeerModel) gui().selectedModel().modelElement().peer()).cadPane().modelPane().getSize();
			int width = size.width, height = size.height;
			Image img = ((VModelPeerModel) gui().selectedModel().modelElement().peer()).createImage(PAGE_WIDTH, PAGE_HEIGHT);
			Graphics ig = img.getGraphics();
			Rectangle clipbounds = pg.getClipBounds();
			int r = (pageNumber % (width / PAGE_WIDTH));
			int f = (int) Math.floor((pageNumber / (width / PAGE_WIDTH)));
			int h = f * PAGE_HEIGHT;
			int w = r * PAGE_WIDTH;
			int totalPages = (width/PAGE_WIDTH) * (height/PAGE_HEIGHT);
			info().setText("Page " + (pageNumber + 1) + " of " + (pageMax() + 1));
			info().validate();
			if (clipbounds == null) clipbounds = new Rectangle(0,0,pageImage().getWidth(null),pageImage().getHeight(null));
			if (pageNumber != pageMax()) {
					pageNumber++;
					ig.setColor(WHITE);
					ig.fillRect(-5,-5,PAGE_WIDTH + 5,PAGE_HEIGHT + 32 + 5);
					ig.translate(-w,-h);
					ig.setClip(w,h,PAGE_WIDTH,PAGE_HEIGHT);
					((VModelFrame) gui().selectedModel().peer()).print(ig);
	   			pg.setColor(WHITE);
					pg.fillRect(0,0,clipbounds.width + 5,clipbounds.height + 5);
					pg.setColor(BLACK);
					pg.drawString("VModel: " + gui().selectedModel().label(), 10,8);
					pg.drawString("Student: " + gui().preferences().getString("NAME"), 10,20);
					pg.drawString("Page: " + pageNumber, 10,32);
					pg.translate(44,44);
					pg.drawLine(0,0,0,32);
					pg.drawLine(0,0,32,0);
					pg.drawLine(PAGE_WIDTH + 4,0,PAGE_WIDTH + 4,32);
					pg.drawLine(PAGE_WIDTH + 4,0,PAGE_WIDTH + 4 - 32,0);
					pg.drawLine(0,PAGE_HEIGHT + 4,0,PAGE_HEIGHT + 4 - 32);
					pg.drawLine(0,PAGE_HEIGHT + 4,32,PAGE_HEIGHT + 4);
					pg.drawLine(PAGE_WIDTH + 4,PAGE_HEIGHT + 4,PAGE_WIDTH + 4,PAGE_HEIGHT + 4 - 32);
					pg.drawLine(PAGE_WIDTH + 4,PAGE_HEIGHT + 4,PAGE_WIDTH + 4 - 32,PAGE_HEIGHT + 4);
					pg.setColor(WHITE);
					pg.translate(2,2);
					pg.setClip(2,2,PAGE_WIDTH,PAGE_HEIGHT);
//					pg.drawImage(rotatedImage,0,0,null);
					pg.drawImage(img,0,0,null);
		   	} else {
					pageNumber++;
					pg.setColor(WHITE);
					pg.fillRect(0,0,clipbounds.width + 5,clipbounds.height + 5);
					pg.setColor(BLACK);
					pg.drawString("VModel: " + gui().selectedModel().label(), 10,8);
					pg.drawString("Student: " + gui().preferences().getString("NAME"), 10,20);
					pg.drawString("Page: " + pageNumber, 10,32);
					pg.drawString("Problem Statement: ", 10,44);
					JTextPane ps = new JTextPane();
					ps.setSize(clipbounds.width-20,clipbounds.height - 56);
					ps.setText(gui().selectedModel().problemStatement());
					pg.translate(10,56);
					ps.print(pg);
				} // end if pageMax
	   } // end if selectedModel
	} // end method drawPage

	public void printPage ( ) {
		if (gui().selectedModel() != null) {
			PrintJob pjob = Toolkit.getDefaultToolkit().getPrintJob((JFrame) gui().frame(), gui().selectedModel().label(), null);
			if (pjob != null) {
	     		ImageFilter filter = new RotateFilter(Math.PI / 2);
	     		ImageProducer producer = null;
	     		Image rotatedImage = null;
	     		Graphics pj = null;				
	     		producer = new FilteredImageSource(pageImage().getSource(), filter);
				rotatedImage = gui().system().createImage(producer);
				pj = pjob.getGraphics();
				pj.drawImage(rotatedImage,0,0,null);
				pjob.end();
			} // end if pjob
	   } // end if selectedModel
	} // method printPage

	// ActionListener methods
	// -----------------------------------------------------------------------
   public void actionPerformed(ActionEvent event) {
      Object source = event.getSource();
      if (source == back()) {
      	pageNumber(pageNumber() - 1);
      	if (pageNumber() < 0) pageNumber(0);
      	if (pageNumber() < pageMax()) forward().setEnabled(true);
      	else forward().setEnabled(false);
      	if (pageNumber() > 0) back().setEnabled(true);
      	else back().setEnabled(false);
      	drawPage(pageImage().getGraphics(), pageNumber());
      	canvas().repaint();
      } else if (source == forward()) {
      	pageNumber(pageNumber() + 1);
      	if (pageNumber() > pageMax()) pageNumber(pageMax());
      	if (pageNumber() < pageMax()) forward().setEnabled(true);
      	else forward().setEnabled(false);
      	if (pageNumber() > 0) back().setEnabled(true);
       	else back().setEnabled(false);
      	drawPage(pageImage().getGraphics(), pageNumber());
       	canvas.repaint();
     } else if (source == printPageButton()) {
      	if (pageImage() == null) 
      		pageImage(canvas().createImage(PAGE_WIDTH + 48, PAGE_HEIGHT));
      	printPage();
      } else if (source == printAllButton()) {
      	gui().printModel();
      } else if (source == done()) {
      	hide();
      } // end if source
   } // method actionPerformed
   
	// KeyListener methods
	// -----------------------------------------------------------------------
	public void keyTyped(KeyEvent e) {
	} // method keyTyped
	
	public void keyPressed(KeyEvent e) {
		int kcode = e.getKeyCode();
		int kmod = e.getModifiers();
		// Window
		if ((kcode == KeyEvent.VK_W) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			hide();

		// model operations
		if ((kcode == KeyEvent.VK_LEFT) || ((QRGutils.detectPlatform() == MACINTOSH) && (kcode == KeyEvent.VK_BACK_SPACE)))
			back().doClick();
		
		if ((kcode == KeyEvent.VK_RIGHT) || ((QRGutils.detectPlatform() == MACINTOSH) && (kcode == KeyEvent.VK_SPACE)))
			forward().doClick();
	} // Method keyPressed
	
	public void keyReleased(KeyEvent e) {
	} // Method keyReleased

	public PrintPreviewDialog(VModelGUI gui) {
		gui(gui);
		
		addKeyListener(this);
		JPanel buttons = new JPanel(new GridLayout(1,8));
		buttons.addKeyListener(this);
		back(new JButton(gui().getImage("back.gif")));
		back().addActionListener(this);
		back().setEnabled(false);
		back().addKeyListener(this);
		buttons.add(back());
		forward(new JButton(gui().getImage("forward.gif")));
		forward().addActionListener(this);
		forward().setEnabled(false);
		forward().addKeyListener(this);
		buttons.add(forward());
		info(new JLabel(" Page 1 of 1"));
		info().addKeyListener(this);
		buttons.add(info());
		buttons.add(new JLabel(" "));
		printPageButton(new JButton("Print Page"));
		printPageButton().addActionListener(this);
		printPageButton().setEnabled(true);
		printPageButton().addKeyListener(this);
		buttons.add(printPageButton());
		printAllButton(new JButton("Print All"));
		printAllButton().addActionListener(this);
		printAllButton().setEnabled(true);
		printAllButton().addKeyListener(this);
		buttons.add(printAllButton());
		buttons.add(new JLabel(" "));
		done(new JButton("Done"));
		done().addActionListener(this);
		done().setEnabled(true);
		done().addKeyListener(this);
		buttons.add(done());
		getContentPane().add(buttons, BorderLayout.SOUTH);
		getContentPane().addKeyListener(this);
		
		canvas(new QRGpanel() {
			public void paint (Graphics g) {
				double xoff; // x offset of page start in window
				double yoff; // y offset of page start in window
				double scale; // scale factor to fit page in window
				double px = pageImage().getWidth(null);
				double py = pageImage().getHeight(null);
				double sx = canvas().getWidth() - 1;
				double sy = canvas().getHeight() - 1;
				g.setColor(WHITE);
				g.fillRect(0,0,g.getClipBounds().width,g.getClipBounds().height);
				if (px / py < sx / sy) { // center horizontally
					scale = sy / py;
					xoff = 0.5 * (sx - scale * px);
					yoff = 0;
				} else {// center vertically
					scale = sx / px;
					xoff = 0;
					yoff = 0.5 * (sy - scale * py);
				} // end if center
				g.translate((int) xoff, (int) yoff);
				g.drawImage(pageImage(), 0,0, (int) (px * scale), (int) (py * scale), null);
			} // method paint
		}); // canvas
		canvas.addKeyListener(this);
		getContentPane().add(canvas, "Center");
		setSize(640,480);
	} // constructor PrintPreviewDialog
	
} // class PrintPreviewDialog
