package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: QRGconstants.java
//    System: QRG Library
//   Version: 0.4
//    Author: Leo C. Ureel II
//   Created: June 21, 2001 12:10:52
//   Purpose: Constants used by QRG. 
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;

// -----------------------------------------------------------------------------
// NOTES: 
// 1. 
// -----------------------------------------------------------------------------

// Interface: QRGconstants
// -----------------------------------------------------------------------------
public interface QRGconstants{
	// Project Info
	public static final String PROJECT = "QRG";
	public static final double VERSION = 1.0;
	public static final int COPYRIGHT = 2002;
	public static final String COPYRIGHTATTRIBUTION = "Northwestern University, Kenneth D. Forbus";

	// Target Platform
	public static final int PLATFORM_UNKNOWN = 0;
	public static final int WINDOWS = 1;
	public static final int UNIX = 2;
	public static final int MACINTOSH = 3;
	public static final String PLATFORM_NAMES[] = { "Unknown", "Windows", "Unix", "Macintosh" };
	
	// Runtime Environment
	public static final boolean TESTRUN = true;
	public static final boolean SUPERUSER = false;
	public static final boolean DEVELOPER = false;

	// Debugging Constants
	public static final String DEFAULT_DEBUG_FILE = "debug.txt";
	public static final int DEFAULT_DEBUG_LIMIT = 25000;
	public static final boolean DEFAULT_DEBUG_FLAG = false;
	
	// Print Constants
	public static final int LANDSCAPE = 16;
	public static final int PORTRAIT = 17;
	public static final int PAGE_HEIGHT = 768; //468; // 552
	public static final int PAGE_WIDTH = 1024; //648; // 720
	
	// Key Modifiers
	public static final int VKM_NONE = 0;
	public static final int VKM_SHIFT = 1;
	public static final int VKM_CONTROL = 2;
	public static final int VKM_COMMAND = 4;
	public static final int VKM_META = 4;
	public static final int VKM_OPTION = 8;
	public static final int VKM_ALT = 8;
	
	// Screen Size Constants
	public static final int SIXbyFOUR = 0;
	public static final int EIGHTbySIX = 1;
	public static final int TENbySEVEN = 2;
	public static final int ELEVENbyEIGHT = 3;
	public static final int TWELVEbyTEN = 4;
	public static final int SIXTEENbyTWELVE = 5;
	
	// Fonts
	public static final Font SERIF_PLAIN_10 = new Font("Serif", Font.PLAIN, 10);
	
	// Colors
	public static final Color RED = Color.red;
	public static final Color DARKRED = new Color(153,0,0);
	public static final Color GREEN = Color.green;
	public static final Color GRASSGREEN = new Color(153,255,153);
	public static final Color DARKGRASSGREEN = new Color(51,205,51);
	public static final Color BRIGHTGREEN = new Color(0,255,0);
	public static final Color MEDIUMGREEN = new Color(0,204,0);
	public static final Color DARKGREEN = new Color(0,102,0);
	public static final Color BLUE = Color.blue;
	public static final Color SKYBLUE = new Color(204,255,255);
	public static final Color DARKSKYBLUE = new Color(0,204,255);
	public static final Color LIGHTBLUE = new Color(51,204,255);
	public static final Color ROYALBLUE = new Color(0,0,255);
	public static final Color PURPLE = new Color(153,0,204);
	public static final Color LIGHTYELLOW = new Color(255,255,204);
	public static final Color YELLOW = Color.yellow;
	public static final Color DARKYELLOW = new Color(255,255,0);
	public static final Color LIGHTPINK = new Color(255,204,204);
	public static final Color PINK = Color.pink;
	public static final Color DARKPINK = new Color(255,153,153);
	public static final Color ORANGE = Color.orange;
	public static final Color MAGENTA = Color.magenta;
	public static final Color CYAN = Color.cyan;
	public static final Color LAVENDER = new Color(255,204,255);
	public static final Color DARKLAVENDER = new Color(255,102,255);
	public static final Color PLUM = new Color(204,153,204);
	public static final Color DARKPLUM = new Color(204,102,153);
	public static final Color YUCKYPUCE = new Color(204,155,102);
	public static final Color DARKYUCKYPUCE = new Color(153,204,51);
	public static final Color LIGHTGRAY = Color.lightGray;
	public static final Color GRAY = Color.gray;
	public static final Color DARKGRAY = Color.darkGray;
	public static final Color LIGHTGREY = new Color(221,221,221);
	public static final Color GREY = new Color(200,200,200);
	public static final Color DARKGREY = new Color(170,170,170);
	public static final Color GOLD = new Color(255,204,102);
	public static final Color DARKGOLD = new Color(255,153,0);
	public static final Color NUTBROWN = new Color(153,102,0);
	public static final Color LIGHTBROWN = new Color(204,153,0);
	public static final Color REDBROWN = new Color(153,51,51);
	public static final Color REDORANGE = new Color(255,102,51);
	public static final Color GREENBROWN = new Color(153,153,51);
	public static final Color WHITE = Color.white;
	public static final Color BLACK = Color.black;
	public static final Color SLATEGREY =new Color(47,79,79);
	
} // Interface QRGconstants

// -----------------------------------------------------------------------------
// End of File: QRGconstants.java               (c) 2001 Northwestern University
