package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/source
// -----------------------------------------------------------------------------
// File name: QRGutils.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: QRGutils is a is a collection of common utilities we use.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import javax.swing.*;
import java.net.*;
import java.lang.*;
import java.text.*;
import java.util.*;
import java.io.*;

// -----------------------------------------------------------------------------
// Notes:
// * Should the file IO routines be included in this class?
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: QRGutils
// Description: QRGutils is a set of common utilities.
// -----------------------------------------------------------------------------
public class QRGutils implements QRGconstants {
	// Properties & Accessors
	// --------------------------------------------------------------------------
	// FilePath Abstraction Properties
	public static String QRGroot = "/QRG/";
	public static String QRGroot ( ) { return( QRGroot ); }
	public static String QRGroot ( String p ) { return( QRGroot = p ); }

	public static String QRGuserpath = "users/student/";
	public static String QRGuserpath ( ) { return( QRGuserpath ); }
	public static String QRGuserpath ( String p ) { return( QRGuserpath = p ); }

	public static String QRGpathseperator = "/";
	public static String QRGpathseperator ( ) { return(QRGpathseperator); }
	public static String QRGpathseperator ( String s ) { 
		return(QRGpathseperator = s); 
	} // writer QRGpathseperator

	// Applet Properties
	protected static Applet applet = null;
	public static Applet applet ( ) { return(applet); }
	public static Applet applet ( Applet a ) { return(applet = a); }

	protected static boolean isApplet = false;
	public static boolean isApplet ( ) { return(isApplet); }
	public static boolean isApplet ( boolean i ) { return(isApplet = i); }
	public static boolean isApplet ( Applet a ) { 
		if (a != null) {
			applet(a);
			isApplet(true);
		} // end if a
		return(isApplet()); 
	} // writer isApplet

	// System/GUI Properties
	public static Toolkit toolkit = null;
	public static Toolkit toolkit ( ) {
		return((toolkit == null) ? toolkit(Toolkit.getDefaultToolkit()) : toolkit);
	} // reader toolkit
	public static Toolkit toolkit ( Toolkit t ) { return(toolkit =t); }

	public static Dimension screenDimensions = null;
	public static Dimension screenDimensions ( ) {
		if(screenDimensions == null) screenDimensions(toolkit().getScreenSize());
		return(screenDimensions);
	} // reader screenDimensions
	public static Dimension screenDimensions ( Dimension s ) {
		return(screenDimensions = s);
	} // writer screenDimensions

	// DateTime Properties
	public static SimpleDateFormat dateformat = null;
	public static SimpleDateFormat dateformat ( ) {
		if (dateformat == null) 
			dateformat(new SimpleDateFormat ("MM.dd.yyyy hh:mm:ss "));
		return(dateformat);
	} // reader dateformatter
	public static SimpleDateFormat dateformat ( SimpleDateFormat d ) {
		return(dateformat = d);
	} // writer dateformatter

	// Debugging Properties
	public static String debugfile = DEFAULT_DEBUG_FILE;
	public static String debugfile ( ) { return(debugfile); }
	public static String debugfile ( String df ) { return(debugfile = df); }
	
	public static int debuglimit = DEFAULT_DEBUG_LIMIT;
	public static int debuglimit ( ) { return(debuglimit); }
	public static int debuglimit ( int l ) { return(debuglimit = l); }

	public static boolean debugflag = DEFAULT_DEBUG_FLAG;
	public static boolean debugflag ( ) { return(debugflag); }
	public static boolean debugflag ( boolean b ) { return(debugflag = b); }

	public static FileWriter debugfw = null;
	public static FileWriter debugfw ( ) { return(debugfw); }
	public static FileWriter debugfw ( FileWriter fw ) { return(debugfw = fw); }

	public static PrintWriter debugpw = null;
	public static PrintWriter debugpw ( ) { return(debugpw); }
	public static PrintWriter debugpw ( PrintWriter pw ) { return(debugpw = pw); }

	// Detect Platform
	// --------------------------------------------------------------------------
	public static int detectPlatform ( ) {
		int result = PLATFORM_UNKNOWN;
		String os = (System.getProperty("os.name")).toUpperCase();
		if (os.startsWith("MAC")) result = MACINTOSH;
		else if (os.startsWith("WIN")) result = WINDOWS;
		else if (os.startsWith("UNIX")) result = UNIX;
		return(result);
	} // method detectPlatform

	// Mouse Methods
	// --------------------------------------------------------------------------
	public static boolean isRightClick(MouseEvent evt) {
		boolean result = (((evt.getModifiers() & InputEvent.BUTTON3_MASK) != 0) ||
							   ((evt.getModifiers() & InputEvent.BUTTON2_MASK) != 0));
		return(result);
	} // method isRightClick

	// --------------------------------------------------------------------------
	// Method: makeQRGpath
	// Description: Set and return the QRG root path.
	// --------------------------------------------------------------------------
	public static String makeQRGpath ( String pathstring ) {
		return(QRGroot + pathstring + QRGpathseperator);
	} // method makeQRGpath

	public static String makeQRGpath ( String[] pathstrings ) {
		String result = QRGroot;
		for( int i = 0; i < pathstrings.length; i++)
			result += pathstrings[i] + QRGpathseperator;
		return(result);
	} // method makeQRGpath

	// --------------------------------------------------------------------------
	// Method: addExtension
	// Description: Add or replace the file extension in a filename.
	// --------------------------------------------------------------------------
	public static String addExtension(String filename, String ext) {
		if (filename.endsWith(ext)) return filename;
		int index = filename.indexOf('.');
		if (index == -1) {
			// no '.' in name
			return filename + "." + ext;
		} else {
			// there is a '.' but the extension is wrong
			return filename + "." + ext;
		} // end if index
	} // method addExtension

	public static String replaceExtension(String filename, String ext) {
		if (filename.endsWith(ext)) return filename;
		int index = filename.indexOf('.');
		if (index == -1) {
			// no '.' in name
			return filename + "." + ext;
		} else {
			// there is a '.' but the extension is wrong
			return filename.substring(0, index) + "." + ext;
		} // end if index
	} // method replaceExtension

	public static String stripExtension(String filename) {
		int index = filename.indexOf('.');
		String result = "";
		if (index == -1) result = filename;
		else result = filename.substring(0, index);
		return(result);
	} // method replaceExtension

	// --------------------------------------------------------------------------
	// Method: space
	// Description: Returns a String of spaces that is length i.
	// --------------------------------------------------------------------------
	public static String space ( int i ) {
		String result = "";
		for( int j = 0; j < i; j++)
			result += " ";
		return(result);
	} // method space

	// --------------------------------------------------------------------------
	// Method: isWhiteSpace
	// Description: returns true if char is whitespace.
	// --------------------------------------------------------------------------
	public static boolean isWhiteSpace ( int c ) {
		return((c == 0x20) || (c == 0xA0) || (c == 0x0D) || 
				 (c == 0x8D) || (c == 0x09) || (c == 0x0A));
	} // method isWhiteSpace

	// --------------------------------------------------------------------------
	// Method: gobbleWhiteSpace
	// Description: gobbles whitespace in a stream.
	// --------------------------------------------------------------------------
	public static int gobbleWhiteSpace ( InputStream inp ) {
		int c = 0;
		try {c = inp.read();}
		catch (Exception e) {c = -1;}
		while((c != -1) && isWhiteSpace(c)) {
			try {c = inp.read();}
			catch (Exception e) {c = -1;}
		} // end while
		return(c);
	} // method gobbleWhitepSpace

	// --------------------------------------------------------------------------
	// Method: replaceStrings
	// Description: Replaces all occurrances of specified substrings in a String.
	// --------------------------------------------------------------------------
	public static String replaceSubstring (String string, String oldS, String newS ) {
		String workspace = string;
		int pos = -1;
		int l = 0;
		pos = -1;
		l = oldS.length();
		try {pos = workspace.indexOf(oldS);}
		catch(Exception e) { }
		while(pos != -1) {
			workspace = workspace.substring(0,pos) + newS +
							workspace.substring(pos + l);
			pos = -1;
			try {pos = workspace.indexOf(oldS);}
			catch(Exception e) { }
		} // end while
		return(workspace);
	} // method replaceSubstrings

	public static String replaceSubstrings (String string, String [] oldS, 
		String [] newS ) {
		String workspace = string;
		for(int i = 0; i < oldS.length; i++)
			workspace = replaceSubstring( workspace, oldS[i], newS[i] );
		return(workspace);
	} // method replaceSubstrings

	// Replace characters in a string.
	// --------------------------------------------------------------------------
	public static String replaceSpaces ( String string ) {
		return(replaceSubstring(string, " ", "-"));
	} // method replaceSpaces

	public static String replaceSpaces ( String string, String replacement) {
		return(replaceSubstring(string, " ", replacement));
	} // method replaceSpaces

	public static String decodeEscapeChars ( String thing ) {
		String[] oldS = {"\\r", "\\n", "&nbsp;", "&quot;", "&amp;"};
		String[] newS = {"\r", "\n", " ", "\"", "&"};
		return(replaceSubstrings(thing, oldS, newS));
	} // method decodeEscapeChars

	public static String replaceEscapeChars ( String thing ) {  // deprecated
		return(decodeEscapeChars(thing));
	} // method replaceEscapeChars

	public static String encodeEscapeChars ( String thing ) {
		String[] newS = {"\\r", "\\n", "&nbsp;", "&quot;", "&amp;"};
		String[] oldS = {"\r", "\n", " ", "\"", "&"};
		return(replaceSubstrings(thing, oldS, newS));
	} // method encodeEscapeChars

	// --------------------------------------------------------------------------
	// Method: stringify
	// Description: Generates a String representation for an object.
	// --------------------------------------------------------------------------
	public static String stringify ( String tag, Object thing, 
		int indent, boolean r) {
		String result = "";
		result += space(indent) + tag + " = " + thing;
		if (r) result += "\n";
		return(result);
	} // method stringify

	public static String stringify ( Object thing, int indent, boolean r) {
		String result = "";
		result += space(indent) + thing.getClass().getName() + " = " + thing;
		if (r) result += "\n";
		return(result);
	} // method stringify

	// --------------------------------------------------------------------------
	// Method: calcScreenSize
	// Description: Returns an int indicating the size of the screen.
	// --------------------------------------------------------------------------
	public static int calcScreenSize ( ) {
		int screensize = SIXbyFOUR;
		if ((screenDimensions().width >= 1600) && (screenDimensions().height >= 1200))
			screensize = SIXTEENbyTWELVE;
		else if ((screenDimensions().width >= 1280) && (screenDimensions().height >= 1024))
			screensize = TWELVEbyTEN;
		else if ((screenDimensions().width >= 1152) && (screenDimensions().height >= 882))
			screensize = ELEVENbyEIGHT;
		else if ((screenDimensions().width >= 1152) && (screenDimensions().height >= 864))
			screensize = ELEVENbyEIGHT;
		else if ((screenDimensions().width >= 1024) && (screenDimensions().height >= 768))
			screensize = TENbySEVEN;
		else if ((screenDimensions().width >= 800) && (screenDimensions().height >= 600))
			screensize = EIGHTbySIX;
		else if ((screenDimensions().width >= 640) && (screenDimensions().height >= 480))
			screensize = SIXbyFOUR;
		else screensize = SIXbyFOUR;
		return(screensize);
	} // method calcScreenSize

	// --------------------------------------------------------------------------
	// Method: center
	// Description: Centers a region.
	// --------------------------------------------------------------------------
	public static Point center (Dimension dimension) {
		Point result = null;
		if (dimension != null) {
			calcScreenSize();
			if (dimension.height > screenDimensions().height)
				dimension.height = screenDimensions().height;
			if (dimension.width > screenDimensions().width)
				dimension.width = screenDimensions().width;
			result = new Point((screenDimensions().width - dimension.width) / 2, 
									 (screenDimensions().height - dimension.height) / 2);
		} // end if dimension
		return(result);
	} // method center

	public static Point center (Dimension outside, Dimension inside) {
		Point result = null;
		Dimension box = new Dimension(inside);
		if ((outside != null) && (inside != null)) {
			if (box.height > outside.height) box.height = outside.height;
			if (box.width > outside.width) box.width = outside.width;
			result = new Point((outside.width - box.width) / 2, 
									 (outside.height - box.height) / 2);
		} // end if outside && inside
		return(result);
	} // method center

	public static Point center (Dimension outside, int width, int height) {
		Point result = null;
		Dimension box = new Dimension(width, height);
		if (outside != null) {
			if (box.height > outside.height) box.height = outside.height;
			if (box.width > outside.width) box.width = outside.width;
			result = new Point((outside.width - box.width) / 2, 
									 (outside.height - box.height) / 2);
		} // end if outside
		return(result);
	} // method center

	// --------------------------------------------------------------------------
	// Method: matchColor
	// Description: Given the string name of a color, returns the color and v-v.
	// --------------------------------------------------------------------------
	public static Color matchColor ( String value ) {
		Color result = Color.black;
		if (value != null) {
			value = value.trim();
			if (value==null || value.equals("")) result = Color.black;
			else {
				try {
					int foo = Integer.parseInt(value);
					result = new Color(foo);
				} catch (NumberFormatException e) {
					if (value.equalsIgnoreCase("RED"))                 result = RED;
					else if (value.equalsIgnoreCase("DARKRED"))        result = DARKRED;
					else if (value.equalsIgnoreCase("GREEN"))          result = GREEN;
					else if (value.equalsIgnoreCase("BRIGHTGREEN"))    result = BRIGHTGREEN;
					else if (value.equalsIgnoreCase("MEDIUMGREEN"))    result = MEDIUMGREEN;
					else if (value.equalsIgnoreCase("DARKGREEN"))      result = DARKGREEN;
					else if (value.equalsIgnoreCase("GRASSGREEN"))     result = GRASSGREEN;
					else if (value.equalsIgnoreCase("DARKGRASSGREEN")) result = DARKGRASSGREEN;
					else if (value.equalsIgnoreCase("LIGHTBLUE"))      result = LIGHTBLUE;
					else if (value.equalsIgnoreCase("BLUE"))           result = BLUE;
					else if (value.equalsIgnoreCase("SKYBLUE"))        result = SKYBLUE;
					else if (value.equalsIgnoreCase("DARKSKYBLUE"))    result = DARKSKYBLUE;
					else if (value.equalsIgnoreCase("ROYALBLUE"))      result = ROYALBLUE;
					else if (value.equalsIgnoreCase("PURPLE"))         result = PURPLE;
					else if (value.equalsIgnoreCase("LIGHTYELLOW"))    result = LIGHTYELLOW;
					else if (value.equalsIgnoreCase("YELLOW"))         result = YELLOW;
					else if (value.equalsIgnoreCase("DARKYELLOW"))     result = DARKYELLOW;
					else if (value.equalsIgnoreCase("LIGHTPINK"))      result = LIGHTPINK;
					else if (value.equalsIgnoreCase("PINK"))           result = PINK;
					else if (value.equalsIgnoreCase("DARKPINK"))       result = DARKPINK;
					else if (value.equalsIgnoreCase("ORANGE"))         result = ORANGE;
					else if (value.equalsIgnoreCase("MAGENTA"))        result = MAGENTA;
					else if (value.equalsIgnoreCase("CYAN"))           result = CYAN;
					else if (value.equalsIgnoreCase("LAVENDER"))       result = LAVENDER;
					else if (value.equalsIgnoreCase("DARKLAVENDER"))   result = DARKLAVENDER;
					else if (value.equalsIgnoreCase("PLUM"))           result = PLUM;
					else if (value.equalsIgnoreCase("DARKPLUM"))       result = DARKPLUM;
					else if (value.equalsIgnoreCase("YUCKYPUCE"))      result = YUCKYPUCE;
					else if (value.equalsIgnoreCase("DARKYUCKYPUCE"))  result = DARKYUCKYPUCE;
					else if (value.equalsIgnoreCase("LIGHTGRAY"))      result = LIGHTGRAY;
					else if (value.equalsIgnoreCase("GRAY"))           result = GRAY;
					else if (value.equalsIgnoreCase("DARKGRAY"))       result = DARKGRAY;
					else if (value.equalsIgnoreCase("LIGHTGREY"))      result = LIGHTGREY;
					else if (value.equalsIgnoreCase("GREY"))           result = GREY;
					else if (value.equalsIgnoreCase("DARKGREY"))       result = DARKGREY;
					else if (value.equalsIgnoreCase("WHITE"))          result = WHITE;
					else if (value.equalsIgnoreCase("GOLD"))           result = GOLD;
					else if (value.equalsIgnoreCase("DARKGOLD"))       result = DARKGOLD;
					else if (value.equalsIgnoreCase("NUTBROWN"))       result = NUTBROWN;
					else if (value.equalsIgnoreCase("LIGHTBROWN"))     result = LIGHTBROWN;
					else if (value.equalsIgnoreCase("REDBROWN"))       result = REDBROWN;
					else if (value.equalsIgnoreCase("REDORANGE"))      result = REDORANGE;
					else if (value.equalsIgnoreCase("GREENBROWN"))     result = GREENBROWN;
					else result = BLACK;
				} // end try/catch
			} // end if else
		} // if value
		return result;
	} // method matchColor
	
	// --------------------------------------------------------------------------
	// Method: beep
	// Description: tweeks the fweeper
	// --------------------------------------------------------------------------
	public static void beep ( ) { Toolkit.getDefaultToolkit().beep(); } 
	
	// --------------------------------------------------------------------------
	// Method: getImage, getImageIcon
	// Description: Loads images.
	// --------------------------------------------------------------------------
	public static Image getImage ( URL location ) {
		return(Toolkit.getDefaultToolkit().getImage(location));
	} // method getImage	

	public static Image getImage ( String filename ) {
		Image result = null;
		URL url = null;
		if ((filename != null) && (filename.length() > 0)) {
			if (isApplet()) {
				try { 
					url = new URL(filename);
					result = getImage(url);
				} catch(Exception e) { }
			} else result = Toolkit.getDefaultToolkit().getImage(filename);
		} // end if filename
		return(result);
	} // method getImage	

	public static ImageIcon getImageIcon ( URL location ) {
		return(new ImageIcon(location));
	} // method getImageIcon	

	public static ImageIcon getImageIcon ( String filename ) {
		ImageIcon result = null;
		URL url = null;
		if (isApplet()) {
			try { 
				url = new URL(filename);
				result = getImageIcon(url);
			} catch(Exception e) { }
		} else result = new ImageIcon(filename);
		return(result);
	} // method getImageIcon

	// --------------------------------------------------------------------------
	// Method: debug
	// Description: Debugging Utilities.
	// --------------------------------------------------------------------------
	public static boolean debug ( ) { return(debugflag); }

	public static boolean debug ( boolean flag, String filename, int limit ) {
		debuglimit(limit);
		return(debug(flag, filename));
	} // method debug

	public static boolean debug ( boolean flag, String filename ) {
		if (debugflag() && flag) debug(false);
		debugfile(filename);
		return(debug(flag));
	} // method debug

	public static boolean debug ( boolean flag ) {
		if (flag != debugflag()) {
			if (debugflag() && !flag) debug("Stop Debugging", "flag=" + flag + " old=" + debugflag + " --------------------------------");
			debugflag(flag);
			if (debugflag()) {
				if ((!isApplet()) && (debugfw() == null) && (debugpw() == null)) {
					try {
						boolean appendflag = false;
						File foo = new File(debugfile());
						if (foo.exists() && (foo.length() < debuglimit())) appendflag=true;
						debugfw(new FileWriter(debugfile(), appendflag));
						debugpw(new PrintWriter(debugfw()));
						debug("Start Debugging", "--------------------------------");
					} catch ( Exception e ) {
						System.out.println("Debug Error: \n" + e);
						e.printStackTrace();
						debugflag(false);
					} // catch
				} // end if
			} else {
				try {
					if (!isApplet()) {
						debugpw().close();
						debugfw().close();
						debugpw(null);
						debugfw(null);
					} // end if !isApplet
				} catch ( Exception e ) {
				System.out.println("debug Error: \n" + e);
				e.printStackTrace();
				debugflag(false);
				} // catch
			} // end if debugflag else
		} // end if flag != debugflag
		return(debugflag);
	} // method debug

	public static boolean debug( String id, Object info) {
		Date currentTime = null;
		String datetime = "";
		if (debugflag()) {
			try {
				if (debugpw() == null) debug(true);
				currentTime = new Date();
				datetime = dateformat().format(currentTime);
				if (TESTRUN) System.out.println(datetime + id + " " + info);
				if (!isApplet()) {
					debugpw().println(datetime + id + " " + info);
					debugpw().flush();
				} // end if !isApplet
			} catch ( Exception e ) {
				System.out.println("DEBUGGER Error: \n" + e);
				e.printStackTrace();
				debug(false);
			} // catch
		} // end if
		return(debugflag());
	} // method debug

	public static void warn ( String id, Object info) {
		if (!debugflag()) debug(true);
		debug(id, info);
		JOptionPane.showMessageDialog(null,  
												"WARNING " + id + ":" + info, 
												"WARNING", JOptionPane.ERROR_MESSAGE);
	} // method error

	public static void error ( String id, Object info) {
		if (!debugflag()) debug(true);
		debug(id, info);
		JOptionPane.showMessageDialog(null,  
												"ERROR " + id + ":" + info, 
												"ERROR", JOptionPane.ERROR_MESSAGE);
	} // method error

	public static void fatalError ( String id, Object info) {
		if (!debugflag()) debug(true);
		debug(id, info);
		debug(false);
		JOptionPane.showMessageDialog(null,  
												"FATAL ERROR " + id + ":" + info, 
												"FATAL ERROR", JOptionPane.ERROR_MESSAGE);
		System.exit(-1);
	} // method fatalError

	// Constructors
	// --------------------------------------------------------------------------
	public QRGutils( ) {
		QRGroot = "";
		QRGpathseperator = "/";
		calcScreenSize();
	} // default constructor QRGutils

	public QRGutils( String path ) {
		this();
		QRGroot = path;
	} // constructor QRGutils

	public QRGutils( String path, String seperator ) {
		this(path);
		QRGpathseperator = seperator;
	} // constructor QRGutils

} // class QRGutils

// -----------------------------------------------------------------------------
// End of File: QRGutils.java                   (c) 2001 Northwestern University