package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelConstants.java
//    System: VModel
//   Version: 0.4
//    Author: Leo C. Ureel II
//   Created: June 21, 2001 12:10:52
//   Purpose: Constants used throughout VModel. 
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;

// -----------------------------------------------------------------------------
// NOTES: 
// 1. 
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Interface: VModelConstants
// Description: Constants used throughout the VModel executable class. Every
//              class should implement this to gain access to these properties.  
// Properties:
// -----------------------------------------------------------------------------
public interface VModelConstants extends QRGconstants{
	// Project Info 
	public static final String PROJECT = "VModel";
	public static final double VERSION = 0.54;

	// Modeling	
	public static final boolean ENFORCE_MODELING_GRAMMAR = false;

	// Events	
	public static final String ADD_OBJECT = "addObject";
	public static final String ADD_GROUP = "addGroup";
	public static final String ADD_ATTRIBUTE = "addAttribute";
	public static final String ADD_RELATIONSHIP = "addRelationship";
	public static final String ADD_MODEL = "addModel";

	public static final String REMOVE_OBJECT = "removeObject";
	public static final String REMOVE_GROUP = "removeGroup";
	public static final String REMOVE_ATTRIBUTE = "removeAttribute";
	public static final String REMOVE_RELATIONSHIP = "removeRelationship";
	public static final String REMOVE_MODEL = "removeModel";

	public static final String NEW_MODEL = "newModel";
	public static final String SAVE_MODEL = "saveModel";
	public static final String OPEN_MODEL = "openModel";
	public static final String MAKE_GROUP = "makeGroup";
	public static final String ADD_TO_GROUP = "addToGroup";
	public static final String AUTO_ADD_TO_GROUP = "autoAddToGroup";
	public static final String AUTOGROUP = "autoGroup";
	public static final String REMOVE_FROM_GROUP = "removeFromGroup";

	public static final String VARIABLIZE = "variablize";
	public static final String BIND = "bind";
	public static final String UNBIND = "unbind";

	public static final String CONNECT = "connect";
	public static final String CONNECT_INPUT = "connectInput";
	public static final String CONNECT_OUTPUT = "connectOutput";
	public static final String DISCONNECT = "disconnect";
	public static final String DISCONNECT_INPUT = "disconnectInput";
	public static final String DISCONNECT_OUTPUT = "disconnectOutput";

	public static final String ADD_TO_LIBRARY = "addToLibrary";

	public static final String UPDATE_PROBLEM_STATEMENT = "updateProblemStatement";
	public static final String UPDATE_DESCRIPTION = "updateDescription";
	public static final String UPDATE_NOTES = "updateNotes";
	public static final String UPDATE_LABEL = "updateLabel";

	public static final String ADD_TO_ONTOLOGY = "addToOntology";
	public static final String REMOVE_FROM_ONTOLOGY = "removeFromOntology";

	// Files
	public static final String SEPARATOR = System.getProperty("file.separator");
	public static final String VMODELROOT = "./";

	public static final String VMODEL_SUFFIX = "vmf";
	public static final String ONT_SUFFIX = "ont";
	public static final String INI_SUFFIX = "ini";
	public static final String JPEG_SUFFIX = "jpg";
	public static final String TIFF_SUFFIX = "tif";
	public static final String GIF_SUFFIX = "gif";
	public static final String HTML_SUFFIX = "html";
	public static final String CML_SUFFIX = "cml";
	
	public static final String IMAGE_JPEG = "JPEG";
	public static final String IMAGE_TIFF = "TIFF";
	
	public static final String DATFILE = "vmodel.dat";
	public static final String INIFILE = "vmodel.ini";
	public static final String ONTFILE = "vmodel.ont";
	public static final String CLASSFILE = "vmodel.class";
	public static final String JARFILE = "vmodel.jar";
	public static final String BATFILE = "vmodel.bat";

	public static final String USERPATH = "users/";
	public static final String MODELDIR = "models";
	public static final String MODELSPATH = "models/";
	public static final String IMAGEPATH = "resources2/icons/";
	public static final String ONTOLOGYPATH = "resources2/ontology/";
	public static final String HELPPATH = "resources2/help/";
	
	public static String userdir = "users";
	public static String vmodelpath = "models/";
	public static String modelpath = "models/";

	// Modes
	public static final int NULL_MODE = 0;
	public static final int PROBLEM_MODE = 100;
	public static final int BUILD_MODE = 101;
	public static final int ANALYZE_MODE = 102;
	public static final int JUSTIFY_MODE = 103;
	
	public static final String MODES[] = {"PROBLEM", "BUILD", "ANALYZE", "JUSTIFY"};
	
	// Views
	public static final int DESCRIBE = 0;
	public static final int SITUATION = 0;
	public static final int EXPLAIN = 1;
	public static final int CAUSAL = 1;
	public static final int JUSTIFY = 2;
	public static final int EVIDENCE = 2;
	
	// Colors
	public static final Color SPLASH = new Color(174, 191, 199);
	public static final Color BACKGROUND_COLOR = new Color(-8084279);
	
	// Component Display Modes
	public static final int UNKNOWN_MODE = -1;
	public static final int RELATIONSHIP_MODE = 0;
	public static final int OBJECT_MODE = 1;
	public static final int BOX_MODE = 2;
	public static final int IMAGE_MODE = 3;
	public static final int GROUP_MODE = 4;
	public static final int MODEL_MODE = 5;
	public static final int ATTRIBUTE_MODE = 6;
	
	// XML
	public static final String URI_PREFIX = "file://";
	public static final String XML_HEADING = "<?xml version = \"1.0\" encoding =\"UTF-8\" standalone = \"no\"?>"+ '\r';
	public static final String MODEL_DOCTYPE = "<!DOCTYPE Model SYSTEM \"vmodel.dtd\">"+'\r';
	public static final String PREFERENCES_DOCTYPE = "<!DOCTYPE Preferences SYSTEM \"vmodel.dtd\">"+'\r';
	public static final String ONTOLOGY_DOCTYPE = "<!DOCTYPE Ontology SYSTEM \"vmodel.dtd\">"+'\r';
	
	// Misc
	public static final int VIEWALL = -1;
	public static final int BLOCKINCREMENT = 1;
	public static final int BACKWARD = -1;
	public static final int FORWARD = 1;
	
} // Interface VModelConstants

// -----------------------------------------------------------------------------
// End of File: VModelConstants.java            (c) 2001 Northwestern University
