package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelEvent.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: Event system for notifying listeners about model events.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.util.*;
import javax.swing.*;
import java.lang.*;
import java.text.*;
import java.util.*;
import java.io.*;
import java.awt.*;

// -----------------------------------------------------------------------------
// Notes:
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelEvent 
// -----------------------------------------------------------------------------
public class VModelEvent extends VModelElement implements VModelConstants {
	// Innerclasses
	// --------------------------------------------------------------------------
	public interface VModelEventListener {
		public boolean event ( VModelEvent e );
	} // end innerclass VModelEventListener

	// Properties & Accessors
	// --------------------------------------------------------------------------
	protected static Vector listeners = null;
	public static Vector listeners ( ) { 
		if (listeners == null) listeners(new Vector());
		return(listeners); 
	} // reader listeners
	public static Vector listeners ( Vector l ) { return(listeners = l); }

	protected String eventID = null;
	public String eventID ( ) { return(eventID); }
	public String eventID ( String s ) { return(eventID = s); }

	protected Object origin = null;
	public Object origin ( ) { return(origin); }
	public Object origin ( Object o ) { return(origin = o); }

	protected String description = "";
	public String description ( ) { return(description); }
	public String description ( String d ) { return(description = d); }

	protected Object argument1 = null;
	public Object argument1 ( ) { return(argument1); }
	public Object argument1 ( Object a1 ) { return(argument1 = a1); }

	protected Object argument2 = null;
	public Object argument2 ( ) { return(argument2); }
	public Object argument2 ( Object a2 ) { return(argument2 = a2); }

	protected Object argument3 = null;
	public Object argument3 ( ) { return(argument3); }
	public Object argument3 ( Object a3 ) { return(argument3 = a3); }

	// Methods
	// --------------------------------------------------------------------------
	public static void addListener(VModelEventListener listener) {
		listeners().addElement(listener);
	} // method addListener

	public boolean removeListener(VModelEventListener listener) {
		return(listeners().removeElement(listener));
	} // method removeListener

	public static boolean signal(VModelEvent event) {
		boolean result = true;
		VModelEventListener listener = null;
		for(int i = 0; i < listeners().size(); i++) {
			listener = (VModelEvent.VModelEventListener) listeners().elementAt(i);
			result &= listener.event(event);
			if (result == false) break;
		} // for i
		return(result);
	} // method signal

	// Constructors
	// --------------------------------------------------------------------------
	public VModelEvent (String eventID, Object origin, String description) {
		super("EVENT");
		eventID(eventID);
		origin(origin);
		description(description);
	} // constructor VModelEvent
	
	public VModelEvent (String eventID, Object origin, String description, Object argument1) {
		this(eventID, origin, description);
		argument1(argument1);
	} // constructor VModelEvent
	
	public VModelEvent (String eventID, Object origin, String description,
							  Object argument1, Object argument2) {
		this(eventID, origin, description, argument1);
		argument2(argument2);
	} // constructor VModelEvent
	
	public VModelEvent (String eventID, Object origin, String description,
							  Object argument1, Object argument2, Object argument3) {
		this(eventID, origin, description, argument1, argument2);
		argument3(argument3);
	} // constructor VModelEvent
	
} // class VModelEvent

// -----------------------------------------------------------------------------
// End of File: VModelEvent.java                (c) 2001 Northwestern University
