package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelGUIModelFrame.java
//    System: VModel
//   Version: 4.0
//  Abstract: VModel is a visual representation system developed to provide 
//            computer support to students learning how to create, articulate,
//            and reason with scientific models.  There is a special emphasis on
//            supporting the reuse and integration of previously modeled
//            material in the course of making new models. 
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModelGUIModelFrame represents the top-level VModel window.  
//            The event driven nature of this system gives this class a great 
//            deal of control over the flow and interpretation of data.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Friday, June 22, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;

public class VModelExternalModelFrame extends JFrame implements VModelConstants, VModelFrame, WindowListener, DocumentListener {
	// Properties & Accessors
	// -------------------------------------------------------------------------
	// VModelFrame Properties & Accessors
	protected VModel system = null;
	public VModel system ( ) { return( system ); }
	public VModel system ( VModel s ) { return( system = s ); }
	
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return( gui ); }
	public VModelGUI gui ( VModelGUI g ) { return( gui = g ); }
	
	protected VModelModel peer = null;
	public VModelModel peer ( ) { return( peer ); }
	public VModelModel peer ( VModelModel p ) { return( peer = p ); }
	
	protected JRadioButtonMenuItem menuitem = null;
	public JRadioButtonMenuItem menuitem ( ) { return( menuitem ); }
	public JRadioButtonMenuItem menuitem ( JRadioButtonMenuItem m ) { return( menuitem = m ); }
	
	protected Object selectedOntology = null;
	public Object selectedOntology ( ) { return( selectedOntology ); }
	public Object selectedOntology ( Object o ) { return( selectedOntology = o ); }
	
	protected VModelPeerModel modelPeer = null;
	public VModelPeerModel modelPeer ( ) { return( modelPeer ); }
	public VModelPeerModel modelPeer ( VModelPeerModel m ) { return( modelPeer = m ); }
	
	protected Vector selectedElements = null;
	public Vector selectedElements ( ) { 
		if (selectedElements == null) selectedElements(new Vector());
		return(selectedElements); 
	} // reader selectedElements
	public Vector selectedElements ( Vector v ) { return(selectedElements = v); }
	
	// Methods
	// --------------------------------------------------------------------------
	
	public void repaint( ) { super.repaint(); }

	public boolean isIcon ( ) { return( false ); }
	public void setIcon ( boolean s ) throws PropertyVetoException { }
	
	public void select ( boolean b ) {
		menuitem().setSelected(b);
		if (b) show();
	} // method select

	public int close ( ) {
		int result = -1;
//		if (modelpane().close(modelpane().close() == 0) == 0) {
//			((modelFrameMenuItem)menuitem).close();
//			gui().closeModel(this);
			dispose();
			result = 0;
//		} // end if close
		return(result);
	} // method close
	
	public int getX ( ) { return( getLocation().x ); }
	public int getY ( ) { return( getLocation().y ); }
	public Dimension getSize ( ) { return( super.getSize() ); }
	
	public void reshape ( int x, int y, int w, int h ) {
		super.reshape(x, y, w, h);
    	invalidate();
    	validate();
	} // method reshape
/*
    public int saveAs ( ) {
		return(save( false ));
    } // method saveAs

    public int save ( ) {
    	return(save( peer().getBoolean("SAVEDONCE") ));
    } // method save

	public int save ( boolean savedB4 ) {
		if (!savedB4) { 
			FileDialog filedialog = new FileDialog((JFrame) gui().frame(), "Save VModel File", FileDialog.SAVE);
			String filename = peer().getString("LABEL");
			File file = null;
			String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
			String filepath = dir + filename;
			Image pic = null;
			int result = 0;
			boolean loop = true;
			filedialog.setFilenameFilter(new vmfFileFilter());
			filedialog.setFile(filename);
			filedialog.setDirectory(dir);
			filedialog.setModal(true);
			
			filedialog.show();
			filename = filedialog.getFile();
			if(filename == null) {
				requestFocus();
				return(-1);
			} else {
				filename = QRGutils.addExtension(filename, "vmf");
				dir = filedialog.getDirectory();
				filepath = dir + filename;
				setTitle(filename);
				peer().set("LABEL", filename);
				peer().set("FILEPATH", filepath);
				peer().set("FILE", filename);
				peer().set("PATH", dir);
				return(save(filename));
			} // end if filename
		}// if savedOnce
		return(save(peer().getString("FILE")));
	} // method save
	
	public int save (String filename) {
		boolean tsavedOnce = peer().getBoolean("SAVEDONCE");
		int result = -1;
		peer().set("SAVEDONCE",true);
		//savePrep();
		peer().save(filename);
		dirty(false);
		result = 0;
		return(result);
	} // method save
*/	
	public void setTitle(String title) { super.setTitle(title); }
	
	public JTextArea problemtext = null;
	public JScrollPane scrollproblemtext = null;
	public boolean problemstatementupdateFlag = false;
	public String originalProblemStatement = "";

	public boolean showProblemStatement ( ) {return(scrollproblemtext.isVisible());}
	public boolean showProblemStatement (boolean state) {
		problemtext.setText(peer().problemStatement());
		scrollproblemtext.setVisible(state);	
		peer().set("SHOW-PROBLEM-STATEMENT", state);	
		validate();
		return(state);
	} // method showProblemStatement
	public void hideProblemStatement () {
		scrollproblemtext.setVisible(false);	
		validate();
	} // method hideProblemStatement

	public boolean dirty() { return( peer().dirty() ); }
	public boolean dirty( boolean dirt ) {
		if (dirt) { if (!peer().dirty()) setTitle("*" + peer().modelElement().getString("LABEL")); 
		} else setTitle(peer().modelElement().getString("LABEL")); 
		return( peer.dirty(dirt) ); 
	} // method dirty
	
	public void setVisible ( boolean b ) { super.setVisible(b); }
	public void show ( ) { super.show(); }
	
	public void setMaximum(boolean b) throws PropertyVetoException { }

	public void dispose ( ) { super.dispose(); }
	public void validate ( ) { super.validate(); }

	public void print (Graphics g) {
		VModelElement modelelement = peer().modelElement();
		VModelPeerModel modelpeer = ((VModelPeerModel) (modelelement.peer()));
		VModelPeerElement foo = null;
		VModelCAD cad = modelpeer.cadPane();
		JPanel pane = cad.componentpane;
		JComponent panel = null;
		boolean opaque = false;
		Color color = null;
		int x,y,w,h;
		g.setColor(WHITE);
		g.fillRect(0,0, pane.getSize().width, pane.getSize().height);
		pane.print(g);
		//cad.modelPane().printAll(g);


		for(int i = 0; i < pane.getComponentCount(); i++) {
			foo = (VModelPeerElement) pane.getComponent(i);

			x = foo.getX();
			y = foo.getY();
			w = foo.getSize().width;
			h = foo.getSize().height;
			g.setClip(x, y, w, h);
			pane.print(g);
			g.translate(x,y);
			g.setClip(0, 0, w, h);
			color = foo.getBackground();
			//foo.setBackground(WHITE);	
			opaque = foo.isOpaque();
			//foo.setOpaque(true);
			foo.printAll(g);	
//			foo.printAll(g);	
			//foo.setOpaque(opaque);	
			//foo.setBackground(color);	
			g.translate(-x,-y);
	} // for i
	
	} // method print


	// WindowListener methods
	// -----------------------------------------------------------------------
	public void windowOpened(WindowEvent e) {}
	public void windowClosing(WindowEvent e) {gui().closeModel(peer());}
	public void windowClosed(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowActivated(WindowEvent e) {
 		if ((QRGutils.detectPlatform() == MACINTOSH) && (gui().selectedModel() != ((VModelExternalModelFrame) e.getSource()).peer())) gui().select(this);
	} // method windowActivated
	public void windowDeactivated(WindowEvent e) {}
	
// Constructor: VModelGUIModelFrame
// --------------------------------------------------------------------------
	public VModelExternalModelFrame(VModelGUI gui, VModelModel model, int x, int y, int width, int height) {
		super();
		gui(gui);
		system(gui().system());
		peer(model);
		
		setLocation(x,y);
		setSize(width, height);
		setTitle(peer().modelElement().getString("LABEL"));
		
		menuitem(new ModelFrameMenuItem(gui(), this, getTitle(), gui().getImage(peer().modelElement().getString("GRAPHIC"))));
		
		addKeyListener(gui());
		addWindowListener(this);
		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		
		getContentPane().setLayout(new BorderLayout());
		modelPeer(new VModelPeerModel(gui(), peer(), peer().modelElement()));
		modelPeer().displayMode(MODEL_MODE);
		getContentPane().add(modelPeer(), BorderLayout.CENTER);
		
		//scrollpane = new JScrollPane();
		//getContentPane().add(scrollpane, BorderLayout.CENTER);

		problemtext = new JTextArea(peer().problemStatement());
		problemtext.setLineWrap(true);
		problemtext.setWrapStyleWord(true);
		problemtext.setRows(4);
		problemtext.getDocument().addDocumentListener(this);
		problemtext.setBackground(gui().preferences().getColor("COLOR"));
		scrollproblemtext = new JScrollPane(problemtext, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollproblemtext.setBorder(new TitledBorder(new LineBorder(Color.black, 2), "Problem Statement"));
		scrollproblemtext.setOpaque(true);
		scrollproblemtext.setBackground(gui().preferences().getColor("COLOR"));
		getContentPane().add(scrollproblemtext, BorderLayout.NORTH);

		
		show();
		
//		modelpane.reshaper(modelpane);
	} // constructor

	public void insertUpdate(DocumentEvent e) { textUpdate( ); }
	public void removeUpdate(DocumentEvent e) { textUpdate( ); }
	public void changedUpdate(DocumentEvent e) { textUpdate( ); }

	public void textUpdate( ) { 
		peer().problemStatement(problemtext.getText()); 
		dirty(true);
	} // method textUpdate
	
} // Class VModelGUIModel

// -----------------------------------------------------------------------------
// End of File: VModelGUIModelFrame.java        (c) 2001 Northwestern University
