package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelGUIModelFrame.java
//    System: VModel
//   Version: 4.0
//  Abstract: VModel is a visual representation system developed to provide 
//            computer support to students learning how to create, articulate,
//            and reason with scientific models.  There is a special emphasis on
//            supporting the reuse and integration of previously modeled
//            material in the course of making new models. 
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModelGUIModelFrame represents the top-level VModel window.  
//            The event driven nature of this system gives this class a great 
//            deal of control over the flow and interpretation of data.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Friday, June 22, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;

// -----------------------------------------------------------------------------
// interface: VModelGUIModelFrame
// -----------------------------------------------------------------------------
public interface VModelFrame {
	// Properties & Accessors
	// -------------------------------------------------------------------------
	public VModel system = null;
	public VModel system ( );
	public VModel system ( VModel s );
	
	public VModelModel peer = null;
	public VModelModel peer ( );
	public VModelModel peer ( VModelModel m );
	
	public JRadioButtonMenuItem menuitem = null;
	public JRadioButtonMenuItem menuitem ( );
	public JRadioButtonMenuItem menuitem ( JRadioButtonMenuItem m );
	
	public Object selectedOntology = null;
	public Object selectedOntology ( );
	public Object selectedOntology ( Object o );
    
	public VModelPeerModel modelPeer = null;
	public VModelPeerModel modelPeer ( );
	public VModelPeerModel modelPeer ( VModelPeerModel m );

	public Vector selectedElements = null;
	public Vector selectedElements ( ); 
	public Vector selectedElements ( Vector v );
	
	// Methods
	// --------------------------------------------------------------------------
/*
	public void delete ( ); 
	public void cut ( ); 
	public void copy ( ); 
	public void paste ( ); 
*/	
	public void print (Graphics g);

	public boolean isIcon ( ); 
	public void setIcon ( boolean s ) throws PropertyVetoException;  
	
	public void select ( boolean b );
	public int close ( );
	public void dispose ( );
	
	public int getX ( );
	public int getY ( );
	public Dimension getSize ( );
/*	
	public int save ( );
	public int saveAs ( );
	public int save ( String filename );
*/	
	public void setTitle(String title);
	
	public boolean showProblemStatement ();
	public boolean showProblemStatement (boolean state);
	public void hideProblemStatement ();

	public boolean dirty();
	public boolean dirty( boolean dirt );

	public void setMaximum(boolean b) throws PropertyVetoException;
	public void setVisible(boolean b);
	public void show ( );
	public void validate ( );
	
	public void reshape ( int x, int y, int w, int h );
	public void repaint ( );
} // Interface VModelGUIModelFrame

// -----------------------------------------------------------------------------
// End of File: VModelGUIModelFrame.java        (c) 2001 Northwestern University
