package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelGUIModelFrame.java
//    System: VModel
//   Version: 4.0
//  Abstract: VModel is a visual representation system developed to provide 
//            computer support to students learning how to create, articulate,
//            and reason with scientific models.  There is a special emphasis on
//            supporting the reuse and integration of previously modeled
//            material in the course of making new models. 
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModelGUIModelFrame represents the top-level VModel window.  
//            The event driven nature of this system gives this class a great 
//            deal of control over the flow and interpretation of data.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Friday, June 22, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;

// -----------------------------------------------------------------------------
// Class: VModelGUIiModel
// -----------------------------------------------------------------------------
public class VModelInternalFrame extends JInternalFrame 
		implements VModelConstants, VModelFrame, InternalFrameListener, ComponentListener, DocumentListener {
	// Properties & Accessors
	// -------------------------------------------------------------------------
	// VModelFrame Properties & Accessors
	protected VModel system = null;
	public VModel system ( ) { return( system ); }
	public VModel system ( VModel s ) { return( system = s ); }
	
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return( gui ); }
	public VModelGUI gui ( VModelGUI g ) { return( gui = g ); }
	
	protected VModelModel peer = null;
	public VModelModel peer ( ) { return( peer ); }
	public VModelModel peer ( VModelModel p ) { return( peer = p ); }
	
	protected JRadioButtonMenuItem menuitem = null;
	public JRadioButtonMenuItem menuitem ( ) { return( menuitem ); }
	public JRadioButtonMenuItem menuitem ( JRadioButtonMenuItem m ) { return( menuitem = m ); }
	
	protected Object selectedOntology = null;
	public Object selectedOntology ( ) { return( selectedOntology ); }
	public Object selectedOntology ( Object o ) { return( selectedOntology = o ); }
	
	protected VModelPeerModel modelPeer = null;
	public VModelPeerModel modelPeer ( ) { return( modelPeer ); }
	public VModelPeerModel modelPeer ( VModelPeerModel m ) { return( modelPeer = m ); }
	
	protected Vector selectedElements = null;
	public Vector selectedElements ( ) { 
		if (selectedElements == null) selectedElements(new Vector());
		return(selectedElements); 
	} // reader selectedElements
	public Vector selectedElements ( Vector v ) { return(selectedElements = v); }
	
	// Methods
	// --------------------------------------------------------------------------
	public void repaint( ) { super.repaint(); }

	public void reshape(int x, int y, int w, int h) {
		super.reshape(x,y,w,h);
//		if (modelpane != null) {
//	    	modelpane.reshaper(modelpane);
//	    	modelpane.invalidate();
//	   } // end if modelpane
    	invalidate();
    	validate();
	} // method reshape
	
	// VModelFrame Methods
	// --------------------------------------------------------------------------
	/*
	public void delete ( ) { 
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		for(int i = selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) selectedElements().elementAt(i);
			elm = elmp.peer();
			if (elm != null) {
				elm.savePrep();
				elm.parent().remove(elm);
				elmp.getParent().remove(elmp);
				elm.peer(null);
			} // if elm
		} // for i
		repaint();
	} // cut

	public void cut ( ) { 
		VModelElement clipboard = gui().clipboard(new VModelElement("GROUP"));
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		clipboard.set("LABEL", "CLIPBOARD");
		for(int i = selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) selectedElements().elementAt(i);
			elm = elmp.peer();
			if (elm != null) {
				elm.savePrep();
				clipboard.add((VModelElement) elm.clone());
				elm.parent().remove(elm);
				elmp.getParent().remove(elmp);
				elm.peer(null);
			} // if elm
		} // for i
		peer().groupInit(clipboard);
		repaint();
	} // cut
	
	public void copy ( ) { 
		VModelElement clipboard = gui().clipboard(new VModelElement("GROUP"));
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		clipboard.set("LABEL", "CLIPBOARD");
		for(int i = selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) selectedElements().elementAt(i);
			elm = elmp.peer();
			if (elm != null) {
				elm.savePrep();
				clipboard.add((VModelElement) elm.clone());
			} // if elm
		} // for i
		peer().groupInit(clipboard);
	} // copy 
	public void paste ( ) { 
	QRGutils.debug("VModelInternalFrame", "paste");
		VModelElement clipboard = gui().clipboard();
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		Vector addedElements = new Vector();
		clipboard.set("LABEL", "CLIPBOARD");
		for(int i = clipboard.elements().size() - 1; i >=0; i--) {
			elm = (VModelElement) clipboard.elements().elementAt(i);
			if (elm != null) {
				elm.savePrep();

					int x = elm.getInt("XOFFSET")+ 20;
					int y = elm.getInt("YOFFSET")+ 20;
					int oldx, oldy, dx, dy, x2, y2;
					VModelElement newElement = (VModelElement) elm.clone();
					oldx = newElement.getInt("XOFFSET");
					oldy = newElement.getInt("YOFFSET");
					dx = x - oldx;
					dy = y - oldy;
					newElement.set("XOFFSET", x);
					newElement.set("YOFFSET", y);
					if (newElement.tag().equalsIgnoreCase("MODEL")) newElement.tag("GROUP");
					peer().modelElement().add(newElement);
					VModelPeerElement grumble = ((VModelPeerModel) peer().modelElement().peer()).cadPane().makePeer(newElement);
					if (grumble != null) {
						addedElements.addElement(grumble);
						//if (!newElement.getBoolean("EXTENDED")) add(grumble); //, mumble.getInt("ID") - 1);
						((VModelPeerElement) peer().modelElement().peer()).cadPane().componentpane.add(grumble); //, mumble.getInt("ID") - 1);
						//if (newElement.getBoolean("HAS-EXTENDED-ELEMENTS")) {
							VModelElement mumbleFrotz = null;
							for(int j = 0; j < newElement.elements().size(); j++) {
								mumbleFrotz = (VModelElement) newElement.elements().elementAt(j);
								x2 = mumbleFrotz.getInt("XOFFSET") + dx;
								y2 = mumbleFrotz.getInt("YOFFSET") + dy;
								mumbleFrotz.set("DX", x2 - x);
								mumbleFrotz.set("DY", y2 - y);
									mumbleFrotz.set("XOFFSET", x2);
									mumbleFrotz.set("YOFFSET", y2);
								if (mumbleFrotz.getBoolean("EXTENDED")) {
									mumbleFrotz.set("XOFFSET", x2);
									mumbleFrotz.set("YOFFSET", y2);
									VModelPeerElement grumbleFrotz = ((VModelPeerElement) peer().modelElement().peer()).cadPane().makePeer(mumbleFrotz);
									if (grumbleFrotz != null) {
										((VModelPeerElement) peer().modelElement().peer()).cadPane().componentpane.add((VModelPeerElement) grumbleFrotz);
										addedElements.addElement(grumbleFrotz);
									}
								} // end if extended
							} // for j
						//} // end if has-extended
					} // end if grumble
					
//		peer().groupInit(peer().modelElement());			

		//peer().sift(peer().modelElement());
		//peer().reconnect();
		//peer().rebind();

		Vector r = new Vector(); // relationships
		Vector v = new Vector(); // variables
		Vector a = new Vector(); // all elements
		peer().sift(peer().modelElement());
		for(int j = addedElements.size() - 1; j >=0; j--) {
			elmp = (VModelPeerElement) addedElements.elementAt(j);
			peer().sift(elmp.peer(), r, v, a);
		}
		peer().reconnect(peer().modelElement(), r, v, a);
		peer().rebind(peer().modelElement(), r, v, a);

					
					validate();
					repaint();

			} // if elm
		} // for i
		peer().savePrep();
		
		((VModelPeerElement) peer().modelElement().peer()).deselectAll();
		for(int j = addedElements.size() - 1; j >=0; j--) {
			elmp = (VModelPeerElement) addedElements.elementAt(j);
			elmp.selected(true);
			elmp.peer().savePrep();
		} // for i
		
		copy();
	} // paste 
*/
	public void setMaximum(boolean b) throws PropertyVetoException {
		super.setMaximum(b);
//    	modelpane.reshaper(modelpane);
//    	modelpane.invalidate();
    	invalidate();
    	validate();
	} // method setMaximum

	public void setVisible ( boolean b ) { super.setVisible(b); }
	public void show ( ) { super.show(); }

	public boolean isIcon ( ) { return( false ); }
	public void setIcon ( boolean s ) throws PropertyVetoException { }
	
	public void select ( boolean b ) {
		QRGutils.debug("VModelInternalFrame", "select b=" + b);
		menuitem().setSelected(b);
		if (b) {
			show();
		} else {
			((JDesktopPane) getParent()).getDesktopManager().deactivateFrame(this);
		} // if b
	} // method select

	public int close ( ) {
		int result = -1;
//		if (modelpane().close(modelpane().close() == 0) == 0) {
//			((modelFrameMenuItem)menuitem).close();
//			gui().closeModel(this);
			dispose();
			result = 0;
//		} // end if close
		return(result);
	} // method close
	
	public void dispose ( ) { super.dispose(); }

	public int getX ( ) { return( super.getX() ); }
	public int getY ( ) { return( super.getY() ); }
	public Dimension getSize ( ) { return( super.getSize() ); }
	
	public void setTitle (String title) {
		super.setTitle(title);
		reshape(getX(),getY(),getSize().width,getSize().height);
	} // method setTitle
	
	public void validate ( ) { super.validate(); }

	public JTextArea problemtext = null;
	public JScrollPane scrollproblemtext = null;
	public boolean problemstatementupdateFlag = false;
	public String originalProblemStatement = "";

	public boolean showProblemStatement ( ) {return(scrollproblemtext.isVisible());}
	public boolean showProblemStatement (boolean state) {
		problemtext.setText(peer().problemStatement());
		scrollproblemtext.setVisible(state);
		peer().set("SHOW-PROBLEM-STATEMENT", state);	
		validate();
		return(state);
	} // method showProblemStatement
	public void hideProblemStatement () {
		scrollproblemtext.setVisible(false);	
		validate();
	} // method hideProblemStatement
	
	public boolean dirty() { return( peer().dirty() ); }
	public boolean dirty( boolean dirt ) {
		if (dirt) { if (!peer().dirty()) setTitle("*" + peer().modelElement().getString("LABEL")); 
		} else setTitle(peer().modelElement().getString("LABEL")); 
		return( peer.dirty(dirt) ); 
	} // method dirty
	
    public void savePrep ( ) { /*
		model.set("XOFFSET",""+frame.getX());
		model.set("YOFFSET",""+frame.getY());
		model.set("WIDTH",""+frame.getSize().width);
		model.set("HEIGHT",""+frame.getSize().height);
		//model.set("MODELWIDTH",""+componentpane.getSize().width);
		//model.set("MODELHEIGHT",""+componentpane.getSize().height);
		mode(mode());
//		for(int i = 0; i < componentpane.getComponentCount(); i++)
//		    ((VModelGUIEntity)componentpane.getComponent(i)).savePrep();
		model.savePrep();
		*/
    } // method savePrep

/*
    public int saveAs ( ) {
		return(save( false ));
    } // method saveAs

    public int save ( ) {
    	return(save( peer().getBoolean("SAVEDONCE") ));
    } // method save

	public int save ( boolean savedB4 ) {
		if (!savedB4) { 
			FileDialog filedialog = new FileDialog((JFrame) gui().frame(), "Save VModel File", FileDialog.SAVE);
			String filename = peer().getString("LABEL");
			File file = null;
			String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
			String filepath = dir + filename;
			Image pic = null;
			int result = 0;
			boolean loop = true;
			filedialog.setFilenameFilter(new vmfFileFilter());
			filedialog.setFile(filename);
			filedialog.setDirectory(dir);
			filedialog.setModal(true);
			
			filedialog.show();
			filename = filedialog.getFile();
			if(filename == null) {
				requestFocus();
				return(-1);
			} else {
				filename = QRGutils.addExtension(filename, "vmf");
				dir = filedialog.getDirectory();
				filepath = dir + filename;
				setTitle(filename);
				peer().set("LABEL", filename);
				peer().set("FILEPATH", filepath);
				peer().set("FILE", filename);
				peer().set("PATH", dir);
				return(save(filename));
			} // end if filename
		}// if savedOnce
		return(save(peer().getString("FILE")));
	} // method save
	
	public int save (String filename) {
		boolean tsavedOnce = peer().getBoolean("SAVEDONCE");
		int result = -1;
		peer().set("SAVEDONCE",true);
		//savePrep();
		peer().save(filename);
		dirty(false);
		result = 0;
		return(result);
	} // method save
*/
	
	public void print (Graphics g) {
		VModelElement modelelement = peer().modelElement();
		VModelPeerModel modelpeer = ((VModelPeerModel) (modelelement.peer()));
		VModelPeerElement foo = null;
		VModelCAD cad = modelpeer.cadPane();
		JPanel pane = cad.componentpane;
		JComponent panel = null;
		boolean opaque = false;
		Color color = null;
		int x,y,w,h;
		g.setColor(WHITE);
		g.fillRect(0,0, pane.getSize().width, pane.getSize().height);
		pane.print(g);
		//cad.modelPane().printAll(g);


		for(int i = 0; i < pane.getComponentCount(); i++) {
			foo = (VModelPeerElement) pane.getComponent(i);

			x = foo.getX();
			y = foo.getY();
			w = foo.getSize().width;
			h = foo.getSize().height;
			g.setClip(x, y, w, h);
			pane.print(g);
			g.translate(x,y);
			g.setClip(0, 0, w, h);
			color = foo.getBackground();
			//foo.setBackground(WHITE);	
			opaque = foo.isOpaque();
			//foo.setOpaque(true);
			foo.printAll(g);	
//			foo.printAll(g);	
			//foo.setOpaque(opaque);	
			//foo.setBackground(color);	
			g.translate(-x,-y);
	} // for i
	
	} // method print

	public void doDefaultCloseAction() {
		//QRGutils.debug("VModelInternalFrame", "doDefaultCloseAction");
		if (QRGutils.detectPlatform() == MACINTOSH) {
			switch(getDefaultCloseOperation()) {
				case HIDE_ON_CLOSE:
					try {
					setClosed(true);
					} catch (PropertyVetoException pve) {}
					break;
				case DISPOSE_ON_CLOSE:
					try {
					setClosed(true);
					dispose();  // only executes if close wasn't vetoed.
					} catch (PropertyVetoException pve) {}
					break;
				case DO_NOTHING_ON_CLOSE:
					default: 
					break;
			}
		} else {
			fireInternalFrameEvent(InternalFrameEvent.INTERNAL_FRAME_CLOSING);
			switch(getDefaultCloseOperation()) {
				case DO_NOTHING_ON_CLOSE:
					break;
				case HIDE_ON_CLOSE:
					setVisible(false);
					if (isSelected())
						try {
							setSelected(false);
						} catch (PropertyVetoException pve) {}

					/* should this activate the next frame? that's really
					desktopmanager's policy... */
					break;
				case DISPOSE_ON_CLOSE:
					try {
						fireVetoableChange(IS_CLOSED_PROPERTY, Boolean.FALSE,
						Boolean.TRUE);
						isClosed = true;
						firePropertyChange(IS_CLOSED_PROPERTY, Boolean.FALSE,
						Boolean.TRUE);
						dispose();
					} catch (PropertyVetoException pve) {}
					break;
				default: 
					break;
			}
		}
	}

	public void setClosed(boolean b) throws PropertyVetoException {
		//QRGutils.debug("VModelInternalFrame", "setClosed");
		if (//(QRGutils.detectPlatform() == MACINTOSH) &&
			 peer().dirty() &&
			 (JOptionPane.YES_OPTION != JOptionPane.showConfirmDialog(null, "The model, " + peer().getString("LABEL") + ", has not been saved.\n Do you want to close it anyway?", "Alert! Model Not Saved.", JOptionPane.YES_NO_OPTION))) 
			throw(new PropertyVetoException("sorry", new PropertyChangeEvent(this, "sorry", this, this)));
		else super.setClosed(b);
	} // method setClosed

	// InternalFrameListener
	// --------------------------------------------------------------------------
	public void internalFrameOpened(InternalFrameEvent e) {
//		QRGutils.debug("VModelInternalFrame", "internalFrameOpened");
	} // method internalFrameOpened
	public void internalFrameClosing(InternalFrameEvent e) {
		//QRGutils.debug("VModelInternalFrame", "internalFrameClosing");
			if (QRGutils.detectPlatform() == WINDOWS) {
				if (gui().closeModel(peer()) == 0) gui().closeModelAux(peer());
			} else gui().closeModelAux(peer());
//		QRGutils.debug("VModelInternalFrame", "internalFrameClosing result=" + result);
//		QRGutils.debug("VModelInternalFrame", "internalFrameClosing closeOperation=" + ((JInternalFrame) e.getSource()).getDefaultCloseOperation());
//		QRGutils.debug("VModelInternalFrame", "internalFrameClosing closeOperation=" + getDefaultCloseOperation());
//		if (result != 0) ((JInternalFrame) e.getSource()).setDefaultCloseOperation(123);
//		if (result != 0) setDefaultCloseOperation(123);
//		if (result != 0) throw(new PropertyVetoException("sorry", (PropertyChangeEvent) e));
//		QRGutils.debug("VModelInternalFrame", "internalFrameClosing2 closeOperation=" + ((JInternalFrame) e.getSource()).getDefaultCloseOperation());
//		QRGutils.debug("VModelInternalFrame", "internalFrameClosing2 closeOperation=" + getDefaultCloseOperation());
	} // method internalFrameClosing
	public void internalFrameClosed(InternalFrameEvent e) {
//		QRGutils.debug("VModelInternalFrame", "internalFrameClosed");
	} // method internalFrameClosed
	public void internalFrameIconified(InternalFrameEvent e) {
//		QRGutils.debug("VModelInternalFrame", "internalFrameIconified");
	} // method internalFrameIconified
	public void internalFrameDeiconified(InternalFrameEvent e) {
// 		QRGutils.debug("VModelInternalFrame", "internalFrameDeiconified"); 
//		modelpane.reshaper(modelpane);
	} // method internalFrameDeiconified
	public void internalFrameActivated(InternalFrameEvent e) {
//		QRGutils.debug("VModelInternalFrame", "internalFrameActivated isSelected=" + isSelected());
 		if (gui().selectedModel() != ((VModelInternalFrame) e.getSource()).peer()) gui().select(this);
//    	modelpane.reshaper(modelpane);
	} // method internalFrameActivated
	public void internalFrameDeactivated(InternalFrameEvent e) {
//		QRGutils.debug("VModelInternalFrame", "internalFrameDeactivated");
	} // method internalFrameDeactivated
		
	// ComponentListener Methods
	// -----------------------------------------------------------------------------
	public void componentHidden(ComponentEvent e) {
//		QRGutils.debug("VModelInternalFrame", "componentHidden");
	} // method componentHidden
	public void componentMoved(ComponentEvent e) {
// 		QRGutils.debug("VModelInternalFrame", "componentMoved"); 
//    	modelpane.reshaper(modelpane);
	} // method componentMoved
	public void componentResized(ComponentEvent e) {
// 		QRGutils.debug("VModelInternalFrame", "componentResized"); 
//		gui.select(this);
//    	modelpane.reshaper(modelpane);
	} // method componentResized
	public void componentShown(ComponentEvent e) {
//		QRGutils.debug("VModelInternalFrame", "componentShown");
	} // method componentShown

/*	
	// WindowListener methods
	// -----------------------------------------------------------------------
	public void windowOpened(WindowEvent e) {}
	public void windowClosing(WindowEvent e) {gui().closeModel(peer());}
	public void windowClosed(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowActivated(WindowEvent e) {
 		if ((QRGutils.detectPlatform() == MACINTOSH) && (gui().selectedModel() != ((VModelExternalModelFrame) e.getSource()).peer())) gui().select(this);
	} // method windowActivated
	public void windowDeactivated(WindowEvent e) {}
*/
	
	// Constructor: VModelGUIiModel
	// --------------------------------------------------------------------------
	public VModelInternalFrame(VModelGUI gui, VModelModel model, int x, int y, int width, int height) {
		super("", true, true, true, true);
		ImageIcon image = null;
		VModelElement modelElement = null;
		
		gui(gui);
		system(gui().system());
		peer(model);
		
		if (peer() == null) peer(new VModelModel(system()));
		modelElement = peer().modelElement();
		image = gui().getImage(modelElement.getString("IMAGE"));
		if (image == null) {
			image = gui().getImage("vmodel2.gif");
			modelElement.set("IMAGE", "vmodel2.gif");
		} // end if image
		
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setLocation(x,y);
		setSize(width, height);
		setFrameIcon(gui().getImage("vmodel.gif"));
		setTitle(peer().modelElement().getString("LABEL"));
		setClosable(true);
		
	   menuitem(new ModelFrameMenuItem(gui, this, getTitle(), image));

		addInternalFrameListener(this);
		addKeyListener(gui());
		addComponentListener(this);

		modelPeer(new VModelPeerModel(gui(), peer(), peer().modelElement()));
		modelPeer().displayMode(MODEL_MODE);
		getContentPane().add(modelPeer(), BorderLayout.CENTER);

		problemtext = new JTextArea(peer().problemStatement());
		problemtext.setLineWrap(true);
		problemtext.setWrapStyleWord(true);
		problemtext.setRows(4);
		problemtext.getDocument().addDocumentListener(this);
		problemtext.setBackground(gui().preferences().getColor("COLOR"));
		scrollproblemtext = new JScrollPane(problemtext, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scrollproblemtext.setBorder(new TitledBorder(new LineBorder(Color.black, 2), "Problem Statement"));
		scrollproblemtext.setOpaque(true);
		scrollproblemtext.setBackground(gui().preferences().getColor("COLOR"));
		getContentPane().add(scrollproblemtext, BorderLayout.NORTH);

		
		show();
    	
//    	modelpane.reshaper(modelpane);
	} // constructor
	

	public void insertUpdate(DocumentEvent e) { textUpdate( ); }
	public void removeUpdate(DocumentEvent e) { textUpdate( ); }
	public void changedUpdate(DocumentEvent e) { textUpdate( ); }

	public void textUpdate( ) { 
		peer().problemStatement(problemtext.getText()); 
		dirty(true);
	} // method textUpdate
	
} // Class VModelGUIiModel

// -----------------------------------------------------------------------------
// End of File: VModelGUIModelFrame.java        (c) 2001 Northwestern University
