package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelModel.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: Basic model.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.util.*;
import javax.swing.*;
import java.lang.*;
import java.text.*;
import java.util.*;
import java.io.*;
import java.awt.*;

// -----------------------------------------------------------------------------
// Notes:
// * basic model operations remaining to be implemented:

//		new skin
//		update skin color
//		add to skin (color group)
//		remove from skin (color group)

//    kill model (need to remove from allVModelElement list to allow gc)

//		export model as cml ?
//		export model as cycL ?
//		export model as java ?

// 	check syntax
// 	compare
// 	findPath
// 	anglicize
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelModel 
// -----------------------------------------------------------------------------
public class VModelModel implements VModelConstants, VModelEvent.VModelEventListener {
	// Properties & Accessors
	// --------------------------------------------------------------------------
	protected static Vector models = null;
	public static Vector models ( ) { 
		if (models == null) models(new Vector());
		return(models); 
	} // reader models
	public static Vector models ( Vector m ) { return(models = m); }
	
	protected static VModel system = null;
	public static VModel system ( ) { return(system); }
	public static VModel system ( VModel s ) { return(system = s); }

	protected Vector objects = null;
	public Vector objects ( ) { 
		if (objects == null) objects(new Vector());
		return(objects); 
	} // reader objects
	public Vector objects ( Vector o ) { return(objects = o); }
	
	protected Vector attributes = null;
	public Vector attributes ( ) { 
		if (attributes == null) attributes(new Vector());
		return(attributes); 
	} // reader attributes
	public Vector attributes ( Vector a ) { return(attributes = a); }
	
	protected Vector relationships = null;
	public Vector relationships ( ) { 
		if (relationships == null) relationships(new Vector());
		return(relationships); 
	} // reader objects
	public Vector relationships ( Vector r ) { return(relationships = r); }
	
	protected Vector groups = null;
	public Vector groups ( ) { 
		if (groups == null) groups(new Vector());
		return(groups); 
	} // reader groups
	public Vector groups ( Vector g ) { return(groups = g); }
	
	protected Vector variables = null;
	public Vector variables ( ) { 
		if (variables == null) variables(new Vector());
		return(variables); 
	} // reader variables
	public Vector variables ( Vector v ) { return(variables = v); }
	
	protected Vector allElements = null;
	public Vector allElements ( ) { 
		if (allElements == null) allElements(new Vector());
		return(allElements); 
	} // reader allElements
	public Vector allElements ( Vector e ) { return(allElements = e); }
	
	protected VModelElement modelElement = null;
	public VModelElement modelElement ( ) {
		if (modelElement == null) {
			modelElement( new VModelElement("MODEL") );
			modelElement.set("TYPE", "MODEL"); 
		} // end if modelElement
		return(modelElement); 
	} // reader modelElement
	public VModelElement modelElement ( VModelElement m ) { return(modelElement = m); }

	protected VModelElement modelHistory = null;
	public VModelElement modelHistory ( ) {
		if ((modelHistory == null) && (modelElement() != null)) 
			modelHistory( modelElement().findElement("HISTORY") ); 
		if (modelHistory == null) {
			modelHistory( new VModelElement("HISTORY") ); 
			modelHistory.set("USERID", system().preferences().getString("USERID"));
			modelElement().add(modelHistory());
		} // end if modelHistory
		return(modelHistory); 
	} // reader modelHistory
	public VModelElement modelHistory ( VModelElement h ) { return(modelHistory = h); }

	protected VModelElement historySession = null;
	public VModelElement historySession ( ) {
		if (historySession == null) {
			historySession( new VModelElement("SESSION") );
			modelHistory().add(historySession);
		} // end if historySession 
		return(historySession); 
	} // reader historySession
	public VModelElement historySession ( VModelElement s ) { return(historySession = s); }

	protected boolean logflag = false;
	public boolean logflag ( ) { return(logflag); }
	public boolean logflag ( boolean l ) { return(logflag = l); }
	
 	protected SimpleDateFormat sessionDateFormat = null;
 	public SimpleDateFormat sessionDateFormat ( ) {
 		if (sessionDateFormat == null) sessionDateFormat(new SimpleDateFormat("yyyyMMddhhmmss"));
 		return(sessionDateFormat);
 	} // reader sessionDateFormat
 	public SimpleDateFormat sessionDateFormat ( SimpleDateFormat s ) {
 		return(sessionDateFormat = s);
 	} // writer sessionDateFormat

 	protected SimpleDateFormat dateFormat = null;
 	public SimpleDateFormat dateFormat ( ) {
 		if (dateFormat == null) dateFormat(new SimpleDateFormat("yyyyMMddhhmmss"));
 		return(dateFormat);
 	} // reader dateFormat
 	public SimpleDateFormat dateFormat ( SimpleDateFormat d ) {
 		return(dateFormat = d);
 	} // writer dateFormat
 	
 	protected static int labelCount = 1;
 	public static int labelCount ( ) { return(labelCount); }
 	public static int labelCount ( int l ) { return(labelCount = l); }

	protected boolean dirty = false;
	public boolean dirty ( ) { return(dirty); }
	public boolean dirty ( boolean d ) { return(dirty = d); }

	protected Object peer = null;
	public Object peer ( ) { return(peer); }
	public Object peer ( Object p ) { 
	   return(peer = p); 
	} // writer peer
	
	// Entity Operations
	// -----------------------------------------------------------------------
	// Should makeEntity be logged?
	public VModelElement makeEntity ( VModelElement element ) {
		VModelElement result = null;
		if (element != null) {
			result = (VModelElement) element.clone();
				if ((result != null) && !result.elements().isEmpty()) groupInit(result);
		} // end if element
		return(result); 
	} // method makeEntity

	public VModelElement makeEntity ( String tag, String type ) {
		VModelElement result = null;
		VModelElement element = system().ontology().find(tag, type);
		result = makeEntity(element);
		return(result); 
	} // method makeEntity

	public VModelElement makeEntity ( VModelElement ontology, String tag, String type ) {
		VModelElement result = null;
		VModelElement element = null;
		if (ontology != null) element = system().ontology().find(ontology, tag, type);
		result = makeEntity(element);
		return(result); 
	} // method makeEntity

	public VModelElement makeEntity ( String ontology, String tag, String type ) {
		VModelElement result = null;
		VModelElement element = system().ontology().find(ontology, tag, type);
		result = makeEntity(element);
		return(result); 
	} // method makeEntity

	// Object Operations
	// -----------------------------------------------------------------------
	public VModelElement makeObject ( VModelElement element ) {
		VModelElement result = null;
		if ((element != null) && (element.typep("OBJECT"))) {
			result = makeEntity(element);
		} // end if element
		return(result); 
	} // method makeObject

	public VModelElement makeObject ( String type ) {
		VModelElement result = null;
		result = makeEntity("OBJECT", type);
		return(result); 
	} // method makeObject

	public VModelElement makeObject ( VModelElement ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "OBJECT", type);
		return(result); 
	} // method makeObject
	
	public VModelElement makeObject ( String ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "OBJECT", type);
		return(result); 
	} // method makeObject
	
	// addObject
	public VModelElement addObject (VModelElement object) {
		VModelElement result = null;
		if (object != null) {
		VModelEvent.signal(new VModelEvent(ADD_OBJECT, this, 
										"Add object to model.",
								  		object));
			sift(object);
			if (object.elements().size() > 0) groupInit(object); 
			result = modelElement().add(object);
			if (result != null) dirty(true);
		} // end if object
		return(result);
	} // method addObject

	public VModelElement addObject ( String type ) {
		VModelElement object = makeObject(type);
		return(addObject(object));
	} // method addObject

	public VModelElement addObject ( VModelElement ontology, String type ) {
		VModelElement result = null;
		VModelElement object = makeObject(ontology, type);
		result = addObject(object);
		return(result);
	} // method addObject

	public VModelElement addObject ( String ontology, String type ) {
		VModelElement object = makeObject(ontology, type);
		return(addObject(object));
	} // method addObject

	// removeObject
	public boolean removeObject (VModelElement object) {
		boolean result = false;
		VModelElement mumble = null;
		if (object != null) {
			for(int i = 0; i < object.connections().size(); i++) {
				mumble = (VModelElement) object.connections().elementAt(i);
				if (mumble != null) {
					if (mumble.typep("OBJECT")) {
						// ? is this the right behavior?
						QRGutils.debug("VModelModel","removeObject mumble=" + mumble);
						removeObject(mumble);
					} else if (mumble.typep("RELATIONSHIP")) {
						disconnect(mumble, object);
					} // end if typep
				} // end if mumble
			} // for i
			for(int j = 0; j < object.bindings().size(); j++) {
				mumble = (VModelElement) object.bindings().elementAt(j);
				if (mumble != null) {
					unbind(mumble, object);
				} // end if mumble
			} // for i
			unvariablize(object);
			removeContained(object);
			VModelEvent.signal(new VModelEvent(REMOVE_OBJECT, this, 
										"Remove object from model.",
								  		object));
			objects().removeElement(object);
			allElements().removeElement(object);
			if (object.parent() != null) result = object.parent().remove(object);
			if (result) dirty(true);
		} // end if object
		return(result);
	} // method removeObject
	
	public void removeContained( VModelElement element ) {
		VModelElement mumble = null;
		for(int i = 0; i < element.elements().size(); i++) {
			mumble = (VModelElement) element.elements().elementAt(i);
			if (mumble.tag().equalsIgnoreCase("OBJECT")) removeObject(mumble);
			else if (mumble.tag().equalsIgnoreCase("ATTRIBUTE")) removeAttribute(mumble);
			else if (mumble.tag().equalsIgnoreCase("RELATIONSHIP")) removeRelationship(mumble);
			else if (mumble.tag().equalsIgnoreCase("GROUP")) removeGroup(mumble);
			else if (mumble.tag().equalsIgnoreCase("MODEL")) removeModel(mumble);
		} // for i
	} // method removeContained

	// Attribute Operations
	// -----------------------------------------------------------------------
	public VModelElement makeAttribute ( VModelElement element ) {
		VModelElement result = null;
		if ((element != null) && (element.tag().equalsIgnoreCase("ATTRIBUTE"))) {
			result = makeEntity(element);
		} // end if element
		return(result); 
	} // method makeAttribute

	public VModelElement makeAttribute ( String type ) {
		VModelElement result = null;
		result = makeEntity("ATTRIBUTE", type);
		return(result); 
	} // method makeAttribute

	public VModelElement makeAttribute ( VModelElement ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "ATTRIBUTE", type);
		return(result); 
	} // method makeAttribute
	
	public VModelElement makeAttribute ( String ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "ATTRIBUTE", type);
		return(result); 
	} // method makeAttribute
	
	// addAttribute
	public VModelElement addAttribute (VModelElement attribute) {
		VModelElement result = null;
		if (attribute != null) {
			VModelEvent.signal(new VModelEvent(ADD_ATTRIBUTE, this, 
											"Add attribute to model.",
								  			attribute));
			sift(attribute);
			result = modelElement().add(attribute);
		} // end if attribute
		return(result);
	} // method addAttribute

	public VModelElement addAttribute ( String type ) {
		VModelElement attribute = makeAttribute(type);
		return(addAttribute(attribute));
	} // method addAttribute

	public VModelElement addAttribute ( VModelElement ontology, String type ) {
		VModelElement attribute = makeAttribute(ontology, type);
		return(addAttribute(attribute));
	} // method addAttribute

	public VModelElement addAttribute ( String ontology, String type ) {
		VModelElement attribute = makeAttribute(ontology, type);
		return(addAttribute(attribute));
	} // method addAttribute

	// removeAttribute
	public boolean removeAttribute (VModelElement attribute) {
		boolean result = false;
		VModelElement mumble = null;
		if (attribute != null) {
			for(int i = 0; i < attribute.connections().size(); i++) {
				mumble = (VModelElement) attribute.connections().elementAt(i);
				if (mumble != null) {
					if ((mumble != null) && (mumble.tag().equalsIgnoreCase("ATTRIBUTE"))) {
						// ? is this the right behavior?
						removeAttribute(mumble);
					} else if (mumble.typep("RELATIONSHIP")) {
						/*if (mumble.typep("DESCRIBER")) removeRelationship(mumble); 
						else*/ disconnect(mumble, attribute);
					} // end if typep
				} // end if mumble
			} // for i
			for(int j = 0; j < attribute.bindings().size(); j++) {
				mumble = (VModelElement) attribute.bindings().elementAt(j);
				if (mumble != null) {
					unbind(mumble, attribute);
				} // end if mumble
			} // for i
			unvariablize(attribute); // just in case.
			VModelEvent.signal(new VModelEvent(REMOVE_ATTRIBUTE, this, 
											"Remove attribute from model.",
								  			attribute));
			attributes().removeElement(attribute);
			allElements().removeElement(attribute);
			if (attribute.parent() != null) result = attribute.parent().remove(attribute);
			if (result) dirty(true);
		} // end if attribute
		return(result);
	} // method removeAttribute

	// Variable Operations
	// -----------------------------------------------------------------------
	// variablize
	public VModelElement variablize (VModelElement object) {
		VModelElement result = null;
		if ((object != null) && 
			 (object.typep("OBJECT") || object.tag().equalsIgnoreCase("ATTRIBUTE") ||
			  object.typep("GROUP") || object.typep("MODEL"))) {
			object.set("VARIABLE", "TRUE");
			VModelEvent.signal(new VModelEvent(VARIABLIZE, this, 
											"Variablize an object.",
									  		object));
			variables().addElement(object);
			result = object;
			if (result != null) dirty(true);
		} // end if object
		return(result);
	} // method variablize

	public void unvariablize (VModelElement variable) {
		if ((variable != null) && variable.getBoolean("VARIABLE")) {
			unbind(variable);
			variable.set("VARIABLE", "FALSE");
			variables().removeElement(variable);
			dirty(true);
		} // end if object
	} // method unvariablize

	// bind
	public VModelElement bind (VModelElement variable, VModelElement object) {
		VModelElement result = null;
		if (((variable != null) && variable.getBoolean("VARIABLE")) && (object != null)) {
			object.bindings().addElement(variable);
			object.set("BOUND", "TRUE");
			variable.bindings().addElement(object);
			variable.set("BOUND", "TRUE");
			variable.set("BINDING", object.id());
			VModelEvent.signal(new VModelEvent(BIND, this, 
											"Bind object to a variable.",
									  		variable, object));
			result = object;
			if (result != null) dirty(true);
		} // end if object
		return(result);
	} // method bind

	public VModelElement unbind (VModelElement variable, VModelElement object) {
		VModelElement result = null;
		if (((variable != null) && variable.getBoolean("VARIABLE")) && (object != null)) {
			object.bindings().removeElement(variable);
			object.set("BOUND", "FALSE");
			variable.bindings().removeElement(object);
			if (variable.bindings().size() > 0)
				variable.set("BINDING", ((VModelElement) variable.bindings().elementAt(0)).id());
			else
				variable.set("BINDING", "0");
			variable.set("BOUND", (variable.bindings().size() > 0));
			VModelEvent.signal(new VModelEvent(UNBIND, this, 
											"UnBind object from a variable.",
									  		variable, object));
			result = object;
			if (result != null) dirty(true);
		} // end if object
		return(result);
	} // method unbind

	public VModelElement unbind (VModelElement element) {
		VModelElement result = null;
		if ((element != null) && (element.bindings().size() > 0)) {
			if (element.getBoolean("VARIABLE"))
				result = unbind(element, (VModelElement) element.bindings().elementAt(0));
			else
				result = unbind((VModelElement) element.bindings().elementAt(0), element);
		} // end if object
		return(result);
	} // method unbind

	public VModelElement value (VModelElement variable) {
		VModelElement result = null;
		if ((variable != null) && variable.getBoolean("VARIABLE")) {
			if (variable.getBoolean("BOUND")) {
				result = (VModelElement) variable.bindings().elementAt(0);
			} // end if bound
		} // end if object
		return(result);
	} // method unbind

	
	// Group Operations
	// -----------------------------------------------------------------------
	public VModelElement makeGroup ( ) {
		VModelElement result = new VModelElement("GROUP");
		result.set("LABEL", "???");
		result.set("ALIAS", "Group");
		result.set("TYPE", "GROUP");
		//result.set("DISPLAY", "TRUE");
		result.set("DESCRIPTION", "A group is a collection of entities and relationships.");
		result.set("GRAPHIC", "group.jpg");
		result.set("HELP", "A group is a collection of entities and relationships.");
		result.set("HELP-LINK", "group.htm");
		result.set("CATEGORY", "BASIC-OBJECT");
		result.set("SUPERTYPE", "GROUP");
		result.set("TYPECHAIN", "GROUP");
		result.set("COLOR", "BLACK");
		result.set("MODE", "BUILD ANALYZE JUSTIFY");
		result.set("VIEW", "DESCRIBE");
		result.set("ALLOW-CONNECTIONS", "TRUE");
		result.set("ALLOWED-INPUTS", "RELATOR CONTROLLER");
		result.set("ALLOWED-OUTPUTS", "DESCRIBER RELATOR CONTROLLER");
		//result.set("ANNOTATION", "???");
		return(result); 
	} // method makeGroup

	public VModelElement makeGroup ( VModelElement element ) {
		VModelElement result = null;
		if ((element != null) && (element.typep("GROUP"))) {
			result = makeEntity(element);
		} // end if element
		return(result); 
	} // method makeGroup

	public VModelElement makeGroup ( String type ) {
		VModelElement result = null;
		result = makeEntity("GROUP", type);
		return(result); 
	} // method makeGroup

	public VModelElement makeGroup ( VModelElement ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "GROUP", type);
		return(result); 
	} // method makeGroup
	
	public VModelElement makeGroup ( String ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "GROUP", type);
		return(result); 
	} // method makeGroup
	
	// addGroup
	public VModelElement addGroup (VModelElement group) {
		VModelElement result = null;
		if (group != null) {
			VModelEvent.signal(new VModelEvent(ADD_GROUP, this, 
											"Add a group to model.",
									  		group));
			sift(group);
			groupInit(group);
			result = modelElement().add(group);
			if (result != null) dirty(true);
		} // end if group
		return(result);
	} // method addGroup

	public VModelElement addGroup ( String type ) {
		VModelElement group = makeGroup(type);
		return(addGroup(group));
	} // method addGroup

	public VModelElement addGroup ( VModelElement ontology, String type ) {
		VModelElement result = null;
		VModelElement group = makeGroup(ontology, type);
		result = addGroup(group);
		return(result);
	} // method addGroup

	public VModelElement addGroup ( String ontology, String type ) {
		VModelElement object = makeGroup(ontology, type);
		return(addGroup(object));
	} // method addGroup

	// removeGroup
	public boolean removeGroup (VModelElement group) {
		boolean result = false;
		VModelElement mumble = null;
		if (group != null) {
			// ? is this the right behavior?
			for(int i = 0; i < group.connections().size(); i++) {
				mumble = (VModelElement) group.connections().elementAt(i);
				if ((mumble != null) && (mumble.typep("GROUP"))) {
					removeGroup(mumble);
				} // end if mumble
			} // for i
			for(int j = 0; j < group.bindings().size(); j++) {
				mumble = (VModelElement) group.bindings().elementAt(j);
				if (mumble != null) {
					unbind(mumble, group);
				} // end if mumble
			} // for i
			unvariablize(group);
			removeContained(group);
			VModelEvent.signal(new VModelEvent(REMOVE_GROUP, this, 
											"Remove a group and all its elements from model.",
									  		group));
			groups().removeElement(group);
			allElements().removeElement(group);
			if (group.parent() != null) result = group.parent().remove(group);
			if (result) dirty(true);
		} // end if group
		return(result);
	} // method removeGroup

	public void autoObjectGroup (VModelElement r, VModelElement s, VModelElement d) {
		VModelElement object = null, attribute = null;
		if ((r != null) && (s != null) && (d != null)) {
			if ((r.typep("DESCRIBER")) && (s.typep("OBJECT") || d.typep("OBJECT"))) {
				if (s.typep("OBJECT")) {
					object = s;
					attribute = d;
				} else {
					object = d;
					attribute = s;
				} // end if object else
				if (r.parent() != null) r.parent().remove(r);
				if (attribute.parent() != null) attribute.parent().remove(attribute);
				object.add(attribute);
				object.add(r);
				VModelEvent.signal(new VModelEvent(AUTO_ADD_TO_GROUP, this, 
												"VModel Automatically added an entity to a group.",
									  			object, attribute));
				VModelEvent.signal(new VModelEvent(AUTO_ADD_TO_GROUP, this, 
												"VModel Automatically added an entity to a group.",
									  			object, r));
			} else if ((s.parent() == d.parent()) && (r.parent() != d.parent())) {
				if (r.parent() != null) r.parent().remove(r);
				s.parent().add(r);
				VModelEvent.signal(new VModelEvent(AUTO_ADD_TO_GROUP, this, 
												"VModel Automatically added an entity to a group.",
									  			s.parent(), r));
			} // end if describer
		} // end if r s d
	} // method autoObjectGroup 
	
	public void autoObjectGroup (VModelElement r) {
		if (r != null) autoObjectGroup(r, r.input(), r.output());
	} // method autoObjectGroup 
	
	// called when a relationship is removed
	public void autoObjectUnGroup (VModelElement r, VModelElement s, VModelElement d) {
		VModelElement object = null, attribute = null;
		if ((r != null) && (s != null) && (d != null)) {
			if (r.typep("DESCRIBER")) {
				if ((s.typep("OBJECT") || d.typep("OBJECT")) && 
					 ((s.tag().equalsIgnoreCase("ATTRIBUTE") || d.tag().equalsIgnoreCase("ATTRIBUTE")))) {
					if (s.typep("OBJECT")) {
						object = s;
						attribute = d;
					} else {
						object = d;
						attribute = s;
					} // end if object else
					if (object.parent() != null) {
						object.remove(attribute);
						object.parent().add(attribute);
					} // end if object parent
				} // end if object and attribute
			} // end if describer
		} // end if r s d
	} // method autoObjectGroup 
	
	public void autoObjectUnGroup (VModelElement r) {
		if (r != null) autoObjectUnGroup(r, r.input(), r.output());
	} // method autoObjectGroup 
	
	public VModelElement addToGroup (VModelElement group, VModelElement element) {
		VModelElement result = null;
		if ((group != null) && (element != null)) {
			if (group.typep("GROUP") || group.typep("MODEL") || group.typep("OBJECT")) {
				if (element.parent() != null) element.parent().remove(element);
				if (!allElements().contains(element)) allElements().addElement(element);
				result = group.add(element);
				VModelEvent.signal(new VModelEvent(ADD_TO_GROUP, this, 
												"Add an entity to a group.",
									  			group, element));
			} // end if group
		} // end if group & element
		return(result);
	} // method addToGroup 
	
	public boolean removeFromGroup (VModelElement group, VModelElement element) {
		boolean result = false;
		if ((group != null) && (element != null)) {
			if (group.typep("GROUP")) {
				result = group.remove(element);
				if (group.parent() != null) group.parent().add(element);
				VModelEvent.signal(new VModelEvent(REMOVE_FROM_GROUP, this, 
												"Remove an entity from a group.",
									  			group, element));
			} // end if group
		} // end if group & element
		return(result);
	} // method removeFromGroup 
	
	// relationship Operations
	// -----------------------------------------------------------------------
	public VModelElement makeRelationship ( VModelElement element ) {
		VModelElement result = null;
		if ((element != null) && (element.typep("RELATIONSHIP"))) {
			result = makeEntity(element);
		} // end if element
		return(result); 
	} // method makeRelationship

	public VModelElement makeRelationship ( String type ) {
		VModelElement result = null;
		result = makeEntity("RELATIONSHIP", type);
		return(result); 
	} // method makeRelationship

	public VModelElement makeRelationship ( VModelElement ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "RELATIONSHIP", type);
		return(result); 
	} // method makeRelationship
	
	public VModelElement makeRelationship ( String ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "RELATIONSHIP", type);
		return(result); 
	} // method makeRelationship
	
	// addRelationship
	public VModelElement addRelationship (VModelElement relationship) {
		VModelElement result = null;
		if (relationship != null) {
			VModelEvent.signal(new VModelEvent(ADD_RELATIONSHIP, this, 
											"Add a relationship to model.",
								  			relationship));
			relationships().addElement(relationship);
			allElements().addElement(relationship);
			result = modelElement().add(relationship);
			if (result != null) dirty(true);
		} // end if relationship
		return(result);
	} // method addRelationship

	public VModelElement addRelationship ( String type ) {
		VModelElement relationship = makeRelationship(type);
		return(addRelationship(relationship));
	} // method addrelationship

	public VModelElement addRelationship ( VModelElement ontology, String type ) {
		VModelElement relationship = makeRelationship(ontology, type);
		return(addRelationship(relationship));
	} // method addrelationship

	public VModelElement addRelationship ( String ontology, String type ) {
		VModelElement relationship = makeRelationship(ontology, type);
		return(addRelationship(relationship));
	} // method addrelationship

	// removeRelationship
	public boolean removeRelationship (VModelElement relationship) {
		boolean result = false;
		VModelElement mumble = null;
		if (relationship != null) {
			if (relationship.typep("DESCRIBER")) {
				if ((relationship.input() != null) && (relationship.output() != null)) {
					VModelElement grumble = relationship.output();
					autoObjectUnGroup(relationship);
					disconnect(relationship, grumble);
					//removeAttribute(grumble);
				} // end if
			} // end if
			autoObjectUnGroup(relationship);
			for(int i = 0; i < relationship.connections().size(); i++) {
				mumble = (VModelElement) relationship.connections().elementAt(i);
				if ((mumble != null) && (mumble.tag().equalsIgnoreCase("RELATIONSHIP"))) {
					removeRelationship(mumble);
				} // end if mumble
			} // for i
			disconnectAux(relationship);
			VModelEvent.signal(new VModelEvent(REMOVE_RELATIONSHIP, this, 
											"Remove a relationship from model.",
								  			relationship));
			relationships().removeElement(relationship);
			allElements().removeElement(relationship);
			if (relationship.parent() != null) result = relationship.parent().remove(relationship);
			if (result) dirty(true);
		} // end if relationship
		return(result);
	} // method removeRelationship

	public boolean checkConnectable (VModelElement r) {
		boolean result = true;
		VModelElement s = r.input();
		VModelElement d = r.output();
		if ((s != null) && (d != null)) result = (checkConnectableInput(r,s) && checkConnectableOutput(r,d));
		else if (s != null) result = checkConnectableInput(r,s);
		else if (d != null) result = checkConnectableOutput(r,d);
		return(result);
	} // method checkConnectable

	public boolean checkConnectable (VModelElement r, VModelElement s, VModelElement d) {
		boolean result = false;
		result = (checkConnectableInput(r,s) && checkConnectableOutput(r,d));
		return(result);
	} // method checkConnectable

	public boolean checkConnectableInput (VModelElement r, VModelElement s) {
		boolean result = false;
		
		String category = r.getString("CATEGORY");
		
		result = s.containsString("ALLOWED-OUTPUTS",category);
		if (!r.getBoolean("DIRECTIONAL")) result = result && s.containsString("ALLOWED-INPUTS",category);
		return(result);
	} // method checkConnectable

	public boolean checkConnectableOutput (VModelElement r, VModelElement d) {
		boolean result = false;
		
		String category = r.getString("CATEGORY");
		
		result = d.containsString("ALLOWED-INPUTS",category);
		if (!r.getBoolean("DIRECTIONAL")) result = result && d.containsString("ALLOWED-OUTPUTS",category);
		return(result);
	} // method checkConnectable

	public VModelElement connectInput (VModelElement r, VModelElement s) {
		VModelElement result = null;
		boolean connectable = checkConnectableInput(r, s);
		if (r != null) { //((r != null) && checkConnectableInput(r, s)) {
			if (r.input() != null) { /* Now what? */ }
			if (s != null) {
				s.connections().addElement(r);
				r.input(s);
				r.set("INPUT", s.id());
			} // end if s
			autoObjectGroup(r);
			VModelEvent.signal(new VModelEvent(CONNECT, this, 
											"Connect source entity with a relationship.",
								  			r, s));
			result = r;
		} // end if r
		return(result);
	} // method connect

	public VModelElement connectOutput (VModelElement r, VModelElement d) {
		VModelElement result = null;
		boolean connectable = checkConnectableOutput(r, d);
		if (r != null) { //((r != null) && checkConnectableOutput(r, d)) {
			if (r.output() != null) { /* Now what? */ }
			if (d != null) {
				d.connections().addElement(r);
				r.output(d);
				r.set("OUTPUT", d.id());
			} // end if d
			autoObjectGroup(r);
			VModelEvent.signal(new VModelEvent(CONNECT, this, 
											"Connect destination entity with a relationship.",
								  			r, d));
			result = r;
		} // end if r
		return(result);
	} // method connect

	public VModelElement connect (VModelElement r, VModelElement s, VModelElement d) {
		VModelElement result = null;
		String s$ = null, d$ = null;
		boolean connectable = checkConnectable(r, s, d);
		if (r != null) { //((r != null) && checkConnectable(r, s, d)) {
			if (r.input() != null) { /* Now what? */ }
			if (s != null) {
				s.connections().addElement(r);
				r.input(s);
				r.set("INPUT", s.id());
				s$ = "" + s.id();
			} // end if s
			if (r.output() != null) { /* Now what? */ }
			if (d != null) {
				d.connections().addElement(r);
				r.output(d);
				r.set("OUTPUT", d.id());
				d$ = "" + d.id();
			} // end if d
			autoObjectGroup(r);
			VModelEvent.signal(new VModelEvent(CONNECT, this, 
											"Connect two entities with a relationship.",
								  			r, s, d));
			result = r;
			if (result != null) dirty(true);
		} // end if r
		return(result);
	} // method connect

	public VModelElement disconnectAux (VModelElement r) {
		VModelElement result = null;
		if (r != null) {
			if (r.input() != null) {
				r.input().connections().removeElement(r);
				r.set("INPUT", -1);
				r.input(null);
			} // end if input
			if (r.output() != null) {
				r.output().connections().removeElement(r);
				r.set("OUTPUT", -1);
				r.output(null);
			} // end if output
			result = r;
			if (result != null) dirty(true);
		} // end if r
		return(result);
	} // method disconnect

	public VModelElement disconnect (VModelElement r) {
		VModelElement result = null;
		if (r != null) {
			result = disconnectAux(r);
			if (result != null) 
				VModelEvent.signal(new VModelEvent(DISCONNECT, this, 
												"DisConnect a relationship.",
									  			r));
		} // end if r
		return(result);
	} // method disconnect

	public VModelElement disconnect (VModelElement r, VModelElement e) {
		VModelElement result = null;
		if (r != null) {
			if (r.input() == e) {
				e.connections().removeElement(r);
				r.set("INPUT", -1);
				r.input(null);
				VModelEvent.signal(new VModelEvent(DISCONNECT_INPUT, this, 
												"DisConnect a relationship from its input.",
									  			r, e));
			} else if (r.output() == e) {
				e.connections().removeElement(r);
				r.set("OUTPUT", -1);
				r.output(null);
				VModelEvent.signal(new VModelEvent(DISCONNECT_INPUT, this, 
												"DisConnect a relationship from its input.",
									  			r, e));
			} // end if output
			result = r;
			if (result != null) dirty(true);
		} // end if r
		return(result);
	} // method disconnect

	public VModelElement reverse (VModelElement r) {
		VModelElement result = null;
		VModelElement foo = null;
		if (r != null) {
			foo = r.input();
			r.input(r.output());
			if (r.input() != null) r.set("INPUT", r.input().id());
			r.output(foo);
			if (r.output() != null) r.set("OUTPUT", r.output().id());
			result = r;
			if (result != null) dirty(true);
		} // end if r
		return(result);
	} // method reverse

	// Model Operations
	// -----------------------------------------------------------------------
	public VModelElement makeModel ( VModelElement element ) {
		VModelElement result = null;
		if ((element != null) && (element.typep("MODEL"))) {
			result = makeEntity(element);
		} // end if element
		return(result); 
	} // method makeModel

	public VModelElement makeModel ( String type ) {
		VModelElement result = null;
		result = makeEntity("MODEL", type);
		return(result); 
	} // method makeModel

	public VModelElement makeModel ( VModelElement ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "MODEL", type);
		return(result); 
	} // method makeModel
	
	public VModelElement makeModel ( String ontology, String type ) {
		VModelElement result = null;
		result = makeEntity(ontology, "MODEL", type);
		return(result); 
	} // method makeModel
	
	// addModel
	public VModelElement addModel (VModelElement model) {
		VModelElement result = null;
		VModelElement mumble = null;
		if (model != null) {
			VModelEvent.signal(new VModelEvent(ADD_MODEL, this, 
											"Add a model to model.",
									  		model));
			mumble = model.findElement("HISTORY");
			if (mumble != null) model.remove(mumble);
			sift(model);
			groupInit(model);
			result = modelElement().add(model);
			if (result != null) dirty(true);
		} // end if model
		return(result);
	} // method addModel

	public VModelElement addModel ( String type ) {
		VModelElement model = makeModel(type);
		return(addModel(model));
	} // method addModel

	public VModelElement addModel ( VModelElement ontology, String type ) {
		VModelElement result = null;
		VModelElement model = makeModel(ontology, type);
		result = addModel(model);
		return(result);
	} // method addModel

	public VModelElement addModel ( String ontology, String type ) {
		VModelElement object = makeModel(ontology, type);
		return(addModel(object));
	} // method addModel

	// removeModel
	public boolean removeModel (VModelElement model) {
		boolean result = false;
		VModelElement mumble = null;
		if (model != null) {
			// ? is this the right behavior?
			for(int i = 0; i < model.connections().size(); i++) {
				mumble = (VModelElement) model.connections().elementAt(i);
				if ((mumble != null) && (mumble.typep("MODEL"))) {
					removeModel(mumble);
				} // end if mumble
			} // for i
			for(int j = 0; j < model.bindings().size(); j++) {
				mumble = (VModelElement) model.bindings().elementAt(j);
				if (mumble != null) {
					unbind(mumble, model);
				} // end if mumble
			} // for i
			unvariablize(model);
			removeContained(model);
			VModelEvent.signal(new VModelEvent(REMOVE_MODEL, this, 
											"Remove a model and all its elements from model.",
									  		model));
			models().removeElement(model);
			allElements().removeElement(model);
			if (model.parent() != null) result = model.parent().remove(model);
			if (result) dirty(true);
		} // end if model
		return(result);
	} // method removeModel
	
	public String problemStatement ( ) { return( getString("PROBLEM_STATEMENT")); }
	public String problemStatement ( String s ) {
		if (!s.equalsIgnoreCase(problemStatement())) {
			VModelEvent.signal(new VModelEvent(UPDATE_PROBLEM_STATEMENT, this, 
											"Update model problem statement. " +
											"before: (" + problemStatement() + ") after: (" + s + ")",
								  			modelElement()));
			set("PROBLEM_STATEMENT", s);
			dirty(true);
		} // end if s
		return( s ); 
	} // method problemStatement

	public String notes ( ) { return( getString("NOTES")); }
	public String notes ( String n ) {
		if (!n.equalsIgnoreCase(notes())) {
			VModelEvent.signal(new VModelEvent(UPDATE_NOTES, this, 
											"Update model notes. " +
											"(" +n + ")",
								  			modelElement()));
			set("NOTES", n);
			dirty(true);
		} // end if n
		return( n ); 
	} // method notes
	
	public String label ( ) { return( getString("LABEL")); }
	public String label ( String n ) {
		if (!n.equalsIgnoreCase(label())) {
			VModelEvent.signal(new VModelEvent(UPDATE_LABEL, this, 
											"Update model label. " +
											"before: (" + label() + ") after: (" + n + ")",
								  			modelElement()));
			set("LABEL", n);
			dirty(true);
		} // end if n
		return( n ); 
	} // method label
	
	public String label ( VModelElement e ) { return( e.getString("LABEL")); }
	public String label ( VModelElement e, String n ) {
		if ((e != null) && (!n.equalsIgnoreCase(label()))) {
			VModelEvent.signal(new VModelEvent(UPDATE_LABEL, this, 
											"Update model label. " +
											"before: (" + e.get("LABEL") + ") after: (" + n + ")",
								  			e));
			e.set("LABEL", n);
			dirty(true);
		} // end if n
		return( n ); 
	} // method label
	
	public static VModelModel loadModel (String filename) {
		VModelModel result = load(filename);
		return(result);
	} // method loadModel

	public VModelElement saveModel (VModelModel model, String filename) {
//		model.savePrep();
		model.save(filename);
		VModelElement mumble = system().ontology().find("MODEL-ONTOLOGY-LIBRARY");
		VModelElement grumble = null;
		VModelElement bumble = null;
		if (mumble!=null) {
			for(int i = 0; i < mumble.elements.size(); i++) {
				bumble = (VModelElement) mumble.elements.elementAt(i);
				if (bumble.getString("LABEL").equalsIgnoreCase(model.getString("LABEL"))) return(null);
			} // for i
			grumble = new VModelElement("MODEL");
			grumble.set("TYPE", "MODEL");
			grumble.set("LABEL", model.getString("LABEL"));
			grumble.set("CREATED", model.getString("CREATED"));
			mumble.add(grumble); 
			VModelEvent.signal(new VModelEvent(UPDATE_LABEL, this, 
											"Added model to model library.",
								  			modelElement()));
			if (grumble != null) dirty(false);
		} // end if mumble
		return(grumble);
	} // method saveModel

	public VModelElement addToOntology (VModelElement element) { return(addToLibrary(element)); } // deprecated
	
	public VModelElement addToLibrary (VModelElement element) {
		VModelElement result = null; 
		if ((element != null) && 
			 (element.typep("OBJECT") || element.typep("GROUP") || element.typep("MODEL"))) {
			VModelEvent.signal(new VModelEvent(ADD_TO_LIBRARY, this, 
											"Added entity to model library.",
								  			element));
			result = VModelOntology.addToLibrary(element);
		} // end if element
		return(result);
	} // method addToOntology 
	
	// Component Operations
	// -----------------------------------------------------------------------
	public void add ( VModelElement element ) {
		if (element.tag().equalsIgnoreCase("OBJECT")) addObject(element);
		else if (element.tag().equalsIgnoreCase("ATTRIBUTE")) addAttribute(element);
		else if (element.tag().equalsIgnoreCase("RELATIONSHIP")) addRelationship(element);
		else if (element.tag().equalsIgnoreCase("GROUP")) addGroup(element);
		else if (element.tag().equalsIgnoreCase("MODEL")) addModel(element);
	} // method add

	public void remove ( VModelElement element ) {
		if (element.tag().equalsIgnoreCase("OBJECT")) removeObject(element);
		else if (element.tag().equalsIgnoreCase("ATTRIBUTE")) removeAttribute(element);
		else if (element.tag().equalsIgnoreCase("RELATIONSHIP")) removeRelationship(element);
		else if (element.tag().equalsIgnoreCase("GROUP")) removeGroup(element);
		else if (element.tag().equalsIgnoreCase("MODEL")) removeModel(element);
	} // method add

	public void remove ( String tag, String type ) {
	   VModelElement element = modelElement().findElement(tag, type); // recursive?
	   if (element != null) remove(element);
	} // method remove

	public VModelElement find (int key) {
		VModelElement result = null;
		VModelElement foo = null;
		for(int i = 0; i < allElements().size(); i++) {
			foo = (VModelElement) allElements().elementAt(i);
			if ((foo != null) && (foo.id() == key)) { result = foo; break; } 
		} // for i
		return(result);
	} // method find

	
	// File IO.
	// -----------------------------------------------------------------------
	public void savePrep ( ) {
		set("PROGRAM-NAME", PROJECT);
		set("PROGRAM-VERSION", VERSION);
		savePrepAux(modelElement());
		modelElement().savePrep();
		savePrepAux2(modelHistory());
	} // method savePrep
	
	public void savePrepAux (VModelElement e ) {
			VModelElement target = null;
			for(int i = 0; i < e.elements().size(); i++) {
				target = (VModelElement) e.elements().elementAt(i);
				if (!target.tag().equalsIgnoreCase("HISTORY")) savePrepAux(target);
			} // for i
		if (e.typep("GROUP") || e.typep("OBJECT") || e.tag().equalsIgnoreCase("ATTRIBUTE") || e.typep("RELATIONSHIP")) {
			e.set("ID", e.id());
		} // if typep
	} // method savePrep
	
	public void savePrepAux2 (VModelElement e ) {
			VModelElement target = null;
			e.removeAttribute("TYPECHAIN");
			if (e.tag().equalsIgnoreCase("ACTION")) {
				e.removeAttribute("KEY");
				e.removeAttribute("ID");
			} else {
				for(int i = 0; i < e.elements().size(); i++) {
					target = (VModelElement) e.elements().elementAt(i);
					savePrepAux2(target);
				} // for i
			}
	} // method savePrep
	
	public void sift ( VModelElement element ) {
		if (element != null) {
			if (element.tag().equalsIgnoreCase("ENTITY")) element.tag("OBJECT");  // wise?
			if (element.tag().equalsIgnoreCase("ATTRIBUTE")) element.tag("ATTRIBUTE");
			if (element.tag().equalsIgnoreCase("OBJECT")) objects().addElement(element);
			//else if (element.tag().equalsIgnoreCase("ENTITY")) objects().addElement(element);
			else if (element.tag().equalsIgnoreCase("ATTRIBUTE")) attributes().addElement(element);
			else if (element.tag().equalsIgnoreCase("RELATIONSHIP")) relationships().addElement(element);
			else if (element.tag().equalsIgnoreCase("GROUP")) groups().addElement(element);
			else if (element.tag().equalsIgnoreCase("MODEL")) groups().addElement(element);
			if (element.getBoolean("VARIABLE")) variables().addElement(element);
			allElements().addElement(element);
			for(int i = 0; i < element.elements().size(); i++)
				sift((VModelElement) element.elements().elementAt(i));
		} // end if element
	} // method sift
	
	public void reconnect ( ) {
		int input = -1;
		int output = -1;
		boolean inputFlag = false, outputFlag = false;
		VModelElement mumble = null, grumble = null;
		VModelElement newInput = null, newOutput = null;
		for(int i = 0; i < relationships().size(); i++) {
			mumble = (VModelElement) relationships().elementAt(i);
			if (mumble != null) {
				input = mumble.getInt("INPUT");
				output = mumble.getInt("OUTPUT");
				if (input == 0) input = -1;
				if (output == 0) output = -1;
				for(int j = 0; j < allElements().size(); j++) {
					grumble = (VModelElement) allElements().elementAt(j);
					if (grumble != null) {
						if (grumble.getInt("ID") == input) {
							newInput = grumble;
							inputFlag = true;
						} // end if input
						if (grumble.getInt("ID") == output) {
							newOutput = grumble;
							outputFlag = true;
						} // end if output
					} // end if grumble
					if (inputFlag &&  outputFlag) break;
				} // for j
				inputFlag = outputFlag = false;
				if (newInput == null) { /* Now What? */ }
				else {
					mumble.set("INPUT", newInput.id());
					mumble.input(newInput);
					newInput.connections().addElement(mumble);
				} // end if newInput
				if (newOutput == null) { /* Now What? */ }
				else {
					mumble.set("OUTPUT", newOutput.id());
				   mumble.output(newOutput);
					newOutput.connections().addElement(mumble);
				} // end if newOutput
			} // end if mumble 
		} // for i
	} // method reconnect
	
	public void rebind ( ) {
		int binding = -1;
		boolean bindingFlag = false;
		VModelElement mumble = null, grumble = null;
		VModelElement inBound = null;
		for(int i = 0; i < variables().size(); i++) {
			mumble = (VModelElement) variables().elementAt(i);
			if (mumble != null) {
				binding = mumble.getInt("BINDING");
				mumble.removeAttribute("BINDINGS"); // TEMPORARY KLUDGE! Eventually we should use this attribute to rebind!
				for(int j = 0; j < allElements().size(); j++) {
					grumble = (VModelElement) allElements().elementAt(j);
					if (grumble != null) {
						if (grumble.getInt("ID") == binding) {
							inBound = grumble;
							bindingFlag = true;
						} // end if input
					} // end if grumble
					if (bindingFlag) break;
				} // for j
				bindingFlag = false;
				if (inBound == null) { 
					mumble.removeAttribute("BINDING");
					mumble.set("BOUND", "FALSE");
				} else {
					mumble.set("BINDING", inBound.id());
					mumble.set("BOUND", "TRUE");
					mumble.bindings().addElement(inBound);
					inBound.set("BOUND", "TRUE");
					inBound.bindings().addElement(mumble);
				} // end if newInput
				mumble.set("BOUND", (mumble.bindings().size() > 0));
			} // end if mumble 
		} // for i
	} // method rebind
	
	public void groupInit ( VModelElement group ) { 
		Vector r = new Vector(); // relationships
		Vector v = new Vector(); // variables
		Vector a = new Vector(); // all elements
		sift(group);
		sift(group, r, v, a);
		reconnect(group, r, v, a);
		rebind(group, r, v, a);
	} // groupInit
	
	public void sift ( VModelElement element, Vector r, Vector v, Vector a ) {
		if (element != null) {
			if (element.tag().equalsIgnoreCase("RELATIONSHIP")) r.addElement(element);
			if (element.getBoolean("VARIABLE")) v.addElement(element);
			a.addElement(element);
			for(int i = 0; i < element.elements().size(); i++)
				sift((VModelElement) element.elements().elementAt(i), r, v, a);
		} // end if element
	} // method sift
	
	public void reconnect ( VModelElement element, Vector r, Vector v, Vector a ) {
		int input = -1;
		int output = -1;
		boolean inputFlag = false, outputFlag = false;
		VModelElement mumble = null, grumble = null;
		VModelElement newInput = null, newOutput = null;
		for(int i = 0; i < r.size(); i++) {
			mumble = (VModelElement) r.elementAt(i);
			if (mumble != null) {
				input = mumble.getInt("INPUT");
				output = mumble.getInt("OUTPUT");
				if (input == 0) input = -1;
				if (output == 0) output = -1;
				for(int j = 0; j < a.size(); j++) {
					grumble = (VModelElement) a.elementAt(j);
					if (grumble != null) {
						if (grumble.getInt("ID") == input) {
							newInput = grumble;
							inputFlag = true;
						} // end if input
						if (grumble.getInt("ID") == output) {
							newOutput = grumble;
							outputFlag = true;
						} // end if output
					} // end if grumble
					if (inputFlag &&  outputFlag) break;
				} // for j
				inputFlag = outputFlag = false;
				if (newInput == null) { /* Now What? */ }
				else {
					mumble.set("INPUT", newInput.id());
					mumble.input(newInput);
					newInput.connections().addElement(mumble);
				} // end if newInput
				if (newOutput == null) { /* Now What? */ }
				else {
					mumble.set("OUTPUT", newOutput.id());
				   mumble.output(newOutput);
					newOutput.connections().addElement(mumble);
				} // end if newOutput
			} // end if mumble 
		} // for i
	} // method reconnect
	
	public void rebind ( VModelElement element, Vector r, Vector v, Vector a ) {
		int binding = -1;
		boolean bindingFlag = false;
		VModelElement mumble = null, grumble = null;
		VModelElement inBound = null;
		for(int i = 0; i < v.size(); i++) {
			mumble = (VModelElement) v.elementAt(i);
			if (mumble != null) {
				binding = mumble.getInt("BINDING");
				mumble.removeAttribute("BINDINGS"); // TEMPORARY KLUDGE! Eventually we should use this attribute to rebind!
				for(int j = 0; j < a.size(); j++) {
					grumble = (VModelElement) a.elementAt(j);
					if (grumble != null) {
						if (grumble.getInt("ID") == binding) {
							inBound = grumble;
							bindingFlag = true;
						} // end if input
					} // end if grumble
					if (bindingFlag) break;
				} // for j
				bindingFlag = false;
				if (inBound == null) { 
					mumble.removeAttribute("BINDING");
					mumble.set("BOUND", "FALSE");
				} else {
					mumble.set("BINDING", inBound.id());
					mumble.set("BOUND", "TRUE");
					mumble.bindings().addElement(inBound);
					inBound.set("BOUND", "TRUE");
					inBound.bindings().addElement(mumble);
				} // end if newInput
				mumble.set("BOUND", (mumble.bindings().size() > 0));
			} // end if mumble 
		} // for i
	} // method reconnect
	
	public static VModelModel load ( String filename ) {
	   VModelModel result = null;
	   VModelElement model = null;
	   VModelElement history = null;
	   FileInputStream inp = null;
		try { inp = new FileInputStream(filename); } 
		catch ( Exception e ) {
	    	QRGutils.debug("VModelModel","VModelElement load Error: \n" + e);
		} // try-catch
		if (inp != null) {
		   model = VModelElement.load(inp);
		   if (model != null) {
		   	result = new VModelModel(system(), model);
		   	if (result.getInt("VERSION") <= 0.4) {
			   	history = VModelElement.load(inp);
			   	if (history != null) result.modelHistory(history);
		   	} // end if version
		   } // end if model
			try {
		    	inp.close();
			} // try
			catch ( Exception e ) {
		    	QRGutils.debug("VModelModel","VModelElement load Error while closing: \n" + e);
			} // catch
		} // end if inp
	   return(result);
	} // method load
	
	public void save ( ) {
		save(getString("LABEL"));
	} // method save
	
	public void save ( String filename ) {
		savePrep();
		label(QRGutils.stripExtension(filename));
		VModelEvent.signal(new VModelEvent(SAVE_MODEL, this, 
								 "save model. filename= " + filename,
								 modelElement()));
		addToLibrary(modelElement());
	} // method save
	
	// --------------------------------------------------------------------------
	// Method: log
	// Description: logging Utilities.
	// --------------------------------------------------------------------------
	public boolean log ( ) { return(logflag); }
	
	public boolean log ( boolean flag ) { return(log(flag, null)); }
	public boolean log ( boolean flag, String label ) {
		if (flag != logflag) {
			if (flag) {
				logflag = true;
				makeHistory(label);
				log("StartLog");
			} else {
				log("StopLog");
				logflag = false;
			} // end if flag else
		} // end if
		return(logflag);
	} // method log
/*	
	public boolean log( VModelElement action) {
		if (logflag) historySession.add(action);
		return(logflag);
	} // method log

	public boolean log( String op, Object info) {
		VModelElement action = new VModelElement("ACTION");
		Date currentTime = new Date();
		String datetime = dateFormat.format(currentTime);
		action.set("TIMESTAMP", datetime);
		action.set("EVENT", op);
		action.set("DESCRIPTION", info);
		return(log(action));
	} // method log

	public boolean log( String op) {
		VModelElement action = new VModelElement("ACTION");
		Date currentTime = new Date();
		String datetime = dateFormat.format(currentTime);
		action.set("TIMESTAMP", datetime);
		action.set("EVENT", op);
		return(log(action));
	} // method log
*/


	public boolean log( VModelElement action) {
		if (logflag) historySession.add(action);
		return(logflag);
	} // method log

	public boolean log( String op, Object info) {
		VModelElement action = new VModelElement("ACTION");
		String logInfo = "";
		action.removeAttribute("KEY");
		action.removeAttribute("TYPECHAIN");
		Date currentTime = new Date();
		String datetime = dateFormat.format(currentTime);
		logInfo += "TIMESTAMP=" + datetime + " ";
		logInfo += "USERID=" + system().preferences().getString("USERID") + " ";
		logInfo += "OPERATION=" + op + " ";
		if (info != null) logInfo += "DATA=" + info;
		action.set("LOG", logInfo);
		return(log(action));
	} // method log

	public boolean log( String op) {
		return(log(op, null));
	} // method log


/*	
	public boolean log( VModelElement action) {
		if (logflag) {
			String mumble = action.getString("TIMESTAMP") + " " +
								 action.getString("EVENT") + " : " +
								 action.getString("DESCRIPTION");
			historySession.elements().addElement(mumble);
		} // end if logflag
		return(logflag);
	} // method log

	public boolean log( String op, Object info) {
		String action = "";
		Date currentTime = new Date();
		String datetime = dateFormat.format(currentTime);
		action += datetime + " ";
		action += op + " ";
		if (info != null) action += info;
		if (logflag) {
			historySession.elements().addElement(action);
		} // end if logflag
		return(logflag);
	} // method log

	public boolean log( String op) {
		return(log(op, null));
	} // method log
*/

	public void makeHistory( String label ) {
		Date currentTime = new Date();
		String datetime = sessionDateFormat().format(currentTime);
		historySession = new VModelElement("SESSION");
		historySession.set("TIMESTAMP", datetime);
QRGutils.debug("VModelModel","makeHistory system=" + system());
		historySession.set("USERID", system().preferences().getString("USERID"));
		if (label != null) historySession.set("LABEL", label);
		modelHistory().add(historySession);
	} // method makeHistory

	// Get attribute values.
	// -----------------------------------------------------------------------
    public Object get ( String tag ) {
		Object result = null;
		if (modelElement() != null) result = modelElement().get(tag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method get

    public Color getColor ( String tag ) {
		Color result = Color.black;
		if (modelElement() != null) result = modelElement().getColor(tag);
		else QRGutils.debug("model", "Variable model = null.");
		return result;
    } // method getColor

    public int getRGBColor ( String tag ) {
		int result = 0;
		Color color = getColor(tag);
		if (color != null) result = color.getRGB();
		else QRGutils.debug("model", "getColor returned null.");
		return(result);
    } // method getRGBColor

    public int getInt ( String tag ) {
		int result = 0;
		if (modelElement() != null) result = modelElement().getInt(tag);
		else QRGutils.debug("model", "Variable model = null.");
		return result;
    } // method getInt

    public double getDouble ( String tag ) {
		double result = 0.0;
		if (modelElement() != null) result = modelElement().getDouble(tag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method getDouble

    public String getString ( String tag ) {
		String result = "";
		if (modelElement() != null) result = modelElement().getString(tag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method getDouble

    public boolean getBoolean ( String tag ) {
		boolean result = false;
		if (modelElement() != null) result = modelElement().getBoolean(tag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method getDouble

	// Get attribute values from a child element.
	// -----------------------------------------------------------------------
    public Object get ( String etag, String atag ) {
		Object result = null;
		if (modelElement() != null) result = modelElement().get(etag, atag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method get

    public Color getColor ( String etag, String atag ) {
		Color result = null;
		if (modelElement() != null) result = modelElement().getColor(etag, atag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method getColor

    public int getRGBColor ( String etag, String atag ) {
		int result = 0;
		Color color = getColor(etag, atag);
		if (color != null) result = color.getRGB();
		else QRGutils.debug("model", "getColor returned null.");
		return(result);
    } // method getRGBColor

    public int getInt ( String etag, String atag ) {
		int result = 0;
		if (modelElement() != null) result = modelElement().getInt(etag, atag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method get

    public double getDouble ( String etag, String atag ) {
		double result = 0;
		if (modelElement() != null) result = modelElement().getDouble(etag, atag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method getDouble

    public String getString ( String etag, String atag ) {
		String result = "";
		if (modelElement() != null) result = modelElement().getString(etag, atag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method getString

    public boolean getBoolean ( String etag, String atag ) {
		boolean result = false;
		if (modelElement() != null) result = modelElement().getBoolean(etag, atag);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method getString

	// Set attribute values.
	// -----------------------------------------------------------------------
    public Object set ( String tag, Object value ) {
		Object result = null;
		if (modelElement() != null) result = modelElement().set(tag, value);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
    } // method set

    public Object set ( String tag, int value ) {
		return(set(tag, "" + value));
    } // method set

    public Object set ( String tag, boolean value ) {
		return(set(tag, "" + value));
    } // method set

    public Object set ( String tag, double value ) {
		return(set(tag, "" + value));
    } // method set

    public Object set ( String tag, Color value ) {
		return(set(tag, "" + value.getRGB()));
    } // method set

	// Set attribute values of a child element.
	// -----------------------------------------------------------------------
	public Object set ( String etag, String atag, Object value ) {
		Object result = null;
		if (modelElement() != null) result = modelElement().set(etag, atag, value);
		else QRGutils.debug("model", "Variable model = null.");
		return(result);
	} // method set
	
	public Object set ( String etag, String atag, int value ) {
		return(set(etag, atag, "" + value));
	} // method set
	
	public Object set ( String etag, String atag, double value ) {
		return(set(etag, atag, "" + value));
	} // method set
	
	public Object set ( String etag, String atag, boolean value ) {
		return(set(etag, atag, "" + value));
	} // method set
	
	public Object set ( String etag, String atag, Color value ) {
		return(set(etag, atag, "" + value.getRGB()));
	} // method set

	// VModelEventListener required methods
	// --------------------------------------------------------------------------
	public boolean event ( VModelEvent event ) {
		boolean result = true;
		String msg = "";
		VModelElement foo = null;
		if (event.origin() == this) {
			msg += event.description();
			if (event.argument1() != null) {
				foo = (VModelElement) event.argument1();
				msg += " KEY=" + foo.get("KEY");
				msg += " TYPE=" + foo.get("TYPE");
				msg += " LABEL=" + foo.get("LABEL");
			} // end if argument1
			if (event.argument2() != null) {
				foo = (VModelElement) event.argument2();
				msg += " KEY=" + foo.get("KEY");
				msg += " TYPE=" + foo.get("TYPE");
				msg += " LABEL=" + foo.get("LABEL");
			} // end if argument1
			if (event.argument3() != null) {
				foo = (VModelElement) event.argument3();
				msg += " KEY=" + foo.get("KEY");
				msg += " TYPE=" + foo.get("TYPE");
				msg += " LABEL=" + foo.get("LABEL");
			} // end if argument1
			log(event.eventID(), msg);
		} // end if origin
		return(result);
	} // method event

	// Constructors
	// --------------------------------------------------------------------------
	public VModelModel (VModel system) {
		Date currentTime = new Date();
		String datetime = dateFormat().format(currentTime);
		String labelCountString = "" + (labelCount++);
		String label = "";
		
		system(system);
		
		if (labelCountString.length() == 1) labelCountString = "0" + labelCountString;
		label = "untitled-" + labelCountString + "." + VMODEL_SUFFIX;

		modelElement().set("TYPE","MODEL");
		modelElement().set("LABEL", label);
		modelElement().set("PROBLEM_STATEMENT", "???");
		modelElement().set("FILENAME",label);
		modelElement().set("PATH","MODELS/");
		modelElement().set("GRAPHIC","vmodel.gif");
		modelElement().set("DISPLAY","TRUE");
		modelElement().set("MODE","PROBLEM BUILD ANALYZE JUSTIFY ALL");
		modelElement().set("DESCRIPTION","A model contains a description of the things in a system and the relationships among them.");
		modelElement().set("HELP","A model is a special kind of description of how something happens in the world.");
		modelElement().set("HELP-LINK","model.html");
		modelElement().set("CREATED",datetime);
		modelElement().set("UPDATED",datetime);
		modelElement().set("ORIGINAL-PROGRAM-NAME", PROJECT);
		modelElement().set("ORIGINAL-PROGRAM-VERSION", VERSION);
		modelElement().set("PROGRAM-NAME", PROJECT);
		modelElement().set("PROGRAM-VERSION", VERSION);
		
		modelHistory().set("CREATED",datetime);
		modelHistory().set("UPDATED",datetime);
		
		VModelEvent.addListener(this);

		log(true);
		VModelEvent.signal(new VModelEvent(NEW_MODEL, this, PROJECT + " v" + VERSION, modelElement()));
								  
		models().addElement(this);
	} // VModelModel
	
	public VModelModel (VModel system, VModelElement model) {
		Date currentTime = new Date();
		String datetime = dateFormat().format(currentTime);

		system(system);
		
		modelElement(model);
		modelElement().set("UPDATED",datetime);
		modelElement().set("LAST-PROGRAM-NAME", modelElement().getString("PROGRAM-NAME"));
		modelElement().set("LAST-PROGRAM-VERSION", modelElement().getString("PROGRAM-VERSION"));
		modelElement().set("PROGRAM-NAME", PROJECT);
		modelElement().set("PROGRAM-VERSION", VERSION);

		if (modelHistory().get("CREATED")==null) modelHistory().set("CREATED",datetime);
		modelHistory().set("UPDATED",datetime);
		
		sift(modelElement());
		reconnect();
		rebind();
		
		VModelEvent.addListener(this);
		
		log(true);
		VModelEvent.signal(new VModelEvent(OPEN_MODEL, this, PROJECT + " v" + VERSION + " " + 
								  modelElement().getString("PROGRAM-NAME")+ 
								  modelElement().getString("PROGRAM-VERSION"),
								  modelElement()));
								  
		models().addElement(this);
	} // VModelModel	

} // class VModelModel

// -----------------------------------------------------------------------------
// End of File: VModelModel.java                (c) 2001 Northwestern University
