package edu.qrg.vmodel.controllers;

import edu.qrg.vmodel.controllers.gui.*;
import edu.qrg.vmodel.*;
import edu.qrg.utils.*;
import javax.swing.*;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/controllers
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: Controller.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
* Interface: Controller
*   Purpose: Controller API.
* ----------------------------------------------------------------------------
* Notes:
* * Very simple to suit the task in VModel.
* * Need to add a toolbar with forward/backward
* -----------------------------------------------------------------------------
* </PRE> */
public interface Controller extends VModelConstants, VModel.VMController {
	// Properties & Accessors
	// -------------------------------------------------------------------------
	// VModel model engine
	public VModel vmodel ( );
	public VModel vmodel ( VModel v );
	
	public HTMLbrowser browser ( );
	public VModelPreferencesDialog preferencesDialog ( );
	public PrintPreviewDialog printPreview ( );
	public void saveImage ( String type );

	/** @deprecated Use selectedLibrary ( ) */
	public Ontology selectedOntology ( );
	/** @deprecated Use selectedLibrary ( Library l ) */
	public Ontology selectedOntology ( Ontology o ); 

	public Library selectedLibrary ( );
	public Library selectedLibrary ( Library l ); 

	public JFrame frame ( );

	public int closeAllModels ( );
	public int closeModel ( );
	public int closeModel( ModelFrame frame, boolean aux );
	public int closeModel( ModelFrame frame );

	public void tileModelFrames();
	public void cascadeModelFrames();

	public ModelFrame selectedWindow ( );
	public ModelFrame selectedWindow ( ModelFrame w );
	public JComboBox openWindows ( );
	public Model currentModel ( );
	public Model currentModel ( Model m );
	/** @deprecated Use currentModel ( ) */
	public Model selectedModel ( );
	/** @deprecated Use currentModel ( Model m ) */
	public Model selectedModel ( Model m );
	public Definition selectedDefinition ( );
	public Definition selectedDefinition ( Definition e );
	
	public Instance addDefinition ( Model model, Definition element, int clickX, int clickY, boolean clearSelectedElement );
	public Instance addConnect ( Model model, Definition relationship, Instance independent, Instance dependent, int x, int y, int orientation );

	public void updateWidgets ( );
	
	public HTMLpanel coachAskPanel ( );

} // interface Controller

// -----------------------------------------------------------------------------
// End of File: Controller.java       (c) 2001 Northwestern University