package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.vmodel.*;
import edu.qrg.vmodel.controllers.common.*;
import edu.qrg.utils.*;
import edu.qrg.utils.KeyValuePair.KVPinterface;
import edu.qrg.vmodel.controllers.macclassroom.ModelPane.Action;
import edu.qrg.vmodel.VModel.VMController;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyVetoException;
import java.io.File;
import java.io.Serializable;
import java.lang.Cloneable;
import java.lang.Exception;
import java.lang.Integer;
import java.lang.Math;
import java.lang.Object;
import java.lang.Runnable;
import java.lang.String;
import java.util.Enumeration;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.ButtonGroup;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultDesktopManager;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDesktopPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.JViewport;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.SwingUtilities;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ListDataListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.Timer;
import javax.swing.JWindow;
//import java.awt.image.BufferedImage;
//import com.sun.image.codec.*;
//import com.sun.image.codec.jpeg.*;
//import com.sun.image.codec.jpeg.JPEGImageEncoder.*;
import com.sun.jimi.core.*;			// Added TRH
import com.sun.jimi.core.options.*;	// Added TRH
import java.awt.*;
import java.awt.datatransfer.*; //Clipboard
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
//import java.awt.print.*;
//import java.awt.geom.*;
//import java.awt.geom.Line2D.Double;
import java.awt.image.*;
//import java.awt.image.BufferedImage;
import java.net.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/controllers/MacClassroom
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: MacClassroom.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: MacClassroom
* Purpose: MacClassroom VModel Interface Controller
* ----------------------------------------------------------------------------
* </PRE> */
public class MacClassroom extends VModel implements Controller {
	// Constructors
	// -------------------------------------------------------------------------
	public MacClassroom () {
		QRGutils.debug("Wrong Constructor Called!!!!!!!!!");
	} // constructor
	
	public MacClassroom (VModel v) {
		self(this);
		vmodel(v);
		init();
	} // constructor

	// Properties & Accessors
	// -------------------------------------------------------------------------
	// self
	protected MacClassroom self = null;
	public MacClassroom self () { return(self); }
	public MacClassroom self (MacClassroom c) { return(self = c); }

	// VModel model engine
	protected VModel vmodel = null;
	public VModel vmodel () { return(vmodel); }
	public VModel vmodel (VModel v) { return(vmodel = v); }
	
	// Browser	
	protected HTMLbrowser browser = null;
	public HTMLbrowser browser () { 
		if (browser == null) browser = new HTMLbrowser();
		return(browser); 
	} // reader browser

	// coach panes
	protected HTMLpanel coachAskPanel = new HTMLpanel();
	public HTMLpanel coachAskPanel () { return(coachAskPanel); }
	public HTMLpanel coachAskPanel (HTMLpanel h) { return(coachAskPanel = h); }

	// Selected Ontology
	protected Ontology selectedOntology = null;
	/** @deprecated Use selectedOntology () */
	public Ontology selectedOntology () { return(selectedOntology); }
	/** @deprecated Use selectedOntology (Ontology l) */
	public Ontology selectedOntology (Ontology o) { 
		if (o != null) VModelStatusBar.showText(o.documentation());
		return(selectedOntology = o); 
	} // writer

	// Selected Model
	/** @deprecated Use currentModel () */
	public Model selectedModel () { return(currentModel()); }
	/** @deprecated Use currentModel (Model m) */
	public Model selectedModel (Model m) { return(currentModel(m)); }

	// Selected Ontology Element
	protected Definition selectedDefinition = null;
	public Definition selectedDefinition () { return(selectedDefinition); }
	public Definition selectedDefinition (Definition e) { 
		if (e != null) VModelStatusBar.showText(e.documentation());
		return(selectedDefinition = e); 
	} // writer
	
	protected JTree myOntologyTree = null;
	public JTree myOntologyTree () { return(myOntologyTree); }
	public JTree myOntologyTree (JTree t) { return(myOntologyTree = t); }

	// Modeler
	protected JPanel modeler = null;
	public JPanel modeler () { 
		if (modeler == null) modeler = new JPanel(new BorderLayout());
		return(modeler); 
	} // reader

	// The top-level system window
	public JFrame frame = null;
	public JFrame frame () { return(frame); }
	public JFrame frame (JFrame f) { return(frame = f); }
	
	// Statusbar
	protected VModelStatusBar statusbar = new VModelStatusBar();
	public VModelStatusBar statusbar () { return(statusbar); }
	public VModelStatusBar statusbar (VModelStatusBar s) { 
		return(statusbar = s); 
	} // writer statusbar
	
	protected Image icon = null;
	public Image icon() { return(icon); }
	public Image icon(Image i) { return(icon = i); }

	protected VModelMenuBar menubar = null;
	public VModelMenuBar menubar () {
		if (menubar == null) menubar(new VModelMenuBar());
		return(menubar);
	} // reader menubar
	public VModelMenuBar menubar (VModelMenuBar m) { return(menubar = m); }

	protected VModelSplitPane splitpane = null;
	public VModelSplitPane splitpane () {
		if (splitpane == null) splitpane(new VModelSplitPane());
		return(splitpane);
	} // reader splitpane
	public VModelSplitPane splitpane (VModelSplitPane s) { 
		return(splitpane = s); 
	} // writer splitpane

	protected VModelSidePanel sidepanel = null;
	public VModelSidePanel sidepanel () { return(sidepanel); } 
	public VModelSidePanel sidepanel (VModelSidePanel s) { 
		return(sidepanel = s); 
	} // writer splitpane

	protected VModelPreferencesDialog preferencesDialog = null;
	public VModelPreferencesDialog preferencesDialog () { 
		if (preferencesDialog == null) preferencesDialog = new VModelPreferencesDialog();
		return(preferencesDialog); 
	} // reader preferencesDialog

	protected ModelOverviewDialog modelOverview = null;
	public ModelOverviewDialog modelOverview () { 
		if (modelOverview == null) modelOverview = new ModelOverviewDialog();
		return(modelOverview); 
	} // reader
		
	// Methods
	// ------------------------------------------------------------------------
	public void updateWidgets () {
		boolean modelexists = (currentModel() != null);
		boolean elementselected = ((selectedWindow() != null) && (! ((ModelFrame) selectedWindow()).modelPane().selectedComponents().isEmpty()));
		updateCoachButton();
		newModelButton().setEnabled(true);
		coachButton().setEnabled(modelexists);
		openButton().setEnabled(true);
		saveButton().setEnabled(modelexists);
		saveasButton().setEnabled(modelexists);
		notesButton().setEnabled(modelexists);
		printButton().setEnabled(modelexists);
		printPreviewButton().setEnabled(modelexists);
		undoButton().setEnabled(modelexists  && 
			(! selectedWindow().modelPane().undoStack().empty()));
		redoButton().setEnabled(modelexists && 
			(! selectedWindow().modelPane().redoStack().empty()));
		selectButton().setEnabled(modelexists);
		deleteButton().setEnabled(modelexists && elementselected);
		copyButton().setEnabled(modelexists && elementselected);
		cutButton().setEnabled(modelexists && elementselected);
		pasteButton().setEnabled(modelexists && (clipboard != null));
		groupButton().setEnabled(modelexists);
		addToLibraryButton().setEnabled(modelexists && (((ModelFrame) selectedWindow()).modelPane().selectedComponents().size() == 1));
		addGroupToLibraryButton().setEnabled(modelexists && elementselected);
		if ( currentModel() != null ) {
			boolean b = currentModel().getBoolean("UNSKINNED");
			if (b) groupButton().setIcon(ImageCache.getImage("groupless.gif"));
			else groupButton().setIcon(ImageCache.getImage("group.gif"));
		} // end if
		menubar().updateWidgets();
		if (selectedWindow() != null) selectedWindow().updateWidgets();
	} // method
	
	public void printModel () {
		try {
			Thread t = new Thread() {
				public void run () {
					modelOverview().printModel();
				} // method run
			}; // Anonymous Class Thread
			t.start();
		} catch (Exception err) {}
	} // end method printModel
		
	public void updateCoachButton () {
		Model model = currentModel();
		String coachImage = "";
		String coachrolloverImage = null;
		if (model == null) {
			coachImage = "coach-lb.gif";
		} else {
			if (model.getInt(MODE) == 0) {
				coachImage = "coach-t-h-l.gif";
				coachrolloverImage = "32_wink_target.gif";
			} else if (model.getInt(MODE) == 1) {
				if (model.getBoolean("uncertaincoachstate")) {
					coachImage = "coach-b-q-l.gif";
				} else if (model.bugs().isEmpty()) {
					coachImage = "coach-b-h-l.gif";
					coachrolloverImage = "32_wink_builder.GIF";
				} else if ((!model.bugs().isEmpty()) && (model.bugs().size() >= model.instances().size())) coachImage = "coach-b-a-l.gif";
				else coachImage = "coach-b-c-l.gif";
			} else {
				if (model.bugs().isEmpty()) {
					coachImage = "coach-e-h-l.gif";
					coachrolloverImage = "32_smiley_wink_einstein.gif";
				} else if (model.bugs().size() < model.instances().size()) coachImage = "coach-e-c-l.gif";
				else coachImage = "coach-e-a-l.gif";
			} // end if
		} // end if
		coachButton().setIcon(ImageCache.getImage(coachImage));
		if (coachrolloverImage != null) coachButton().setRolloverIcon(ImageCache.getImage(coachrolloverImage));
		else coachButton().setRolloverIcon(null);
	}
	
	// Load specified controller class
	public void init () {
		controller(this);
		
		myModels().icon("IconModel");
		myProcesses().icon("IconProcess");
		myEntities().icon("IconEntity");
		myThings().icon("IconEntity");
		myMultipleThings().icon("IconEntity");
		mySubstances().icon("IconEntity");
		myAttributes().icon("IconAttribute");
		
		if (userIsDeveloper()) SoundCache.playSound("fanfare.au");
			
		ontology();
		
		initDone = true;
	} // method init
	
	public static boolean initDone = false;
	
	Ontology qpOntology = null;

	public void realizeProject () {
		((HTMLpanel) sidepanel().projectPanel()).gotoPage(QRGutils.QRGroot() + HELPPATH, project().getBackground());
		Ontology library = (Ontology) XMLio.load(QRGutils.QRGroot() + PROJECTPATH + project().getFolder() + project().getString("LIBRARY"));
		QRGutils.debug("MacClassroom.realizeProject", "project file = "+preferences().getString("PROJECT") + QRGutils.eol() + QRGutils.eol());
		if (library == null) {
			if (qpOntology == null) {
				if (preferences().getString("PROJECT").equalsIgnoreCase("classroom.vmp")) qpOntology = new ClassroomOntology();
				else qpOntology = new QPontology();
			} // end if
			library = qpOntology;
			File file = new File(QRGutils.QRGroot() + PROJECTPATH + project().getFolder() + project().getString("LIBRARY"));
			if (!file.exists()) {
				XMLio.save(QRGutils.QRGroot() + PROJECTPATH + project().getFolder() + project().getString("LIBRARY"), library);
				CMLio.save(QRGutils.QRGroot() + PROJECTPATH + project().getFolder() + project().getString("LIBRARY") + ".cml", library);
			} // end if
		} // else XMLio.save(QRGutils.QRGroot() + PROJECTPATH + project().getFolder() + "two-" + project().getString("LIBRARY"), library);
		sidepanel().add(library);
		projectOntology(library);
	} // method realizeProject
	
	// Description: Load several commonly used images.
	// -----------------------------------------------------------------------
	public void loadImages () {
		// Named images (very common)
		icon(QRGutils.getImage(QRGutils.QRGroot()+IMAGEPATH+"vmodel.gif"));
		String bgImage = preferences().getString("BACKGROUNDIMAGE");
		ImageCache.loadImage("back.gif");

		// Cache these
		ImageCache.loadImage("BACK.GIF");
		ImageCache.loadImage("FORWARD.GIF");
		ImageCache.loadImage("NEWMODEL.GIF");
		ImageCache.loadImage("OPEN.GIF");
		ImageCache.loadImage("SAVE.GIF");
		ImageCache.loadImage("PRINT.GIF");
		ImageCache.loadImage("PREVIEW.GIF");
		ImageCache.loadImage("UNDO.GIF");
		ImageCache.loadImage("REDO.GIF");
		ImageCache.loadImage("HAND.GIF");
		ImageCache.loadImage("COPY.GIF");
		ImageCache.loadImage("CUT.GIF");
		ImageCache.loadImage("PASTE.GIF");
		ImageCache.loadImage("GROUP.GIF");
		ImageCache.loadImage("COACH-LB.GIF");
		ImageCache.loadImage("COACH-LB-M.GIF");
		ImageCache.loadImage("COACH-E-M.GIF");
		ImageCache.loadImage("COACH-ML-M.GIF");
		ImageCache.loadImage("EDIT.GIF");
		ImageCache.loadImage("NEWENTITY.GIF");
		ImageCache.loadImage("NEWPROCESS.GIF");
		ImageCache.loadImage("NEW.GIF");
		ImageCache.loadImage("VMODELLOGIN.GIF");
		ImageCache.loadImage("VMODEL.GIF");
		ImageCache.loadImage("COACH-T-H-S.GIF");
		ImageCache.loadImage("COACH-B-H-S.GIF");
		ImageCache.loadImage("COACH-E-H-S.GIF");
		ImageCache.loadImage("GLASSES.GIF");
		ImageCache.loadImage("GLASSES-ENTITY.GIF");
		ImageCache.loadImage("GLASSES-PROCESS.GIF");
		ImageCache.loadImage("GLASSES-RELATIONSHIP.GIF");
		ImageCache.loadImage("GLASSES-SITUATION.GIF");
		ImageCache.loadImage("GLASSES-CAUSAL.GIF");
		ImageCache.loadImage("GLASSES-JUSTIFICATION.GIF");
		ImageCache.loadImage("GLASSES-COACH.GIF");
		ImageCache.loadImage("GLASSES-ANNOTATION.GIF");
		ImageCache.loadImage("GLASSES-ROLE.GIF");
		ImageCache.loadImage("GLASSES-QP.GIF");
		ImageCache.loadImage("GLASSES-TARGET.GIF");
		ImageCache.loadImage("MAGNIFY.GIF");
		ImageCache.loadImage("ICONMODEL.GIF");
		ImageCache.loadImage("ICONENTITYDATA.GIF");
		ImageCache.loadImage("ICONRELATIONSHIPSUPPORTS.GIF");
		ImageCache.loadImage("ICONHYPOTHESIS.GIF");
		ImageCache.loadImage("ICONRELATIONSHIP.GIF");
		ImageCache.loadImage("ICONRELATIONSHIPCAUSAL.GIF");
		ImageCache.loadImage("ICONRELATIONSHIPSTRUCTURAL.GIF");
		ImageCache.loadImage("ICONATTRIBUTE.GIF");
		ImageCache.loadImage("ICONQUANTITY.GIF");
		ImageCache.loadImage("ICONPROCESS.GIF");
		ImageCache.loadImage("ICONENTITY.GIF");
		ImageCache.loadImage("MARKER.GIF");
		ImageCache.loadImage("SAVEAS.GIF");
		ImageCache.loadImage("ANNOTATION.GIF");
		ImageCache.loadImage("DELETE.GIF");
		ImageCache.loadImage("NOBACKGROUND_16_LIGHTBULB");
		ImageCache.loadImage("NOBACKGROUND16-EINSTEIN.GIF");
		ImageCache.loadImage("ICONMODELOPEN.GIF");
		ImageCache.loadImage("ICONPROCESS");
		ImageCache.loadImage("ICONMODELCLOSED");
		ImageCache.loadImage("ICONATTRIBUTECLOSED");
		ImageCache.loadImage("BLACK-ARROWS.JPGCLOSED");
		ImageCache.loadImage("ICONCAUSALCLOSED");
		ImageCache.loadImage("ICONMODELOPEN");
		ImageCache.loadImage("ICONENTITY");
		ImageCache.loadImage("ICONATTRIBUTEOPEN");
		ImageCache.loadImage("ICONQUANTITY");
		ImageCache.loadImage("BLACK-ARROWS.JPGOPEN");
		ImageCache.loadImage("ICONRELATIONSHIPSTRUCTURAL");
		ImageCache.loadImage("ICONRELATIONSHIP");
		ImageCache.loadImage("ICONCAUSALOPEN");
		ImageCache.loadImage("ICONCAUSAL");
		ImageCache.loadImage("COACH-T-C-L.GIF");
		ImageCache.loadImage("NOBACKGROUND_16_TARGET.GIF");
		ImageCache.loadImage("NOBACKGROUND_16_BUILD.GIF");
		ImageCache.loadImage("COACH-T-H-L.GIF");
		ImageCache.loadImage("32_WINK_TARGET.GIF");
		ImageCache.loadImage("COACH-B-C-L.GIF");
		ImageCache.loadImage("BLUE-DOWN.JPG");
		ImageCache.loadImage("BLUE-UP.JPG");
		ImageCache.loadImage("BLACK-BOTH.JPG");
		ImageCache.loadImage("COACH-B-H-L.GIF");
		ImageCache.loadImage("32_WINK_BUILDER.GIF");
		ImageCache.loadImage("BLUE-BOTH.JPG");
		ImageCache.loadImage("INFLUENCES.JPG");
    } // method loadImages

	
	public void doLogin() {
		while(! initDone) { 
			try { Thread.sleep(1000); }
			catch(Exception e) { }
		} // end while

		LoginWizard foo = new LoginWizard(frame(), preferences(), true);
		
		if ( preferences().getBoolean("SYSTEMLOOK") ) {
			try {
				UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			} catch(Exception e) { e.printStackTrace(); }
		} // end if
		
		frame().setTitle(frame().getTitle() + " : " + preferences().getString("USERID"));
		String projectfile = preferences().getString("PROJECT");
		if (!projectfile.equals("")) {
			loadProject(QRGutils.QRGroot() + PROJECTPATH + projectfile);
		} // end if
		realizeProject();
		
		loadMyModels();
		if ( ! preferences().getBoolean("newLogin") ) {
			myProcesses((Ontology) Ontology.load("myProcesses"));
			myEntities((Ontology) Ontology.load("myEntities"));
			myThings((Ontology) Ontology.load("myThings"));
			myMultipleThings((Ontology) Ontology.load("myMultipleThings"));
			mySubstances((Ontology) Ontology.load("mySubstances"));
			myAttributes((Ontology) Ontology.load("myAttributes"));
		} // end if
		myOntologyTree(sidepanel().add(myLibrary()));
		if (preferences().getBoolean("LOGGED-IN-BEFORE")) {
			int loc = preferences().getInt("DIVIDER-LOCATION");
			if ( loc > 0 ) splitpane().setDividerLocation(loc);
			splitpane().getRightComponent().doLayout();
		} // end if else
		sidepanel().librarian().sound(preferences().getBoolean("SOUND"));
		frame().setVisible(true);
		if (preferences().getBoolean("LOGGED-IN-BEFORE")) {
//			if (! preferences().getBoolean("ALLOW-EMPTY-DESKTOP")) makeModel();
		} else {
			preferences().set("LOGGED-IN-BEFORE", true);
//			makeModel();
		} // end if else
	} // end method
	
	public void loadMyModels () {
		String path = QRGutils.makeUserPath(MODELDIR);
		File dir = null;
//		Model mumble = null;
		Definition mumble = null;
		String [] files = null;
		QRGfilefilter fileFilter = new QRGfilefilter();
		dir = new File(path);
		dir.mkdirs();
//		fileFilter.suffix(fileFilter.VModel);
		fileFilter.suffix(fileFilter.XML);
		files = dir.list(fileFilter);
		for(int i = 0; i < files.length; i++) {
//			mumble = (Model) Model.load(path + files[i]);
			mumble = (Definition) XMLio.load(path + files[i]);
			myModels().add(mumble);
		} // for i
	} // method
	
	// From Modeler Class
	// -----------------------------------------------------------------------
	// Properties & Accessors
	// -------------------------------------------------------------------------
	protected static Vector listDataListeners = null;
	public static Vector listDataListeners () {
		if (listDataListeners == null) listDataListeners = new Vector();
		return(listDataListeners);
	} // reader
		
	protected static ComboModel comboModel = null;
	public static ComboModel comboModel () {
		if (comboModel == null) comboModel = new ComboModel();
		return(comboModel);
	} // reader
	public ComboModel comboModel (ComboModel c) { return(comboModel = c); }

	protected static JComboBox openWindows = null;
	public JComboBox openWindows () {
		if (openWindows == null) {
			openWindows = new JComboBox(comboModel());
			openWindows.setRenderer(new ComboRenderer());
			openWindows.setOpaque(true);
		} // end if
		return(openWindows);
	} // reader
		
	protected JToolBar toolbar = null;
	public JToolBar toolbar () { 
		if (toolbar == null) {
			toolbar = new JToolBar();
			toolbar.setFloatable(false);
		} // end if
		return(toolbar); 
	} // reader

	protected JToolBar toolbar2 = null;
	public JToolBar toolbar2 () { 
		if (toolbar2 == null) {
			toolbar2 = new JToolBar();
			toolbar2.setFloatable(false);
		} // end if
		return(toolbar2); 
	} // reader

	protected JPanel toppanel = null;
	public JPanel toppanel () { return(toppanel); } 
	public JPanel toppanel (JPanel j) { 
		return(toppanel = j); 
	} // writer toppanel

	protected JPanel topleftpanel = null;
	public JPanel topleftpanel () { return(topleftpanel); } 
	public JPanel topleftpanel (JPanel j) { 
		return(topleftpanel = j); 
	} // writer topleftpanel

	protected JPanel toprightpanel = null;
	public JPanel toprightpanel () { return(toprightpanel); } 
	public JPanel toprightpanel (JPanel j) { 
		return(toprightpanel = j); 
	} // writer toprightpanel

	protected static JDesktopPane desktop = new JDesktopPane();
	public static JDesktopPane desktop () { return(desktop); } 
	public JDesktopPane desktop (JDesktopPane j) { 
		return(desktop = j); 
	} // writer desktop

	protected static JScrollPane desktopScrollPane = new JScrollPane();
	public static JScrollPane desktopScrollPane () { return(desktopScrollPane); } 
	public static JScrollPane desktopScrollPane (JScrollPane j) { 
		return(desktopScrollPane = j); 
	} // writer desktopScrollPane

	protected static ModelFrame selectedWindow = null;
	public ModelFrame selectedWindow () { return(selectedWindow); }
	public ModelFrame selectedWindow (ModelFrame w) { 
		return(selectedWindow = w); 
	} // writer
	
	protected static Model currentModel = null;
	public Model currentModel () { return(currentModel); }
	public Model currentModel (Model m) { 
		return(currentModel = m); 
	} // writer
	
	// forrester, bond-graphs, shueller-murphy
	
	protected boolean stupidToggle = true;
	protected JButton coachButton = null;
	public JButton coachButton () { 
		if (coachButton == null) {
			coachButton = new JButton(ImageCache.getImage("coach-lb.gif"));
			coachButton.setToolTipText("Check your model.");
			coachButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					Model model = currentModel();
					if (model != null) {
						int mode = model.getInt("MODE");
//						long buildcheck = Model.CHECKSYNTAX;
//						if (currentModel().getBoolean("CHECKQLOOPS")) buildcheck = buildcheck | Model.CHECKQLOOP;
						if (mode == 0) checkModel(model, Model.CHECKTARGET, true);
						else if (mode == 1) checkModel(model, model.CHECKDESIGN, true);
//						else if (mode == 1) checkModel(model, buildcheck, true);
						else if (mode == 2) checkModel(model, Model.CHECKALL, true);
						else checkModel(model, model.CHECKDESIGN, true);
//						else checkModel(model, buildcheck, true);
						model.set("uncertaincoachstate", false);
						selectedWindow().modelPane().updateContextHelp();
						if (stupidToggle || (mode == 2)) sidepanel().coachButton().doClick();
						else if ((mode == 1) && (!sidepanel().librarian().libraryButton().isSelected())) sidepanel().librarian().libraryButton().doClick();
						else sidepanel().projectButton().doClick();
						stupidToggle = ! stupidToggle;
						updateCoachButton();
					} // end if
				} // method
			}); // ActionListener
		} // end if
		return(coachButton); 
	} // reader 

	protected JButton newModelButton = null;
	public JButton newModelButton () {
		if (newModelButton == null) {
			newModelButton = new JButton(ImageCache.getImage("newModel.gif"));
			newModelButton.setToolTipText("New Model"); 
			newModelButton.setEnabled(true);
			newModelButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						makeModel();
					} // method
				}); // ActionListener
		} // end if
		return(newModelButton);
	} // reader
	
	protected JButton openButton = null;
	public JButton openButton () {
		if (openButton == null) {
			openButton = new JButton(ImageCache.getImage("open.gif"));
			openButton.setToolTipText("Open"); 
			openButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						load();
					} // method
				}); // ActionListener
		} // end if
		return(openButton);
	} // reader
	
	protected JButton saveButton = null;
	public JButton saveButton () {
		if (saveButton == null) {
			saveButton = new JButton(ImageCache.getImage("save.gif"));
			saveButton.setToolTipText("Save"); 
			saveButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						save();
					} // method
				}); // ActionListener
		} // end if
		return(saveButton);
	} // reader
	
	protected JButton saveasButton = null;
	public JButton saveasButton () {
		if (saveasButton == null) {
			saveasButton = new JButton(ImageCache.getImage("saveas.gif"));
			saveasButton.setToolTipText("Save As"); 
			saveasButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						save(false);
					} // method
				}); // ActionListener
		} // end if
		return(saveasButton);
	} // reader
	
	protected JButton notesButton = null;
	public JButton notesButton () {
		if (notesButton == null) {
			notesButton = new JButton(ImageCache.getImage("annotation.gif"));
			notesButton.setToolTipText("Annotate"); 
			notesButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						selectedWindow().annotate();
					} // method
				}); // actionListener
		} // end if
		return(notesButton);
	} // reader
	
	protected JButton printButton = null;
	public JButton printButton () {
		if (printButton == null) {
			printButton = new JButton(ImageCache.getImage("print.gif"));
			printButton.setToolTipText("Print"); 
			printButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						try {
							Thread t = new Thread() {
								public void run () {
									modelOverview().printModel();
								} // method run
							}; // Anonymous Class Thread
							t.start();
						} catch (Exception err) {}
					} // method
				}); // actionListener
		} // end if
		return(printButton);
	} // reader
	
	protected JButton printPreviewButton = null;
	public JButton printPreviewButton () {
		if (printPreviewButton == null) {
			printPreviewButton = new JButton(ImageCache.getImage("printpreview.gif"));
			printPreviewButton.setToolTipText("Print Preview"); 
			printPreviewButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						modelOverview().showPreview();
					} // method
				}); // actionListener
		} // end if
		return(printPreviewButton);
	} // reader
	
	protected JButton undoButton = null;
	public JButton undoButton () {
		if (undoButton == null) {
			undoButton = new JButton(ImageCache.getImage("undo.gif"));
			undoButton.setToolTipText("Undo"); 
			undoButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						if (currentModel() != null) {
							ModelPane.Action action = selectedWindow().modelPane().undoAction();
							if (action != null) {
								if (action.action() == ModelPane.Action.ADD) {
									Definition definition = (Definition) action.arguments().elementAt(0);
									Instance instance = (Instance) action.arguments().elementAt(1);
									int x = ((Integer) action.arguments().elementAt(2)).intValue();;
									int y = ((Integer) action.arguments().elementAt(3)).intValue();;
									PeerElement peer = (PeerElement) action.arguments().elementAt(4);
									Vector instances = (Vector) action.arguments().elementAt(5);
									for(Enumeration items = instances.elements(); items.hasMoreElements();) {
										removeInstance(currentModel(), (Instance) items.nextElement());
									} // end if								
									currentModel().log("undo." + action.action(), "definition=" + definition.id() +" instance=" + instance);
								} else if (action.action() == ModelPane.Action.ADDCONNECT) {
									Definition definition = (Definition) action.arguments().elementAt(0);
									Instance instance = (Instance) action.arguments().elementAt(1);
									PeerElement peer = (PeerElement) action.arguments().elementAt(2);
									Instance independent = (Instance) action.arguments().elementAt(3);
									Instance dependent = (Instance) action.arguments().elementAt(4);
									int x = ((Integer) action.arguments().elementAt(5)).intValue();
									int y = ((Integer) action.arguments().elementAt(6)).intValue();
									int orientation = ((Integer) action.arguments().elementAt(7)).intValue();
									removeInstance(instance.model(), instance);
									currentModel().log("undo." + action.action(), "definition=" + definition.id() + " instance=" + instance.id());
								} else if (action.action() == ModelPane.Action.REMOVE) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Vector instances = (Vector) action.arguments().elementAt(0);
									Vector connects = (Vector) action.arguments().elementAt(1);
									Instance candidate = null;
									PeerElement peer = null;
									Vector mumble = null;
									for (Enumeration enum = instances.elements() ; enum.hasMoreElements() ;) {
										candidate = (Instance) enum.nextElement();
										addInstance(currentModel(), candidate);
									} // end for
									for (Enumeration enum = instances.elements() ; enum.hasMoreElements() ;) {
										candidate = (Instance) enum.nextElement();
										peer = (PeerElement) candidate.peer();
										pane.select((PeerElement) candidate.peer(), true);
									} // end for
									for (Enumeration enum = connects.elements() ; enum.hasMoreElements() ;) {
										mumble = (Vector) enum.nextElement();
										candidate = currentModel().findInstance((String) mumble.elementAt(0));
										if (candidate != null) connect(currentModel(), candidate, currentModel().findInstance((String) mumble.elementAt(1)), currentModel().findInstance((String) mumble.elementAt(2)));
									} // end for
									currentModel().log("undo." + action.action(), "instances=" + instances);
								}  else if (action.action() == ModelPane.Action.MOVE) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Vector selectionVector = (Vector) action.arguments();
									PeerElement candidate = null;
									int oldx, newx, oldy, newy;
									for (Enumeration enum = selectionVector.elements() ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement();
										oldx = ((Integer) enum.nextElement()).intValue();
										oldy = ((Integer) enum.nextElement()).intValue();
										newx = ((Integer) enum.nextElement()).intValue();
										newy = ((Integer) enum.nextElement()).intValue();
										candidate.setPosition(oldx, oldy);
										pane.select(candidate, false);
									} // end for
									for (Enumeration enum = selectionVector.elements() ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement();
										oldx = ((Integer) enum.nextElement()).intValue();
										oldy = ((Integer) enum.nextElement()).intValue();
										newx = ((Integer) enum.nextElement()).intValue();
										newy = ((Integer) enum.nextElement()).intValue();
										pane.select(candidate, true);
									} // end for
								} else if (action.action() == ModelPane.Action.CONNECT) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Instance relationship = (Instance) action.arguments().elementAt(0);
									Instance independent = (Instance) action.arguments().elementAt(1);
									Instance dependent = (Instance) action.arguments().elementAt(2);
									String which = (String) action.arguments().elementAt(3);
									if (which.equalsIgnoreCase("BOTH")) connect(currentModel(), relationship, independent, dependent);
									else if (which.equalsIgnoreCase("INPUT")) connect(currentModel(), relationship, null, dependent);
									else connect(currentModel(), relationship, independent, null);
									currentModel().log("undo." + action.action(), "relationship= " + relationship + " independent=" + independent + " dependent=" + dependent);
									relationship.update( false, false, true );
//									relationship.updatePeer();
									selectedWindow().repaint();
								} else if (action.action() == ModelPane.Action.DISCONNECT) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Instance relationship = (Instance) action.arguments().elementAt(0);
									Instance independent = (Instance) action.arguments().elementAt(1);
									Instance dependent = (Instance) action.arguments().elementAt(2);
									String which = (String) action.arguments().elementAt(3);
									connect(currentModel(), relationship, independent, dependent);
									currentModel().log("undo." + action.action(), "relationship= " + relationship + " independent=" + independent + " dependent=" + dependent);
									relationship.update( false, false, true );
//									relationship.updatePeer();
									selectedWindow().repaint();
								}  else if (action.action() == ModelPane.Action.TWIST) {
									PeerElement peer = (PeerElement) action.arguments().elementAt(0);
									peer.turn();
									peer.update( false, false, true );
//									peer.updatePeer();
									((ModelFrame) selectedWindow()).modelPane().drawpane().repaint();
								} else if (action.action() == ModelPane.Action.FLIP) {
									PeerElement peer = (PeerElement) action.arguments().elementAt(0);
									peer.flip();
									peer.update( false, false, true );
//									peer.updatePeer();
									((ModelFrame) selectedWindow()).modelPane().drawpane().repaint();
								} else if (action.action() == ModelPane.Action.REVERSE) {
									PeerElement peer = (PeerElement) action.arguments().elementAt(0);
									peer.reverse();
									peer.update( false, false, true );
//									peer.updatePeer();
									((ModelFrame) selectedWindow()).modelPane().drawpane().repaint();
								} else if (action.action() == ModelPane.Action.PASTE) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									Instance candidate = null;
									pane.deselectAll();
									Vector instances = (Vector) action.arguments().elementAt(1);
									PeerElement peer = null;
									for (Enumeration enum = instances.elements() ; enum.hasMoreElements() ;) {
										candidate = (Instance) enum.nextElement();
										peer = (PeerElement) candidate.peer();
										pane.select(peer, true);
									} // end for
									delete(false);
									currentModel().log("redo." + action.action(), "instances=" + instances);
								} // end if else if else ....
							} // end if
						} // end if
						selectedWindow().dirty(true);
					} // method
				}); // actionListener
		} // end if
		return(undoButton);
	} // reader

	protected JButton redoButton = null;
	public JButton redoButton () {
		if (redoButton == null) {
			redoButton = new JButton(ImageCache.getImage("redo.gif"));
			redoButton.setToolTipText("Redo"); 
			redoButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						if (currentModel() != null) {
							ModelPane.Action action = selectedWindow().modelPane().redoAction();
							if (action != null) {
								if (action.action() == ModelPane.Action.ADD) {
									Definition definition = (Definition) action.arguments().elementAt(0);
									Instance instance = (Instance) action.arguments().elementAt(1);
									int x = ((Integer) action.arguments().elementAt(2)).intValue();;
									int y = ((Integer) action.arguments().elementAt(3)).intValue();;
									PeerElement peer = (PeerElement) action.arguments().elementAt(4);
									Vector instances = (Vector) action.arguments().elementAt(5);
									for(Enumeration items = instances.elements(); items.hasMoreElements();) {
										addInstance(currentModel(), (Instance) items.nextElement());
									} // end if								
									currentModel().log("redo." + action.action(), "definition=" + definition.id());
								}  else if (action.action() == ModelPane.Action.ADDCONNECT) {
									Definition definition = (Definition) action.arguments().elementAt(0);
									Instance instance = (Instance) action.arguments().elementAt(1);
									PeerElement peer = (PeerElement) action.arguments().elementAt(2);
									Instance independent = (Instance) action.arguments().elementAt(3);
									Instance dependent = (Instance) action.arguments().elementAt(4);
									int x = ((Integer) action.arguments().elementAt(5)).intValue();
									int y = ((Integer) action.arguments().elementAt(6)).intValue();
									int orientation = ((Integer) action.arguments().elementAt(7)).intValue();
									independent = currentModel().findInstance(independent.id());
									dependent = currentModel().findInstance(dependent.id());
									addInstance(currentModel(), instance);
									connect(currentModel(), instance, independent, dependent);
									instance.update( false, false, true );
//									instance.updatePeer();
									currentModel().log("undo." + action.action(), "definition=" + definition.id() + " instance=" + instance.id());
								} else if (action.action() == ModelPane.Action.REMOVE) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									Instance candidate = null;
									pane.deselectAll();
									Vector instances = (Vector) action.arguments().elementAt(0);
									PeerElement peer = null;
									for (Enumeration enum = instances.elements() ; enum.hasMoreElements() ;) {
										candidate = (Instance) enum.nextElement();
										peer = (PeerElement) candidate.peer();
										pane.select(peer, true);
									} // end for
									delete(false);
									currentModel().log("redo." + action.action(), "instances=" + instances);
								} else if (action.action() == ModelPane.Action.MOVE) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Vector selectionVector = (Vector) action.arguments();
									PeerElement candidate = null;
									int oldx, newx, oldy, newy;
									for (Enumeration enum = selectionVector.elements() ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement();
										oldx = ((Integer) enum.nextElement()).intValue();
										oldy = ((Integer) enum.nextElement()).intValue();
										newx = ((Integer) enum.nextElement()).intValue();
										newy = ((Integer) enum.nextElement()).intValue();
										candidate.setPosition(newx, newy);
										pane.select(candidate, false);
									} // end for
									for (Enumeration enum = selectionVector.elements() ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement();
										oldx = ((Integer) enum.nextElement()).intValue();
										oldy = ((Integer) enum.nextElement()).intValue();
										newx = ((Integer) enum.nextElement()).intValue();
										newy = ((Integer) enum.nextElement()).intValue();
										pane.select(candidate, true);
									} // end for
								} else if (action.action() == ModelPane.Action.CONNECT) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Instance relationship = (Instance) action.arguments().elementAt(0);
									Instance independent = (Instance) action.arguments().elementAt(1);
									Instance dependent = (Instance) action.arguments().elementAt(2);
									String which = (String) action.arguments().elementAt(3);
									if (which.equalsIgnoreCase("BOTH")) connect(currentModel(), relationship, null, null);
									else connect(relationship.model(), relationship, independent, dependent);
									currentModel().log("redo." + action.action(), "relationship= " + relationship + " independent=" + independent + " dependent=" + dependent);
									relationship.update( false, false, true );
//									relationship.updatePeer();
									selectedWindow().repaint();
								} else if (action.action() == ModelPane.Action.DISCONNECT) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Instance relationship = (Instance) action.arguments().elementAt(0);
									Instance independent = (Instance) action.arguments().elementAt(1);
									Instance dependent = (Instance) action.arguments().elementAt(2);
									String which = (String) action.arguments().elementAt(3);
									if (which.equalsIgnoreCase("BOTH")) connect(currentModel(), relationship, null, null);
									else if (which.equalsIgnoreCase("INPUT")) connect(relationship.model(), relationship, null, dependent);
									else connect(relationship.model(), relationship, independent, null);
									currentModel().log("redo." + action.action(), "relationship= " + relationship + " independent=" + independent + " dependent=" + dependent);
									relationship.update( false, false, true );
//									relationship.updatePeer();
									selectedWindow().repaint();
								} else if (action.action() == ModelPane.Action.TWIST) {
									PeerElement peer = (PeerElement) action.arguments().elementAt(0);
									peer.twist();
									peer.update( false, false, true );
//									peer.updatePeer();
									((Controller) controller()).selectedWindow().modelPane().drawpane().repaint();
								} else if (action.action() == ModelPane.Action.FLIP) {
									PeerElement peer = (PeerElement) action.arguments().elementAt(0);
									peer.flip();
									peer.update( false, false, true );
//									peer.updatePeer();
									((Controller) controller()).selectedWindow().modelPane().drawpane().repaint();
								} else if (action.action() == ModelPane.Action.REVERSE) {
									PeerElement peer = (PeerElement) action.arguments().elementAt(0);
									peer.reverse();
									peer.update( false, false, true );
//									peer.updatePeer();
									((ModelFrame) selectedWindow()).modelPane().drawpane().repaint();
								} else if (action.action() == ModelPane.Action.PASTE) {
									ModelPane pane = ((ModelFrame) selectedWindow()).modelPane();
									pane.deselectAll();
									Vector instances = (Vector) action.arguments().elementAt(1);
									Vector connects = (Vector) action.arguments().elementAt(2);
									Instance candidate = null;
									PeerElement peer = null;
									Vector mumble = null;
									for (Enumeration enum = instances.elements() ; enum.hasMoreElements() ;) {
										candidate = (Instance) enum.nextElement();
										addInstance(currentModel(), candidate);
									} // end for
									for (Enumeration enum = instances.elements() ; enum.hasMoreElements() ;) {
										candidate = (Instance) enum.nextElement();
										peer = (PeerElement) candidate.peer();
										pane.select((PeerElement) candidate.peer(), true);
									} // end for
									for (Enumeration enum = connects.elements() ; enum.hasMoreElements() ;) {
										mumble = (Vector) enum.nextElement();
										candidate = currentModel().findInstance((String) mumble.elementAt(0));
										if (candidate != null) connect(currentModel(), candidate, currentModel().findInstance((String) mumble.elementAt(1)), currentModel().findInstance((String) mumble.elementAt(2)));
									} // end for
									currentModel().log("undo." + action.action(), "instances=" + instances);
								} // end if else if else if ....
							} // end if
						} // end if
						selectedWindow().dirty(true);
					} // method
				}); // actionListener
		} // end if
		return(redoButton);
	} // reader
	
	protected JButton selectButton = null;
	public JButton selectButton () {
		if (selectButton == null) {
			selectButton = new JButton(ImageCache.getImage("hand.gif"));
			selectButton.setToolTipText("Deselection Tool"); 
			selectButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						Librarian.selectedTree().clearSelection();
						Librarian.selectedDefinition(null);
						selectedWindow().modelPane().deselectAll();
					} // method
				}); // actionListener
		} // end if
		return(selectButton);
	} // reader
	
	protected JButton deleteButton = null;
	public JButton deleteButton () {
		if (deleteButton == null) {
			deleteButton = new JButton(ImageCache.getImage("delete.gif"));
			deleteButton.setToolTipText("Delete Selection"); 
			deleteButton.addActionListener(new ActionListener() {
					public void actionPerformed (ActionEvent e) {
						delete(true);
					} // method
				}); // actionListener
		} // end if
		return(deleteButton);
	} // reader
	
	protected JButton copyButton = null;
	public JButton copyButton () {
		if (copyButton == null) {
			copyButton = new JButton(ImageCache.getImage("copy.gif"));
			copyButton.setToolTipText("Copy"); 
			copyButton.addActionListener(new ActionListener () {
				public void actionPerformed (ActionEvent e) {
					copy();
				} // method
			}); // ActionListener
		} // end if
		return(copyButton);
	} // reader
	
	protected JButton cutButton = null;
	public JButton cutButton () {
		if (cutButton == null) {
			cutButton = new JButton(ImageCache.getImage("cut.gif"));
			cutButton.setToolTipText("Cut"); 
			cutButton.addActionListener(new ActionListener () {
				public void actionPerformed (ActionEvent e) {
					cut();
				} // method
			}); // ActionListener
		} // end if
		return(cutButton);
	} // reader
	
	protected JButton pasteButton = null;
	public JButton pasteButton () {
		if (pasteButton == null) {
			pasteButton = new JButton(ImageCache.getImage("paste.gif"));
			pasteButton.setToolTipText("Paste"); 
			pasteButton.addActionListener(new ActionListener () {
				public void actionPerformed (ActionEvent e) {
					paste();
				} // method
			}); // ActionListener
		} // end if
		return(pasteButton);
	} // reader
	
	protected JButton groupButton = null;
	public JButton groupButton () {
		if (groupButton == null) {
			groupButton = new JButton(ImageCache.getImage("group.gif"));
			if ( currentModel() != null ) {
				boolean b = currentModel().getBoolean("UNSKINNED");
				if (b) groupButton().setIcon(ImageCache.getImage("groupless.gif"));
				else groupButton().setIcon(ImageCache.getImage("group.gif"));
			} // end if
			groupButton.setToolTipText("Toggle Skins"); 
			groupButton.addActionListener(new ActionListener () {
				public void actionPerformed (ActionEvent e) {
					boolean b2 = !currentModel().getBoolean("UNSKINNED");
					currentModel().set("UNSKINNED", b2);
					if (b2) groupButton().setIcon(ImageCache.getImage("groupless.gif"));
					else groupButton().setIcon(ImageCache.getImage("group.gif"));
					selectedWindow().modelPane().reView();
				} // method
			}); // ActionListener
		} // end if
		return(groupButton);
	} // reader
	
	protected JButton addToLibraryButton = null;
	public JButton addToLibraryButton () {
		if (addToLibraryButton == null) {
			addToLibraryButton = new JButton(ImageCache.getImage("addToLibrary.gif"));
			addToLibraryButton.setToolTipText("Add My Stuff to My Library"); 
			addToLibraryButton.addActionListener(new ActionListener () {
				public void actionPerformed (ActionEvent e) {
					addToLibrary( currentModel(), ((PeerElement) selectedWindow().modelPane().selectedComponents().elementAt(0)).instance());
				} // method
			}); // ActionListener
		} // end if
		return(addToLibraryButton);
	} // reader
	
	protected JButton addGroupToLibraryButton = null;
	public JButton addGroupToLibraryButton () {
		if (addGroupToLibraryButton == null) {
			addGroupToLibraryButton = new JButton(ImageCache.getImage("addGroupToLibrary.gif"));
			addGroupToLibraryButton.setToolTipText("Add Selected Stuff to My Library"); 
			addGroupToLibraryButton.addActionListener(new ActionListener () {
				public void actionPerformed (ActionEvent e) {
					Vector stuff = new Vector();
					for ( Enumeration instances = selectedWindow().modelPane().selectedComponents().elements(); instances.hasMoreElements(); ) {
						stuff.addElement(((PeerElement) instances.nextElement()).instance());
					} // end for
					addToLibrary( currentModel(), stuff );
				} // method
			}); // ActionListener
		} // end if
		return(addGroupToLibraryButton);
	} // reader
	
	
	// Methods
	// -------------------------------------------------------------------------
	protected JFileChooser fileDialog = null;
	public JFileChooser fileDialog () {
		if (fileDialog == null) {
			fileDialog(new JFileChooser() {
				public void approveSelection() {
					boolean approve = false;
					String filename = getSelectedFile().getName();
					String suffix = "";
					String preferredSuffix = "";
					javax.swing.filechooser.FileFilter filter = getFileFilter();
					if (filter == modelFileFilter()) preferredSuffix = "." + VMODEL_SUFFIX;
					else if (filter == modelXMLFileFilter()) preferredSuffix = "." + XML_SUFFIX;
					else if (filter == jpgFileFilter()) preferredSuffix = "." + JPEG_SUFFIX;
					else if (filter == tifFileFilter()) preferredSuffix = "." + TIFF_SUFFIX;
					else if (filter == htmlFileFilter()) preferredSuffix = "." + HTML_SUFFIX;
					suffix = filename.substring(filename.length() - preferredSuffix.length(), filename.length());
					if (suffix.equalsIgnoreCase(preferredSuffix)) {
						if (!getApproveButtonText().equalsIgnoreCase("OPEN")) { // assume save dialog
							if (!getSelectedFile().exists()) approve = true;
							else approve = (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, "The file, " + filename + ", already exists.\n Do you want to overwrite it?", "Alert! File Exists", JOptionPane.YES_NO_OPTION));
						} else approve = true;
					} else {
						JOptionPane.showMessageDialog(null, "Your filename must end with " + preferredSuffix, "Alert! Improper Filename.", JOptionPane.ERROR_MESSAGE);
					} // end if preferredSuffix
					if (approve) super.approveSelection();
				} // method approveSelection
			}); // anonymous subclass
			fileDialog.setFileHidingEnabled(true);
			fileDialog.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
			fileDialog.setMultiSelectionEnabled(false);
		} // if fileDialog
		return(fileDialog);
	} // reader fileDialog
	public JFileChooser fileDialog (JFileChooser f) { return(fileDialog = f); }
	
	protected VModelFileFilter modelFileFilter = null;
	public VModelFileFilter modelFileFilter () {
		if (modelFileFilter == null) modelFileFilter(new VModelFileFilter(VMODEL_SUFFIX,"VModel File"));
		return(modelFileFilter);
	} // reader modelFileFilter
	public VModelFileFilter modelFileFilter (VModelFileFilter f) { return(modelFileFilter = f); }
	
	protected VModelFileFilter modelXMLFileFilter = null;
	public VModelFileFilter modelXMLFileFilter () {
		if (modelXMLFileFilter == null) modelXMLFileFilter = new VModelFileFilter(XML_SUFFIX,"VModel XML File");
		return(modelXMLFileFilter);
	} // reader 
	public VModelFileFilter modelXMLFileFilter (VModelFileFilter f) { return(modelXMLFileFilter = f); }
	
	protected VModelFileFilter jpgFileFilter = null;
	public VModelFileFilter jpgFileFilter () {
		if (jpgFileFilter == null) jpgFileFilter(new VModelFileFilter(JPEG_SUFFIX,"JPEG File"));
		return(jpgFileFilter);
	} // reader jpgFileFilter
	public VModelFileFilter jpgFileFilter (VModelFileFilter f) { return(jpgFileFilter = f); }
	
	protected VModelFileFilter tifFileFilter = null;
	public VModelFileFilter tifFileFilter () {
		if (tifFileFilter == null) tifFileFilter(new VModelFileFilter(TIFF_SUFFIX,"TIFF File"));
		return(tifFileFilter);
	} // reader tifFileFilter
	public VModelFileFilter tifFileFilter (VModelFileFilter f) { return(tifFileFilter = f); }
	
	protected VModelFileFilter bmpFileFilter = null;
	public VModelFileFilter bmpFileFilter () {
		if (bmpFileFilter == null) bmpFileFilter(new VModelFileFilter(BMP_SUFFIX,"BMP File"));
		return(bmpFileFilter);
	} // reader bmpFileFilter
	public VModelFileFilter bmpFileFilter (VModelFileFilter f) { return(bmpFileFilter = f); }
	
	protected VModelFileFilter pnmFileFilter = null;
	public VModelFileFilter pnmFileFilter () {
		if (pnmFileFilter == null) pnmFileFilter = new VModelFileFilter(PNM_SUFFIX,"PNM File");
		return(pnmFileFilter);
	} // reader 
	public VModelFileFilter pnmFileFilter (VModelFileFilter f) { return(pnmFileFilter = f); }
	
	protected VModelFileFilter htmlFileFilter = null;
	public VModelFileFilter htmlFileFilter () {
		if (htmlFileFilter == null) htmlFileFilter(new VModelFileFilter(HTML_SUFFIX,"HTML File"));
		return(htmlFileFilter);
	} // reader htmlFileFilter
	public VModelFileFilter htmlFileFilter (VModelFileFilter f) { return(htmlFileFilter = f); }
	
	protected VModelFileFilter cmlFileFilter = null;
	public VModelFileFilter cmlFileFilter () {
		if (cmlFileFilter == null) cmlFileFilter(new VModelFileFilter(CML_SUFFIX, "Compositional Modeling Language File"));
		return(cmlFileFilter);
	} // reader cmlFileFilter
	public VModelFileFilter cmlFileFilter (VModelFileFilter f) { return(cmlFileFilter = f); }
	
	// www.2020telescopes.com
	
	protected JDialog saveProgressDialog = null;
	protected JLabel saveProgressDialogLabel = null;
	protected JProgressBar saveProgressDialogBar = null;
	public JDialog saveProgressDialog ( ) {
		if (saveProgressDialog == null) {
			saveProgressDialog = new JDialog(frame(), "Save progress...", true );
			saveProgressDialog.getContentPane().setLayout(new BorderLayout( ) );
			saveProgressDialogLabel = new JLabel("Saving...");
			saveProgressDialog.getContentPane().add( saveProgressDialogLabel, BorderLayout.NORTH );
			saveProgressDialogBar = new JProgressBar(0,100);
			saveProgressDialog.getContentPane().add( saveProgressDialogBar, BorderLayout.CENTER );
			saveProgressDialog().setSize(200,100);
			saveProgressDialog().setLocation(QRGutils.center(frame.getSize(), saveProgressDialog().getSize()));
		} // end if
		return( saveProgressDialog );
	} // reader
	

	public int save () {
    	return(save(currentModel().getBoolean("SAVEDONCE")));
    } // method save

	int saveResult = -1;
	public int save (boolean savedB4) {
		int result = -1;
		saveProgressDialog();
		if (!savedB4) { 
			fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
			fileDialog.setDialogTitle("Save VModel File");
			fileDialog.setApproveButtonText("Save");
			String filename = currentModel().name();
//			if (! filename.toUpperCase().endsWith(".VMF")) filename = QRGutils.replaceExtension(filename, "vmf");
			filename = QRGutils.replaceExtension(filename, XML_SUFFIX);
			String dir = QRGutils.QRGuserpath() + MODELSPATH;
			final String filepath = dir + filename;
			File file = new File(filepath);
			Image pic = null;
			boolean loop = true;
			//fileDialog().setFileFilter(modelFileFilter());
			fileDialog().setFileFilter(modelXMLFileFilter());
			fileDialog().setSelectedFile(file);
			fileDialog().setCurrentDirectory(file);
			fileDialog().rescanCurrentDirectory();
			result = fileDialog().showDialog(frame(), null);
			if(result == JFileChooser.APPROVE_OPTION) {
				file = fileDialog.getSelectedFile();
				filename = file.getName();
				if(filename == null) {
					return(-1);
				} else {
					String filename2 = QRGutils.stripExtension(filename);
					dir = file.getParent() + QRGutils.QRGpathseparator();		// Changed from "/" (TRH)
					final String filepath2 = dir + filename;
					((ModelFrame) selectedWindow()).setTitle(filename);
					currentModel().name(filename2);
					currentModel().set("FILEPATH", filepath2);
					currentModel().set("FILE", filename);
					currentModel().set("PATH", dir);
		try {
			Thread t = new Thread() {
				public void run () {
					saveResult = (save(filepath2));
				} // method run
			}; // Anonymous Class Thread
			t.start();
			saveProgressDialog().setVisible(true);
		} catch (Exception err) {
			saveProgressDialog().setVisible(false);
			saveResult = -1;
		}
					return(saveResult);
				} // end if filename
			} else return(-1);
		}// if savedOnce
		try {
			Thread t = new Thread() {
				public void run () {
					saveResult = (save(currentModel().getString("FILEPATH")));
				} // method run
			}; // Anonymous Class Thread
			t.start();
			saveProgressDialog().setVisible(true);
		} catch (Exception err) {
			saveProgressDialog().setVisible(false);
			saveResult = -1;
		}
		return(saveResult);
	} // method save
	
	public int save (String filename) {
		saveProgressDialog();
		saveProgressDialogBar.setValue(0);
		saveProgressDialogLabel.setText("Saving " + currentModel().getString("FILE") + " ...");
		saveProgressDialog().setSize(saveProgressDialog().getMinimumSize());
		saveProgressDialog().setLocation(QRGutils.center(frame.getSize(), saveProgressDialog().getSize()));
		boolean tsavedOnce = currentModel().getBoolean("SAVEDONCE");
		int result = -1;
		currentModel().set("SAVEDONCE", true);
		((ModelFrame) selectedWindow()).setTitle(currentModel().getString("FILE"));
		currentModel().name(currentModel().getString("FILE"));
		((ModelFrame) selectedWindow()).dirty(false);
		currentModel().save(filename);
		saveProgressDialogBar.setValue(25);
		CMLio.save(QRGutils.replaceExtension(filename, CML_SUFFIX), currentModel());
//		XMLio.save(QRGutils.replaceExtension(filename, XML_SUFFIX), currentModel());
		saveProgressDialogBar.setValue(50);
		saveXML( filename );
		saveProgressDialogBar.setValue(75);
		myModels().removeAll();
		loadMyModels();
		saveProgressDialogBar.setValue(100);
		myLibrary().reload(myModels());
		result = 0;
		saveProgressDialog().setVisible(false);
		return(result);
	} // method save	

	public void saveXML (String filename) {
		Definition def = makeDefinition( currentModel( ) );
		XMLio.save(QRGutils.replaceExtension(filename, XML_SUFFIX), def);
	} // method save	

	public Model loadVMF () {
		fileDialog().setDialogType(JFileChooser.OPEN_DIALOG);
		fileDialog().setDialogTitle("Open VModel File");
		fileDialog().setApproveButtonText("Open");
		String filename = "";
		String dir = QRGutils.QRGuserpath() + MODELSPATH;
		String filepath = dir + filename;
		File file = new File(filepath);
		Image pic = null;
		int result = 0;
		boolean loop = true;
		fileDialog().setFileFilter(modelFileFilter());
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showDialog(frame(), null);
		if (result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			filename = file.getName();
			if(filename != null) {
				// Allow loading other formats (TRH)
				if (! filename.endsWith(".vmf") && ! filename.endsWith(".xml") && ! filename.endsWith(".cml"))
					filename = QRGutils.addExtension(filename, "vmf");
				dir = file.getParent() + QRGutils.QRGpathseparator();		// Changed from "/" (TRH)
				return(load(dir, filename));
			} // end if filename
		} // end APPROVED
		return(null);
	} // method

	public Model load () {
		return( loadXML() );
/*		
		fileDialog().setDialogType(JFileChooser.OPEN_DIALOG);
		fileDialog().setDialogTitle("Open VModel File");
		fileDialog().setApproveButtonText("Open");
		String filename = "";
		String dir = QRGutils.QRGuserpath() + MODELSPATH;
		String filepath = dir + filename;
		File file = new File(filepath);
		Image pic = null;
		int result = 0;
		boolean loop = true;
		fileDialog().setFileFilter(modelFileFilter());
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showDialog(frame(), null);
		if (result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			filename = file.getName();
			if(filename != null) {
				// Allow loading other formats (TRH)
				if (! filename.endsWith(".vmf") && ! filename.endsWith(".xml") && ! filename.endsWith(".cml"))
					filename = QRGutils.addExtension(filename, "vmf");
				dir = file.getParent() + QRGutils.QRGpathseparator();		// Changed from "/" (TRH)
				return(load(dir, filename));
			} // end if filename
		} // end APPROVED
		return(null);
*/
	} // method

	public Model load (String dir, String filename) {
		Model result = null;
		result = load(dir + filename);
		return(result);
	} // method

	public Model loadXML () {
		fileDialog().setDialogType(JFileChooser.OPEN_DIALOG);
		fileDialog().setDialogTitle("Open VModel XML File");
		fileDialog().setApproveButtonText("Open");
		String filename = "";
		String dir = QRGutils.QRGuserpath() + MODELSPATH;
		String filepath = dir + filename;
		File file = new File(filepath);
		Image pic = null;
		int result = 0;
		boolean loop = true;
		fileDialog().setFileFilter(modelXMLFileFilter());
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showDialog(frame(), null);
		if (result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			if ( file != null ) {
				filename = file.getName();
				if(filename != null) {
					if ((! filename.endsWith(".vmf")) && (! filename.endsWith(".xml")) && (! filename.endsWith(".cml")))
						filename = QRGutils.addExtension(filename, "xml");
					dir = file.getParent() + QRGutils.QRGpathseparator();		// Changed from "/" (TRH)
					return(load(dir, filename));
				} // end if filename
			} // end if file
		} // end APPROVED
		return(null);
	} // method

	// Added support for XML input (TRH)
	public Model load (String filepath) {
		Model result = null;
		if (filepath.endsWith(".vmf")) {
			result = (Model) Model.load(filepath);
			if (result != null){
				 result.set("SAVEDONCE", true);
				 add(result);
			} else QRGutils.beep();
		} else if (filepath.endsWith(".xml")) {
			Definition def = (Definition)XMLio.load(filepath);
			result = makeModel();
			result.plist(result.copyKeyValuePairs(def).plist());
			result.connections(new Vector()); 
			result.connectors(new Vector()); 
			result.removeKey(CHILDINSTANCES);
			result.removeKey(PARENTINSTANCES);
			result.removeKey(INPUTS);
			result.removeKey(OUTPUTS);
			result.removeKey(CAUSALINPUTS);
			result.removeKey(CAUSALOUTPUTS);
			addDefinition( result, def, 0, 0,false, false );
			result.set("SAVEDONCE", true);
		} // end if else
		// Do nothing for CML right now.
		return(result);
	} // method
	
	// Close
	// -----------------------------------------------------------------------
	public int closeAllModels () {
		JInternalFrame [ ] frames = desktop().getAllFrames();
		ModelFrame frame = null;
		for(int i = frames.length - 1; i >= 0; i--) {
			frame = (ModelFrame) frames[ i ];
			frame.select(true);
			if (closeModel(frame) == -1) return(-1);
		} // for i
		return(0);
	} // method close


	public int closeModel () {
		return(closeModel((ModelFrame) selectedWindow(), false));
	} // method close

	public int closeModel(ModelFrame frame, boolean aux) {
		int result = 0;
		if (aux) result = closeModelAux(frame);
		else result= closeModel(frame);
		return(result);
	} // method

	public int closeModel(ModelFrame frame) {
		final String [] options = { "Save", "Close", "Cancel" };
		int result = 0;
		Model model = (Model) frame.model();
		if (frame.dirty()) {
//			boolean continuep = (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, "The model, " + model.name() + ", has not been saved.\n Do you want to close it anyway?", "Alert! Model Not Saved.", JOptionPane.YES_NO_OPTION));
//			if (! continuep) result = -1;

			int choice = JOptionPane.showOptionDialog(null, "The model, " + model.name() + ", has not been saved.\n", "Alert! Model Not Saved.", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, ImageCache.getImage("coach-ml.gif"), options, options[0]); 
			if ( choice == 0 ) ((MacClassroom) controller()).save();
			else if ( choice == 2 ) result = -1;
		} // end if dirty
		if (result == 0) closeModelAux(frame);
		return(result);
	} // method closeModel
	
	public int closeModelAux(ModelFrame frame) {
		int result = 0;
		Model model = (Model) frame.model();
		VModelMenuBar.menuWindowModels().remove(frame.menuItem());
		frame.close();
		frame.dispose();
		if (desktop().getAllFrames().length == 0) {
			selectedWindow(null);
			currentModel(null);
			comboModel(null);
			openWindows().setModel(comboModel());
			openWindows.setRenderer(new ComboRenderer());
			frame.menuItem().doClick();
			if (! preferences().getBoolean("ALLOW-EMPTY-DESKTOP")) makeModel();
		} else {
			if (model == currentModel()) {
				((ModelFrame) desktop().getAllFrames()[ 0 ]).select(true);
			} // end if model
		} // end if size else
		repaint();
		if (desktop().getAllFrames().length > 0)
			((ModelFrame) desktop().getAllFrames()[ 0 ]).menuItem().setSelected(true);
		return(result);
	} // method closeModel
	
	// Methods
	// -------------------------------------------------------------------------
	// Load specified controller class
	protected ButtonGroup menuButtonGroup = null;
	public ButtonGroup menuButtonGroup () {
		if (menuButtonGroup == null) menuButtonGroup = new ButtonGroup();
		return(menuButtonGroup);
	} // method
	
	protected static int nextWindowLocationX = 10;
	protected static int nextWindowLocationY = 10;

	public Dimension nextWindowSize () {
		Dimension result = QRGutils.calcWindowSize(desktopScrollPane().getSize());
		return(result);
	} // method

	public Point nextWindowLocation () {
		Point result = new Point(nextWindowLocationX, nextWindowLocationY);
		int width = desktopScrollPane().getSize().width - 10 - nextWindowSize().width;
		int height = desktopScrollPane().getSize().height - 10 - nextWindowSize().height;
		nextWindowLocationX += 10;
		nextWindowLocationY += 10;
		if (nextWindowLocationX > width) nextWindowLocationX = 5;
		if (nextWindowLocationY > height) nextWindowLocationY = 5;
		return(result);
	} // method
	
	public void add (Model model) {
		ModelFrame window =  new ModelFrame(model);
		window.setLocation(nextWindowLocation());
		window.setSize(nextWindowSize());
		window.setPreferredSize(window.getSize());
		if (preferences().getBoolean("MAXIMIZE-NEW-MODELS")) {
			window.reshape(0, 0, desktop().getWidth(), desktop().getHeight());
		} // end if maximized
		window.setVisible(true);
		window.dirty(true);
		VModelMenuBar.menuWindowModels().add(window.menuItem());
		menuButtonGroup().add(window.menuItem());
		desktop().add(window);
		comboModel(null);
		openWindows().setModel(comboModel());
		window.menuItem().doClick();
	} // method
	
	public void tileModelFrames() {
		tileModelFrames(desktop().getAllFrames());
	} // method tileModelFrames

	public void tileModelFrames(Container frames[]) {
		int counter = frames.length;
		int rows = 0;
		int cols = 0;
		int extra = 0;
		int width = 0;
		int height = 0;
		int r = 0;
		int c = 0;
		int xoffset = 0;
		int yoffset = 0;
		int length = frames.length;
		int desktopheight = 0;
		JInternalFrame selectedFrame = null;
		for (int i = 0; i < length; i++) {
			if (((JInternalFrame)frames[i]).isSelected()) selectedFrame = (JInternalFrame) frames[i];
		} // for i
		rows = (int)Math.sqrt(counter);
		cols = counter/rows;
		extra = counter - rows * cols;
		if (extra != 0) {
			counter++;
			rows = (int)Math.sqrt(counter);
			cols = counter/rows;
			extra = counter - rows * cols;
		} // end if extra
		width = desktop().getWidth()/cols;
		desktopheight = desktop().getHeight();
		height = desktopheight/rows;
		for (int i = 0; i < length; i++) {
			if (width < ((JInternalFrame) frames[i]).getContentPane().getMinimumSize().width)
				width = ((JInternalFrame) frames[i]).getContentPane().getMinimumSize().width + 10;
			if (height < ((JInternalFrame) frames[i]).getMinimumSize().height)
				height = ((JInternalFrame) frames[i]).getMinimumSize().height + 32;
		} // for i
		for (int j = 0; j < length; j++) {
				try {
					((JInternalFrame)frames[j]).setMaximum(false);
					((JInternalFrame)frames[j]).setIcon(false);
					((JInternalFrame)frames[j]).reshape(c*width, r*height, width, height);
					r++;
					if (r == rows) {
						r = 0;
						c++;
						if (c == cols - extra) {
							rows++;
							height = desktopheight/rows;
						}
					}
				} catch (Exception pve) {
				pve.printStackTrace();
				}
		} // for j
		if (selectedFrame != null) {
			try {
				selectedFrame.show();
				selectedFrame.toFront();
				selectedFrame.setVisible(true);
				selectedFrame.setSelected(true);
			} catch (PropertyVetoException pve) {}
		} // end if
	} // method tileWindows

	public void cascadeModelFrames() { 
		cascadeModelFrames(desktop().getAllFrames());
	} // method cascadeModelFrames

	public void cascadeModelFrames(Container frames[]) {
		int fDistance = 20;
		int x = 10;
		int y = 10;
		int width = 0;
		int height = 0;
		int xoffset = 0;
		int yoffset = 0;
		int desktopheight = 0;
		int length = frames.length;
		width = desktop().getWidth()/2;
		desktopheight = desktop().getHeight();
		height = desktopheight/2;
		JInternalFrame selectedFrame = null;
		for (int i = 0; i < length; i++) {
			if (((JInternalFrame)frames[i]).isSelected()) selectedFrame = (JInternalFrame) frames[i];
			if (width < ((JInternalFrame) frames[i]).getContentPane().getMinimumSize().width)
				width = ((JInternalFrame) frames[i]).getContentPane().getMinimumSize().width + 10;
			if (height < ((JInternalFrame) frames[i]).getMinimumSize().height)
				height = ((JInternalFrame) frames[i]).getMinimumSize().height + 32;
		} // for i
		for (int i = frames.length - 1; i >= 0; i--) {
				try {
					((JInternalFrame)frames[i]).setMaximum(false);
					((JInternalFrame)frames[i]).setIcon(false);
					((JInternalFrame)frames[i]).reshape(xoffset + x,yoffset + y, width, height);
					x+=fDistance;
					y+=fDistance;
					if (x > width)
					x += - width;
					if (y > height)
					y += - height;
				} catch (Exception pve) {
					pve.printStackTrace();
				} // end try - catch
		} // for i
		if (selectedFrame != null) {
			try {
				selectedFrame.show();
				selectedFrame.toFront();
				selectedFrame.setVisible(true);
				selectedFrame.setSelected(true);
			} catch (PropertyVetoException pve) {}
		} // end if
	} // method cascadeWindows
	
	// Inner Classes
	// -------------------------------------------------------------------------
	public static class ComboModel implements VModelConstants, ComboBoxModel, ListModel {
		// ComboBoxModel
		public Object getSelectedItem() { 
			Object result = null;
			if (getSize() > 0) result = desktop().getAllFrames()[0];
			return(result);
		} // method
		
	 	public void setSelectedItem(Object anItem) { 
	 		if (anItem instanceof JInternalFrame) {
	 			JInternalFrame frame = (JInternalFrame) anItem;
		 		frame.toFront();
		 		try { 
		 			if (frame.isIcon()) frame.setIcon(false); 
		 			frame.setSelected(true);
		 			// Quick Test. Need to expand to whole rectangle test. 
		 			if (!desktopScrollPane().getViewport().getViewRect().contains(frame.getLocation()))
		 				desktopScrollPane().getViewport().setViewPosition(frame.getLocation());
		 		} catch (PropertyVetoException e) { }
		 	} // end if
	 	} // method

		// ListModel
		public void addListDataListener(ListDataListener l) { 
			listDataListeners().addElement(l);
		} // method

		public void removeListDataListener(ListDataListener l) { 
			listDataListeners().removeElement(l);
		} // method

		public Object getElementAt(int index) {
			Object result = null;
			if (index < getSize()) result = desktop().getAllFrames()[ index ];
			return(result);
		} // method

		public int getSize() {
			int result = desktop().getAllFrames().length;
			return(result);
		} // method
	} // innerclass

	public static class ComboRenderer extends JLabel implements ListCellRenderer {
		public ComboRenderer() {
			setOpaque(true);
		}

		public Component getListCellRendererComponent(
									JList list,
									Object value,
									int index,
									boolean isSelected,
									boolean cellHasFocus) {
			if (value != null) {
				setText(((JInternalFrame) value).getTitle());
				setIcon(((JInternalFrame) value).getFrameIcon());
			} // end if
			setBackground(isSelected ? Color.blue : Color.white);
			setForeground(isSelected ? Color.white : Color.black);
			return this;
		}
	}
	
	public void saveImage (String type) {
		fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
		fileDialog.setDialogTitle("Export TIFF File");
		fileDialog.setApproveButtonText("Export");
		String name = selectedModel().getString("NAME");
		String dir = QRGutils.QRGuserpath() + MODELSPATH;
		if (type == IMAGE_JPEG) {
			if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, JPEG_SUFFIX);
		} else if (type == IMAGE_TIFF) {	
			if (!name.toUpperCase().endsWith(".TIF")) name = QRGutils.replaceExtension(name, TIFF_SUFFIX);
		} else if (type == IMAGE_BMP) {	
			if (!name.toUpperCase().endsWith(".BMP")) name = QRGutils.replaceExtension(name, BMP_SUFFIX);
		} else if (type == IMAGE_PNM) {	
			if (!name.toUpperCase().endsWith(".PPM")) name = QRGutils.replaceExtension(name, PNM_SUFFIX);
		} else {	
			if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, JPEG_SUFFIX);
			type = IMAGE_JPEG;
		}
		String filepath = dir + name;
		File file = new File(filepath);
		int result = 0;
		fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
		fileDialog.setApproveButtonText("Export");
		if (type == IMAGE_JPEG) {
			fileDialog.setDialogTitle("Export VModel JPG Image File");
			fileDialog().setFileFilter(jpgFileFilter());
		} else if (type == IMAGE_TIFF) {
			fileDialog.setDialogTitle("Export VModel TIF Image File");
			fileDialog().setFileFilter(tifFileFilter());
		} else if (type == IMAGE_BMP) {
			fileDialog.setDialogTitle("Export VModel BMP Image File");
			fileDialog().setFileFilter(bmpFileFilter());
		} else if (type == IMAGE_PNM) {
			fileDialog.setDialogTitle("Export VModel PNM Image File");
			fileDialog().setFileFilter(pnmFileFilter());
		} else {
			fileDialog.setDialogTitle("Export VModel JPG Image File");
			fileDialog().setFileFilter(jpgFileFilter());
		} // end if type
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showDialog((Component) frame(), null);
		if(result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			name = file.getName();
			dir = file.getParent() + "/";
			if (name != null) {
				saveImage(type, dir + name);
			} // end if name
		} // end if APPROVED
	} // end method saveImage

	public void saveImage (String type, String name) {
		ModelPane modelpane = selectedWindow().modelPane();
		Model model = currentModel();
		modelpane.deselectAll();
		Dimension size = modelpane.viewpane().getSize();
		int width = 0;
		int height = 0;
		int minX = size.width;
		int minY = size.height;
		int maxX = 0;
		int maxY = 0;
		Point fpos = null;
		Dimension fsiz = null;
		int fsizW = 0;
		int fsizH = 0;
		Instance instance = null;
		PeerElement peer = null;
		for(Enumeration instances = model.instances().elements(); instances.hasMoreElements();) {
			instance = (Instance) instances.nextElement();
			peer = (PeerElement) instance.peer();
			if (peer.isVisible()) {
				fpos = peer.getLocation();
				fsiz = peer.getSize();
				fsizW = fsiz.width;
				fsizH = fsiz.height;
				minX = (int) Math.min(minX, fpos.x);
				minY = (int) Math.min(minY, fpos.y);
				maxX = (int) Math.max(maxX, fpos.x + fsizW);
				maxY = (int) Math.max(maxY, fpos.y + fsizH);
			} // end if
		} // end for
		if (model.instances().isEmpty()) {
			minX = minY = 0;
			maxX = PAGE_WIDTH;
			maxY = PAGE_HEIGHT;
			width = maxX - minX;
			height = maxY - minY;
		} else {
			width = maxX - minX;
			height = maxY - minY;
		} // end if
		Image img = modelpane.viewpane().createImage(width, height);
		Graphics ig = img.getGraphics();
		int result = 0;
		ig.translate(-minX, -minY);
		Color fi = modelpane.viewpane().getBackground();
		modelpane.viewpane().setBackground(WHITE);
		modelpane.viewpane().paint(ig);
		modelpane.viewpane().setBackground(fi);
		if (type == IMAGE_JPEG) {
			if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
			saveJPEG(img, name);
		} else if (type == IMAGE_TIFF) {	
			TIFF tiff = new TIFF();
			if (!name.toUpperCase().endsWith(".TIF")) name = QRGutils.replaceExtension(name, "tif");
			tiff.encode(img, name, tiff.RGB_COLOR);
		} else if (type == IMAGE_BMP) {
			if (!name.toUpperCase().endsWith(".BMP")) name = QRGutils.replaceExtension(name, "bmp");
			saveBMP(img, name);
		} else if (type == IMAGE_PNM) {
			PNM pnm = new PNM();
			if (!name.toUpperCase().endsWith(".ppm")) name = QRGutils.replaceExtension(name, "ppm");
			pnm.encode(img, name, pnm.P3);
		} else {	
			if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
			saveJPEG(img, name);
		}
	} // end method saveImage
	
    public void saveJPEG(Image pic, String filepath) {
	    try {
			JPGOptions fo = new JPGOptions();
			fo.setQuality(90);
			JimiWriter jw = Jimi.createJimiWriter(filepath);
			jw.setSource(pic);
			if (fo != null) {
				jw.setOptions(fo);
			}
			jw.putImage(filepath);
	    } catch (Exception ex) {
			QRGutils.warn("MacClassroom.saveJPEG", "IOException in saveJPEG()");
	    } // end try - catch
    }

    public void saveBMP(Image pic, String filepath) {
	    try {
			JimiWriter jw = Jimi.createJimiWriter(filepath);
			jw.setSource(pic);
			jw.putImage(filepath);
	    } catch (Exception ex) {
			QRGutils.warn("MacClassroom.saveBMP", "IOException in saveBMP()");
	    } // end try - catch
    }

	public void saveHTML () {
		selectedWindow().modelPane().deselectAll();
		selectedWindow().modelPane().reView();
		String name = selectedModel().name();
		String dir = QRGutils.QRGuserpath() + WEBSPATH;
		File file = new File(dir);
		file.mkdirs();
		if (!name.toUpperCase().endsWith(".HTM")) name = QRGutils.replaceExtension(name, "htm");
		String filepath = dir + name;
		file = new File(filepath);
		int result = 0;
		fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
		fileDialog.setApproveButtonText("Export");
		fileDialog.setDialogTitle("Export VModel as a Web Page");
		fileDialog().setFileFilter(htmlFileFilter());
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showSaveDialog((Component) frame());
		if(result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			name = file.getName();
			dir = file.getParent() + "/";
			if (name != null) {
				if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
				saveImage(IMAGE_JPEG, dir + name);
	
				try {
					String jpgname = name;
					name = QRGutils.replaceExtension(name, "htm");
				    FileWriter fw = new FileWriter(dir+name);
				    PrintWriter pw = new PrintWriter(fw);
				    pw.println("<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">");
				    pw.println("<HTML>");
				    pw.println(" <HEAD>");
			        pw.println("  <META NAME=\"Author\" CONTENT=\""+preferences().getString("NAME")+"\">");
				    pw.println("  <META NAME=\"Description\" CONTENT=\""+selectedModel().get("DESCRIPTION")+"\">");
			        pw.println("  <META NAME=\"KeyWords\" CONTENT=\"VModel, QRG, Northwestern University\">");
				    pw.println("  <TITLE>VModel "+name+"</TITLE>");
				    pw.println(" </HEAD>");
				    pw.println(" <BODY TEXT=\"#000000\" BGCOLOR=\"#A0B0C0\">");
				    pw.println("    <P><B>AUTHOR: </B>" + preferences().getString("USERNAME")+" <B>MODEL:</B> " + selectedModel().name()+"<P>");
				    pw.println("    <IMG SRC=\""+jpgname+"\" ALT=\"Picture of a VModel design.\" BORDER=\"2\"><BR><BR>");
				    pw.println("    <B>NOTES:</B><P ALIGN=\"JUSTIFY\">" + selectedModel().getString("NOTES")+"</P>");
				    pw.println("   <HR>");
				    pw.println(updateContextHelp());
				    pw.println(" </BODY>");
				    pw.println("</HTML>");
				    pw.close();
				    fw.close();
					browser().setTitle("VModel ");
					browser().setSize(800,600);
					browser().setLocation(QRGutils.center(browser().getSize()));
					browser().gotoPage(dir, name);
				} // try
				catch (Exception e) {
				    QRGutils.debug("VModelGUI", "saveHTML Error: \n" + e);
				    e.printStackTrace();
				}
	
			} // end if name
		} // end if APPROVED
	} // end method saveImage

	public String updateContextHelp() {
		Model model = currentModel();
		int mode = model.getInt(MODE);
		String coachImage = "";
		String text = "";
		URL coachURL = null;
		if (mode == 0) {
			if (model.bugs().isEmpty() && (! model.getString("PROBLEM_STATEMENT").equalsIgnoreCase(""))) coachImage = "coach-t-h-l.gif";
			else if ((model.bugs().size() < model.instances().size()) || (model.getString("PROBLEM_STATEMENT").equalsIgnoreCase(""))) coachImage = "coach-t-c-l.gif";
			else coachImage = "coach-t-a-l.gif";
			File file = null;
			try {
				String sep = QRGutils.QRGpathseparator();
				file = new File(QRGutils.makeQRGpath("resources" +sep + "icons" + sep + coachImage));
				coachURL = QRGutils.fileToURL(file);	// toURL is java 1.2
			} catch(Exception e) { 
				QRGutils.debug("Couldn't make url for " + file);
			}
			text += "<P><IMG src=\"" + coachURL + "\"><B><FONT COLOR=BLUE>The Target Coach thinks before modeling.</FONT></B><BR>";
			
			text += "<H2>Model Target</H2>";
			if (! model.getString("PROBLEM_STATEMENT").equalsIgnoreCase("")) text += model.getString("PROBLEM_STATEMENT");
			else text += "<FONT COLOR=RED><B>You have not entered a Problem Statement yet.</B></FONT>";
		} else if (model.getInt(MODE) == 1) {
			if (model.bugs().isEmpty()) coachImage = "coach-b-h-l.gif";
			else if ((!model.bugs().isEmpty()) && (model.bugs().size() >= model.instances().size())) coachImage = "coach-b-a-l.gif";
			else coachImage = "coach-b-c-l.gif";
			try {
				String[] pathToCoachImage = {"resources", "icons", coachImage };
				File file = new File(QRGutils.makeQRGpath(pathToCoachImage) );
				coachURL = QRGutils.fileToURL(file);	// toURL is java 1.2
			} catch(Exception e) { }
			text += "<P><IMG src=\"" + coachURL + "\"><B><FONT COLOR=BLUE>The Builder examines your links.</FONT></B>";

			text += "<H2>Model Target</H2>";
			if (! model.getString("PROBLEM_STATEMENT").equalsIgnoreCase("")) text += model.getString("PROBLEM_STATEMENT");
			else text += "<FONT COLOR=RED><B>You have not entered a Problem Statement yet.</B></FONT>";

			text += "<H2>Selected Modeling Elements</H2>";
			if (selectedWindow().modelPane().selectedComponents().size() > 0) {
				PeerElement peer = null;
				for(Enumeration instances = selectedWindow().modelPane().selectedComponents().elements(); instances.hasMoreElements();) {
					peer = (PeerElement) instances.nextElement();
					text += "<P><B>You have selected the " + peer.typeName() + " named " + peer.name() + ".</B><UL>";
					if (peer.typep("Thing")) text += "<LI>" + peer.name() + " is a Thing.</LI>";
					if (peer.typep("Multiple Thing")) text += "<LI>" + peer.name() + " is a Multiple Thing.</LI>";
					if (peer.typep("Substance")) text += "<LI>" + peer.name() + " is a Substance.</LI>";
					if (peer.typep("Process")) text += "<LI>" + peer.name() + " is a Process.</LI>";
					if (peer.typep("Measurable")) text += "<LI>" + peer.name() + " is a Measurable.</LI>";
					if (peer.typep(RELATIONSHIP)) text += "<LI>" + peer.name() + " is a relationship.</LI>";
					if (peer.typep(CAUSALRELATIONSHIP)) text += "<LI>" + peer.name() + " is a causal relationship.</LI>";
					if (peer.typep(CONSTRAINTRELATIONSHIP)) text += "<LI>" + peer.name() + " is a comparer relationship.</LI>";
					if (peer.typep(ATTRIBUTE) || peer.typep(PROCESSRATE)) {
						if ((! peer.predictedState().equalsIgnoreCase(UNKNOWN)) && (! peer.predictedState().equalsIgnoreCase(""))) { 
							if (peer.predictedState().equalsIgnoreCase(INCREASING)) text += "<LI>You predicted that this " + peer.typeName()+" is increasing.</LI>";
							if (peer.predictedState().equalsIgnoreCase(DECREASING)) text += "<LI>You predicted that this " + peer.typeName()+" is decreasing.</LI>";
							if (peer.predictedState().equalsIgnoreCase(CONSTANT)) text += "<LI>You predicted that this " + peer.typeName()+" is not changing.</LI>";
						} // end if
						if (peer.isAssumption()) { 
							if (peer.state().equalsIgnoreCase(INCREASING)) text += "<LI>You have assumed that this " + peer.typeName()+" is increasing.</LI>";
							if (peer.state().equalsIgnoreCase(DECREASING)) text += "<LI>You have assumed that this " + peer.typeName()+" is decreasing.</LI>";
							if (peer.state().equalsIgnoreCase(CONSTANT)) text += "<LI>You have assumed that this " + peer.typeName()+" is not changing.</LI>";
						} // end if
					} // end if
//					peer.instance().checkInstance();
					if (peer.getVector("PROBLEMS").size() > 0) {
						text += "<LI><FONT COLOR=RED>" + peer.name() + " has the following problems: </FONT><UL>";
						String err = null;
						String msg = null;
						for(Enumeration problems = peer.getVector("PROBLEMS").elements(); problems.hasMoreElements();) {
							err = (String) problems.nextElement();
							msg = (String) problems.nextElement();
							text += "<LI>" + msg + "</LI>";
						} // end for
						text += "</UL></LI>";
					}
					text += "</UL>";
				} // end for
			} else text += "<FONT COLOR=BLUE><B>You have not selected anything for the builder to think about.</B></FONT>";

			text += "<H2>Model Check</H2>";
			if (model.instances().isEmpty()) text += "<FONT COLOR=RED><B>You have not added any modeling elements to your model.</B></FONT>";
			else if (model.bugs().isEmpty()) text += "<FONT COLOR=GREEN><B>The Builder can find no problems with your model.</B></FONT>";
			else {
//QRGutils.debug("MacClassroom.updateContextHelp", "model.problems=" + model.problems2() );			
				for( Enumeration problems = model.problems2().elements(); problems.hasMoreElements(); ) {
					String errnum = (String) problems.nextElement();
					String errmsg = (String) problems.nextElement();
					text += "<FONT COLOR=RED><B>" +  errmsg + "</B></FONT><BR><BR>";
				} // end for
//				if (!model.checkModel(Model.CHECKPROCESS, false)) text += "<FONT COLOR=RED><B>This model can't be analyzed because it isn't complete.  You must have at least one process in your model.</B></FONT><BR><BR>";
//				if (!model.checkModel(Model.CHECKINFLUENCE, false)) text += "<FONT COLOR=RED><B>This model can't be analyzed because it isn't complete.  You must have at least one increases or decreases in your model.</B></FONT><BR><BR>";
				Vector item = null;
				Vector bugVector = null;
				String id = null;
				Instance instance = null;
				Vector errlist = null;
				String err = null;
				String message = null;
				Object bugObject = null;
				URL icon = null;
				for(Enumeration items = model.bugs().elements(); items.hasMoreElements();) {
					item = (Vector) items.nextElement();
					bugObject = item.elementAt(0);
					bugVector = (Vector) item.elementAt(1);
//					id = (String) item.elementAt(0);
//					instance = model.findInstance(id);
					if (bugObject instanceof Instance) instance = (Instance) bugObject;
					else {
//QRGutils.debug("MacClassroom.updateContextHelp", "item=" + item);
//QRGutils.debug("MacClassroom.updateContextHelp", "bugVector=" + bugVector);
						continue;
					}
					if (instance != null) {
						try {
							String[] pathToInstanceIcon = {"resources", "icons", instance.icon() };
							File file = new File(QRGutils.makeQRGpath(pathToInstanceIcon));
							icon = QRGutils.fileToURL(file);	// toURL is java 1.2
						} catch(Exception e) { }
						if (! instance.typep(RELATIONSHIP)) text += "<FONT COLOR=RED><IMG src=\"" + icon + "\"><B>" + instance.typeName() + "</B> " + instance.name() + "</FONT><UL>";
						else {
							Instance inp = model.findInstance(instance.input());
							Instance out = model.findInstance(instance.output());
							String inpS = "(nothing)";
							String outS = "(nothing)";
							if (inp != null) inpS = inp.name();
							if (out != null) outS = out.name();
							text += "<FONT COLOR=RED><IMG src=\"" + icon + "\">" + inpS + " <B>" + instance.typeName() + "</B> " + outS + "</FONT><UL>";
						} // end if
						for(int index = 0; index < bugVector.size(); index+=2) {
							err = (String) bugVector.elementAt(index);
							message = (String) bugVector.elementAt(index + 1);
							text += "<LI>" + message + "</LI>";
						} // end for
						text += "</UL>";
					} // end if
				} // end for
			} // end if
		} else {
			if (model.bugs().isEmpty()) coachImage = "coach-e-h-l.gif";
			else if (model.bugs().size() < model.instances().size()) coachImage = "coach-e-c-l.gif";
			else coachImage = "coach-e-a-l.gif";
			try {
				String[] pathToCoachImage = { "resources", "icons", coachImage };
				File file = new File(QRGutils.makeQRGpath(pathToCoachImage));
				coachURL = QRGutils.fileToURL(file);	// toURL is java 1.2
			} catch(Exception e) { }
			text += "<P><IMG src=\"" + coachURL + "\"><B><FONT COLOR=BLUE>The Professor analyzes your work.</FONT></B>";

			text += "<H2>Model Target</H2>";
			if (! model.getString("PROBLEM_STATEMENT").equalsIgnoreCase("")) text += model.getString("PROBLEM_STATEMENT");
			else text += "<FONT COLOR=RED><B>You have not entered a Problem Statement yet.</B></FONT>";

			text += "<H2>Selected Modeling Elements</H2>";
			if (selectedWindow().modelPane().selectedComponents().size() > 0) {
				PeerElement peer = null;
				for(Enumeration instances = selectedWindow().modelPane().selectedComponents().elements(); instances.hasMoreElements();) {
					peer = (PeerElement) instances.nextElement();
					text += "<P><B>You have selected the " + peer.typeName() + " named " + peer.name() + ".</B><UL>";
					if (peer.typep("Thing")) text += "<LI>" + peer.name() + " is a Thing.</LI>";
					if (peer.typep("Multiple Thing")) text += "<LI>" + peer.name() + " is a Multiple Thing.</LI>";
					if (peer.typep("Substance")) text += "<LI>" + peer.name() + " is a Substance.</LI>";
					if (peer.typep("Process")) text += "<LI>" + peer.name() + " is a Process.</LI>";
					if (peer.typep("Measurable")) text += "<LI>" + peer.name() + " is a Measurable.</LI>";
					if (peer.typep(RELATIONSHIP)) text += "<LI>" + peer.name() + " is a relationship.</LI>";
					if (peer.typep(CAUSALRELATIONSHIP)) text += "<LI>" + peer.name() + " is a causal relationship.</LI>";
					if (peer.typep(CONSTRAINTRELATIONSHIP)) text += "<LI>" + peer.name() + " is a comparer relationship.</LI>";
					if (peer.typep(ATTRIBUTE) || peer.typep(PROCESSRATE)) {
						if ((! peer.predictedState().equalsIgnoreCase(UNKNOWN)) && (! peer.predictedState().equalsIgnoreCase(""))) { 
							if (peer.predictedState().equalsIgnoreCase(INCREASING)) text += "<LI>You predicted that this " + peer.typeName()+" is increasing.</LI>";
							if (peer.predictedState().equalsIgnoreCase(DECREASING)) text += "<LI>You predicted that this " + peer.typeName()+" is decreasing.</LI>";
							if (peer.predictedState().equalsIgnoreCase(CONSTANT)) text += "<LI>You predicted that this " + peer.typeName()+" is not changing.</LI>";
						} // end if
						if (peer.isAssumption()) { 
							if (peer.state().equalsIgnoreCase(INCREASING)) text += "<LI>You have assumed that this " + peer.typeName()+" is increasing.</LI>";
							if (peer.state().equalsIgnoreCase(DECREASING)) text += "<LI>You have assumed that this " + peer.typeName()+" is decreasing.</LI>";
							if (peer.state().equalsIgnoreCase(CONSTANT)) text += "<LI>You have assumed that this " + peer.typeName()+" is not changing.</LI>";
						} // end if
						if (mode == 2) { 
							if (peer.state().equalsIgnoreCase(INCREASING)) text += "<LI>After Simulation this " + peer.typeName()+" is increasing.</LI>";
							if (peer.state().equalsIgnoreCase(DECREASING)) text += "<LI>After Simulation this " + peer.typeName()+" is decreasing.</LI>";
							if (peer.state().equalsIgnoreCase(CONSTANT)) text += "<LI>After Simulation this " + peer.typeName()+" is not changing.</LI>";
							if (peer.state().equalsIgnoreCase(UNKNOWN)) text += "<LI>After Simulation this " + peer.typeName()+" is unknown.</LI>";
							if (peer.state().equalsIgnoreCase(CONTRADICTION)) text += "<LI>I can't see how this " + peer.typeName()+" is changing because there are multiple arrows going into it that would change it in opposite directions. Fix this by making an arrow stronger or by making an assumption (right click).</LI>";
							if (peer.state().equalsIgnoreCase(DEFAULT)) text += "<LI>I can't see how this " + peer.typeName()+" is changing because either no arrows go into it, or there is an influence from a parameter that I can't figure out.</LI>";
							if ((! peer.predictedState().equalsIgnoreCase(UNKNOWN)) && (! peer.predictedState().equalsIgnoreCase(""))) {
								if (!peer.predictedState().equalsIgnoreCase(peer.state())) text += "<LI><FONT COLOR=RED><B>Your prediction " + peer.predictedState() + " does not match the results!</B></FONT></LI>"; 
								else text += "<LI><FONT COLOR=GREEN><B>Your prediction matches the results!</B></FONT></LI>"; 
							} // end if
						} // end if
					} // end if
//					peer.instance().checkInstance();
					if (peer.getVector("PROBLEMS").size() > 0) {
						text += "<LI><FONT COLOR=RED>" + peer.name() + " has the following problems: </FONT><UL>";
						String err = null;
						String msg = null;
						for(Enumeration problems = peer.getVector("PROBLEMS").elements(); problems.hasMoreElements();) {
							err = (String) problems.nextElement();
							msg = (String) problems.nextElement();
							text += "<LI>" + msg + "</LI>";
						} // end for
						text += "</UL></LI>";
					}
					text += "</UL>";
				} // end for
			} else text += "<FONT COLOR=BLUE><B>You have not selected anything for the builder to think about.</B></FONT>";

			text += "<H2>Model Summary</H2>";
			text += modelSummary(model); // "<FONT COLOR=RED><B>NOT YET IMPLEMENTED.</B></FONT>";
			
			text += "<H2>Model Check</H2>";
			if (model.instances().isEmpty()) text += "<FONT COLOR=RED><B>You have not added any modeling elements to your model.</B></FONT>";
			else if (model.bugs().isEmpty()) text += "<FONT COLOR=GREEN><B>The Professor can find no problems with your model.</B></FONT>";
			else {
//QRGutils.debug("MacClassroom.updateContextHelp", "model.problems=" + model.problems2() );			
				for( Enumeration problems = model.problems2().elements(); problems.hasMoreElements(); ) {
					String errnum = (String) problems.nextElement();
					String errmsg = (String) problems.nextElement();
					text += "<FONT COLOR=RED><B>" +  errmsg + "</B></FONT><BR><BR>";
				} // end for
//				if (!model.checkModel(Model.CHECKPROCESS, false)) text += "<FONT COLOR=RED><B>This model can't be analyzed because it isn't complete.  You must have at least one process in your model.</B></FONT><BR><BR>";
//				if (!model.checkModel(Model.CHECKINFLUENCE, false)) text += "<FONT COLOR=RED><B>This model can't be analyzed because it isn't complete.  You must have at least one increases or decreases in your model.</B></FONT><BR><BR>";
				Vector item = null;
				Vector bugVector = null;
				String id = null;
				Instance instance = null;
				Vector errlist = null;
				String err = null;
				String message = null;
				Object bugObject = null;
				URL icon = null;
				for(Enumeration items = model.bugs().elements(); items.hasMoreElements();) {
					item = (Vector) items.nextElement();
					bugObject = item.elementAt(0);
					bugVector = (Vector) item.elementAt(1);
//					id = (String) item.elementAt(0);
//					instance = model.findInstance(id);
					if (bugObject instanceof Instance) instance = (Instance) bugObject;
					else {
//QRGutils.debug("MacClassroom.updateContextHelp", "item=" + item);
//QRGutils.debug("MacClassroom.updateContextHelp", "bugVector=" + bugVector);
						continue;
					}
					if (instance != null) {
						try {
							String[] pathToInstanceIcon = {"resources", "icons", instance.icon() };
							File file = new File(QRGutils.makeQRGpath(pathToInstanceIcon));
							icon = QRGutils.fileToURL(file);	// TRH
						} catch(Exception e) { }
						if (! instance.typep(RELATIONSHIP)) text += "<FONT COLOR=RED><IMG src=\"" + icon + "\"><B>" + instance.typeName() + "</B> " + instance.name() + "</FONT><UL>";
						else {
							Instance inp = model.findInstance(instance.input());
							Instance out = model.findInstance(instance.output());
							String inpS = "(nothing)";
							String outS = "(nothing)";
							if (inp != null) inpS = inp.name();
							if (out != null) outS = out.name();
							text += "<FONT COLOR=RED><IMG src=\"" + icon + "\">" + inpS + " <B>" + instance.typeName() + "</B> " + outS + "</FONT><UL>";
						} // end if
						for(int index = 0; index < bugVector.size(); index+=2) {
							err = (String) bugVector.elementAt(index);
							message = (String) bugVector.elementAt(index + 1);
							text += "<LI>" + message + "</LI>";
						} // end for
						text += "</UL>";
					} // end if
				} // end for
			} // end if
		} // end if
		return(text);
	} // method

	public String modelSummary (Model model) {
		String result = "";
		Vector quantities = new Vector();
		Instance instance = null;
		Instance inp = null;
		Vector directInfluences = new Vector();
		Vector indirectInfluences = new Vector();
		Vector directlyInfluenced = new Vector();
		Vector indirectlyInfluenced = new Vector();
		Vector attributes = new Vector();
		Vector mumble = new Vector();
		result += "<UL>";
		for(Enumeration instances = model.instances().elements(); instances.hasMoreElements();) {
			inp = (Instance) instances.nextElement();
			if (inp.typep(PROCESS)) {
				result += "<LI>There is the process of " + inp.name();
				if ( ! inp.causalOutputs().isEmpty() ) {
					result += " which ";
					for ( Enumeration stuff = inp.causalOutputs().elements( ); stuff.hasMoreElements(); ) {
						instance = (Instance) stuff.nextElement();
						if ( instance.typep( DIRECTINFLUENCE ) ) {
							result += traceCauses(model, instance);
						} // end if
					} // end for
				} // end if
				result += "</LI>";
			} 
		} // end for
		result += "</UL>";
		return(result);
	} // method
	
	public String traceCauses (Model model, Instance relationship) {
		return( traceCauses(model, relationship, new Vector( ) ) );
	} // method

	public String traceCauses (Model model, Instance relationship, Vector visited) {
		String result = "";
		if (relationship.typep(REQUIRES)) return(result);
		Instance input = (Instance) model.findInstance(relationship.input());
		Instance output = (Instance) model.findInstance(relationship.output());
		Instance candidate = null;
		String mumble = "";
		if (input != null) {
			if (output != null) {
//				output.set(CAUSALCOUNT, (output.getInt(CAUSALCOUNT) + 1));
//				if (output.getInt(CAUSALCOUNT) == output.causalInputs().size()) {
					if ( output.typep( PROCESSRATE ) ) result += "<LI><B>"+relationship.name()+"</B> the rate of " + output.name();
					else result += "<LI><B>"+relationship.name()+"</B> the " + output.name();
					if ( ! output.parentInstances().isEmpty() ) {
						result += " of " + ( (Instance) output.parentInstances().elementAt( 0 ) ).name();
					} // end if
					result += " that is ";
					if ( (output.reasons().elementAt(0) instanceof String) && (((String) output.reasons().elementAt(0)).equals(USERASSUMPTION))) result += " assumed to be ";
					result += output.state();
					if ((! output.typep( PROCESSRATE ) ) && ( !output.causalOutputs().isEmpty() )) {
						boolean p = false;
						// result += " and which " + "<UL>";
						for(Enumeration enum = output.causalOutputs().elements(); enum.hasMoreElements();) {
							candidate = (Instance) enum.nextElement();
	//						mumble = (String) enum.nextElement();
	//						candidate = model.findInstance(mumble);
							if ((candidate != null) && (!visited.contains(candidate))) {
								visited.addElement( candidate );
								if ( !p ) { result += " and which " + "<UL>"; p = true; }
								result += traceCauses(model, candidate, visited);
							} // end if
						} // end for
						result += "</UL>";
					} // end if
					result += "</LI>";
//				} // end if
			} // end if
		} // end if
		return(result);
	} // method
	
	// VModel Methods
	// -------------------------------------------------------------------------
	// Start Controller
	public void go () {
		// Create external frame window.
		frame(new JFrame());
		frame().setVisible(false);
		frame().addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				if ( quit() ) {
					frame().dispose();
					System.exit( 0 );
				} else frame().setVisible(true);
			} // method windowClosing
		}); // addWindowListener
		frame().setIconImage(icon());
		frame().setTitle("" + QRGutils.projectName() + " v" + QRGutils.projectVersion());
		frame().setSize(QRGutils.calcWindowSize());
		frame().setLocation(QRGutils.center(QRGutils.calcWindowSize()));
		frame().setDefaultCloseOperation( JFrame.DO_NOTHING_ON_CLOSE );
//		frame().addKeyListener(frameKeyAdapter());

		// load graphics
		loadImages();
		
		// build modeler panel
		// from modeler
		// -------------------------------------------------------------------
		// Add SplitPane
		topleftpanel(new JPanel(new BorderLayout()));
		toprightpanel(new JPanel(new FlowLayout(FlowLayout.RIGHT)));
		toppanel(new JPanel(new BorderLayout()));

		toolbar().add(newModelButton());
		toolbar().add(openButton());
		toolbar().addSeparator();
		toolbar().add(saveButton());
		toolbar().add(saveasButton());
		toolbar().addSeparator();
		toolbar().add(printButton());
		toolbar().add(printPreviewButton());
		toolbar().addSeparator();
		toolbar().add(notesButton());
		toolbar().addSeparator();
		toolbar().add(groupButton());
		toolbar().addSeparator();
		toolbar().add(undoButton());
		toolbar().add(redoButton());
		toolbar().addSeparator();
		toolbar().add(selectButton());
		toolbar().addSeparator();
		toolbar().add(deleteButton());
		toolbar().addSeparator();
		toolbar().add(copyButton());
		toolbar().add(cutButton());
		toolbar().add(pasteButton());
		toolbar().addSeparator();
		toolbar().add(addToLibraryButton());
		toolbar().add(addGroupToLibraryButton());
		toolbar2().add(new JLabel("Selected Window: "));
		toolbar2().add(openWindows());
		topleftpanel().add(toolbar2(), BorderLayout.NORTH);
		topleftpanel().add(toolbar(), BorderLayout.SOUTH);
		toppanel().add(coachButton(), BorderLayout.EAST);
		toppanel().add(topleftpanel(), BorderLayout.CENTER);
		modeler().add(toppanel(), BorderLayout.NORTH);
		desktopScrollPane().setBorder(new EtchedBorder());
		JViewport fubar = new JViewport();
		fubar.setView(desktop());
		desktopScrollPane().setViewportView(desktop());
		
		desktop().setDesktopManager(new DefaultDesktopManager() {
			public void endDraggingFrame(JComponent f)  {
				JInternalFrame[] frames = desktop().getAllFrames();
				JInternalFrame jif = null;
				Point fpos = f.getLocation();
				Dimension fsiz = f.getSize();
				double fsizW = fsiz.width;
				double fsizH = fsiz.height;
				Dimension vsiz = desktopScrollPane().getViewport().getSize();
				double vsizW = vsiz.width;
				double vsizH = vsiz.height;
				Point vp = desktopScrollPane().getViewport().getViewPosition();
				int minX = (int) Math.min(vp.x, fpos.x);
				int minY = (int) Math.min(vp.y, fpos.y);
				int maxX = (int) Math.max(vsizW, fpos.x + fsizW);
				int maxY = (int) Math.max(vsizH, fpos.y + fsizH);
				
				for(int i = 0; i < frames.length; i++) {
					jif = frames[i];
					fpos = jif.getLocation();
					fsiz = jif.getSize();
					fsizW = fsiz.width;
					fsizH = fsiz.height;
					minX = (int) Math.min(minX, fpos.x);
					minY = (int) Math.min(minY, fpos.y);
					maxX = (int) Math.max(maxX, fpos.x + fsizW);
					maxY = (int) Math.max(maxY, fpos.y + fsizH);
				} // end for
				
				int w = maxX - minX;
				int h = maxY - minY;
				
				desktop().setSize(w,h);
				desktop().setPreferredSize(desktop().getSize());
				
				for(int i = 0; i < frames.length; i++) {
					jif = frames[i];
					fpos = jif.getLocation();
					jif.setLocation(fpos.x - minX, fpos.y);
				} // end for
				vp.translate(- minX, 0); 

				for(int i = 0; i < frames.length; i++) {
					jif = frames[i];
					fpos = jif.getLocation();
					jif.setLocation(fpos.x, fpos.y - minY);
				} // end for
				vp.translate(0, - minY); 

				desktopScrollPane().setAutoscrolls(false);
				desktopScrollPane().doLayout();
			} });

		modeler().add(desktopScrollPane(), BorderLayout.CENTER);

		// Add SplitPane
		sidepanel(new VModelSidePanel());
		modeler().setMinimumSize(new Dimension(0,100));
		sidepanel().setMinimumSize(new Dimension(0,100));
		splitpane().setLeftComponent(modeler());
		splitpane().setRightComponent(sidepanel());
		frame().getContentPane().add(splitpane(), BorderLayout.CENTER);
		
		// Add StatusBar
		frame().getContentPane().add(statusbar(), BorderLayout.SOUTH);
		
		// Add Menubar
		frame().setJMenuBar(menubar());
		
		if (!classModels().isLeaf()) sidepanel().add(classModels());
		if (!vModels().isLeaf()) sidepanel().add(vModels());

//		splitpane().setDividerLocation(frame().getSize().width - splitpane().getRightComponent().getMinimumSize().width - splitpane().getDividerSize() - 10);
		splitpane().setDividerLocation(frame().getSize().width - 200);
		splitpane().getRightComponent().doLayout();
		
		sidepanel().addCoachPanel("Ask Doc V.", coachAskPanel());
		
		keyAdapterInit();
		
		frame().setVisible(false);
		
				doLogin();

		updateWidgets();
	} // method go

	public void keyAdapterInit ( ) {
		JComponent contentPane = ((JComponent) frame().getContentPane());
		if ( QRGutils.javaVersionD() > 1.2 ) {
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (currentModel() != null) delete(true);
					else QRGutils.beep();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_DELETE, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					help();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_F1, 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					shortcutHelp();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_F1, java.awt.Event.SHIFT_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					quit();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_F4, java.awt.Event.META_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					quit();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_F4, java.awt.Event.CTRL_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					QRGutils.beep();
					QRGutils.warn("", "There is no escape from VModel!");
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_ESCAPE, /* java.awt.Event.CTRL_MASK */ 0), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);

			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					quit();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_Q, java.awt.Event.CTRL_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					quit();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_Q, java.awt.Event.META_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					load();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_O, java.awt.Event.CTRL_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					load();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_O, java.awt.Event.META_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					makeModel();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_N, java.awt.Event.CTRL_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					makeModel();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_N, java.awt.Event.META_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (currentModel() != null) save();
					else QRGutils.beep();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_S, java.awt.Event.CTRL_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (currentModel() != null) save();
					else QRGutils.beep();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_S, java.awt.Event.META_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (currentModel() != null) undoButton().doClick();
					else QRGutils.beep();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_Z, java.awt.Event.CTRL_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (currentModel() != null) undoButton().doClick();
					else QRGutils.beep();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_Z, java.awt.Event.META_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (currentModel() != null) redoButton().doClick();
					else QRGutils.beep();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_Z, java.awt.Event.CTRL_MASK | java.awt.Event.SHIFT_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			contentPane.registerKeyboardAction(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (currentModel() != null) redoButton().doClick();
					else QRGutils.beep();
				} // end if
			}, KeyStroke.getKeyStroke((char) KeyEvent.VK_Z, java.awt.Event.META_MASK | java.awt.Event.SHIFT_MASK), JComponent.WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);
			
		} else {
//			frame().getContentPane().addKeyListener( frameKeyAdapter( ) );
			frame().addKeyListener( frameKeyAdapter( ) );
		} // end if else
	} // method

	protected FrameKeyAdapter frameKeyAdapter = null;
	public FrameKeyAdapter frameKeyAdapter () { 
		if (frameKeyAdapter == null) frameKeyAdapter = new FrameKeyAdapter();
		return(frameKeyAdapter); 
	} // reader
	
	public class FrameKeyAdapter extends KeyAdapter {
		public void keyPressed(KeyEvent e) {
			if (e.getKeyCode() == e.VK_DELETE) {
				if (currentModel() != null) delete(true);
				else QRGutils.beep();
			} // end if
			if (e.getKeyCode() == e.VK_F1) {
				if ( e.isShiftDown() ) shortcutHelp();
				else help();
			} // end if
			if (e.getKeyCode() == e.VK_F4) {
				if ( e.isMetaDown() || e.isControlDown() ) quit();
			} // end if
			if (e.getKeyCode() == e.VK_ESCAPE) {
				QRGutils.beep();
				QRGutils.warn("", "There is no escape from VModel!!");
			} // end if
			if (e.getKeyCode() == e.VK_Q) {
				if ( e.isMetaDown() || e.isControlDown() ) quit();
			} // end if
			if (e.getKeyCode() == e.VK_O) {
				if ( e.isMetaDown() || e.isControlDown() ) load();
			} // end if
			if (e.getKeyCode() == e.VK_N) {
				if ( e.isMetaDown() || e.isControlDown() ) makeModel();
			} // end if
			if (e.getKeyCode() == e.VK_S) {
				if ( e.isMetaDown() || e.isControlDown() ) {
					if (currentModel() != null) save();
					else QRGutils.beep();
				} // end if
			} // end if
			if (e.getKeyCode() == e.VK_Z) {
				if ( e.isMetaDown() || e.isControlDown() ) {
					if ( e.isShiftDown() ) {
						if (currentModel() != null) redoButton().doClick();
						else QRGutils.beep();
					} else {
						if (currentModel() != null) undoButton().doClick();
						else QRGutils.beep();
					} // end if
				} // end if
			} // end if
		} // method
	} // innerclass
		
	// Quit Program
	public boolean quit () {
		boolean result = false;
		if ( closeAllModels() == 0 ) {
			frame().setVisible(false);
			preferences().saveLocalPrefs();
			myProcesses().save("myProcesses");
			myEntities().save("myEntities");
			myThings().save("myThings");
			myMultipleThings().save("myMultipleThings");
			mySubstances().save("mySubstances");
			myAttributes().save("myAttributes");
			ImageCache.dumpImages("ImageDump.java");
			frame().dispose();
			result = super.quit();
		} // end if
		return(result);
	} // method quit
	
	public Definition clipboard = null;
	
	public void copy () {
		PeerElement peer = null;
		Instance instance = null;
		Instance clone = null;
		Instance original = null;
		Instance duplicate = null;
		Instance source = null;
		Instance destination = null;
		Instance foo = null;
		Vector instances = new Vector();
		Vector mumble = null;
		Vector grumble = null;
		clipboard = new Definition();
		for(Enumeration peers = selectedWindow().modelPane().selectedComponents().elements(); peers.hasMoreElements();) {
			peer = (PeerElement) peers.nextElement();
			if ( peer.typep( ENTITY ) ) {
//				for ( Enumeration outps = peer.causalOutputs().elements( ); outps.hasMoreElements(); ) {
				for ( Enumeration outps = peer.outputs().elements( ); outps.hasMoreElements(); ) {
					instance = currentModel().findInstance((String) outps.nextElement());
//					instance = (Instance) outps.nextElement();
					if ((instance != null) && instance.typep(STRUCTURE) && instance.getBoolean("HIDDEN") && (!instance.output().equals(""))) {
						Instance out = currentModel().findInstance(instance.output());
						if (( out != null ) && (selectedWindow().modelPane().selectedComponents().contains(out.peer()))) {
							foo = instance;
							instance = new Instance(instance);
							instance.removeKey(OUTPUT);
							instance.removeKey(OUTPUTS);
							instance.removeKey(CAUSALOUTPUTS);
							instance.removeKey(INPUT);
							instance.removeKey(INPUTS);
							instance.removeKey(CAUSALINPUTS);
							instance.connectors().removeAllElements();
							instance.connections().removeAllElements();
							clipboard.add(instance);
							mumble = new Vector();
							mumble.addElement(foo);
							mumble.addElement(instance);
							instances.addElement(mumble);
						} // end if
					} // end if
				} // end for
			} // end if
			instance = new Instance(peer.instance());
			instance.removeKey(OUTPUT);
			instance.removeKey(OUTPUTS);
			instance.removeKey(CAUSALOUTPUTS);
			instance.removeKey(INPUT);
			instance.removeKey(INPUTS);
			instance.removeKey(CAUSALINPUTS);
			instance.connectors().removeAllElements();
			instance.connections().removeAllElements();
			clipboard.add(instance);
			mumble = new Vector();
			mumble.addElement(peer.instance());
			mumble.addElement(instance);
			instances.addElement(mumble);
		} // end for
		for(Enumeration list = instances.elements(); list.hasMoreElements();) {
			mumble = (Vector) list.nextElement();
			original = (Instance) mumble.elementAt(0);
			duplicate = (Instance) mumble.elementAt(1);
			if (original.typep(RELATIONSHIP)) {
				source = null;
				destination = null;
				for(Enumeration list2 = instances.elements(); list2.hasMoreElements();) {
					grumble = (Vector) list2.nextElement();
					instance = (Instance) grumble.elementAt(0);
					clone = (Instance) grumble.elementAt(1);
					if (instance.id().equalsIgnoreCase(original.input())) source = clone;
					if (instance.id().equalsIgnoreCase(original.output())) destination = clone;
				} // end for
				if ((source != null) || (destination != null)) {
					connect(duplicate, source, destination);
				} // end if
			} // end if
		} // end for
		clipboard.set("model-id", currentModel().id());
		clipboard.set("model-name", currentModel().name());
		clipboard.set("model-author", currentModel().getString("USERID"));
		copyButton().setEnabled(true);
		updateWidgets();
	} // method
	
	public void cut () {
		copy();
		delete(true);
	} // method
	
	public Vector paste () {
		Vector bumble = null;
		Vector humble = null;
		Vector connects = new Vector();
		int offset = clipboard.getInt("OFFSET") + 25;
		if (offset > 125) offset = 5 - offset;
		clipboard.set("OFFSET", offset);
		Vector instances = addDefinition(currentModel(), clipboard);
		Instance instance = null;
		PeerElement peer = null;
		((ModelFrame) selectedWindow()).modelPane().deselectAll();
		for(Enumeration list = instances.elements(); list.hasMoreElements();) {
			instance = (Instance) list.nextElement();
			peer = (PeerElement) instance.peer();
			((ModelFrame) selectedWindow()).modelPane().componentpane().add((Component) peer);
			peer.setVisible(true);
			peer.setPosition(offset + instance.getInt("X-OFFSET"), offset + instance.getInt("Y-OFFSET"));
			if (instance.typep(RELATIONSHIP)) {
				peer.orientation(instance.getInt("ORIENTATION"));
				humble = new Vector();
				humble.addElement(instance.id());
				humble.addElement(instance.input());
				humble.addElement(instance.output());
				connects.addElement(humble);
			} // end if
			((ModelFrame) selectedWindow()).modelPane().select(peer, true);
		} // end for
		Vector undoArgs = new Vector();
		Definition clipcopy =  new Definition(clipboard) ;
		undoArgs.addElement(clipcopy);
		undoArgs.addElement(instances);
		undoArgs.addElement(connects);
		undoArgs.addElement(new Integer(offset));
		((ModelFrame) selectedWindow()).modelPane().doAction(ModelPane.Action.PASTE, undoArgs);
		currentModel().log("PASTE", "Paste from " + clipboard.getString("model-id") + " :: " + clipboard.getString("model-id") + " :: " + clipboard.getString("model-author") + " instances=" + instances);
		updateWidgets();
		return(instances);
	} // method
	
	// Models
	// --------------------------------------------------------------------------
	public Model makeModel () {
		Model result = super.makeModel(true);
		add(result);
		updateWidgets();
		result.set("USERID", preferences().getString("USERID"));
		result.set("USERNAME", preferences().getString("USERNAME"));
		result.set("USERMAIL", preferences().getString("userEmail"));
		if (result != null) result.log("makeModel", "Model Created");
		return(result);
	} // method

	
	public Definition makeDefinition (Model model, Instance source) {
		Definition result = null;
		PeerElement peer = (PeerElement) source.peer( );
		for(Enumeration enum = source.childInstances().elements(); enum.hasMoreElements();) {
			Instance child = (Instance) enum.nextElement();
			PeerElement childPeer = (PeerElement) child.peer( );
			if (childPeer != null) {
				child.set("X", (childPeer.getX() - peer.getX()));
				child.set("Y", (childPeer.getY() - peer.getY()));
			} // end if
		} // end for
		result = super.makeDefinition(model, source);
		return(result);
	} // method

	public Vector addDefinition (Model model, Definition definition, int clickX, int clickY, boolean clearSelectedElement, boolean undop) {
		Vector result = addDefinition(model, definition);
		Instance instance = (Instance) result.elementAt(0);
		PeerElement peer = (PeerElement) instance.peer();
		String grrr = "";
		Instance childpeer = null;
		JComponent component = peer;
		component.setVisible(false);
		peer.scale(((ModelFrame) selectedWindow()).modelPane().scale());
		((ModelFrame) selectedWindow()).modelPane().componentpane().add(component);
		peer.setPosition(clickX, clickY);
		component.setVisible(true);
		for(Enumeration enum = peer.childInstances().elements(); enum.hasMoreElements();) {
			childpeer = (Instance) enum.nextElement();
			grrr = childpeer.id();
			if (childpeer != null) {
				((ModelFrame) selectedWindow()).modelPane().componentpane().add((Component) childpeer.peer());
				((Component) childpeer.peer()).setVisible(true);
				((PeerElement) childpeer.peer()).setPosition(clickX + childpeer.getInt("X"), clickY + childpeer.getInt("Y"));
			} // end if
		} // end for
		if (clearSelectedElement) {
			Librarian.selectedTree().clearSelection();
			Librarian.selectedDefinition(null);
		} // end if
		model.set("uncertaincoachstate", true);
		updateCoachButton();
//		instance.update(true, true, false);
		if (undop) {		
			Vector undoArgs = new Vector();
			undoArgs.addElement(definition);
			undoArgs.addElement(instance);
			undoArgs.addElement(new Integer(clickX));
			undoArgs.addElement(new Integer(clickY));
			undoArgs.addElement(peer);
			undoArgs.addElement(result);
			((ModelFrame) selectedWindow()).modelPane().doAction(ModelPane.Action.ADD, undoArgs);
		} // end if
		return(result);
	} // method


	// Instances
	// ----------------------------------------------------------------------
	public Instance makeInstance (Instance prototype) { return(super.makeInstance(prototype)); }
	public Instance makeInstance (Model model, Instance prototype) {
		Instance result = super.makeInstance(model, prototype);
		if (result.typep(ENTITY) && (result.findKey("SKINNED") == null)) result.set("SKINNED", true);
		result.peer(makePeer(model, result));
		return(result);
	} // method
	
	public Peer makePeer(Model model, Instance instance) {
		PeerElement result = new PeerElement(model, instance);
		double s = model.getDouble("SCALE");
		if (s == 0.0) s = 1.0;
		result.scale(s);
		result.setLocation( instance.getInt("X-OFFSET"), instance.getInt("Y-OFFSET") );
		result.setVisible( !instance.getBoolean("HIDDEN") );
		if (result.typep(RELATIONSHIP)) {
			if ( result.get( "ORIENTATION" ) != null ) result.orientation(result.getInt("ORIENTATION"));
			else result.orientation(result.getInt("ROTATION"));
		} // end if
		selectedWindow().modelPane().componentpane().add(result);
		return(result);
	} // method
	
	public void addInstance (Model model, Instance instance) { 
		super.addInstance(model, instance); 
		if ((selectedWindow() != null) && (instance.peer() != null)) {
			selectedWindow().modelPane().componentpane().add((PeerElement) instance.peer());
			selectedWindow.modelPane().repaint();
			instance.update( false, false, true );
//			instance.updatePeer();
		} // end if
	} // method
	public void addInstance (Model model, Vector instanceVector) { super.addInstance(model, instanceVector); }
	public void removeInstance (Model model, Instance instance) { 
		((ModelFrame) selectedWindow()).modelPane().select((PeerElement) instance.peer(), false);
		((ModelFrame) selectedWindow()).modelPane().componentpane().remove((PeerElement) instance.peer());
		((ModelFrame) selectedWindow()).modelPane().repaint();
		super.removeInstance(model, instance); 
	} // method
	public void removeInstance (Model model, Vector instanceVector) { super.removeInstance(model, instanceVector); }
	public void delete (boolean undop) {
		Vector instances = new Vector();
		Vector connects = new Vector();
		Vector relationships = new Vector();
		Vector mumble = null;
		Vector grumble = null;
		Instance bumble = null;
		PeerElement peer = null;
		Instance instance = null;
		Model model = null;
		for(Enumeration enum  = ((ModelFrame) selectedWindow()).modelPane().selectedComponents().elements(); enum.hasMoreElements();) {
			peer = (PeerElement) enum.nextElement();
			instances.addElement(peer.instance());
		} // end for
		for(Enumeration enum2  = instances.elements(); enum2.hasMoreElements();) {
			instance = (Instance) enum2.nextElement();
			if ( instance.typep( ENTITY )) {
				for (Enumeration stuff = instance.outputs( ).elements( ); stuff.hasMoreElements();  ) {
					bumble = (Instance) currentModel( ).findInstance( (String) stuff.nextElement() );
					if ( bumble.typep( HASATTRIBUTE ) ) instances.addElement(bumble);
				} // end for
			} // end if
		} // end for
		for(Enumeration enum2  = instances.elements(); enum2.hasMoreElements();) {
			instance = (Instance) enum2.nextElement();
			model = instance.model();
			peer = (PeerElement) instance.peer();
			if (instance.typep(RELATIONSHIP) && (! relationships.contains(instance)))  relationships.addElement(instance);
			for(Enumeration inps = instance.inputs().elements(); inps.hasMoreElements();) {
				bumble = model.findInstance((String) inps.nextElement());
				if ((bumble != null) && (! relationships.contains(bumble))) relationships.addElement(bumble);
			} // end for
			if (! instance.typep(RELATIONSHIP))  {
				for(Enumeration outps = instance.outputs().elements(); outps.hasMoreElements();) {
					bumble = model.findInstance((String) outps.nextElement());
					if ((bumble != null) && (! relationships.contains(bumble))) relationships.addElement(bumble);
				} // end for
			} // end if
			((ModelFrame) selectedWindow()).modelPane().select(peer, false);
			peer.setVisible(false);
			((ModelFrame) selectedWindow()).modelPane().componentpane().remove(peer);
		} // end for
		for(Enumeration rels = relationships.elements(); rels.hasMoreElements();) {
			bumble = (Instance) rels.nextElement();
			mumble = new Vector();
			mumble.addElement(bumble.id());
			mumble.addElement(bumble.input());
			mumble.addElement(bumble.output());
			connects.addElement(mumble);
		} // end for
		removeInstance(currentModel(), instances);
		if (undop) {		
			Vector undoArgs = new Vector();
			undoArgs.addElement(instances);
			undoArgs.addElement(connects);
			selectedWindow().modelPane().doAction(ModelPane.Action.REMOVE, undoArgs);
		} // end if
		updateWidgets();
	} // method
	
	public void rename (Model model, Instance instance, String name, boolean logp) { 
		super.rename(model, instance, name, logp); 
		instance.update( false, false, true );
//		instance.updatePeer();
	} // method
	
	// Simulation
	// ----------------------------------------------------------------------
	public void resetState (Model model) { super.resetState(model); }
		
/*		
	public boolean simulate (Model model) {
		boolean result = super.simulate(model);
		Instance instance = null;
		for(Enumeration instances = model.instances().elements(); instances.hasMoreElements();) {
			instance = (Instance) instances.nextElement();
			if (instance.peer() != null) ((PeerElement) instance.peer()).updatePeer();
		} // end for
		return(result);
	} // method
*/
	
	public void updatePeers (Model model) { 
		super.updatePeers(model);
	}// method
	
	public void rechildProcess ( Model model, Instance process ) {
		for(Enumeration enum = process.childInstances().elements(); enum.hasMoreElements();) {
			Instance r = (Instance) enum.nextElement();
			if (r.typep(DIRECTINFLUENCE)) {
				Instance out = model.findInstance(r.output());
				if ( ( out != null ) && out.typep( QUANTITY ) &&  (!out.parentInstances().isEmpty())) {
					Instance entity = (Instance) out.parentInstances().elementAt(0);
					process.addChild( entity );
				} // end if
			} else if (r.typep(RATE) ) { // ick!
				for(Enumeration enum2 = r.causalOutputs().elements(); enum2.hasMoreElements();) {
					Instance r2 = (Instance) enum2.nextElement();
					if (r2.typep(DIRECTINFLUENCE)) {
						process.addChild(r2);
						Instance out = model.findInstance(r2.output());
						if ( ( out != null ) && out.typep( QUANTITY ) &&  (!out.parentInstances().isEmpty())) {
							Instance entity = (Instance) out.parentInstances().elementAt(0);
							process.addChild( entity );
						} // end if
					} // end if
				} // end for
			} // end if
		} // end for
	} // method

	public Instance connect (Model model, Instance relationship, Instance source, Instance target) {
		Instance result = null;
		// 1. remove Children
		Instance mumble = null;
		if ((relationship.input() != null) && (! relationship.input().equalsIgnoreCase(""))) {
			mumble = model.findInstance(relationship.input());
			if (mumble != null) {
				if (relationship.typep(DIRECTINFLUENCE) && mumble.typep(PROCESS)) {
					mumble.removeChild(relationship);
					mumble.removeChild(model.findInstance(relationship.output()));
					Instance out = model.findInstance(relationship.output());
					if ( ( out != null ) && out.typep( QUANTITY ) &&  (!out.parentInstances().isEmpty())) {
						Instance entity = (Instance) out.parentInstances().elementAt(0);
						mumble.removeChild( entity );
					} // end if
					rechildProcess(model, mumble);
				} // end if
			} else QRGutils.debug("MacClassroom.connect", "Could not find input during disconnect. input=" + relationship.input());
		} // end if
		if ((relationship.output() != null) && (! relationship.output().equalsIgnoreCase(""))) {
			mumble = model.findInstance(relationship.output());
			if (mumble != null) {
			} else QRGutils.debug("MacClassroom.connect", "Could not find output during disconnect. output=" + relationship.output());
		} // end if
		if (relationship.typep(INDIRECTINFLUENCE) && (!relationship.parentInstances().isEmpty()) ) {
			Instance e1 = (Instance) relationship.parentInstances().elementAt(0);
			e1.removeChild(relationship);
		} // end if
		// 2. add Children
		if (relationship.typep(HASATTRIBUTE) && (source != null) && source.typep(PROCESS) && (target != null) && target.typep(RATE)) {
			for(Enumeration enum = target.causalOutputs().elements(); enum.hasMoreElements();) {
				Instance r = (Instance) enum.nextElement();
				if (r.typep(DIRECTINFLUENCE)) {
					source.addChild(r);
					Instance out = model.findInstance(r.output());
					if ( ( out != null ) && out.typep( QUANTITY ) &&  (!out.parentInstances().isEmpty())) {
						Instance entity = (Instance) out.parentInstances().elementAt(0);
						source.addChild( entity );
					} // end if
				} // end if
			} // end for
		} // end if
		if (relationship.typep(HASATTRIBUTE) && (source != null) && source.typep(ENTITY) && (target != null) && target.typep(QUANTITY)) {
			for(Enumeration enum = target.causalInputs().elements(); enum.hasMoreElements();) {
				Instance r = (Instance) model.findInstance((String)enum.nextElement());
				if ((r!=null) && r.typep(DIRECTINFLUENCE)) {
					source.addChild(r);
					Instance out = model.findInstance(r.output());
					if ( ( out != null ) && out.typep( QUANTITY ) &&  (!out.parentInstances().isEmpty())) {
						Instance entity = (Instance) out.parentInstances().elementAt(0);
						source.addChild( entity );
					} // end if
				} // end if
			} // end for
		} // end if
/*		
		if (relationship.typep(DIRECTINFLUENCE) && (source != null)) {
			if (source.typep(PROCESS)) {
				source.addChild(relationship);
				if ( ( target != null ) && target.typep( QUANTITY ) &&  (!target.parentInstances().isEmpty())) {
					Instance entity = (Instance) target.parentInstances().elementAt(0);
					source.addChild( entity );
				} // end if
			} else if (source.typep(RATE) && (!source.parentInstances().isEmpty())) {
				Instance process = (Instance) source.parentInstances().elementAt(0);
				process.addChild(relationship);
				if ( ( target != null ) && target.typep( QUANTITY ) &&  (!target.parentInstances().isEmpty())) {
					Instance entity = (Instance) target.parentInstances().elementAt(0);
					process.addChild( entity );
				} // end if
			} // end if
		} // end if
*/		
		if (relationship.typep(INDIRECTINFLUENCE) && 
				(source != null) && source.typep(QUANTITY) && (!source.parentInstances().isEmpty()) &&
				(target != null) && target.typep(QUANTITY) && (!target.parentInstances().isEmpty()) ) {
			Instance e1 = (Instance) source.parentInstances().elementAt(0);
			Instance e2 = (Instance) target.parentInstances().elementAt(0);
			if ( e1 == e2 ) e1.addChild( relationship );
			else {
				Instance e3 = null;
				if (!e1.parentInstances().isEmpty()) e3 = (Instance) e1.parentInstances().elementAt(0);
				Instance e4 = null;
				if (!e2.parentInstances().isEmpty()) e4 = (Instance) e2.parentInstances().elementAt(0);
				if (e1 == e4) e1.addChild( relationship );
				else if (e2 == e3) e2.addChild( relationship );
				else if ((e4 != null) && (e4 == e3)) e4.addChild( relationship );
			} // end if
		} // end if
		// 3. connect
		result = super.connect( model, relationship, source, target );
//		relationship.update( true, true, true );
		if ( source != null ) {
//			source.update( true, true, true );
		} // end if
		if ( target != null ) {
//			target.update( true, true, true );
		} // end if
		model.set("uncertaincoachstate", true);
		updateCoachButton();
		return( result );
	} // method

	public Instance connect (Model model, Definition relationship, Instance independent, Instance dependent, int x, int y, int orientation, boolean undop) {
		Vector result = (Vector) addDefinition(model, relationship, x, y, true, false);
		Instance instance = (Instance) result.elementAt(0);
		PeerElement peerElement = (PeerElement) instance.peer();
		boolean flip_p = false;
		orientation = peerElement.orientation(orientation);
		if (relationship.typep(HASATTRIBUTE)) {
			if ((! independent.typep(ENTITY)) &&
					(dependent.typep(ENTITY))) {
				Instance foo = independent;
				independent = dependent;
				dependent = foo;
				flip_p = true;
			} // end if
		} else if (relationship.typep(HASPARTICIPANT)) {
			if ((! independent.typep(PROCESS)) &&
					(dependent.typep(PROCESS))) {
				Instance foo = independent;
				independent = dependent;
				dependent = foo;
				flip_p = true;
			} // end if
		} else if (relationship.typep(PARTICIPATESIN)) {
			if ((independent.typep(PROCESS)) &&
					(! dependent.typep(PROCESS))) {
				Instance foo = independent;
				independent = dependent;
				dependent = foo;
				flip_p = true;
			} // end if
		} // end if

		connect(model, instance, independent, dependent);

/*		
		peerElement.orientation(orientation);		
		peerElement.positionMarkers();
*/		
		if (flip_p) {
			QRGutils.beep();
			((PeerElement) instance.peer()).flip();
		} // end if
/*		
		Librarian.selectedTree().clearSelection();
		Librarian.selectedDefinition(null);
*/
//		selectedWindow().modelPane().deselectAll();

		if (undop) {		
			Vector undoArgs = new Vector();
			undoArgs.addElement(relationship);
			undoArgs.addElement(instance);
			undoArgs.addElement(peerElement);
			undoArgs.addElement(independent);
			undoArgs.addElement(dependent);
			undoArgs.addElement(new Integer(x));
			undoArgs.addElement(new Integer(y));
			undoArgs.addElement(new Integer(orientation));
			selectedWindow().modelPane().doAction(ModelPane.Action.ADDCONNECT, undoArgs);
		} // end if
		return(instance);
	} // method


	public void about ( ) {
		browser().setTitle("About " + QRGutils.projectName() + " v" + QRGutils.projectVersion());
		browser().setSize(340,400);
		browser().setLocation(QRGutils.center(browser().getSize()));
		browser().gotoPage(QRGutils.QRGroot() + HELPPATH, "about.html");
	} // method
	
	public void help ( ) {
		browser().setTitle("VModel Help");
		browser().setSize(800,600);
		browser().setLocation(QRGutils.center(browser().getSize()));
		browser().gotoPage(QRGutils.QRGroot() + HELPPATH, "index.htm");
	} // method

	public void shortcutHelp ( ) {
		browser().setTitle("VModel Help");
		browser().setSize(800,600);
		browser().setLocation(QRGutils.center(browser().getSize()));
		browser().gotoPage(QRGutils.QRGroot() + HELPPATH, "keys.htm");
	} // method
	
	public void refresh ( ) {
		Runnable doStuff = new Runnable() {
			public void run () {
//				if (currentModel() != null) updatePeers(currentModel());
				if (selectedWindow()!=null) selectedWindow().modelPane().drawpane().repaint();
			} };
		SwingUtilities.invokeLater(doStuff);
	} // method

	public boolean simulate (Model model) {
		boolean result = false;
		if ( checkModel( model, Model.CHECKGRAMMAR, true ) ) {
			for( Enumeration instances = model.instances().elements(); instances.hasMoreElements(); ) {
				((Instance) instances.nextElement()).set("HIGHLIGHTED", false);
			} // end for
			refresh();
//				if (currentModel() != null) updatePeers(currentModel());
//				if (selectedWindow()!=null) selectedWindow().modelPane().repaint();
			result = super.simulate(model);
			refresh();
		} // end if
		try { Thread.sleep(2000); }
		catch(Exception e) { QRGutils.debug( "MacClassroom.getEffect", "not sleeping"); QRGutils.debugStackTrace( e ); }
		if (result && preferences().getBoolean("SOUND") && model.bugs().isEmpty()) SoundCache.playSound("CLAP.au");
		else if (result && preferences().getBoolean("SOUND") && (!model.bugs().isEmpty())) SoundCache.playSound("sci_fi_gun.au");
		else if (preferences().getBoolean("SOUND")) SoundCache.playSound("Aww.au");
		updateWidgets();
		return(result);
	} // method

	public void finalizeState ( Instance attribute, String state ) {
			String prediction =  attribute.predictedState();
			if (( !prediction.equals("")) && ( !prediction.equalsIgnoreCase(UNKNOWN))) {
				if ( prediction.equalsIgnoreCase( state) ) {
					if (preferences().getBoolean("SOUND")) SoundCache.playSound("CHEER.au");
				} else {
					if (preferences().getBoolean("SOUND")) SoundCache.playSound("Buzzer.au");
				} // end if
			} else {
//				if (preferences().getBoolean("SOUND")) SoundCache.playSound("computer.au");
				if (preferences().getBoolean("SOUND")) SoundCache.playSound("mumble.au");
			} // end if
			try { Thread.sleep(500); }
			catch(Exception e) { QRGutils.debug( "MacClassroom.getEffect", "not sleeping"); QRGutils.debugStackTrace( e ); }
		refresh();
	} // method

	public String getEffect (Model model, Instance instance) {
		String result = super.getEffect( model, instance );
		Instance relationship = instance;
		Instance inputInstance = model.findInstance(instance.input());
		Instance outputInstance = model.findInstance(instance.output());
		if ( outputInstance != null ) {
				if (preferences().getBoolean("SOUND")) SoundCache.playSound("mumble.au");
			if (inputInstance != null) inputInstance.set("HIGHLIGHTED", true);
		refresh();
			try { Thread.sleep(500); }
			catch(Exception e) { QRGutils.debug( "MacClassroom.getEffect", "not sleeping"); QRGutils.debugStackTrace( e ); }
			relationship.set("HIGHLIGHTED", true);
		refresh();
			try { Thread.sleep(500); }
			catch(Exception e) { QRGutils.debug( "MacClassroom.getEffect", "not sleeping"); QRGutils.debugStackTrace( e ); }
			String prediction =  outputInstance.predictedState();
			outputInstance.set("HIGHLIGHTED", true);
		refresh();
			try { Thread.sleep(500); }
			catch(Exception e) { QRGutils.debug( "MacClassroom.getEffect", "not sleeping"); QRGutils.debugStackTrace( e ); }
		} // end if
		return(result);
	} // method

	public Definition addToLibrary (Model model, Instance instance) {
		Definition result = super.addToLibrary(model, instance);
		if ( result != null ) {
			result.set("ONTDELETABLE", true);
			result.set("NOONTHELP", true);
			Ontology ontology = null;
			if (instance.typep(PROCESS)) ontology = myProcesses();
			else if (instance.typep("SUBSTANCE")) ontology = mySubstances();
			else if (instance.typep("MULTIPLETHING")) ontology = myMultipleThings();
			else if (instance.typep("THING")) ontology = myThings();
			else if (instance.typep(ENTITY)) ontology = myEntities();
			else if (instance.typep(MODEL)) ontology = myModels();
			else if (instance.typep(ATTRIBUTE)) ontology = myAttributes();
			else ontology = myLibrary();
			if (ontology != null ) {
				myLibrary().reload( ontology );
				Librarian.expandTree( Librarian.selectedTree() );			
				Librarian.expandTree( Librarian.libraryJTree() );			
			} // end if
		} // end if
		return(result);
	} // method

	public Definition addToLibrary (Model model, Vector stuff) {
		Definition result = null;
		String name = JOptionPane.showInputDialog("What should I call this stuff in the Library?");
		if ( name != null ) {
			result = super.addToLibrary(model, stuff);
			result.name(name);
			if ( result != null ) {
				result.set("ONTDELETABLE", true);
				result.set("NOONTHELP", true);
				Ontology ontology = myEntities();
				if (ontology != null ) {
					myLibrary().reload( ontology );
					Librarian.expandTree( Librarian.selectedTree() );			
					Librarian.expandTree( Librarian.libraryJTree() );			
				} // end if
			} // end if
		} else QRGutils.beep();
		return(result);
	} // method
	
	public static boolean simRunning = false;
	public synchronized void runSimulation ( Model model ) {
	if ( simRunning ) return;
	simRunning = true;
	final MouseInputAdapter listen = new MouseInputAdapter() {
			public void mousePressed ( MouseEvent e ) {
				QRGutils.beep();
			} // method
			public void mouseReleased ( MouseEvent e ) {
				QRGutils.beep();
			} // method
			public void mouseClicked ( MouseEvent e ) {
				QRGutils.beep();
			} // method
		};
	final Model m = model;
		try {
			Thread t = new Thread() {
				public void run () {
					frame().getGlassPane().setVisible( true );
					frame().getGlassPane().requestFocus( );
					frame().getGlassPane().addMouseListener(listen);
					simulate(m);
					frame().getGlassPane().removeMouseListener(listen);
					frame().getGlassPane().setVisible( false );
					selectedWindow().modelPane().updateContextHelp();
					updateWidgets();
				} // method run
			}; // Anonymous Class Thread
			t.start();
		} catch (Exception err) {}
	simRunning = false;
	} // method

} // class

// -----------------------------------------------------------------------------
// End of File: MacClassroom.java       (c) 2001 Northwestern University