package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import java.awt.*;
import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.lang.Cloneable;
import java.lang.Object;
import java.util.EventListener;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/gui
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: VModelSidePanel.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: VModelSidePanel
* Purpose: Side panel for Project, Ontology, and Coach panes.
* ----------------------------------------------------------------------------
* </PRE> */
public class VModelSidePanel extends JPanel implements VModelConstants {
	public Controller controller () { return((Controller) VModel.controller()); }

	// Constructors
	// -----------------------------------------------------------------------
	public VModelSidePanel () {
		super();
		
		setMinimumSize(new Dimension(100, 100));
		
		setBackground(DARKGREY);
		
		ButtonGroup buttongroup = new ButtonGroup();
		
		toolbar().setLayout(new GridLayout(1, 3));
		toolbar().setBackground(DARKGREY);
		toolbar().setFloatable(false);
		
		librarian().libraryButton().addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
					JToggleButton source = (JToggleButton) e.getSource();
					boolean state =  source.isSelected();
					source.setBorderPainted(!state);
					if (state) {
						cardlayout.show(cardpanel, "library");
				if (controller().selectedWindow().userClick) {
						if ((((int) Math.floor(Math.random() * (100))) < 5) &&
								(VModel.preferences().getString("USERID").equalsIgnoreCase("developer") ||
								VModel.preferences().getString("USERID").equalsIgnoreCase("ureel") ||
								VModel.preferences().getString("USERID").equalsIgnoreCase("kcarney")))
							SoundCache.playSound("computer.au");
						else SoundCache.playSound("Kachunk.au");
				} } } });

		coachButton().setBackground(DARKGREY);
		coachButton().addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
					JToggleButton source = (JToggleButton) e.getSource();
					boolean state =  source.isSelected();
					source.setBorderPainted(!state);
					coachPanel().setSelectedComponent(controller().coachAskPanel());
					if (state) {
						cardlayout.show(cardpanel, "coach");
if ( controller().currentModel() != null ) {						
				if (controller().selectedWindow().userClick) {
						if ((((int) Math.floor(Math.random() * (100))) < 5) &&
								(VModel.preferences().getString("USERID").equalsIgnoreCase("developer") ||
								VModel.preferences().getString("USERID").equalsIgnoreCase("ureel") ||
								VModel.preferences().getString("USERID").equalsIgnoreCase("kcarney")))
							SoundCache.playSound("hallelujah.au");
						else SoundCache.playSound("Kachunk.au");
				} } } } });
		
		projectButton().setBorderPainted(false);
		projectButton().addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
					JToggleButton source = (JToggleButton) e.getSource();
					boolean state =  source.isSelected();
					source.setBorderPainted(!state);
					if (state) {
						cardlayout.show(cardpanel, "project");
				if (controller().selectedWindow().userClick) {
						if ((((int) Math.floor(Math.random() * (100))) < 5) &&
								(VModel.preferences().getString("USERID").equalsIgnoreCase("developer") ||
								VModel.preferences().getString("USERID").equalsIgnoreCase("ureel") ||
								VModel.preferences().getString("USERID").equalsIgnoreCase("kcarney")))
							SoundCache.playSound("cat-3.au");
						else SoundCache.playSound("Kachunk.au");
				} } } });
		projectButton().setBackground(DARKGREY);
		
		buttongroup.add(projectButton());
		buttongroup.add(librarian().libraryButton());
		buttongroup.add(coachButton());
		
		toolbar().add(projectButton());
		toolbar().add(librarian().libraryButton());
		toolbar().add(coachButton());
		
		setLayout(new BorderLayout());
		add(toolbar(), BorderLayout.NORTH);

		projectPanel().setBackground(DARKERGREY);

		coachPanel().setBackground(DARKERGREY);
		coachSyntaxPanel().setBackground(DARKERGREY);
		coachAnalysisPanel().setBackground(DARKERGREY);
		coachEmailPanel().setBackground(DARKERGREY);
		coachHelpPanel().setBackground(DARKERGREY);
//		coachAskPanel().setBackground(DARKERGREY);
//		coachPanel().addTab("Build Coach", coachSyntaxPanel());
//		coachPanel().addTab("Analysis Coach", coachAnalysisPanel());
//		coachPanel().addTab("Ask Doc V.", coachAskPanel());
		coachPanel().addTab("eMail da Doc", coachEmailPanel());
		coachPanel().addTab("Help", coachHelpPanel());
		
		cardpanel().setLayout(cardlayout());
		cardpanel().setBackground(DARKERGREY);
		cardpanel().add(projectPanel(), "project");
		cardpanel().add(librarian(), "library");
		cardpanel().add(coachPanel(), "coach");
		cardlayout().show(cardpanel(), "project");
		
		add(cardpanel(), BorderLayout.CENTER);
		
		self(this);
		
	} // default constructor
	
	public void addCoachPanel (String label, HTMLpanel panel) {
		panel.setBackground(WHITE);
		coachPanel().addTab(label, panel);
	} // method
	
	// Properties & Accessors
	// -----------------------------------------------------------------------
	protected JToolBar toolbar = new JToolBar();
	public JToolBar toolbar () { return(toolbar); }

	protected CardLayout cardlayout = new CardLayout();
	public CardLayout cardlayout() { return(cardlayout); }
	
	protected JPanel cardpanel = new JPanel();
	public JPanel cardpanel() { return(cardpanel); }
	
	protected JToggleButton projectButton = new JToggleButton("Project", ImageCache.getImage("nobackground_16_lightbulb"), true);
	public JToggleButton projectButton () { return(projectButton); }
	
	protected JToggleButton coachButton = new JToggleButton("Coach", ImageCache.getImage("nobackground16-einstein.GIF"));
	public JToggleButton coachButton () { return(coachButton); }
	
	protected HTMLpanel projectPanel = new HTMLpanel(); // "index.html");
	public HTMLpanel projectPanel () { return(projectPanel); }
	public HTMLpanel projectPanel (HTMLpanel j) { return(projectPanel = j); }
	
	protected Librarian librarian = null;
	public Librarian librarian () {
		if (librarian == null) librarian = new Librarian();
		return(librarian);
	} // reader
	public Librarian librarian (Librarian l) { return(librarian = l); }
	
	protected JTabbedPane coachPanel = new JTabbedPane();
	public JTabbedPane coachPanel () { return(coachPanel); }
	public JTabbedPane coachPanel (JTabbedPane j) { return(coachPanel = j); }

	protected HTMLpanel coachHelpPanel = new HTMLpanel(QRGutils.QRGroot() +  HELPPATH, "index.htm");
	public HTMLpanel coachHelpPanel () { return(coachHelpPanel); }
	public HTMLpanel coachHelpPanel (HTMLpanel h) { return(coachHelpPanel = h); }

	protected HTMLpanel coachSyntaxPanel = new HTMLpanel();
	public HTMLpanel coachSyntaxPanel () { return(coachSyntaxPanel); }
	public HTMLpanel coachSyntaxPanel (HTMLpanel h) { return(coachSyntaxPanel = h); }

	protected HTMLpanel coachAnalysisPanel = new HTMLpanel();
	public HTMLpanel coachAnalysisPanel () { return(coachAnalysisPanel); }
	public HTMLpanel coachAnalysisPanel (HTMLpanel h) { return(coachAnalysisPanel = h); }

	protected EMailDialog coachEmailPanel = new EMailDialog();
	public EMailDialog coachEmailPanel () { return(coachEmailPanel); }
	public EMailDialog coachEmailPanel (EMailDialog e) { return(coachEmailPanel = e); }

	public JTree add (Ontology o) { return(librarian().add(o)); }
	
	protected static VModelSidePanel self = null;
	public static VModelSidePanel self () { return(self); }
	public static VModelSidePanel self (VModelSidePanel s) { return(self = s); }
	
} // class 

// -----------------------------------------------------------------------------
// End of File: VModelSidePanel.java       (c) 2001 Northwestern University
