package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
//import KeyValuePair;
//import CMLio.CMLable;
//import Definition;
//import Model. Interface;
//import PList. Interface;
//import XMLio.XMLable;
import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import javax.swing.Icon;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.Serializable;
import java.lang.Cloneable;
import java.lang.Double;
import java.lang.Integer;
import java.lang.Math;
import java.lang.NumberFormatException;
import java.lang.Object;
import java.lang.Runnable;
import java.lang.String;
//import java.util.AbstractCollection;
//import java.util.AbstractList;
import java.util.Date;
import java.util.Enumeration;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.ButtonGroup;
import javax.swing.Icon;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;
import javax.swing.border.AbstractBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.LineBorder;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/references
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: PeerElement.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: PeerElement
* Purpose: GUI element. 
* ----------------------------------------------------------------------------
* </PRE> */
public class PeerElement extends QRGpanel implements Cloneable, Serializable,
		PeerElement.Interface, Peer {
	// Constructors
	// -------------------------------------------------------------------------
	public PeerElement () {
		super();
//		id(composeUniqueIdentifier());
//		allInstances().addElement(this);
//		addKeyListener(new PeerKeyAdapter());
	} // constructor

/*	
	public class PeerKeyAdapter extends KeyAdapter {
		public void keyPressed(KeyEvent e) {
QRGutils.debug("PeerElement.keyPressed", "e=" + e);		
			if ((model() != null) && (e.getKeyCode() == e.VK_DELETE)) {
				if (! ((ModelFrame) controller().selectedWindow()).modelPane().selectedComponents().isEmpty()) {
					((MacClassroom) controller()).delete(true);
				} // end if
			} // end if
		} // method
	} // innerclass
*/
		
	public PeerElement (Model model, Instance peer) {
		this();
//		QRGutils.debug("PeerElement.PeerElement(model, peer)", "model=" + model + " peer=" + peer);
		peer.peer(this);
		instance(peer);
		icon("vmodel.gif");
		setOpaque(false);
		add(skinPane(), BorderLayout.CENTER);
		setVisible(true);
		setSize(getMinimumSize());
		setPreferredSize(getSize());
		setAutoscrolls(true);
		addMarkers();
		positionMarkers();
		setLocation(peer.getInt("X-OFFSET"), peer.getInt("Y-OFFSET"));
		validate();
	} // constructor
	
	// Interface
	// ------------------------------------------------------------------------
	public interface Interface extends Cloneable, Serializable, VModelConstants, 
			/* Instance, */ Peer {
		public Instance instance ();
		public Instance instance (Instance p);

		public boolean selected ();
		public boolean selected (boolean b);

		public boolean active ();
		public boolean active (boolean b);
		
		public String icon ();
		public ImageIcon image ();
		
		public int mode ();
		public int mode (int i);

		public int view ();
		public int view (int i);

		public void setPosition (int x, int y);
		
		// Relationships
		public void addMarkers();
		public void positionMarkers();
		public void twist ();
		public void flip ();
		public void turn ();
		public void reverse ();
		public Marker independentMarker ();
		public Marker dependentMarker ();
	} // class VModelInstance

	// Properties & Accessors
	// -------------------------------------------------------------------------
	public Instance instance = null;
	public Instance instance () { return(instance); }
	public Instance instance (Instance p) { return(instance = p); }
	
	protected boolean selected = false;
	public boolean selected () { return(selected); }
	public boolean selected (boolean b) { 
		VModelStatusBar.displayText(name() + ": " + documentation());
		instance().checkInstance();
		return(selected = b); 
	} // writer

	protected boolean active = true;
	public boolean active () { return(active); }
	public boolean active (boolean b) { return(active = b); }
	
	public Vector typeChain () { return(getVector(TYPECHAIN)); }

	public String icon () { return(getString(ICON)); }
	public String icon (String s) { return((String) set(ICON, s)); }
	public String icon (boolean expanded) { 
		String result = icon();
		if (expanded) result += "Open";
		else result += "Closed";
		return(result); 
	} // method
	
	protected int mode = BUILD_MODE;
	public int mode () { return(model().getInt(MODE)); }
	public int mode (int i) { return(mode = i); }
	
	protected transient JLabel nameLabel = null;
	public JLabel nameLabel () {
		if (nameLabel == null) {
			nameLabel = new JLabel(); // JLabel
			nameLabel.setText(name());
			nameLabel.setBorder(new LineBorder(WHITE, 1) {
					public Insets getBorderInsets (Component c)       {
						int thickness = getThickness();
						return(new Insets(0, thickness, 0, thickness));
					} // method
					public Insets getBorderInsets (Component c, Insets insets) {
						int thickness = getThickness();
						insets.left = insets.right = thickness;
						return(insets);
					} // method
				});
			nameLabel.setBackground(WHITE);
			nameLabel.setForeground(BLACK);
			nameLabel.setOpaque(true);
			nameLabel.setVisible(true);
		} // end if
		return(nameLabel); 
	} // reader

	protected transient JTextField nameField = null;
	public JTextField nameField () {
		if (nameField == null) {
			nameField = new JTextField();
			nameField.setText(name());
			nameField.setBorder(new LineBorder(WHITE, 1) {
					public Insets getBorderInsets (Component c)       {
						int thickness = getThickness();
						return(new Insets(0, thickness, 0, thickness));
					} // method
					public Insets getBorderInsets (Component c, Insets insets) {
						int thickness = getThickness();
						insets.left = insets.right = thickness;
						return(insets);
					} // method
				});
			nameField.addFocusListener(new FocusAdapter() {
				public void focusLost(FocusEvent e) {
					editLabel(false);
				} // method
			});
			nameField.setBackground(WHITE);
			nameField.setForeground(BLACK);
			nameField.setOpaque(true);
			nameField.setEditable(true);
			nameField.setEnabled(true);
			nameField.setVisible(false);
		} // end if
		return(nameField); 
	} // reader

	protected transient JLabel typeLabel = null;
	public JLabel typeLabel () {
		if (typeLabel == null) {
			typeLabel = new JLabel();
			typeLabel.setText(typeName());
			typeLabel.setForeground(WHITE);
			typeLabel.setBackground(getEntityColor());
			typeLabel.setOpaque(false);
			typeLabel.setVisible(true);
		} // end if
		return(typeLabel); 
	} // reader
	
	protected transient JLabel quantitylabel = null;
	public JLabel quantitylabel () {
		if (quantitylabel == null) {
			quantitylabel = new JLabel();
//			if (element().typep(PROCESSRATE)) quantitylabel.setText("Rate");
//			else quantitylabel.setText("Amount");
			quantitylabel.setText("Parameter");
			quantitylabel.setForeground(WHITE);
			quantitylabel.setBackground(getEntityColor());
			quantitylabel.setOpaque(false);
			quantitylabel.setVisible(true);
		} // end if
		return(quantitylabel); 
	} // reader
	
	protected transient JLabel quantitylabel2 = null;
	public JLabel quantitylabel2 () {
		if (quantitylabel2 == null) {
			quantitylabel2 = new JLabel();
			if (instance().typep(PROCESSRATE)) quantitylabel2.setText("Rate");
			else quantitylabel2.setText("Amount");
			quantitylabel2.setForeground(BLACK);
			quantitylabel2.setBackground(WHITE);
			quantitylabel2.setOpaque(true);
			quantitylabel2.setVisible(true);
		} // end if
		return(quantitylabel2); 
	} // reader
	
	public boolean hasSelectedAncestor() {
		boolean result = false;
//		if ((instance() != null) && (instance().parent() != null) && (instance().parent().peer() != null)) {
//			if (((PeerElement) instance().parent().peer()).selected()) result = true;
//			else result = ((PeerElement) instance().parent().peer()).hasSelectedAncestor();
//		} // end if
		return(result);
	} // method
	
	protected transient QRGpanel quantitypane = null;
	public QRGpanel quantitypane () {
		if (quantitypane == null) {
			quantitypane = new QRGpanel() {
				public Insets getInsets() {
					return(new Insets(4, getSize().height/2, 2, getSize().height/2));
				} // method
				public void localpaint(Graphics g) {
//					super.paint(g);
					if (selected()) {
						g.setColor(RED);
						g.fillRoundRect(0, 0, getSize().width, getSize().height, getSize().height, getSize().height);
					} else if (hasSelectedAncestor()) {
						if (model().getInt(MODE) < 2) g.setColor(PINK);
						else g.setColor(GREEN);
						g.fillRoundRect(0, 0, getSize().width, getSize().height, getSize().height, getSize().height);
					} // end if
					if (instance().getVector("PROBLEMS").isEmpty()) g.setColor(BLUE);
					else g.setColor(DARKRED);
					g.fillRoundRect(2, 2, getSize().width - 4, getSize().height - 4, getSize().height - 4, getSize().height - 4);
				} // method
				public void paint(Graphics g) {
					localpaint(g);
					super.paint(g);
				} // method
				public void print(Graphics g) {
					localpaint(g);
					super.print(g);
				} // method
			};
			quantitypane.add(quantitylabel2(), BorderLayout.NORTH);
			quantitypane.add(quantitylabel(), BorderLayout.WEST);
			if (processquantLinks() != null) quantitypane.add(processquantLinks(), BorderLayout.EAST);
			quantitypane.setOpaque(false);
		} // end if
		return(quantitypane);
	} // reader
	
	protected transient QRGpanel quantitypane2 = null;
	public QRGpanel quantitypane2 () {
		if (quantitypane2 == null) {
			quantitypane2 = new QRGpanel();
			quantitypane2.add(nameLabel(), BorderLayout.CENTER);
			quantitypane2.add(linkPane(), BorderLayout.SOUTH);
			quantitypane2.setBackground(BLACK);
			quantitypane2.setOpaque(true);
		} // end if
		return(quantitypane2);
	} // reader
	
	protected transient QRGpanel skinPane = null;
	public QRGpanel skinPane () {
		if (skinPane == null) {
			skinPane = new QRGpanel();
			skinPane.add(selectPane(), BorderLayout.CENTER);
			skinPane.setOpaque(false);
			if(instance().typep(RELATIONSHIP)) addMarkers();
		} // end if
		return(skinPane);
	} // reader
	
	protected transient QRGpanel selectPane = null;
	public QRGpanel selectPane () {
		if (selectPane == null) {
			selectPane = new QRGpanel();
			selectPane.setOpaque(false);
			selectPane.add(elementPane(), BorderLayout.CENTER);
			if (typep(ATTRIBUTE) || typep(PROCESSRATE))
				selectPane.add(stateLabel(), BorderLayout.EAST);
		} // end if
		return(selectPane);
	} // reader

	protected transient QRGpanel linkPane = null;
	public QRGpanel linkPane () {
		if (linkPane == null) {
			linkPane = new QRGpanel(new FlowLayout()) {
				public Insets getInsets() {
					return(new Insets(0, 0, 0, 0));
				} // method
			};
			((FlowLayout) linkPane.getLayout()).setVgap(0);
			linkPane.setOpaque(false);
			addLinks();
		} // end if
		return(linkPane);
	} // reader
	
	public void addLinks () {
		ImageIcon baz = null;
		if (image() != null) {
			Image foo = image().getImage();
			int w = (int) Math.floor(scale() * image().getIconWidth());
			if (w < 1) w = 1;
			Image bar = foo.getScaledInstance(w, -1, 0);
			baz = new ImageIcon(bar);
		} // end if
		linkPane().removeAll();
		linkPane().add(typeLabel());
		if (baz != null) linkPane().add(new JLabel(baz));
	} // method
	
	
	protected transient QRGpanel link2Pane = null;
	public QRGpanel link2Pane () {
		if (link2Pane == null) {
			link2Pane = new QRGpanel(new FlowLayout()) {
				public Insets getInsets() {
					return(new Insets(1, 1, 1, 1));
				} // method
			};
			((FlowLayout) link2Pane.getLayout()).setVgap(0);
			link2Pane.setOpaque(false);
			processquantLinks();
		} // end if
		return(link2Pane);
	} // reader
	
	public QRGpanel processquantLinks () {
		if (link2Pane == null) {
			link2Pane = new QRGpanel(new FlowLayout()) {
				public Insets getInsets() {
					return(new Insets(3, 0, 0, 0));
				} // method
			};
			if (((FlowLayout) link2Pane.getLayout()) != null) ((FlowLayout) link2Pane.getLayout()).setVgap(0);
			link2Pane.setOpaque(false);
		} // end if
		if (link2Pane != null) {
			link2Pane.removeAll();
			if (image2() != null) {
				Image foo = image2().getImage();
				if (foo != null) {
					int w = (int) Math.floor(scale() * image2().getIconWidth());
					if (w < 1) w = 1;
					Image bar = foo.getScaledInstance(w, -1, 0);
					if (bar != null) {
						ImageIcon baz = new ImageIcon(bar);
						if (baz != null) {
							JLabel quux = new JLabel (baz);
							if (quux != null) {
								quux.setVerticalAlignment(JLabel.CENTER);
								link2Pane.add(quux);
							} // endi f
						} // end if
					} // end if
				} // end if
			} // end if
		} // end if
		return(link2Pane);
	} // method

	protected transient JLabel imageLabel = null;
	public JLabel imageLabel () {
		if (imageLabel == null) {
			imageLabel = new JLabel();
			imageLabel.setOpaque(false);
		} // end if
		return(imageLabel);
	} // reader

	protected transient JLabel stateLabel = null;
	public JLabel stateLabel () {
		if (stateLabel == null) {
			stateLabel = new JLabel("?");
			stateLabel.setVisible(false);
		} // end if
		return(stateLabel);
	} // reader
	
	public Color selectColor () {
		Color result = RED;
		if (! getVector("PROBLEMS").isEmpty()) result = NUTBROWN;
		return(result);
	} // method

	protected transient QRGpanel elementPane = null;
	public QRGpanel elementPane () {
		if (elementPane == null) {
			if (instance().typep(RELATIONSHIP)) {
				elementPane = new QRGpanel() {
					public Insets getInsets() {
						if (!(instance().typep(CAUSES))) return(new Insets(4, 4, 2, 4));
						return(new Insets(4, getSize().height/4, 2, getSize().height/4));
					} // method
					public void localpaint(Graphics g) {
						if (instance().typep(CAUSES)) {
							g.setColor(selectColor());
							if (selected()) g.fillRoundRect(0, 0, getSize().width, getSize().height, getSize().height, getSize().height);
							else if (hasSelectedAncestor()) {
						if (model().getInt(MODE) < 2) g.setColor(PINK);
						else g.setColor(GREEN);
								g.fillRoundRect(0, 0, getSize().width, getSize().height, getSize().height, getSize().height);
							} // end if
							g.setColor(getEntityColor());
							g.fillRoundRect(2, 2, getSize().width - 4, getSize().height - 4, getSize().height - 4, getSize().height - 4);
						} else {
							g.setColor(selectColor());
							if (selected()) g.fillRect(0, 0, getSize().width, getSize().height);
							else if (hasSelectedAncestor()) {
						if (model().getInt(MODE) < 2) g.setColor(PINK);
						else g.setColor(GREEN);
								g.fillRect(0, 0, getSize().width, getSize().height);
							} // end if
							if (instance().getVector("PROBLEMS").isEmpty()) g.setColor(getEntityColor());
							else g.setColor(RED);
							g.fillRect(2, 2, getSize().width - 4, getSize().height - 4);
						} // end if else
					} // method
					public void paint(Graphics g) {
						localpaint(g);
						super.paint(g);
					} // method
					public void print(Graphics g) {
						localpaint(g);
						super.print(g);
					} // method
				};
				typeLabel().setText(name());
				elementPane.setBackground(getEntityColor());
				elementPane.setOpaque(false);
				elementPane.add(linkPane(), BorderLayout.CENTER);
				elementPane.revalidate();
				elementPane.validate();
				elementPane.setLocation(getInt("XOFFSET"), getInt("YOFFSET")) ;
				elementPane.setSize(elementPane.getMinimumSize());
				elementPane.setPreferredSize(getSize());
				elementPane.revalidate();
				elementPane.validate();
			} else if (instance().typep(PROCESSRATE) || instance().typep(COLLECTIONAMOUNT)) {
				elementPane = new QRGpanel() {
					public Insets getInsets() {
						return(new Insets(4, 4, 2, 4));
					} // method
					public void localpaint(Graphics g) {
						g.setColor(selectColor());
						if (selected()) g.fillRect(0, 0, getSize().width, getSize().height);
						else if (hasSelectedAncestor()) {
						if (model().getInt(MODE) < 2) g.setColor(PINK);
						else g.setColor(GREEN);
								g.fillRect(0, 0, getSize().width, getSize().height);
						} // end if
						g.setColor(getEntityColor());
						g.fillRect(2, 2, getSize().width - 4, getSize().height - 4);
					} // method
					public void paint(Graphics g) {
						localpaint(g);
						super.paint(g);
					} // method
					public void print(Graphics g) {
						localpaint(g);
						super.print(g);
					} // method
					public Color getBackground () {
						return(BLACK);
					} // method
				};
				elementPane.setBackground(getEntityColor());
				elementPane.add(imageLabel(), BorderLayout.NORTH);
				elementPane.add(quantitypane2(), BorderLayout.CENTER);
				elementPane.add(quantitypane(), BorderLayout.SOUTH);
//				elementPane.add(stateLabel(), BorderLayout.EAST);
				elementPane.setOpaque(false);
				elementPane.revalidate();
				elementPane.validate();
				elementPane.setLocation(getInt("XOFFSET"), getInt("YOFFSET")) ;
				elementPane.setSize(elementPane.getMinimumSize());
				elementPane.setPreferredSize(getSize());
				elementPane.revalidate();
				elementPane.validate();
			} else if (instance().typep(ATTRIBUTE)) {
				elementPane = new QRGpanel() {
					public Insets getInsets() {
						return(new Insets(4, getSize().height/2, 2, getSize().height/2));
					} // method
					public void localpaint(Graphics g) {
						g.setColor(selectColor());
						if (selected()) g.fillRoundRect(0, 0, getSize().width, getSize().height, getSize().height, getSize().height);
						else if (hasSelectedAncestor()) {
						if (model().getInt(MODE) < 2) g.setColor(PINK);
						else g.setColor(GREEN);
								g.fillRoundRect(0, 0, getSize().width, getSize().height, getSize().height, getSize().height);
						} // end if
						g.setColor(getEntityColor());
						g.fillRoundRect(2, 2, getSize().width - 4, getSize().height - 4, getSize().height - 4, getSize().height - 4);
					} // method
					public void paint(Graphics g) {
						localpaint(g);
						super.paint(g);
					} // method
					public void print(Graphics g) {
						localpaint(g);
						super.print(g);
					} // method
				};
				elementPane.setBackground(getEntityColor());
				elementPane.setOpaque(false);
				elementPane.add(imageLabel(), BorderLayout.NORTH);
				elementPane.add(nameLabel(), BorderLayout.CENTER);
				elementPane.add(linkPane(), BorderLayout.SOUTH);
//				elementPane.add(stateLabel(), BorderLayout.EAST);
				elementPane.revalidate();
				elementPane.validate();
				elementPane.setLocation(getInt("XOFFSET"), getInt("YOFFSET")) ;
				elementPane.setSize(elementPane.getMinimumSize());
				elementPane.setPreferredSize(getSize());
				elementPane.revalidate();
				elementPane.validate();
			} else {
				elementPane = new QRGpanel() {
					public Insets getInsets() {
						return(new Insets(4, 4, 2, 4));
					} // method
					public void localpaint(Graphics g) {
						g.setColor(selectColor());
						if (selected()) g.fillRect(0, 0, getSize().width, getSize().height);
						else if (hasSelectedAncestor()) {
						if (model().getInt(MODE) < 2) g.setColor(PINK);
						else g.setColor(GREEN);
								g.fillRect(0, 0, getSize().width, getSize().height);
						} // end if
						g.setColor(getEntityColor());
						g.fillRect(2, 2, getSize().width - 4, getSize().height - 4);
					} // method
					public void paint(Graphics g) {
						localpaint(g);
						super.paint(g);
					} // method
					public void print(Graphics g) {
						localpaint(g);
						super.print(g);
					} // method
					public Color getBackground () {
						return(BLACK);
					} // method
				};
				elementPane.setBackground(getEntityColor());
				elementPane.add(imageLabel(), BorderLayout.NORTH);
				elementPane.add(nameLabel(), BorderLayout.CENTER);
				elementPane.add(linkPane(), BorderLayout.SOUTH);
				elementPane.setOpaque(false);
				elementPane.revalidate();
				elementPane.validate();
				elementPane.setLocation(getInt("XOFFSET"), getInt("YOFFSET")) ;
//				elementPane.setMinimumSize(new Dimension(100, elementPane.getMinimumSize().height + 25));
				elementPane.setSize(elementPane.getMinimumSize());
				elementPane.setPreferredSize(getSize());
				elementPane.revalidate();
				elementPane.validate();
			} // end if else
		} // end if 
		return(elementPane);
	} // reader 

	public PeerElement self () { return(this); }
	
	protected static Font staticFont = null;
	protected Font staticFont () { 
		if (staticFont == null) staticFont = new Font(getFont().getName(), getFont().getStyle(), getFont().getSize());
		return(staticFont); 
	} // reader
	protected Font staticFont (Font f) { return(staticFont = f); }
	
	protected double altscale = 1.0;
	protected double scale = 1.0;
	public double scale () { return(scale); }
	public double scale (double f) {
		altscale = f;
		if (typep(CAUSES)) {
			if (initialState().equalsIgnoreCase(DOMINANT)) altscale = controller().selectedWindow().modelPane().scale() *  1.35;
			else if (initialState().equalsIgnoreCase(NEGLIGABLE)) altscale = controller().selectedWindow().modelPane().scale() * 0.75;
		} // end if 
		scale = f;
		setFont(new Font(staticFont().getName(), 
								 staticFont().getStyle(), 
								 scaled(staticFont().getSize(), altscale)));
		if (stateLabel().isVisible()) {
			stateLabel().setSize(stateLabel().getMinimumSize());
			stateLabel().setPreferredSize(stateLabel().getSize());
		} // end if
		nameLabel().setSize(nameLabel().getMinimumSize());
		nameLabel().setPreferredSize(nameLabel().getSize());
		nameField().setSize(nameField().getMinimumSize());
		nameField().setPreferredSize(nameField().getSize());
		typeLabel().setSize(typeLabel().getMinimumSize());
		typeLabel().setPreferredSize(typeLabel().getSize());
		addLinks();
		processquantLinks();
		if ((instance().typep(ENTITY)) && (! instance().typep(PROCESSRATE))) {
			linkPane().setMinimumSize(null);
			Dimension lsize = linkPane().getMinimumSize();
			if (lsize.width < scaled(100, altscale)) lsize.width = scaled(100, altscale);
			if (lsize.height < scaled(25, altscale)) lsize.height = scaled(25, altscale);
			linkPane().setMinimumSize(lsize);
		} // end if
		if (instance().typep(ATTRIBUTE)) {
			linkPane().setMinimumSize(null);
			Dimension lsize = linkPane().getMinimumSize();
			if (lsize.width < scaled(75, altscale)) lsize.width = scaled(75, altscale);
			if (lsize.height < scaled(25, altscale)) lsize.height = scaled(25, altscale);
			linkPane().setMinimumSize(lsize);
		} // end if
		linkPane().setSize(linkPane().getMinimumSize());
		linkPane().setPreferredSize(linkPane().getSize());

		if (instance().typep(PROCESSRATE) || instance().typep(COLLECTIONAMOUNT)) {
			quantitylabel2().setSize(quantitylabel2().getMinimumSize());
			quantitylabel2().setPreferredSize(quantitylabel2().getSize());
			quantitylabel().setSize(quantitylabel().getMinimumSize());
			quantitylabel().setPreferredSize(quantitylabel().getSize());
			quantitypane().setSize(quantitypane().getMinimumSize());
			quantitypane().setPreferredSize(quantitypane().getSize());
			quantitypane2().setSize(quantitypane2().getMinimumSize());
			quantitypane2().setPreferredSize(quantitypane2().getSize());
		} // end if
		
		elementPane().doLayout();
		elementPane().setSize(elementPane().getMinimumSize());
		elementPane().setPreferredSize(elementPane().getSize());

		selectPane().doLayout();
		selectPane().setSize(selectPane().getMinimumSize());
		selectPane().setPreferredSize(selectPane().getSize());

		skinPane().doLayout();
		skinPane().setSize(skinPane().getMinimumSize());
		skinPane().setPreferredSize(skinPane().getSize());

		if (instance().typep(RELATIONSHIP)) {
//		QRGutils.debug("PeerElement.scale", "Relationship!");
			int portsize = scaled(15, altscale);
			independentPort().setSize(portsize, portsize);
			independentPort().setPreferredSize(independentPort().getSize());
			dependentPort().setSize(portsize, portsize);
			dependentPort().setPreferredSize(dependentPort().getSize());
			selectPane().setSize(selectPane().getMinimumSize());
			selectPane().setPreferredSize(selectPane().getSize());
			skinPane().setSize(skinPane().getMinimumSize());
			skinPane().setPreferredSize(skinPane().getSize());
		} // end if

		getPane(instance()).setSize(getPane(instance()).getMinimumSize());
		getPane(instance()).setPreferredSize(getPane(instance()).getSize());

		selectPane().setSize(selectPane().getMinimumSize());
		selectPane().setPreferredSize(selectPane().getSize());

		skinPane().setSize(skinPane().getMinimumSize());
		skinPane().setPreferredSize(skinPane().getSize());

//		if (typep(ATTRIBUTE) || typep(PROCESSRATE)) setSize(getMinimumSize().width, elementPane().getMinimumSize().height + 2);
//		else setSize(getMinimumSize());
		if (typep(ATTRIBUTE) || typep(PROCESSRATE)) setSize(getMinimumSize().width, elementPane().getMinimumSize().height + 2);
		setSize(getMinimumSize());
		setPreferredSize(getSize());
		setLocation(scaled(getInt("X-OFFSET")), 
						 scaled(getInt("Y-OFFSET")));
		invalidate();
		validate();
		repaint();
		return(scale);
	} // method
	
	public void setPosition (int x, int y) {
		set("X-OFFSET", (int) Math.floor(x / scale()));
		set("Y-OFFSET", (int) Math.floor(y / scale()));
		setLocation(x, y);
	} // method
	
	public void movePeer (int dx, int dy) {
		int x = self().getLocation().x + dx;
		int y = self().getLocation().y + dy;
		setLocation(x, y);
		moveChildren(dx, dy);
	} // method
	
	public void moveChildren(int dx, int dy) {
		Instance candidate = null;
		for(Enumeration instances = instance().childInstances().elements(); instances.hasMoreElements();) {
			candidate = (Instance) instances.nextElement();
			if ((candidate.peer() != null) &&
					(! candidate.peer().selected())) {
				((PeerElement) candidate.peer()).movePeer(dx, dy);
			} // end if
		} // end for
	} // method	

	public void movePeer2 (int dx, int dy) {
		int x = self().getLocation().x + dx;
		int y = self().getLocation().y + dy;
		setPosition(x, y);
		moveChildren2(dx, dy);
	} // method
	
	public void moveChildren2(int dx, int dy) {
		Instance candidate = null;
		for(Enumeration instances = instance().childInstances().elements(); instances.hasMoreElements();) {
			candidate = (Instance) instances.nextElement();
			if ((candidate.peer() != null) &&
					(! candidate.peer().selected())) {
				((PeerElement) candidate.peer()).movePeer2(dx, dy);
			} // end if
		} // end for
	} // method	

	// Methods
	// -------------------------------------------------------------------------
	public ImageIcon image () { 
		ImageIcon result = null;
		if (typep(ATTRIBUTE)) result = ImageCache.getImage("blue-both.jpg");
		//else if (typep(PROCESS)) result = ImageCache.getImage("blue-down.jpg");
		else if (typep(PROCESS)) result = ImageCache.getImage("black-both.jpg");
		else if (typep(ENTITY)) result = ImageCache.getImage("black-both.jpg");
		else if (typep(IPLUS)) result = ImageCache.getImage("increases.jpg");
		else if (typep(IMINUS)) result = ImageCache.getImage("decreases.jpg");
		else if (typep(QPROPPLUS)) result = ImageCache.getImage("influences.jpg");
		else if (typep(QPROPMINUS)) result = ImageCache.getImage("influences-opposite.jpg");
		else if (typep(ISGREATERTHAN)) result = ImageCache.getImage("g-than.gif");
		else if (typep(ISLESSTHAN)) result = ImageCache.getImage("l-than.gif");
		else if (typep(ISEQUALTO)) result = ImageCache.getImage("equals.gif");
		return(result); 
	} // method
//	public ImageIcon image2 () { return(ImageCache.getImage("blue-up.jpg")); }
	public ImageIcon image2 () { return(ImageCache.getImage("blue-both.jpg")); }
	
	public Color getEntityColor () {
		Color result = null;
		if (instance() != null) {
			if (!getVector("PROBLEMS").isEmpty()) result = RED;
			else if (instance().typep(PROCESSRATE)) result = BLACK;
			else if (instance().typep(HYPOTHESIS)) result = PINK;
			else if (instance().typep(PREDICTS)) result = PINK;
			else if (instance().typep(SUPPORTS)) result = PINK;
			else if (instance().typep(QUANTITY)) result = BLUE;
			else if (instance().typep(ATTRIBUTE)) result = BLACK;
			else if (instance().typep(PROCESS)) result = BLUE;
			else if (instance().typep(STRUCTURE)) result = BLACK;
			else if (instance().typep(SPATIALRELATIONSHIPS)) result = BLACK;
			else if (instance().typep(CONSTRAINT)) result = BLUE;
			else if (instance().typep(CAUSES)) result = BLUE;
			else if (instance().typep(RELATIONSHIP)) result = BLACK;
			else result = BLACK;
		}
		// Code to return other color if needed (e.g. grey-out)
		if (result == null) result = BLACK;
//		if ( instance.getBoolean("VARIABLE") && instance.getBoolean("BOUND") ) result = new Color( result.getRed(), result.getGreen(), result.getBlue(), 128 );
//		result = new Color( result.getRed(), result.getGreen(), result.getBlue(), 128 );
		return(result);
	} // method
	
	public Color getEntityColor2 () {
		Color result = null;
		if (instance() != null) {
			if (!getVector("PROBLEMS").isEmpty()) result = RED;
			else if (instance().typep(HYPOTHESIS)) result = PINK;
			else if (instance().typep(PROCESSRATE)) result = BLACK;
			else if (instance().typep(PREDICTS)) result = PINK;
			else if (instance().typep(SUPPORTS)) result = PINK;
			else if (instance().typep(QUANTITY)) result = BLUE;
			else if (instance().typep(ATTRIBUTE)) result = BLACK;
			else if (instance().typep(PROCESS)) result = BLUE;
			else if (instance().typep(STRUCTURE)) result = BLACK;
			else if (instance().typep(SPATIALRELATIONSHIPS)) result = BLACK;
			else if (instance().typep(CONSTRAINT)) result = BLUE;
			else if (instance().typep(CAUSES)) result = BLUE;
			else if (instance().typep(RELATIONSHIP)) result = BLACK;
			else result = BLACK;
		}
		// Code to return other color if needed (e.g. grey-out)
		if (result == null) result = BLACK;
//		if ( instance.getBoolean("VARIABLE") && instance.getBoolean("BOUND") ) result = new Color( result.getRed(), result.getGreen(), result.getBlue(), 128 );
//		result = new Color( result.getRed(), result.getGreen(), result.getBlue(), 128 );
		return(result);
	} // method
	
	public int scaled (int i) { return((int) Math.floor(scale() * i)); }
	public int scaled (int i, double s) { return((int) Math.floor(s * i)); }
	public int scaled (double d) { return((int) Math.floor(scale() * d)); }
	public int scaled (double d, double s) { return((int) Math.floor(s * d)); }
	
	public QRGpanel getPane (Instance e) {
		return(elementPane());
	} // method

	public void setFont(Font f) {
		super.setFont(f);
		if (instance() != null) {
			nameLabel().setFont(f);
			nameLabel().invalidate();
			if (f.getSize() > staticFont().getSize()) {
				nameField().setFont(f);
				nameField().invalidate();
			} else {
				nameField().setFont(staticFont());
				nameField().invalidate();
			} // end if
			if (instance().typep(PROCESSRATE) || instance().typep(COLLECTIONAMOUNT)) {
				quantitylabel2().setFont(f);
				quantitylabel2().invalidate();
				quantitylabel().setFont(f);
				quantitylabel().invalidate();
			} // end if
			typeLabel().setFont(f);
			typeLabel().invalidate();
			Font f2 =  new Font(staticFont().getName(), 
								 Font.BOLD, 
								 scaled(staticFont().getSize(), altscale) * 3) ;
			stateLabel().setFont(f2);
			stateLabel().invalidate();
			invalidate();
		} // end if
	} // method
	
	public void editLabel (boolean edit) {
//QRGutils.debug("PeerElement.editLabel", "edit=" + edit + " text=" + nameField().getText());	
		QRGpanel pane = null;
		if (instance().typep(PROCESSRATE) || instance().typep(COLLECTIONAMOUNT)) pane = quantitypane2();
		else pane = elementPane();
		if (edit) {
			pane.remove(nameLabel());
			pane.add(nameField(), BorderLayout.CENTER);
			nameField().setText(name());
			nameField().setVisible(true);
			nameField().setEditable(true);
			nameField().setEnabled(true);
			scale(scale());
			nameField().requestFocus();
		} else {
			pane.remove(nameField());
			pane.add(nameLabel(), BorderLayout.CENTER);
			if (! name().equalsIgnoreCase(nameField().getText())) {
				nameLabel().setText(nameField().getText());
//				name(nameField().getText());
				controller().rename(model(), instance(), nameField().getText(), true);
//				Modeler.self().currentModel().log("changeLabel", "entity= " + id() + " name= " + name());
			} // end if
			nameLabel().setVisible(true);
			scale(scale);
		} // method
	} // method
	
	public static String replaceReturns (String string) {
		String result = QRGutils.replaceSubstring(string, "\r", " ");
		result = QRGutils.replaceSubstring(result, "\n", " ");
		return(result);
	} // method replaceIllegalFileSystemChars

	public String annotation = "";
	public void annotate () {
		final JDialog d = new JDialog();
		Container c = d.getContentPane();
		JTextArea t = new JTextArea(notes());
		JScrollPane s = new JScrollPane(t);
		QRGpanel buttons = new QRGpanel(new BorderLayout());
		JButton ok = new JButton("OK");
		buttons.add(ok, BorderLayout.EAST);
		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				d.setVisible(false);
			} // method actionPerformed
		}); // actionListener
		t.setBorder(new EmptyBorder(5, 5, 5, 5));
		t.setLineWrap(true);
		c.setLayout(new BorderLayout());
		c.add(new JLabel(ImageCache.getImage("wizard.gif")), BorderLayout.WEST);
		c.add(new JLabel("Enter Notes:"), BorderLayout.NORTH);
		c.add(s, BorderLayout.CENTER);
		c.add(buttons, BorderLayout.SOUTH);
		d.setModal(true);
		d.setSize(300,200);
		d.setLocation(QRGutils.center(d.getSize()));
		d.show();
		annotation = t.getText();
		if (! annotation.equals(notes())) {
			notes(annotation);
			controller().selectedWindow().dirty(true);
//			Modeler.self().currentModel().log("Annotation", "element=" + id() + " text=\"" + replaceReturns(annotation()) +"\"");
		} // end if
		d.dispose();
	} // method annotate

	// Menuitems

	public boolean hidden () { return(getBoolean("HIDDEN")); }
	public boolean hidden (boolean b) { set("HIDDEN", b); return(b); }
	
	public class AddElementMenuItem extends JMenuItem {
		protected Definition definition = null;
		public AddElementMenuItem (Definition def) { 
			super(def.name(), ImageCache.getImage(def.icon())); 
			definition = def;
			addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							double theta = getDouble("THETA");
							double x = self().getLocation().x + (self().getSize().width /  2.0);
							double y = self().getLocation().y + (self().getSize().height /  2.0);
							double radius =  self().getSize().width * 1.0;
							int x1 = (int) Math.floor(x + (Math.sin(theta + (Math.PI * 1.25)) * radius));
							int y1 = (int) Math.floor(y + (Math.cos(theta + (Math.PI * 1.25)) * radius));
							int orientation = 0;
							if (Math.abs(y - y1) > Math.abs(x - x1)) {
								if (y > y1) orientation = SOUTH2NORTH;
								else orientation = NORTH2SOUTH;
							} else {
								if (x > x1) orientation = EAST2WEST;
								else orientation = WEST2EAST;
							} // end if magnitude
							Instance foo = (Instance) controller().addDefinition(model(), definition, x1, y1, true, true).elementAt(0);
							Instance bar = ((MacClassroom) controller()).connect(model(), BaseOntology.hasAttribute, instance(), foo, (int) Math.floor(x + ((x1 - x) / 2)), (int) Math.floor(y + ((y1 - y) / 2)), orientation, false);
							((PeerElement) bar.peer()).hidden(true);
							((PeerElement) bar.peer()).setVisible(false);
							updatePeer();
							controller().selectedWindow().modelPane().selectOne((PeerElement)foo.peer());
							foo.updatePeer();
							bar.updatePeer();
//							controller().move(model(), instance(), instance);
							set("THETA", theta + (2.0 * Math.PI / 7.0));
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // constructor
	} // inner class
	protected transient JMenu menuitemAddElement = null;
	public JMenu menuitemAddElement () {
		JMenu menuitemAddElement = new JMenu("Add to " + instance().typeName());
		Vector attributes = new Vector();
		Vector entities = new Vector();
		JMenuItem item = null;
		Definition def = null;
		for(Enumeration elements = Librarian.uberlibrary().flatten().elements(); elements.hasMoreElements();) {
			def = (Definition) elements.nextElement();
			if(def.typep(ATTRIBUTE) && (typep(PROCESS) || (!def.typep(RATE)))) {
				item = new AddElementMenuItem(def);
				attributes.addElement(item);
			} // end if
//			if(def.typep(ENTITY) && (! def.typep(PROCESS))) {
//				item = new AddElementMenuItem(def);
//				entities.addElement(item);
//			} // end if
		} // end for
		for(Enumeration items = attributes.elements(); items.hasMoreElements();) {
			item = (JMenuItem) items.nextElement();
			menuitemAddElement.add(item);
		} // end for
		if (instance().typep(PROCESS)) {
			for(Enumeration items = entities.elements(); items.hasMoreElements();) {
				item = (JMenuItem) items.nextElement();
				menuitemAddElement.add(item);
			} // end for
		} // end if
		return(menuitemAddElement);
	} // reader 

	public class AddRequiresMenuItem extends JMenuItem {
		protected Instance definition = null;
		public AddRequiresMenuItem (Instance def) { 
			super(def.name(), ImageCache.getImage(def.icon())); 
			definition = def;
			String txt = "";
			Instance in = model().findInstance(def.input());
			if (in != null) txt += in.name();
			else txt += "(nothing)";
			txt += "->" + definition.name() + "->"; 
			Instance out = model().findInstance(def.output());
			if (out != null) txt += out.name();
			else txt += "(nothing)";
			setText(txt);
			addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							double x = self().getLocation().x + (self().getSize().width /  2.0);
							double y = self().getLocation().y + (self().getSize().height /  2.0);
							int radius =  self().getSize().width * 2;
							int x1 = ((PeerElement)definition.peer()).getX();
							int y1 = ((PeerElement)definition.peer()).getY();
							int orientation = 0;
							if (Math.abs(y - y1) > Math.abs(x - x1)) {
								if (y > y1) orientation = SOUTH2NORTH;
								else orientation = NORTH2SOUTH;
							} else {
								if (x > x1) orientation = EAST2WEST;
								else orientation = WEST2EAST;
							} // end if magnitude
							Instance bar = ((MacClassroom) controller()).connect(model(), BaseOntology.requires, instance(), definition, (int) Math.floor(x + ((x1 - x) / 2)), (int) Math.floor(y + ((y1 - y) / 2)), orientation, false);
//							((PeerElement) bar.peer()).hidden(true);
//							((PeerElement) bar.peer()).setVisible(false);
							updatePeer();
							controller().selectedWindow().modelPane().selectOne((PeerElement)definition.peer());
							definition.updatePeer();
							bar.updatePeer();
//							controller().move(model(), instance(), instance);
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // constructor
	} // inner class
	protected transient JMenu menuitemAddRequires = null;
	public JMenu menuitemAddRequires () {
		JMenu menuitemAddRequires = new JMenu("Connect Requires to ");
		Vector rels = new Vector();
		JMenuItem item = null;
		Instance def = null;
		for(Enumeration elements = model().instances().elements(); elements.hasMoreElements();) {
			def = (Instance) elements.nextElement();
			if(def.typep(CONSTRAINT)) {
				item = new AddRequiresMenuItem(def);
				rels.addElement(item);
			} // end if
		} // end for
		for(Enumeration items = rels.elements(); items.hasMoreElements();) {
			item = (JMenuItem) items.nextElement();
			menuitemAddRequires.add(item);
		} // end for
		return(menuitemAddRequires);
	} // reader 
	
	protected transient JMenu menuitemMakePrediction = null;
	public JMenu menuitemMakePrediction () {
		JMenu menuitemMakePrediction = null;
		if (typep(ATTRIBUTE)) menuitemMakePrediction = new JMenu("Make prediction that " + name() + " is");
		else menuitemMakePrediction = new JMenu("Make prediction that the rate of " + name() + " is");
		Vector attributes = new Vector();
		Vector entities = new Vector();
		ButtonGroup group = new ButtonGroup();
		JMenuItem item = new JRadioButtonMenuItem("Increasing", predictedState().equalsIgnoreCase(INCREASING));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().predictedState(INCREASING);
						updatePeer();
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakePrediction.add(item);
		item = new JRadioButtonMenuItem("Unchanging", predictedState().equalsIgnoreCase(CONSTANT));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().predictedState(CONSTANT);
						updatePeer();
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakePrediction.add(item);
		item = new JRadioButtonMenuItem("Decreasing", predictedState().equalsIgnoreCase(DECREASING));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().predictedState(DECREASING);
						updatePeer();
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakePrediction.add(item);
		item = new JRadioButtonMenuItem("Unknown", predictedState().equalsIgnoreCase(UNKNOWN));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().predictedState(UNKNOWN);
						updatePeer();
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakePrediction.add(item);
		return(menuitemMakePrediction);
	} // reader 

	protected transient JMenu menuitemMakeAssumption = null;
	public JMenu menuitemMakeAssumption () {
		JMenu menuitemMakeAssumption = null;
		if (typep(ATTRIBUTE)) menuitemMakeAssumption = new JMenu("Assume this " + name() + " is:");
		else menuitemMakeAssumption = new JMenu("Assume the rate of " + name() + " is:");
		Vector attributes = new Vector();
		Vector entities = new Vector();
		ButtonGroup group = new ButtonGroup();
		JMenuItem item = new JRadioButtonMenuItem("Increasing", initialState().equalsIgnoreCase(INCREASING));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().initialState(INCREASING);
						instance().initialReason(USERASSUMPTION);
						controller().runSimulation(model());
						controller().updatePeers(model());
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakeAssumption.add(item);
		item = new JRadioButtonMenuItem("Unchanging", initialState().equalsIgnoreCase(CONSTANT));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().initialState(CONSTANT);
						instance().initialReason(USERASSUMPTION);
						controller().runSimulation(model());
						controller().updatePeers(model());
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakeAssumption.add(item);
		item = new JRadioButtonMenuItem("Decreasing", initialState().equalsIgnoreCase(DECREASING));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().initialState(DECREASING);
						instance().initialReason(USERASSUMPTION);
						controller().runSimulation(model());
						controller().updatePeers(model());
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakeAssumption.add(item);
		item = new JRadioButtonMenuItem("Make no assumption.", initialState().equalsIgnoreCase(UNKNOWN));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().initialState(DEFAULT);
						instance().initialReason(DEFAULTASSUMPTION);
						controller().runSimulation(model());
						controller().updatePeers(model());
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemMakeAssumption.add(item);
		return(menuitemMakeAssumption);
	} // reader 

	public JMenu menuitemPayAttention () {
		JMenu menuitemPayAttention = null;
		menuitemPayAttention = new JMenu("How strong is this relationship?");
		Vector attributes = new Vector();
		Vector entities = new Vector();
		ButtonGroup group = new ButtonGroup();
		JMenuItem item = new JRadioButtonMenuItem(instance().name() + " a lot.", initialState().equalsIgnoreCase(DOMINANT));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().initialState(DOMINANT);
						instance().initialReason(USERASSUMPTION);
						if (model().getInt(MODE) == 2) controller().runSimulation(model());
						controller().updatePeers(model());
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemPayAttention.add(item);
		item = new JRadioButtonMenuItem(instance().name(), initialState().equalsIgnoreCase(NORMAL));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().initialState(NORMAL);
						instance().initialReason(USERASSUMPTION);
						if (model().getInt(MODE) == 2) controller().runSimulation(model());
						controller().updatePeers(model());
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemPayAttention.add(item);
		item = new JRadioButtonMenuItem(instance().name() + " a little.", initialState().equalsIgnoreCase(NEGLIGABLE));
		item.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				Runnable doIt = new Runnable() {
					public void run () {
						instance().initialState(NEGLIGABLE);
						instance().initialReason(USERASSUMPTION);
						if (model().getInt(MODE) == 2) controller().runSimulation(model());
						controller().updatePeers(model());
					} };
				SwingUtilities.invokeLater(doIt);
			} // method actionPerformed
		}); // actionListener
		group.add(item);
		menuitemPayAttention.add(item);
		return(menuitemPayAttention);
	} // reader 

	protected transient JMenuItem menuitemAnnotate = null;
	public JMenuItem menuitemAnnotate () {
		if (menuitemAnnotate == null) {
			menuitemAnnotate(new JMenuItem("Annotate"));
			menuitemAnnotate.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							annotate();
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemAnnotate
		return(menuitemAnnotate);
	} // reader menuitemAnnotate
	public JMenuItem menuitemAnnotate (JMenuItem m) { return(menuitemAnnotate = m); }

	protected transient JMenuItem menuitemHelp = null;
	public JMenuItem menuitemHelp () {
		if (menuitemHelp == null) {
			menuitemHelp(new JMenuItem("Help"));
			menuitemHelp.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							HTMLbrowser.popupBrowser("VModel Help: " + getString("LABEL"),
								helpURL(), new Dimension(700,300));
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemHelp
		return(menuitemHelp);
	} // reader menuitemHelp
	public JMenuItem menuitemHelp (JMenuItem m) { return(menuitemHelp = m); }
	
/*	
	public class VMenuItem extends JMenuItem implements ActionListener {
		public VModelElement element = null;
		public VMenuItem (String s) { super(s); }
		public void actionPerformed(ActionEvent ev) {
			final ActionEvent e = ev;
			try {
				Thread t = new Thread() {
					public void run () {
						model().disconnect(element, reference());
						((Component) model().reference()).repaint();
					} // method run
				}; // Anonymous Class Thread
				t.start();
			} catch (Exception err) {}
		} // method actionPerformed
	} // innerclass VMenuItem
	
	protected JMenu menuitemDisconnectConnections = null;
	public JMenu menuitemDisconnectConnections () {
		VModelElement mumble = null;
		VMenuItem grumble = null;
		if (menuitemDisconnectConnections == null) menuitemDisconnectConnections(new JMenu("Disconnect"));
		menuitemDisconnectConnections.removeAll();
		for(int i = connections().size() - 1; i >= 0; i--) {
			mumble = (VModelElement) connections().elementAt(i);
			grumble = new VMenuItem(mumble.getString("TYPE"));
			grumble.element = mumble;
			grumble.addActionListener(grumble);
			menuitemDisconnectConnections.add(grumble);
		} // end for i
		return(menuitemDisconnectConnections);
	} // reader menuitemDisconnectConnections
	public JMenu menuitemDisconnectConnections (JMenu m) { return(menuitemDisconnectConnections = m); }
	
	protected JMenuItem menuitemExtendOne = null;
	public JMenuItem menuitemExtendOne () {
		if (menuitemExtendOne == null) {
			menuitemExtendOne(new JMenuItem("Expand One Level"));
			menuitemExtendOne.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							expandOne(reference());
							validate();
							((Component) model().reference()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemExtendOne
		return(menuitemExtendOne);
	} // reader menuitemExtendOne
	public JMenuItem menuitemExtendOne (JMenuItem m) { return(menuitemExtendOne = m); }
	
	protected JMenuItem menuitemExtendAll = null;
	public JMenuItem menuitemExtendAll () {
		if (menuitemExtendAll == null) {
			menuitemExtendAll(new JMenuItem("Expand All Levels"));
			menuitemExtendAll.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							expandAll(reference());
							validate();
							((Component) model().reference()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemExtendAll
		return(menuitemExtendAll);
	} // reader menuitemExtendAll
	public JMenuItem menuitemExtendAll (JMenuItem m) { return(menuitemExtendAll = m); }
	
	protected JMenuItem menuitemContractAll = null;
	public JMenuItem menuitemContractAll () {
		if (menuitemContractAll == null) {
			menuitemContractAll(new JMenuItem("Contract All Levels"));
			menuitemContractAll.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							contractAll(reference());
							validate();
							((Component) model().reference()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemContractAll
		return(menuitemContractAll);
	} // reader menuitemContractAll
	public JMenuItem menuitemContractAll (JMenuItem m) { return(menuitemContractAll = m); }
	
	protected JMenuItem menuitemSelectGrouped = null;
	public JMenuItem menuitemSelectGrouped () {
		if (menuitemSelectGrouped == null) {
			menuitemSelectGrouped(new JMenuItem("Select Grouped Elements"));
			menuitemSelectGrouped.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							selected(true);
							VModelElement mumbleFrotz = null;
							for(int j = 0; j < elements().size(); j++) {
								mumbleFrotz = (VModelElement) elements().elementAt(j);
								VModelPeerElement grumbleFrotz = makeInstance(mumbleFrotz);
								if (grumbleFrotz != null) grumbleFrotz.selected(true);
							} // for j
							((Component) model().reference()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemSelectGrouped
		return(menuitemSelectGrouped);
	} // reader menuitemSelectGrouped
	public JMenuItem menuitemSelectGrouped (JMenuItem m) { return(menuitemSelectGrouped = m); }
	
	protected JMenuItem menuitemUnBind = null;
	public JMenuItem menuitemUnBind () {
		if (menuitemUnBind == null) {
			menuitemUnBind(new JMenuItem("UnBind"));
			menuitemUnBind.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							model().unbind(reference());
							validate();
							((Component) model().reference()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemUnBind
		return(menuitemUnBind);
	} // reader menuitemUnBind
	public JMenuItem menuitemUnBind (JMenuItem m) { return(menuitemUnBind = m); }
	
	protected JMenuItem menuitemVariablize = null;
	public JMenuItem menuitemVariablize () {
		if (menuitemVariablize == null) {
			menuitemVariablize(new JMenuItem("Variablize"));
			menuitemVariablize.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							model().variablize(reference());
							validate();
							((Component) model().reference()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemVariablize
		return(menuitemVariablize);
	} // reader menuitemVariablize
	public JMenuItem menuitemVariablize (JMenuItem m) { return(menuitemVariablize = m); }
	
	protected JMenuItem menuitemUnVariablize = null;
	public JMenuItem menuitemUnVariablize () {
		if (menuitemUnVariablize == null) {
			menuitemUnVariablize(new JMenuItem("UnVariablize"));
			menuitemUnVariablize.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							model().unvariablize(reference());
							validate();
							((Component) model().reference()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemUnVariablize
		return(menuitemUnVariablize);
	} // reader menuitemUnVariablize
	public JMenuItem menuitemUnVariablize (JMenuItem m) { return(menuitemUnVariablize = m); }
*/
	
	protected JMenuItem menuitemSkin = null;
	public JMenuItem menuitemSkin () {
		if (menuitemSkin == null) {
			menuitemSkin(new JMenuItem("Skin"));
			menuitemSkin.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							set("SKINNED", true);
							controller().selectedWindow().modelPane().repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemSkin
		return(menuitemSkin);
	} // reader menuitemSkin
	public JMenuItem menuitemSkin (JMenuItem m) { return(menuitemSkin = m); }
	
	protected JMenuItem menuitemUnSkin = null;
	public JMenuItem menuitemUnSkin () {
		if (menuitemUnSkin == null) {
			menuitemUnSkin(new JMenuItem("UnSkin"));
			menuitemUnSkin.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							set("SKINNED", false);
							controller().selectedWindow().modelPane().repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemUnSkin
		return(menuitemUnSkin);
	} // reader menuitemUnSkin
	public JMenuItem menuitemUnSkin (JMenuItem m) { return(menuitemUnSkin = m); }
	
	protected JMenuItem menuitemSkinColor = null;
	public JMenuItem menuitemSkinColor () {
		if (menuitemSkinColor == null) {
			menuitemSkinColor(new JMenuItem("Change Skin Color"));
			menuitemSkinColor.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
							Color c =  getColor("SKINCOLOR");
							if (c == BLACK) c = GREEN;
							c = JColorChooser.showDialog(null, "Select Skin Color", c);
							if (c != null) {
								set("SKINCOLOR", c.getRGB());
								controller().selectedWindow().modelPane().repaint();
							} // end if c
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemSkinColor
		return(menuitemSkinColor);
	} // reader menuitemSkinColor
	public JMenuItem menuitemSkinColor (JMenuItem m) { return(menuitemSkinColor = m); }

	protected JMenuItem menuitemSubtype = null;
	public JMenuItem menuitemSubtype () {
		if (menuitemSubtype == null) {
			menuitemSubtype(new JMenuItem("Add To Library"));
			menuitemSubtype.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run () {
//							QRGutils.debug("PeerElement.menuitemSubtype");
							controller().addToLibrary(model(), instance());
//for( Enumeration enum = instance().childInstances().elements(); enum.hasMoreElements(); ) {
//	Instance foo = (Instance) enum.nextElement();
//	QRGutils.debug( "PeerElement.menuitemSubtype", "foo=" + foo.name() + " parent=" + foo.parentInstances() );
//} // end for		
//							updateLabels();
//boolean flag = true;
//VModelInstanceOntology mumble = null;
//VModelElement grumble = reference();
//for(int i = 0; i < VModelInstanceOntology.allInstanceOntologies().size(); i++) {
//	mumble = (VModelInstanceOntology) VModelInstanceOntology.allInstanceOntologies().elementAt(i);
//	if (mumble.getString("LABEL").equalsIgnoreCase(grumble.getString("LABEL"))) {
//		flag = (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, grumble.getString("TYPE") + ", already exists.\n Do you want to overwrite it?", "Alert! " + grumble.getString("TYPE") + " Exists", JOptionPane.YES_NO_OPTION));
//		break;
//	}
//} // for i
//if (flag) {
//							model().addToLibrary(reference());
//							objectPane(null);
//							boxPane(null);
//							displayMode();
//				}
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemSubtype
		return(menuitemSubtype);
	} // reader menuitemSubtype
	public JMenuItem menuitemSubtype (JMenuItem m) { return(menuitemSubtype = m); }
	
	protected JMenuItem menuitemReverse = null;
	public JMenuItem menuitemReverse () {
		if (menuitemReverse == null) {
			menuitemReverse(new JMenuItem("Reverse"));
			menuitemReverse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							Vector selectionVector = new Vector();
							selectionVector.addElement(self());
							reverse();
							controller().selectedWindow().modelPane().doAction(ModelPane.Action.REVERSE, selectionVector);
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemReverse
		return(menuitemReverse);
	} // reader menuitemReverse
	public JMenuItem menuitemReverse (JMenuItem m) { return(menuitemReverse = m); }
	
	protected JMenuItem menuitemTwist = null;
	public JMenuItem menuitemTwist () {
		if (menuitemTwist == null) {
			menuitemTwist(new JMenuItem("Twist"));
			menuitemTwist.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							Vector selectionVector = new Vector();
							selectionVector.addElement(self());
							twist();
							controller().selectedWindow().modelPane().doAction(ModelPane.Action.TWIST, selectionVector);
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemTwist
		return(menuitemTwist);
	} // reader menuitemTwist
	public JMenuItem menuitemTwist (JMenuItem m) { return(menuitemTwist = m); }
	
	protected JMenuItem menuitemFlip = null;
	public JMenuItem menuitemFlip () {
		if (menuitemFlip == null) {
			menuitemFlip(new JMenuItem("Flip"));
			menuitemFlip.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							Vector selectionVector = new Vector();
							selectionVector.addElement(self());
							flip();
							controller().selectedWindow().modelPane().doAction(ModelPane.Action.FLIP, selectionVector);
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemFlip
		return(menuitemFlip);
	} // reader menuitemFlip
	public JMenuItem menuitemFlip (JMenuItem m) { return(menuitemFlip = m); }
	
	protected JMenuItem menuitemDisconnectAll = null;
	public JMenuItem menuitemDisconnectAll () {
		if (menuitemDisconnectAll == null) {
			menuitemDisconnectAll(new JMenuItem("Disconnect All"));
			menuitemDisconnectAll.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					try {
						Thread t = new Thread() {
							public void run () {
								if (instance().typep(RELATIONSHIP)) {
									Vector connectionVector = new Vector();
									connectionVector.addElement(self().instance());
									connectionVector.addElement(model().findInstance(instance().input()));
									connectionVector.addElement(model().findInstance(instance().output()));
									connectionVector.addElement("BOTH");
									controller().connect(model(), self().instance(), null, null);
									controller().selectedWindow().modelPane().doAction(ModelPane.Action.DISCONNECT, connectionVector);
								} // end if
//								for(int i = connections().size() - 1; i >= 0; i--) {
//									mumble = (VModelElement) connections().elementAt(i);
//									model().disconnect(mumble, reference()); 
//								} // end for i
//								((Component) model().reference()).repaint();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception err) {}
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemDisconnectAll
		return(menuitemDisconnectAll);
	} // reader menuitemDisconnectAll
	public JMenuItem menuitemDisconnectAll (JMenuItem m) { return(menuitemDisconnectAll = m); }
	
	protected JMenuItem menuitemDisconnectInput = null;
	public JMenuItem menuitemDisconnectInput () {
		if (menuitemDisconnectInput == null) {
			menuitemDisconnectInput(new JMenuItem("Disconnect Input"));
			menuitemDisconnectInput.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							Vector connectionVector = new Vector();
							connectionVector.addElement(self().instance());
							connectionVector.addElement(model().findInstance(self().instance().input()));
							connectionVector.addElement(model().findInstance(self().instance().output()));
							connectionVector.addElement("INPUT");
							controller().selectedWindow().modelPane().doAction(ModelPane.Action.DISCONNECT, connectionVector);
							controller().connect(model(), self().instance(), null, model().findInstance(self().instance().output()));
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemDisconnectInput
		return(menuitemDisconnectInput);
	} // reader menuitemDisconnectInput
	public JMenuItem menuitemDisconnectInput (JMenuItem m) { return(menuitemDisconnectInput = m); }
	
	protected JMenuItem menuitemDisconnectOutput = null;
	public JMenuItem menuitemDisconnectOutput () {
		if (menuitemDisconnectOutput == null) {
			menuitemDisconnectOutput(new JMenuItem("Disconnect Output"));
			menuitemDisconnectOutput.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					Runnable doIt = new Runnable() {
						public void run () {
							Vector connectionVector = new Vector();
							connectionVector.addElement(self().instance());
							connectionVector.addElement(model().findInstance(self().instance().input()));
							connectionVector.addElement(model().findInstance(self().instance().output()));
							connectionVector.addElement("OUTPUT");
							controller().selectedWindow().modelPane().doAction(ModelPane.Action.DISCONNECT, connectionVector);
							controller().connect(model(), self().instance(), model().findInstance(self().instance().input()), null);
						} };
					SwingUtilities.invokeLater(doIt);
				} // method actionPerformed
			}); // actionListener
		} // end if menuitemDisconnectOutput
		return(menuitemDisconnectOutput);
	} // reader menuitemDisconnectOutput
	public JMenuItem menuitemDisconnectOutput (JMenuItem m) { return(menuitemDisconnectOutput = m); }
	
	protected transient JPopupMenu menu = null;
	public JPopupMenu menu () { 
		if (menu == null) menu(new JPopupMenu());
		return(menu); 
	} // reader menu
	public JPopupMenu menu (JPopupMenu m) { return(menu = m); }

	public void twist () {
		int direction = getInt("ORIENTATION");
		direction++;
		if (direction > SOUTH2NORTH) direction = WEST2EAST;
		orientation(direction);
//		updatePeer();
	} // method
	
	public void turn () {
		int direction = getInt("ORIENTATION");
		direction--;
		if (direction < WEST2EAST) direction = SOUTH2NORTH;
		orientation(direction);
//		updatePeer();
	} // method
	
	public void flip () {
		int direction = getInt("ORIENTATION");
		direction += 2;
		if (direction > SOUTH2NORTH) direction -= (SOUTH2NORTH + 1);
		orientation(direction);
//		updatePeer();
	} // method

	public void reverse () {
		controller().connect(model(), self().instance(), model().findInstance(self().instance().output()), model().findInstance(self().instance().input()));
		flip();
	} // method
	
	public int orientation() { 
		return(instance().getInt("ORIENTATION"));
	} // method
	
	public int orientation(int i) { 
		if ((i >= WEST2EAST) && (i <= SOUTH2NORTH)) {
			instance().set("ORIENTATION", i);
			positionMarkers();
//			((ModelFrame) controller().selectedWindow()).modelPane().drawpane().repaint();
		} // end if
		return(orientation());
	} // method
	
	public Controller controller () {
		Controller result = (Controller) VModel.controller();
		return(result);
	} // method
	
/*	
	public void collapse (Definition frag) {
			
	} // method
	
	public void expand (Definition frag) {
	
	} // method
*/	
/*
	public void skin (Definition element, boolean value, SkinColor skinColor) {
		activeSkins(element).removeElement(skinColor);
		for(int i = activeSkins(element).size() - 1; i >= 0; i--) {
			SkinColor s = (SkinColor)activeSkins(element).elementAt(i);
			if (s.tag().equalsIgnoreCase(skinColor.tag())) activeSkins(element).removeElement(s);
		} // end for
		if (value) activeSkins(element).addElement(skinColor);
		if (element instanceof Definition) {
			Definition e = null;
			for(Enumeration enum = element.children(); enum.hasMoreElements();) {
				e = (Definition) enum.nextElement();
				skin(e, value, skinColor);
			} // end for
		} // end if
	} // method
	
	public void skin (Definition frag, boolean value) {
		Definition element = null;
		int localColor = frag.getRGBColor("LOCAL-SKIN-COLOR");
		SkinColor skinColor = (SkinColor) frag.get("SKIN-COLOR");
		if ((localColor == 0) || (localColor == -16777216)) {
			localColor = nextSkinColor();
			frag.set("LOCAL-SKIN-COLOR", localColor);
		} // end if
		if (skinColor == null) {
			skinColor = new SkinColor(frag.id(), localColor);
			frag.set("SKIN-COLOR", skinColor);
		} // end if
		activeSkins(frag).removeElement(skinColor);
		for(int i = activeSkins(frag).size() - 1; i >= 0; i--) {
			SkinColor s = (SkinColor)activeSkins(frag).elementAt(i);
			if (s.tag().equalsIgnoreCase(frag.id())) activeSkins(frag).removeElement(s);
		} // end for
		if (value) {
			activeSkins(frag).addElement(skinColor);
			for(int i = activeSkins(frag).size() - 1; i >= 0; i--) {
				SkinColor s = (SkinColor)activeSkins(frag).elementAt(i);
				for(Enumeration enum = frag.children(); enum.hasMoreElements();) {
					element = (Definition) enum.nextElement();
					skin(element, value, s);
				} // end for
			} // end for
		} else {
			for(Enumeration enum = frag.children(); enum.hasMoreElements();) {
				element = (Definition) enum.nextElement();
				skin(element, value, skinColor);
			} // end for
		} // end if
	} // method
	
	public Vector activeSkins (Definition element) {
		Vector result = (Vector) element.get("ACTIVE-SKINS");
		if (result == null) {
			result = new Vector();
			element.set("ACTIVE-SKINS", result);
		} // end if
		return(result);
	} // method

	public boolean isSkinned (Definition frag) {
		boolean result = false;
		Vector activeskins = (Vector) frag.get("ACTIVE-SKINS");
		SkinColor skinColor = (SkinColor) frag.get("SKIN-COLOR");
		result = ((skinColor != null) && (activeskins.contains(skinColor)));
		return(result);
	} // method
*/
	
	protected static int skinColorIndex = -1;

	protected final Color [] skinColors = {YELLOW,PURPLE,DARKRED,LIGHTPINK,ORANGE,CYAN,LAVENDER,YUCKYPUCE,NUTBROWN,
	                 			GRASSGREEN,ROYALBLUE,DARKYELLOW,MAGENTA,PLUM,
	                        DARKGRASSGREEN,DARKYUCKYPUCE,GREENBROWN,
								   BRIGHTGREEN,LIGHTYELLOW,SKYBLUE,DARKPINK,
								   DARKGREEN,DARKLAVENDER,REDBROWN,DARKGOLD,
								   MEDIUMGREEN,DARKSKYBLUE,LIGHTBROWN,LIGHTBLUE,REDORANGE};
								   
	public int nextSkinColor () {
		int result = 0;
		skinColorIndex++;
		if (skinColorIndex >= skinColors.length) skinColorIndex = 0;
		result = skinColors[ skinColorIndex ].getRGB();
		return(result);
	} // method groupColor
	
	public Color skinColor () {
		Color result = getColor("SKINCOLOR");
		if (result == BLACK) {
			result = new Color(nextSkinColor());
			set("SKINCOLOR", result);
		} // end if
		return(result);
	} // method
	
	public boolean skinP () { return(getBoolean("SKINNED")); }
	
	public Vector skins () {
		Vector result = skins( null );
		return(result);
	} // method

	public Vector skins (Vector visited) {
		Vector result = new Vector();
		Instance instance = null;
		PeerElement peer = null;
		Vector tempVector = null;
		if (visited == null) visited = new Vector( );
		if ( !visited.contains( this ) ) {
			visited.addElement( this );
			for(Enumeration parents = instance().parentInstances().elements(); parents.hasMoreElements();) {
				instance = (Instance) parents.nextElement();
				peer = (PeerElement) instance.peer();
				if ( peer != null ) {
					tempVector = peer.skins(visited);
					tempVector = QRGutils.removeElements( tempVector, result );
					result = QRGutils.mergeVector(result, tempVector );
				} // end if
			} // end for
			if(typep(ENTITY) && skinP()) result.addElement(instance());
		} // end if
		return(result);
	} // method

	public class SkinColor extends Vector implements Serializable, VModelConstants {
		public SkinColor (String tag, int color) {
			super();
			addElement(tag);
			addElement(new Integer(color));
		} // constructor
		public String tag () {
			String result = null;
			result = (String) elementAt(0) ;
			return(result);
		} // method
		public Color color () {
			Color result = BLACK;
			result = new Color(((Integer) elementAt(1)).intValue());
			return(result);
		} // method
		public Color color (Color c) {
			Color result = c;
			removeElement(elementAt(1));
			addElement(new Integer(c.getRGB()));
			return(result);
		} // method
	} // innerclass
	
	public Vector problems () { return(instance.problems()); }
	public Vector problems (String err, String msg) { return(instance.problems(err, msg)); }
	
	public CoachMenuItem makeCoachMenuItem (String l, PeerElement r) { return(new CoachMenuItem(l,r)); }
	
	public class CoachMenuItem extends JMenuItem implements ActionListener {
		PeerElement peer = null;
		String rlabel = "";
		public void actionPerformed (ActionEvent e) {
			String message = "";
			String mumble = null;
			instance().checkInstance();
			updatePeer();
			for(Enumeration probs = problems().elements(); probs.hasMoreElements();) {
				mumble = (String) probs.nextElement();
				message += (String) probs.nextElement();
				message += QRGutils.eol();
			} // end for
			String happycoach = "coach-b-h-l.gif";
			String confusedcoach = "coach-b-c-l.gif";
			if (mode() != 1) {
				happycoach = "coach-e-h-l.gif";
				confusedcoach = "coach-e-c-l.gif";
			} // end if
			String [] buttons = {"View help information on " + instance.typeName() + " relationships.", "OK"};
			if (! problems().isEmpty()) {
				if (JOptionPane.YES_OPTION == JOptionPane.showOptionDialog(null, message, "VModel Coach", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,ImageCache.getImage(confusedcoach), buttons, null)) {
					controller().browser().setTitle("VModel Coach");
					controller().browser().setSize(700,300);
					controller().browser().setLocation(QRGutils.center(controller().browser().getSize()));
					controller().browser().gotoPage(QRGutils.QRGroot() + HELPPATH, peer.helpURL());
				}
			} else JOptionPane.showMessageDialog(null, "No worries, Mate.", "VModel Coach", JOptionPane.ERROR_MESSAGE,ImageCache.getImage(happycoach));
		} // method actionPerformed
		public CoachMenuItem (String label, PeerElement r) {
			super(label);
			addActionListener(this);
			peer = r;
			rlabel = label;
		} // constructor CoachMenuItem
	} // innerclass CoachMenuItem

	public void makePopupMenu () {
		updatePeer();
		menu().removeAll();

		JMenuItem coachMenuItem = null;
		if (mode() == 1) {
			coachMenuItem = makeCoachMenuItem("The Builder Coach says", self());;
			if (problems().isEmpty()) coachMenuItem.setIcon(ImageCache.getImage("coach-b-h-s.gif"));
			else coachMenuItem.setIcon(ImageCache.getImage("coach-b-c-s.gif"));
		} else {
			coachMenuItem = makeCoachMenuItem("The Professor Coach says", self());
			if (problems().isEmpty()) coachMenuItem.setIcon(ImageCache.getImage("coach-e-h-s.gif"));
			else coachMenuItem.setIcon(ImageCache.getImage("coach-e-c-s.gif"));
		} // end if
		menu().add(coachMenuItem);

		if (instance().typep(ENTITY)) {
			if (mode() == 1) {
				menu().addSeparator();
				menu().add(menuitemAddElement());
				if (instance().typep(PROCESS)) menu().add(menuitemAddRequires());
				menu().addSeparator();
				menu().add(menuitemSubtype());
				menu().addSeparator();
				menu().add(menuitemSkin());
				menu().add(menuitemUnSkin());
				menu().add(menuitemSkinColor());
			} else {
			} // end if
		} // end if
		if (instance().typep(ATTRIBUTE) || instance().typep(PROCESSRATE)) {
				menu().addSeparator();
			if (mode() == 1) {
				menu().add(menuitemMakePrediction());
			} else {
				menu().add(menuitemMakeAssumption());
			} // end if
		} // end if
//		menu().addSeparator();

		if (instance().typep(RELATIONSHIP)) {
			if (mode() == 1) {
				menu().addSeparator();
//				if(!instance.typep(STRUCTURE)) menu().add(menuitemPayAttention());
				if (! (instance().typep(STRUCTURE))) {
					menu().addSeparator();
					menu().add(menuitemReverse());
				} // end if reversable
				menu().addSeparator();
				menu().add(menuitemTwist());
				menu().add(menuitemFlip());

				
				Instance input = model().findInstance(input());
				Instance output = model().findInstance(output());
				if ((input != null) || (output != null) || (!inputs().isEmpty())) {
					menu().addSeparator();
					menu().add(menuitemDisconnectAll());
				} // end if connections
				if (input != null) {
					menuitemDisconnectInput().setText("Disconnect " + input.typeName() + ": " + input.name());
					menu().add(menuitemDisconnectInput());
				} // end if input
				if (output != null) {
					menuitemDisconnectOutput().setText("Disconnect " + output.typeName() + ": " + output.name());
					menu().add(menuitemDisconnectOutput());
				} // end if input
			} else {
				if(!instance.typep(STRUCTURE)) menu().add(menuitemPayAttention());
			} // end if
		} // end if

/*
		if (instance() instanceof Definition) {
			if (! isSkinned((Definition) instance())) menu().add(menuitemSkin());
			else menu().add(menuitemUnSkin());
			menu().add(menuitemSkinColor());
		} // end if
*/
/*
		if (!connections().isEmpty()) {
			menu().add(menuitemDisconnectConnections());
		} // end if input
*/
/*		
		if (!getBoolean("VARIABLE")) menu().add(menuitemVariablize());
		else menu().add(menuitemUnVariablize());
		if (getBoolean("BOUND")) menu().add(menuitemUnBind());
		menu().addSeparator();
		if (!getBoolean("SKINNED")) menu().add(menuitemSkin());
		else menu().add(menuitemUnSkin());
		menu().add(menuitemSkinColor());
		if (!elements().isEmpty()) {
			menu().addSeparator();
			menu().add(menuitemExtendOne());
			menu().add(menuitemExtendAll());
			menu().add(menuitemContractAll());
			menu().addSeparator();
			menu().add(menuitemSelectGrouped());
		} // end if elements
		if (!connections().isEmpty()) {
			menu().addSeparator();
			menu().add(menuitemDisconnectAll());
			menu().add(menuitemDisconnectConnections());
		} // end if connections
*/
		menu().addSeparator();
		menu().add(menuitemAnnotate());
		menu().add(menuitemHelp());
	} // method makePopupMenu

	public void showPopupMenu (int x, int y) {
		makePopupMenu();
		//menu.show(gui().frame(), x, y); 
		menu.show(this, x, y); 
	} // method showPopupMenu

	// From Instance
	// -----------------------------------------------------------------------
/*	
	public Instance parent () {
		Instance result = null;
		if (instance() != null) result = instance().parent();
		else QRGutils.debug("PeerElement.parent", "peer=" + instance());
		return(result);
	} // reader
	public Instance parent (Instance p) {
		Instance result = null;
		if (instance() != null) result = instance().parent(p);
		else QRGutils.debug("PeerElement.parent", "p=" + p + " peer=" + instance());
		return(result);
	} // writer
*/

	public Model model () {
		Model result = null;
		if (instance() != null) result = instance().model();
		else QRGutils.debug("PeerElement.model", "peer=" + instance());
		return(result);
	} // reader
	public Model model (Model m) {
		Model result = null;
		if (instance() != null) result = instance().model(m);
		else QRGutils.debug("PeerElement.model", "m=" + m + " peer=" + instance());
		return(result);
	} // writer

	public Vector plist () {
		Vector result = null;
		if (instance() != null) result = instance().plist();
		else QRGutils.debug("PeerElement.plist", "peer=" + instance());
		return(result);
	} // reader
	
	public String id () {
		String result = null;
		if (instance() != null) result = instance().id();
		else QRGutils.debug("PeerElement.id()", "peer=" + instance());
		return(result);
	} // reader
	public String id (String s) {
		String result = null;
		if (instance() != null) result = instance().id(s);
		else QRGutils.debug("PeerElement.id(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String input () {
		String result = null;
		if (instance() != null) result = instance().input();
		else QRGutils.debug("PeerElement.input()", "peer=" + instance());
		return(result);
	} // reader
	public String input (String s) {
		String result = null;
		if (instance() != null) result = instance().input(s);
		else QRGutils.debug("PeerElement.input(s)", "peer=" + instance());
		return(result);
	} // writer
	public String output () {
		String result = null;
		if (instance() != null) result = instance().output();
		else QRGutils.debug("PeerElement.output()", "peer=" + instance());
		return(result);
	} // reader
	public String output (String s) {
		String result = null;
		if (instance() != null) result = instance().output(s);
		else QRGutils.debug("PeerElement.output(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public Vector causalInputs () {
		Vector result = null;
		if (instance() != null) result = instance().causalInputs();
		else QRGutils.debug("PeerElement.causalInputs()", "peer=" + instance());
		return(result);
	} // reader
	public Vector causalOutputs () {
		Vector result = null;
		if (instance() != null) result = instance().causalOutputs();
		else QRGutils.debug("PeerElement.causalOutputs()", "peer=" + instance());
		return(result);
	} // reader
	
	public Vector inputs () {
		Vector result = null;
		if (instance() != null) result = instance().inputs();
		else QRGutils.debug("PeerElement.inputs()", "peer=" + instance());
		return(result);
	} // reader
	public Vector outputs () {
		Vector result = null;
		if (instance() != null) result = instance().outputs();
		else QRGutils.debug("PeerElement.outputs()", "peer=" + instance());
		return(result);
	} // reader
	
//	public String reference () {
//		String result = null;
//		if (instance() != null) result = instance().reference().id();
//		else QRGutils.debug("PeerElement.reference()", "peer=" + instance());
//		return(result);
//	} // reader
//	public String reference (String s) {
//		String result = null;
//		if (instance() != null) result = instance().reference(s);
//		else QRGutils.debug("PeerElement.reference(s)", "peer=" + instance());
//		return(result);
//	} // writer
	
	public String predictedState () {
		String result = null;
		if (instance() != null) result = instance().predictedState();
		else QRGutils.debug("PeerElement.predictedState()", "peer=" + instance());
		return(result);
	} // reader
	public String predictedState (String s) {
		String result = null;
		if (instance() != null) result = instance().predictedState(s);
		else QRGutils.debug("PeerElement.predictedState(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String state () {
		String result = null;
		if (instance() != null) result = instance().state();
		else QRGutils.debug("PeerElement.state()", "peer=" + instance());
		return(result);
	} // reader
	public String state (String s) {
		String result = null;
		if (instance() != null) result = instance().state(s);
		else QRGutils.debug("PeerElement.state(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public Vector reasons () {
		Vector result = null;
		if (instance() != null) result = instance().reasons();
		else QRGutils.debug("PeerElement.reasons()", "peer=" + instance());
		return(result);
	} // reader
	public Vector reasons (Vector v) {
		Vector result = null;
		if (instance() != null) result = instance().reasons(v);
		else QRGutils.debug("PeerElement.reasons(v)", "peer=" + instance());
		return(result);
	} // writer
	
	public String initialState () {
		String result = null;
		if (instance() != null) result = instance().initialState();
		else QRGutils.debug("PeerElement.initialState()", "peer=" + instance());
		return(result);
	} // reader
	public String initialState (String s) {
		String result = null;
		if (instance() != null) result = instance().initialState(s);
		else QRGutils.debug("PeerElement.initialState(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String initialReason () {
		String result = null;
		if (instance() != null) result = instance().initialReason();
		else QRGutils.debug("PeerElement.initialReason()", "peer=" + instance());
		return(result);
	} // reader
	public String initialReason (String s) {
		String result = null;
		if (instance() != null) result = instance().initialReason(s);
		else QRGutils.debug("PeerElement.initialReason(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String notes () {
		String result = null;
		if (instance() != null) result = instance().notes();
		else QRGutils.debug("PeerElement.notes()", "peer=" + instance());
		return(result);
	} // reader
	public String notes (String s) {
		String result = null;
		if (instance() != null) result = instance().notes(s);
		else QRGutils.debug("PeerElement.notes(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String name () {
		String result = null;
		if (instance() != null) result = instance().name();
		else QRGutils.debug("PeerElement.name()", "peer=" + instance());
		return(result);
	} // reader
	public String name (String s) {
		String result = null;
		if (instance() != null) result = instance().name(s);
		else QRGutils.debug("PeerElement.name(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String category () {
		String result = null;
		if (instance() != null) result = instance().category();
		else QRGutils.debug("PeerElement.category()", "peer=" + instance());
		return(result);
	} // reader
	public String category (String s) {
		String result = null;
		if (instance() != null) result = instance().category(s);
		else QRGutils.debug("PeerElement.category(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String type () {
		String result = null;
		if (instance() != null) result = instance().type();
		else QRGutils.debug("PeerElement.type()", "peer=" + instance());
		return(result);
	} // reader
	public String type (String s) {
		String result = null;
		if (instance() != null) result = instance().type(s);
		else QRGutils.debug("PeerElement.type(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String Otype () {
		String result = null;
		if (instance() != null) result = instance().Otype();
		else QRGutils.debug("PeerElement.Otype()", "peer=" + instance());
		return(result);
	} // reader
	public String Otype (String s) {
		String result = null;
		if (instance() != null) result = instance().Otype(s);
		else QRGutils.debug("PeerElement.Otype(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String Jtype () {
		String result = null;
		if (instance() != null) result = instance().Jtype();
		else QRGutils.debug("PeerElement.Jtype()", "peer=" + instance());
		return(result);
	} // reader
//	public String Jtype (String s) {
//		String result = null;
//		if (instance() != null) result = instance().Jtype(s);
//		else QRGutils.debug("PeerElement.Jtype(s)", "peer=" + instance());
//		return(result);
//	} // writer
	
	public String documentation () {
		String result = null;
		if (instance() != null) result = instance().documentation();
		else QRGutils.debug("PeerElement.documentation()", "peer=" + instance());
		return(result);
	} // reader
	public String documentation (String s) {
		String result = null;
		if (instance() != null) result = instance().documentation(s);
		else QRGutils.debug("PeerElement.documentation(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public String helpURL () {
		String result = null;
		if (instance() != null) result = instance().helpURL();
		else QRGutils.debug("PeerElement.helpURL()", "peer=" + instance());
		return(result);
	} // reader
	public String helpURL (String s) {
		String result = null;
		if (instance() != null) result = instance().helpURL(s);
		else QRGutils.debug("PeerElement.helpURL(s)", "peer=" + instance());
		return(result);
	} // writer
	
	public Vector keyValuePairs () {
		Vector result = null;
		if (instance() != null) result = instance().keyValuePairs();
		else QRGutils.debug("PeerElement.keyValuePairs()", "peer=" + instance());
		return(result);
	} // reader
	public Vector keyValuePairs (Vector v) {
		Vector result = null;
		if (instance() != null) result = instance().keyValuePairs(v);
		else QRGutils.debug("PeerElement.keyValuePairs(v)", "peer=" + instance());
		return(result);
	} // writer
	
	public Vector keys () {
		Vector result = new Vector();
		KeyValuePair.KVPinterface candidate = null;
		for (Enumeration e = keyValuePairs().elements() ; e.hasMoreElements() ;) {
			candidate =  (KeyValuePair.KVPinterface) e.nextElement();
			result.addElement(candidate.key());
		} // end for
		return(result);
	} // method
	
	public Vector values () {
		Vector result = new Vector();
		KeyValuePair.KVPinterface candidate = null;
		for (Enumeration e = keyValuePairs().elements() ; e.hasMoreElements() ;) {
			candidate =  (KeyValuePair.KVPinterface) e.nextElement();
			result.addElement(candidate.value());
		} // end for
		return(result);
	} // method
	
	public Vector connections () {
		Vector result = null;
		if (instance() != null) result = instance().connections();
		else QRGutils.debug("PeerElement.connections()", "peer=" + instance());
		return(result);
	} // reader
	
	public Vector connectors () {
		Vector result = null;
		if (instance() != null) result = instance().connectors();
		else QRGutils.debug("PeerElement.connectors()", "peer=" + instance());
		return(result);
	} // reader
	
//	public Vector participants () {
//		Vector result = null;
//		if (instance() != null) result = instance().participants();
//		else QRGutils.debug("PeerElement.participants()", "peer=" + instance());
//		return(result);
//	} // reader
//	public Vector participants (Vector v) {
//		Vector result = null;
//		if (instance() != null) result = instance().participants(v);
//		else QRGutils.debug("PeerElement.participants(v)", "peer=" + instance());
//		return(result);
//	} // writer
	
	public Vector quantities () {
		Vector result = null;
//		if (instance() != null) result = instance().quantities();
//		else QRGutils.debug("PeerElement.quantities()", "peer=" + instance());
		return(result);
	} // reader
//	public Vector quantities (Vector v) {
//		Vector result = null;
//		if (instance() != null) result = instance().quantities(v);
//		else QRGutils.debug("PeerElement.quantities(v)", "peer=" + instance());
//		return(result);
//	} // writer
	
	public Vector conditions () {
		Vector result = null;
//		if (instance() != null) result = instance().conditions();
//		else QRGutils.debug("PeerElement.conditions()", "peer=" + instance());
		return(result);
	} // reader
//	public Vector conditions (Vector v) {
//		Vector result = null;
//		if (instance() != null) result = instance().conditions(v);
//		else QRGutils.debug("PeerElement.conditions(v)", "peer=" + instance());
//		return(result);
//	} // writer
	
	public Vector consequences () {
		Vector result = null;
//		if (instance() != null) result = instance().consequences();
//		else QRGutils.debug("PeerElement.consequences()", "peer=" + instance());
		return(result);
	} // reader
//	public Vector consequences (Vector v) {
//		Vector result = null;
//		if (instance() != null) result = instance().consequences(v);
//		else QRGutils.debug("PeerElement.consequences(v)", "peer=" + instance());
//		return(result);
//	} // writer
	
	public Vector structure () {
		Vector result = null;
//		if (instance() != null) result = instance().structure();
//		else QRGutils.debug("PeerElement.structure()", "peer=" + instance());
		return(result);
	} // reader
//	public Vector structure (Vector v) {
//		Vector result = null;
//		if (instance() != null) result = instance().structure(v);
//		else QRGutils.debug("PeerElement.structure(v)", "peer=" + instance());
//		return(result);
//	} // writer
	
	public Vector childInstances () {
		Vector result = null;
		if (instance() != null) result = instance().childInstances();
		else QRGutils.debug("PeerElement.childInstances()", "peer=" + instance());
		return(result);
	} // reader
	public Vector childInstances (Vector v) {
		Vector result = null;
		if (instance() != null) result = instance().childInstances(v);
		else QRGutils.debug("PeerElement.childInstances(v)", "peer=" + instance());
		return(result);
	} // writer
	
	// Methods
	// -------------------------------------------------------------------------
	public Enumeration children () {
		Enumeration result = null;
		if (instance() != null) result = instance().children();
		else QRGutils.debug("PeerElement.children", "peer=" + instance());
		return(result);
	} // method

	// This is getting called way too often.	
//	public Reference.RefInterface elementReference () {
//		Reference.RefInterface result = null;
//		if (instance() != null) result = instance().reference();
//		else QRGutils.debug("PeerElement.elementReference", "peer=" + instance());
//QRGutils.debug("PeerElement.elementReference", "result=" + result);		
//		return(result);
//	} // methods
//	public Reference.RefInterface elementReference (Reference.RefInterface e) {
//		Reference.RefInterface result = null;
//		if (instance() != null) result = instance().elementReference(e);
//		else QRGutils.debug("PeerElement.elementReference", "e=" + e + " peer=" + peer);
//		return(result);
//	} // methods

//	public String elementID () { 
//		return(elementReference().reference()); 
//	} // method

//	public Definition element () {
//		QRGutils.debug("PeerElement", "element", "elementID=" + elementID());
//		Definition result = controller().findDefinition(model(), elementID());
//		QRGutils.debug("PeerElement", "element", "elementID=" + elementID() + " result=" + result);
//		return(result); 
//	} // method

	public boolean typep (String s) {
		boolean result = false;
		if (instance() != null) result = instance().typep(s);
		else QRGutils.debug("PeerElement.typep(s)", "peer=" + instance());
		return(result);
	} // reader
		
	public boolean Jtypep (String s) {
		boolean result = false;
		if (instance() != null) result = instance().Jtypep(s);
		else QRGutils.debug("PeerElement.Jtypep(s)", "peer=" + instance());
		return(result);
	} // reader
		
	public boolean Otypep (String s) {
		boolean result = false;
		if (instance() != null) result = instance().Otypep(s);
		else QRGutils.debug("PeerElement.Otypep(s)", "peer=" + instance());
		return(result);
	} // reader
		
	public String typeName () {
		String result = null;
		if (instance() != null) result = instance().typeName();
		else QRGutils.debug("PeerElement.typeName()", "peer=" + instance());
		return(result);
	} // reader
		
	// Methods
	// ------------------------------------------------------------------------
	public PeerElement.Interface find (String id) {
		PeerElement.Interface result = null;
		Instance mumble = null;
		if (instance() != null) {
			mumble = (Instance) model().findInstance(id);
			if (mumble != null) result = (PeerElement) mumble.peer();
			else QRGutils.debug("PeerElement.find", "id=" + id + " mumble=" + mumble);
		} else QRGutils.debug("PeerElement.find", "id=" + id + " peer=" + instance());
		return(result);
	} // method
	
	// Uniquify
	protected static long sessionCount = 0;

	public String composeUniqueIdentifier () {
		String result = ""; // QRGutils.projectName(); 
		result += /* "-" + */ "Artifact"; 
//		result += "-" + getClass().getName(); 
		result += "-" + (new Date()).getTime(); 
		result += "-" + (sessionCount++);
		result += "-" + hashCode();
		result += "-" + String.valueOf((char) ((Math.random() * 25) + 65));
		return(result);
	} // method 
	
	public Definition subtype (String name) { return(null); }

//	public void save (String filename) { instance().save(filename); }

	// Get keyValuePair values.
	// -----------------------------------------------------------------------
    public Object get (String tag) {
		Object result = instance().get(tag);
		return(result);
    } // method get

    public Color getColor (String tag) {
		Color result = Color.black;
		Object value = null;
		value = instance().get(tag);
		if (value != null) result = QRGutils.matchColor((String) value);
		return result;
    } // method getColor

    public int getRGBColor (String tag) {
		int result = 0;
		Color color = getColor(tag);
		if (color != null) result = color.getRGB();
		return(result);
    } // method getRGBColor

    public int getInt (String tag) {
		int result = 0;
		String value = (String) get(tag);
		if (value != null) {
			value = value.trim();
			try {result = Integer.parseInt(value);}
			catch(NumberFormatException e) {}
		} // end if
		return result;
    } // method getInt

    public double getDouble (String tag) {
		double result = 0.0;
		String value = (String) get(tag);
		if (value != null) {
			value = value.trim();
			try {result = Double.valueOf(value).doubleValue();}
			catch(NumberFormatException e) {}
		} // end if
		return(result);
    } // method getDouble

    public boolean getBoolean (String tag) {
		boolean result = false;
		String value = (String) get(tag);
		if (value != null) {
			value = value.trim();
			result = value.equalsIgnoreCase("TRUE");
		} // end if
		return(result);
    } // method getBoolean

    public String getString (String tag) {
		String result = "";
		String value = (String) get(tag);
		if (value != null) result = value;
		return(result);
    } // method getString

	public boolean containsString (String key, String target) {
		boolean result = false;
		String value = getString(key);
		result =  (value.indexOf(target)>=0);
		return(result);
	} // method getDouble
	
	public Vector getVector (String tag) {
		Vector result = null;
		Vector value = (Vector) get(tag);
		if (value != null) result = value;
		else { 
			result = new Vector();
			set(tag, result);
		} // end if else
		return(result);
	} // method getString

	// Set KeyValuePair values.
	// -----------------------------------------------------------------------
    public Object set (String tag, Object value) {
		Object result = null;
		result = instance().set(tag, value);
		return(result);
    } // method set

    public Object set (String tag, int value) {
		return(set(tag, "" + value));
    } // method set

    public Object set (String tag, boolean value) {
		return(set(tag, "" + value));
    } // method set

    public Object set (String tag, double value) {
		return(set(tag, "" + value));
    } // method set

    public Object set (String tag, Color value) {
		return(set(tag, "" + value.getRGB()));
    } // method set
    
    // Add & Remove KeyValuePairs
    // -----------------------------------------------------------------------
    public void add (String key, Object value) {
    	instance().add(key, value);
    } // method

    public boolean remove (String key) {
    	return(plist().removeElement(key));	// modified for the Mac
    } // method
    
 	// CMLio.CMLable
	// -----------------------------------------------------------------------
	/** Use the constructors.
	    @see #CMLcommand() 
	    @see #CMLcommand(String) */
	protected String CMLcommand = "defartifact";
	/** <PRE>
	* ------------------------------------------------------------------------
	* Purpose: Returns the CML command used to represent the object.
	* ------------------------------------------------------------------------
	* </PRE> 
	*/
	public String CMLcommand () { return(CMLcommand); }
	/** @see #CMLcommand() */
	public String CMLcommand (String s) { return(CMLcommand = s); }

	public String toCML () {
		String result = "(" + CMLcommand() + " " + id();
		KeyValuePair mumble = null;
		result += QRGutils.eol() + "   :Otype " + Otype();
		result += QRGutils.eol() + "   :type " + type();
		result += QRGutils.eol() + "   :name \"" + name() + "\"";
		result += QRGutils.eol() + "   :id " + instance().id();
		for (Enumeration e = keyValuePairs().elements() ; e.hasMoreElements() ;) {
			mumble = (KeyValuePair) e.nextElement();
			if (! mumble.key().equalsIgnoreCase(ID)) {
				if (mumble.value() instanceof Vector) {
					result += QRGutils.eol() + "   :" + mumble.key() + " (";
					for (Enumeration values = ((Vector) mumble.value()).elements(); values.hasMoreElements();) {
						result += values.nextElement();
						if (values.hasMoreElements()) result += " ";
					} // end for
					result += ")";
				} else if (mumble.key().equalsIgnoreCase(REFERENCE)) result += QRGutils.eol() + "   :" + mumble.key() + " " + mumble.value();
				else result += QRGutils.eol() + "   :" + mumble.key() + " \"" + mumble.value() + "\"";
			} // end if
		} // end for
		result += ")" + QRGutils.eol();
		return(result);
	} // method
	
	/** <PRE>
	* ------------------------------------------------------------------------
	* Purpose: Saves the ontology to filename in CML format.
	* ------------------------------------------------------------------------
	* </PRE> 
	*/
	public void exportCML (String filename) {
		CMLio.save(QRGutils.QRGuserpath() + filename + "." + CML_SUFFIX , this);
	} // method
	
	// XMLio.XMLable
	// -----------------------------------------------------------------------
	public String xmlDef () { 
		String result = 	"";
		KeyValuePair mumble = null;
		String classname = this.getClass().getName();
		result += "<!DOCTYPE " + classname + " [\r\n";
		result += "<!ELEMENT " + classname + " EMPTY >\r\n";
		for (Enumeration e = instance().keyValuePairs().elements() ; e.hasMoreElements() ;) {
			mumble = (KeyValuePair) e.nextElement();
			result += "<!ATTLIST " + classname + " " + mumble.key().toUpperCase() + " CDATA #REQUIRED >\r\n";
		} // end for
		result += "]>";
		return(result); 
	} // method
	
	public String xmlify () {
		String result = stringify();
		return(result);
	} // method
	
	/** <PRE>
	* ------------------------------------------------------------------------
	* Purpose: Initializes slots after object is created by XML loader.
	* ------------------------------------------------------------------------
	* </PRE> 
	*/
	public void XMLioObjectInit (Vector attr, Vector elmnt) {
		keyValuePairs(attr);
	} // method
	
	/** <PRE>
	* ------------------------------------------------------------------------
	* Purpose: Saves the ontology to filename in XML format.
	* ------------------------------------------------------------------------
	* </PRE> 
	*/
	public void exportXML (String filename) {
		XMLio.save(QRGutils.QRGuserpath() + filename + "." + XML_SUFFIX , this);
	} // method
	
	// Stringification.
	// -----------------------------------------------------------------------
	public String stringifyKeyValuePairs (int indent) {
		String result = "";
		int j = 0;
		KeyValuePair candidate = null;
		if (instance().keyValuePairs() != null) {
			j = 0;
			while(j < instance().keyValuePairs().size()) {
				candidate = (KeyValuePair) instance().keyValuePairs().elementAt(j);
				if (! (candidate.value() instanceof Vector)) {
					if (j > 0) result += QRGutils.eol() + QRGutils.space(indent);
					else result += " "; 
					result += candidate;
				} // end if
				j++;
			} // while
		} // end if
		return(result);
	} // method toString
	
	public String stringify (int indent) {
		String result = "";
		KeyValuePair pair = null;
		Object mumble = null;
		final VectorElement grumble = new VectorElement();
		boolean flag = true;
		result = QRGutils.space(indent) + "<" + "PeerElement"; //this.getClass().getName();
		result += stringifyKeyValuePairs(result.length() + 1);
		for (Enumeration e = instance().keyValuePairs().elements() ; e.hasMoreElements() ;) {
			pair = (KeyValuePair) e.nextElement();
			if ((pair.value() instanceof Vector) &&
					(! ((Vector) pair.value()).isEmpty())) {
				flag = false;
				break;
			} // end if
		} // end for
		int tabs = indent + 3;
		if (! flag) result += " />" + QRGutils.eol();
		else {
			result += " >" + QRGutils.eol();
			for (Enumeration e = instance().keyValuePairs().elements() ; e.hasMoreElements() ;) {
				pair = (KeyValuePair) e.nextElement();
				if (pair.value() instanceof Vector) {
					for (Enumeration p = ((Vector) pair.value()).elements() ; p.hasMoreElements() ;) {
						mumble = p.nextElement();
						grumble.set(TAG, pair.key());
						grumble.set(VALUE, mumble);
						result += QRGutils.space(tabs) + grumble.toString();
					} // end for
				} // end if
			} // end for
			result += QRGutils.space(indent) + "</" + "PeerElement" /* this.getClass().getName() */ + ">" + QRGutils.eol();
		} // end if 
//		result += QRGutils.eol();
		return(result);
	} // method toString
	
	public String stringify () { 
		return(stringify(0)); 
	} // method toString
	
	public String toString (int i) {
		return(stringify(i));
	} // method
	
	public String toString () {
		return(id());
	} // method

	// Relationship stuff
	// -----------------------------------------------------------------------
	public class Marker extends JLabel {
		public PeerElement peerElement = null;
//		public Point connectPoint = new Point(0, 0);
		public Marker (Icon image) { super(image); }
	} // innerclass
	
	protected Marker independentMarker = null;
	public Marker independentMarker () {
		if(independentMarker == null) {
			independentMarker = new Marker(ImageCache.getImage("marker.gif"));
			independentMarker.peerElement = this;
		} // end if
		return(independentMarker);
	} // reader
	
	protected Marker dependentMarker = null;
	public Marker dependentMarker () {
		if(dependentMarker == null) {
			dependentMarker = new Marker(ImageCache.getImage("marker.gif"));
			dependentMarker.peerElement = this;
		} // end if
		return(dependentMarker);
	} // reader
	
	public class PortPanel extends QRGpanel {
		public Point connectPoint = new Point(0, 0);
		public Point connectPoint ( ) { return( connectPoint ); }
				protected Dimension minSize = new Dimension();
				public Dimension getMinimumSize (){
					int side = scaled(15, altscale);
					minSize.setSize(side, side);
					return(minSize);
				} // method
	} // innerclass

	protected PortPanel independentPort = null;
	public PortPanel independentPort () {
		if(independentPort == null) {
			independentPort = new PortPanel() {
				public Point connectPoint ( ) {
					int w0,w1,w2,h0,h1,h2;
					w0 = 0;
					w1 = getSize().width;
					w2 = w1 / 2;
					h0 = 0;
					h1 = getSize().height;
					h2 = h1 / 2;
					switch(instance().getInt("ORIENTATION")) {
						case SOUTH2NORTH: {
							int s15 = scaled(1.5, altscale);
							connectPoint.setLocation(w2, h1);
							break;
						} // south2north
						case EAST2WEST:{
							connectPoint.setLocation(w1, h2);
							break;
						} // east2west
						case NORTH2SOUTH:{
							connectPoint.setLocation(w2, h0);
							break;
						} // north2south
						case WEST2EAST: 
						default:{
							connectPoint.setLocation(w0, h2);
						} // default
					} // end switch
					return(connectPoint);
				} // method
				public void localpaint (Graphics g) {
					int w0,w1,w2,h0,h1,h2;
					Polygon p = null;
					w0 = 0;
					w1 = getSize().width;
					w2 = w1 / 2;
					h0 = 0;
					h1 = getSize().height;
					h2 = h1 / 2;
					switch(instance().getInt("ORIENTATION")) {
						case SOUTH2NORTH: {
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w2, w2 - s15, w2 - s15, w2 - h2, w2, w2 + h2, w2 + scaled(2, altscale), w2 + scaled(2, altscale), w2 },
												 new int[]{ h1, h1,       h2,       h2,      h0, h2,      h2,       h1,       h1 },
												 9); 
							connectPoint.setLocation(w2, h1);
							break;
						} // south2north
						case EAST2WEST:{
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w1, w1,       w2,       w2,      w0, w2,      w2,       w1,       w1 },
												 new int[]{ h2, h2 - s15, h2 - s15, h2 - w2, h2, h2 + w2, h2 + scaled(2, altscale), h2 + scaled(2, altscale), h2 },
												 9); 
							connectPoint.setLocation(w1, h2);
							break;
						} // east2west
						case NORTH2SOUTH:{
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w2, w2 - s15, w2 - s15, w2 - h2, w2, w2 + h2, w2 + scaled(2, altscale), w2 + scaled(2, altscale), w2 },
												 new int[]{ h0, h0,       h2,       h2,      h1, h2,      h2,       h0,       h0 },
												 9); 
							connectPoint.setLocation(w2, h0);
							break;
						} // north2south
						case WEST2EAST: 
						default:{
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w0, w0,       w2,       w2,      w1, w2,      w2,       w0,       w0 },
												 new int[]{ h2, h2 - s15, h2 - s15, h2 - w2, h2, h2 + w2, h2 + scaled(2, altscale), h2 + scaled(2, altscale), h2 },
												 9); 
							connectPoint.setLocation(w0, h2);
						} // default
					} // end switch
					g.setColor(getEntityColor());
					g.fillPolygon(p);
					if (selected()) {
						g.setColor(RED);
						g.drawPolygon(p);
					} // end if
				} // method
				public void paint (Graphics g) {
					super.paint(g);
					localpaint(g);
				} // method
				public void print (Graphics g) {
					super.print(g);
					localpaint(g);
				} // method
			}; // QRGpanel
			independentPort.setOpaque(false);
			independentPort.setSize(15, 15);
			independentPort.setPreferredSize(independentPort.getSize());
		} // end if
		return(independentPort);
	} // reader
	
	protected PortPanel dependentPort = null;
	public PortPanel dependentPort () {
		if(dependentPort == null) {
			dependentPort = new PortPanel() {
				public Point connectPoint() {
					int w0,w1,w2,h0,h1,h2;
					w0 = 0;
					w1 = getSize().width;
					w2 = w1 / 2;
					h0 = 0;
					h1 = getSize().height;
					h2 = h1 / 2;
					switch(instance().getInt("ORIENTATION")) {
						case SOUTH2NORTH: {
							connectPoint.setLocation(w2, h0);
							break;
						} // south2north
						case EAST2WEST:{
							connectPoint.setLocation(w0, h2);
							break;
						} // east2west
						case NORTH2SOUTH:{
							connectPoint.setLocation(w2, h1);
							break;
						} // north2south
						case WEST2EAST: 
						default:{
							connectPoint.setLocation(w1, h2);
						} // default
					} // end switch
					return( connectPoint );
				} // method
				public void localpaint (Graphics g) {
					int w0,w1,w2,h0,h1,h2;
					Polygon p = null;
					w0 = 0;
					w1 = getSize().width;
					w2 = w1 / 2;
					h0 = 0;
					h1 = getSize().height;
					h2 = h1 / 2;
					switch(instance().getInt("ORIENTATION")) {
						case SOUTH2NORTH: {
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w2, w2 - s15, w2 - s15, w2 - h2, w2, w2 + h2, w2 + scaled(2, altscale), w2 + scaled(2, altscale), w2 },
												 new int[]{ h1, h1,       h2,       h2,      h0, h2,      h2,       h1,       h1 },
												 9); 
							connectPoint.setLocation(w2, h0);
							break;
						} // south2north
						case EAST2WEST:{
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w1, w1,       w2,       w2,      w0, w2,      w2,       w1,       w1 },
												 new int[]{ h2, h2 - s15, h2 - s15, h2 - w2, h2, h2 + w2, h2 + scaled(2, altscale), h2 + scaled(2, altscale), h2 },
												 9); 
							connectPoint.setLocation(w0, h2);
							break;
						} // east2west
						case NORTH2SOUTH:{
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w2, w2 - s15, w2 - s15, w2 - h2, w2, w2 + h2, w2 + scaled(2, altscale), w2 + scaled(2, altscale), w2 },
												 new int[]{ h0, h0,       h2,       h2,      h1, h2,      h2,       h0,       h0 },
												 9); 
							connectPoint.setLocation(w2, h1);
							break;
						} // north2south
						case WEST2EAST: 
						default:{
							int s15 = scaled(1.5, altscale);
							p = new Polygon(new int[]{ w0, w0,       w2,       w2,      w1, w2,      w2,       w0,       w0 },
												 new int[]{ h2, h2 - s15, h2 - s15, h2 - w2, h2, h2 + w2, h2 + scaled(2, altscale), h2 + scaled(2, altscale), h2 },
												 9); 
							connectPoint.setLocation(w1, h2);
						} // default
					} // end switch
					g.setColor(getEntityColor());
					g.fillPolygon(p);
					if (selected()) {
						g.setColor(RED);
						g.drawPolygon(p);
					} // end if
				} // method
				public void paint (Graphics g) {
					super.paint(g);
					localpaint(g);
				} // method
				public void print (Graphics g) {
					super.print(g);
					localpaint(g);
				} // method
			}; // Port Panel
			dependentPort.setOpaque(false);
			dependentPort.setSize(15, 15);
			dependentPort.setPreferredSize(dependentPort.getSize());
		} // end if
		return(dependentPort);
	} // reader
	
	public void addMarkers () {
		if(instance().typep(RELATIONSHIP)) {
			skinPane().remove(independentMarker());
			skinPane().remove(dependentMarker());
			selectPane().remove(independentMarker());
			selectPane().remove(dependentMarker());
			skinPane().add(independentMarker(), BorderLayout.WEST);
			skinPane().add(dependentMarker(), BorderLayout.EAST);
			selectPane().add(independentPort(), BorderLayout.WEST);
			selectPane().add(dependentPort(), BorderLayout.EAST);
			positionMarkers();
		} // end if
	} // method
	
	public void positionMarkers () {
		if(instance().typep(RELATIONSHIP)) {
			switch(instance().getInt("ORIENTATION")) {
				case SOUTH2NORTH: {
					skinPane().remove(independentMarker());
					skinPane().remove(dependentMarker());
					selectPane().remove(independentPort());
					selectPane().remove(dependentPort());
					skinPane().add(independentMarker(), BorderLayout.SOUTH);
					skinPane().add(dependentMarker(), BorderLayout.NORTH);
					selectPane().add(independentPort(), BorderLayout.SOUTH);
					selectPane().add(dependentPort(), BorderLayout.NORTH);
					independentMarker().setVisible(instance().input().equals(""));
					dependentMarker().setVisible(instance().output().equals(""));
					scale(scale());
					break;
				} // case 
				case EAST2WEST: {
					skinPane().remove(independentMarker());
					skinPane().remove(dependentMarker());
					selectPane().remove(independentPort());
					selectPane().remove(dependentPort());
					skinPane().add(independentMarker(), BorderLayout.EAST);
					skinPane().add(dependentMarker(), BorderLayout.WEST);
					selectPane().add(independentPort(), BorderLayout.EAST);
					selectPane().add(dependentPort(), BorderLayout.WEST);
					independentMarker().setVisible(instance().input().equals(""));
					dependentMarker().setVisible(instance().output().equals(""));
					scale(scale());
					break;
				} // case
				case NORTH2SOUTH: {
					skinPane().remove(independentMarker());
					skinPane().remove(dependentMarker());
					selectPane().remove(independentPort());
					selectPane().remove(dependentPort());
					skinPane().add(independentMarker(), BorderLayout.NORTH);
					skinPane().add(dependentMarker(), BorderLayout.SOUTH);
					selectPane().add(independentPort(), BorderLayout.NORTH);
					selectPane().add(dependentPort(), BorderLayout.SOUTH);
					independentMarker().setVisible(instance().input().equals(""));
					dependentMarker().setVisible(instance().output().equals(""));
					scale(scale());
					break;
				} // case
				case WEST2EAST: 
				default: {
					skinPane().remove(independentMarker());
					skinPane().remove(dependentMarker());
					selectPane().remove(independentPort());
					selectPane().remove(dependentPort());
					skinPane().add(independentMarker(), BorderLayout.WEST);
					skinPane().add(dependentMarker(), BorderLayout.EAST);
					selectPane().add(independentPort(), BorderLayout.WEST);
					selectPane().add(dependentPort(), BorderLayout.EAST);
					independentMarker().setVisible(instance().input().equals(""));
					dependentMarker().setVisible(instance().output().equals(""));
					scale(scale());
				} // default
			} // end switch
//			QRGutils.debug("PeerElement.positionMarkers", "input=" +  (instance().input().equals("")));
//					independentMarker().setVisible(true);
//					dependentMarker().setVisible(true);
			scale(scale());
/*			
			elementPane().setSize(elementPane().getMinimumSize());
			elementPane().setPreferredSize(elementPane().getSize());
			selectPane().setSize(selectPane().getMinimumSize());
			selectPane().setPreferredSize(selectPane().getSize());
			skinPane().setSize(skinPane().getMinimumSize());
			skinPane().setPreferredSize(skinPane().getSize());
			setSize(getMinimumSize());
			setPreferredSize(getSize());
			validate();
*/
		} // end if
	} // method


	
	public void updateLabels () {
		if (! nameField().isVisible()) nameField().setText(name());
		nameLabel().setText(name());
		typeLabel().setText(typeName());
		scale(scale);
	} // method
	
	public boolean isDefaultState() {
		boolean result =  (reasons().size() == 1) && 
			(reasons().elementAt(0) instanceof String) &&
			(((String) reasons().elementAt(0)).equalsIgnoreCase(DEFAULTASSUMPTION));
		return(result);
	} // method
	
	public boolean isAssumption() {
		boolean result =  (reasons().size() == 1) && 
			(reasons().elementAt(0) instanceof String) &&
			(((String) reasons().elementAt(0)).equalsIgnoreCase(USERASSUMPTION));
		return(result);
	} // method
	
	public void updateStateIndicators () {
		if (state().equalsIgnoreCase(CONTRADICTION)) {
			stateLabel().setForeground(RED);
//		} else if (isDefaultState()) {
//			stateLabel().setForeground(PURPLE);
//		} else if (isAssumption()) {
//			stateLabel().setForeground(PURPLE);
		} else {
			stateLabel().setForeground(BLACK);
		} // end if
		stateLabel().setBackground(LIGHTYELLOW);
		stateLabel().setOpaque(false);
		String text = "";
		if ((!predictedState().equalsIgnoreCase("")) && (!predictedState().equalsIgnoreCase(UNKNOWN))) {
			if((!predictedState().equalsIgnoreCase(state())) && (model().getInt(MODE) == 2)) {
				stateLabel().setForeground(RED);
			} else {
				stateLabel().setForeground(BLACK);
			} // end if
			if (predictedState().equalsIgnoreCase(INCREASING)) text = "+";
			else if (predictedState().equalsIgnoreCase(DECREASING)) text = "-";
			else if (predictedState().equalsIgnoreCase(CONSTANT)) text = "0";
			else if (predictedState().equalsIgnoreCase(DEFAULT)) text = "?";
			else if (predictedState().equalsIgnoreCase(UNKNOWN)) text = "?";
			else if (predictedState().equalsIgnoreCase(UNCONNECTED)) text = "?";
			else if (predictedState().equalsIgnoreCase(CONTRADICTION)) text = "?";
//			else text = predictedState();
			if (model().getInt(MODE) == 2) text += "/";
		} // end if

		if (model().getInt(MODE) == 2) {
			if (initialReason().equals(USERASSUMPTION)) text += "(";
			if (state().equalsIgnoreCase(INCREASING)) text += "+" ;
			else if (state().equalsIgnoreCase(DECREASING)) text += "-" ;
			else if (state().equalsIgnoreCase(CONSTANT)) text += "0" ;
			else if (state().equalsIgnoreCase(DEFAULT)) text += "?" ;
			else if (state().equalsIgnoreCase(UNKNOWN)) text += "?" ;
			else if (state().equalsIgnoreCase(UNCONNECTED)) text += "?" ;
			else if (state().equalsIgnoreCase(CONTRADICTION)) text += "?" ;
//			else text += state();
			if (initialReason().equals(USERASSUMPTION)) text += ")";
		} // end if
		
		stateLabel().setText(text);
		stateLabel().setVisible(((!predictedState().equalsIgnoreCase("")) && (!predictedState().equalsIgnoreCase(UNKNOWN))) ||
			(model().getInt(MODE) == 2));
		//stateLabel().setVisible(true);
	} // method
	
	public void updatePeer () {
//		instance().checkInstance();
		updateLabels();
		updateStateIndicators();
		addMarkers();
		positionMarkers();
		scale(scale);
		repaint();
	} // method
	
	public int view ( ) { return( getInt( "VIEW" ) ); }
	public int view ( int i  ) { 
		set( "VIEW", i );
		return( i );
	} // method
	
} // class 

// ---------------------------------------------------------------------------
// End of File: PeerElement.java              (c) 2003 Northwestern University
