package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import edu.qrg.vmodel.controllers.common.*;
//import Definition;
//import KeyValuePair;
import edu.qrg.utils.KeyValuePair.KVPinterface;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.lang.Cloneable;
import java.lang.Object;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/gui
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: Librarian.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: Librarian
* Purpose: Visual Ontology Manager / Controller.
* -----------------------------------------------------------------------------
* </PRE> */
public class Librarian extends JPanel 
							  implements VModelConstants, ChangeListener,
							  				 TreeSelectionListener, MouseListener {
	protected JToolBar toolbar = new JToolBar();

	protected JToggleButton libraryButton = new JToggleButton("Library", ImageCache.getImage("iconmodelopen.gif"));
	public JToggleButton libraryButton () { return(libraryButton); }
	
	protected static JTabbedPane libraryTabPanel = new JTabbedPane();
	public static JTabbedPane libraryTabPanel () { return(libraryTabPanel); }
	public static JTabbedPane libraryTabPanel (JTabbedPane j) { return(libraryTabPanel = j); }

	protected JScrollPane libraryScrollPanel = new JScrollPane();
	public JScrollPane libraryScrollPanel () { return(libraryScrollPanel); }
	public JScrollPane libraryScrollPanel (JScrollPane j) { return(libraryScrollPanel = j); }
	
	protected static JTree libraryJTree = new JTree();
	public static JTree libraryJTree () { return(libraryJTree); }
	public static JTree libraryJTree (JTree j) { return(libraryJTree = j); }
	
//	protected JPanel libraryButtonPanel = new JPanel(new GridLayout(2, 2));
//	protected JPanel libraryButtonPanel = new JPanel();
//	protected JPanel libraryButtonPanel = new JPanel(new GridBagLayout());
//	protected JPanel libraryButtonPanel = new JPanel(new FlowLayout());
	protected JPanel libraryButtonPanel = new JPanel(new BorderLayout());
	public JPanel libraryButtonPanel () { return(libraryButtonPanel); }
	public JPanel libraryButtonPanel (JPanel j) { return(libraryButtonPanel = j); }
	
	protected JPanel libraryButtonPanelTop = new JPanel(new GridBagLayout());
	public JPanel libraryButtonPanelTop () { return(libraryButtonPanelTop); }
	public JPanel libraryButtonPanelTop (JPanel j) { return(libraryButtonPanelTop = j); }
	
	protected JPanel libraryButtonPanelBottom = new JPanel(new GridBagLayout());
	public JPanel libraryButtonPanelBottom () { return(libraryButtonPanelBottom); }
	public JPanel libraryButtonPanelBottom (JPanel j) { return(libraryButtonPanelBottom = j); }
	
	protected static JButton libraryEditButton = new JButton("Edit Selected");
	public static JButton libraryEditButton () { return(libraryEditButton); }
	public JButton libraryEditButton (JButton j) { return(libraryEditButton = j); }
	
	protected JButton libraryNewEntityButton = new JButton("New Entity");
	public JButton libraryNewEntityButton () { return(libraryNewEntityButton); }
	public JButton libraryNewEntityButton (JButton j) { return(libraryNewEntityButton = j); }
	
	protected JButton libraryNewProcessButton = new JButton("New Process");
	public JButton libraryNewProcessButton () { return(libraryNewProcessButton); }
	public JButton libraryNewProcessButton (JButton j) { return(libraryNewProcessButton = j); }
	
	protected JButton libraryNewModelButton = new JButton("New Model");
	public JButton libraryNewModelButton () { return(libraryNewModelButton); }
	public JButton libraryNewModelButton (JButton j) { return(libraryNewModelButton = j); }
	
	protected static OntologyRenderer libraryRenderer = new OntologyRenderer();
	public static OntologyRenderer libraryRenderer () { return(libraryRenderer); }
	public static OntologyRenderer libraryRenderer (OntologyRenderer l) { return(libraryRenderer = l); }
	
	protected static Ontology selectedOntology = null;
	public static Ontology selectedOntology () { return(selectedOntology); }
	public Ontology selectedOntology (Ontology o) { 
//		if (VModel.controller() != null) VModel.controller().selectedOntology(o);
		return(selectedOntology = o); 
	} // writer
	
	public static Controller controller () {
		Controller result = null;
		result = (Controller) VModel.controller();
		return(result);
	} // method
	
	protected static Definition selectedDefinition = null;
	public static Definition selectedDefinition () { return(selectedDefinition); }
	public static Definition selectedDefinition (Definition e) { 
			controller().selectedDefinition(e);
			if (e != null) libraryEditButton().setEnabled(true);
			else libraryEditButton().setEnabled(false);
		return(selectedDefinition = e); 
	} // writer
	
	protected boolean sound = false;
	public boolean sound () { return(sound); }
	public boolean sound (boolean b) { return(sound = b); }
	
	public void playButtonSound () {
		if (sound()) SoundCache.playSound("Kachunk.au");
	} // method playButtonSound

	public void playTabSound () {
//		if (sound()) SoundCache.playSound("sonar.au");
		if (sound()) SoundCache.playSound("click1.au");
	} // method playTabSound
	
	public static Ontology uberlibrary = null;
	public static Ontology uberlibrary () {
		if(uberlibrary == null) uberlibrary = new Ontology();
		return(uberlibrary);
	} // reader
	
	public JTree add (Ontology o) {
		JScrollPane pane = new JScrollPane();
		JTree tree = new JTree();
		tree.setCellRenderer(libraryRenderer());
		tree.setModel(o);
		tree.setRootVisible(false);
		tree.setScrollsOnExpand(false);
		tree.setEditable(false);
//		tree.setToggleClickCount(1);
		tree.setShowsRootHandles(true);
		tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		tree.addTreeSelectionListener(this);
		tree.addMouseListener(this);
		pane.setViewportView(tree);
		libraryTabPanel().add(pane, o.name());
		uberlibrary().add(o);
		expandTree(tree);
		return(tree);
	} // method
	
    // Notes: To what level? (Should specify?)
    public static void expandTree (JTree tree) {
		if (tree != null) {
		    int level = 0;
		    int rows = tree.getRowCount();
		    int i = 0;
		    while(level < rows) {
			for(i = level; i < rows; i++) {
			    tree.expandRow(i);
			} // end for i
			level = rows;
			rows = tree.getRowCount();
		    } // end while
		} // if tree
    } // method expandTree

//	public static JTree currentWindowTree = null;
//	public static JTree currentWindowTree () {
//		if (currentWindowTree == null) {
//			currentWindowTree = new JTree();
//			currentWindowTree.setCellRenderer(libraryRenderer());
//			currentWindowTree.setRootVisible(true);
//			currentWindowTree.setScrollsOnExpand(false);
//			currentWindowTree.setEditable(true);
//			currentWindowTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
//		} // end if
//		return(currentWindowTree);
//	} // method
	
//	public static JScrollPane currentWindowScrollPane = null;
//	public static JScrollPane currentWindowScrollPane () {
//		if (currentWindowScrollPane == null) {
//			currentWindowScrollPane = new JScrollPane();
//			currentWindowScrollPane.setViewportView(currentWindowTree());
//		} // end if
//		return(currentWindowScrollPane);
//	} // method

	
//	public static Model currentWindowFragment = null;
//	public static Model currentWindowFragment () {
//		return(currentWindowFragment);
//	} // method
//	public static Model currentWindowFragment (Model f) {
//		int index = libraryTabPanel().getSelectedIndex();
//		libraryTabPanel().remove(currentWindowScrollPane());
//		currentWindowFragment = f;
//		if (currentWindowFragment != null) {
//			currentWindowScrollPane = null; // ugly. possible leak.
//			currentWindowTree().setModel(currentWindowFragment.localOntology());
//			currentWindowScrollPane().setViewportView(currentWindowTree());
//			libraryTabPanel().add(currentWindowScrollPane(), "Current Model");
//			libraryTabPanel().setIconAt(libraryTabPanel().indexOfComponent(currentWindowScrollPane()), ImageCache.getImage(currentWindowFragment.icon()));
//			libraryTabPanel().getModel().clearSelection();
//			if (index < 0) libraryTabPanel().setSelectedComponent(currentWindowScrollPane());
//			else libraryTabPanel().setSelectedIndex(index);
//			//if (self() != null) self().repaint();
//		} // end if
//		return(currentWindowFragment);
//	} // method

	
	public static Librarian self = null;
	public static Librarian self () { return(self); }
	public static Librarian self (Librarian s) { return(self = s); }
	
	public void doButton () {
		libraryButton().doClick();
	} // method

	protected static JTree selectedTree = null;
	public static JTree selectedTree () { return(selectedTree); }
	public JTree selectedTree (JTree t) { return(selectedTree = t); }

	// ChangeListener
	public void stateChanged(ChangeEvent e) {
//		QRGutils.debug("Librarian", "stateChanged");
		JTabbedPane tabs = (JTabbedPane) e.getSource();
		JScrollPane scroll = (JScrollPane) tabs.getSelectedComponent();
		if (scroll != null) {
			JTree tree =  (JTree) scroll.getViewport().getView();
			TreeModel model = (TreeModel) tree.getModel();
			if (model instanceof Ontology) {
				playTabSound();
				selectedTree(tree);
				selectedOntology((Ontology) model);
//				selectedDefinition(selectedOntology().selectedDefinition()); 
//				VModelStatusBar.showText(((Ontology) model).documentation());
			} else selectedOntology(null);
		} else selectedOntology(null);
//		QRGutils.debug("Librarian", "stateChanged", "EXIT");
	} // method

	// TreeSelectionListener		
	public void valueChanged(TreeSelectionEvent e) {
//		QRGutils.debug("Librarian", "ValueChanged");
		JTree tree = (JTree) e.getSource();
		TreePath path = e.getPath();
		TreeNode node = (TreeNode) path.getPathComponent(path.getPathCount() - 1);
		TreeModel model = (TreeModel) tree.getModel();
		boolean flag = true;
		if (model instanceof Ontology) {
			Ontology ontology = (Ontology) model;
			if ((node != null) && (node instanceof Definition) && (selectedDefinition() != node)) {
//				ontology.selectedDefinition((Definition) node);
				if (((Definition) node).typep(MODEL)) {
/*				
					VModelStatusBar.showText(((Definition) node).getString(NOTES));
					int choice = JOptionPane.showConfirmDialog(null, "Do you want to open "+((Definition) node).name()+"?");
					if (choice == JOptionPane.YES_OPTION) {
						((Classic) controller()).add(((Model) node));
						selectedDefinition((Definition) node);
						selectedTree().clearSelection();
						flag = false;
					} // end if choice
*/					
					flag = false;
				} // end if data
				if (flag) {
					if ((controller() != null) && (controller().selectedWindow() != null) && (controller().selectedWindow().modelPane() != null))
						controller().selectedWindow().modelPane().deselectAll();
					selectedDefinition((Definition) node);
					VModelStatusBar.showText(((Definition) node).documentation());
				} // end if
			} else {
//				ontology.selectedDefinition(null);
				selectedDefinition(null);
				if (node instanceof Ontology) VModelStatusBar.showText(((Ontology) node).documentation());
			} // end if else
		} // end if
//		QRGutils.debug("Librarian", "ValueChanged", "EXIT");
	} // method
	
	public JPopupMenu makepopmenu (TreeNode n, TreePath p, JTree jt) {
		final TreeNode node = n;
		JPopupMenu result = new JPopupMenu(node.toString());
		if (node instanceof Ontology.Category) {
			final Ontology.Category def = (Ontology.Category) node;
			JMenuItem help = new JMenuItem("Help");
			help.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					try {
						Thread t = new Thread() {
							public void run () {
								controller().browser().setTitle("VModel Help: " + (def).name());
								controller().browser().setSize(700,300);
								controller().browser().gotoPage(QRGutils.QRGroot() + HELPPATH, (def).helpURL());
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception err) {}
				} // method actionPerformed
			}); // actionListener
			result.add(help);
		} // end if
		if ((node instanceof Model) || ((node instanceof Definition) && ((Definition) node).getString(NAME).equalsIgnoreCase(((Definition) node).getString("FILE")))) {
			final Definition def = (Definition) node;
			JMenuItem help = new JMenuItem("Open Model");
			help.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					try {
						Thread t = new Thread() {
							public void run () {
			Model mdl = controller().makeModel();
			mdl.plist(mdl.copyKeyValuePairs(def).plist());
			mdl.connections(new Vector()); 
			mdl.connectors(new Vector()); 
			mdl.removeKey(CHILDINSTANCES);
			mdl.removeKey(PARENTINSTANCES);
			mdl.removeKey(INPUTS);
			mdl.removeKey(OUTPUTS);
			mdl.removeKey(CAUSALINPUTS);
			mdl.removeKey(CAUSALOUTPUTS);
			controller().addDefinition( mdl, (Definition) def, 0, 0,false, false );
			mdl.set("SAVEDONCE", true);
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception err) {}
				} // method actionPerformed
			}); // actionListener
			result.add(help);
		} // end if
		if (node instanceof Definition) {
			final Definition def = (Definition) node;
			if ( !def.getBoolean("NOONTHELP") ) {
				JMenuItem help = new JMenuItem("Help");
				help.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent ev) {
						final ActionEvent e = ev;
						try {
							Thread t = new Thread() {
								public void run () {
									controller().browser().setTitle("VModel Help: " + (def).name());
									controller().browser().setSize(700,300);
									controller().browser().gotoPage(QRGutils.QRGroot() + HELPPATH, (def).helpURL());
								} // method run
							}; // Anonymous Class Thread
							t.start();
						} catch (Exception err) {}
					} // method actionPerformed
				}); // actionListener
				result.add(help);
			} // end if
			if ( def.getBoolean("ONTDELETABLE") ) {
				final TreePath selpath = p;
				final JTree seltree = jt;
				JMenuItem help = new JMenuItem("Delete");
				help.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent ev) {
						final ActionEvent e = ev;
						try {
							Thread t = new Thread() {
								public void run () {
			Ontology ontology = null;
			if (def.typep(PROCESS)) ontology = ((MacClassroom)controller()).myProcesses();
			else if (def.typep("SUBSTANCE")) ontology = ((MacClassroom)controller()).mySubstances();
			else if (def.typep("MULTIPLETHING")) ontology = ((MacClassroom)controller()).myMultipleThings();
			else if (def.typep("THING")) ontology = ((MacClassroom)controller()).myThings();
			else if (def.typep(MODEL)) ontology = ((MacClassroom)controller()).myModels();
			else if (def instanceof Definition) ontology = ((MacClassroom)controller()).myEntities();
			else if (def.typep(ATTRIBUTE)) ontology = ((MacClassroom)controller()).myAttributes();
			else ontology = ((MacClassroom)controller()).myLibrary();
									if ( ontology != null ) {
										uberlibrary().remove(def);
										ontology.remove(def);
										seltree.removeSelectionPath(selpath);
										uberlibrary().reload(ontology);
										expandTree(selectedTree());
				((MacClassroom)controller()).myLibrary().reload( ontology );
				expandTree( selectedTree() );			
				expandTree( libraryJTree() );			
									} else QRGutils.debug("Librarian.makepopmenu", "cat=" + ontology);
								} // method run
							}; // Anonymous Class Thread
							t.start();
						} catch (Exception err) {}
					} // method actionPerformed
				}); // actionListener
				result.add(help);
			} // end if
		} // end if
		return(result);
	} // method

	// MouseListener Methods
	// -------------------------------------------------------------------------
	public void mousePressed(MouseEvent e) {
		JTree tree = (JTree) e.getSource();
		int selRow = selectedTree().getRowForLocation(e.getX(), e.getY());
		TreePath selPath = selectedTree().getPathForLocation(e.getX(), e.getY());
		tree.setSelectionPath(selPath);
		TreeNode node = (TreeNode) ((JTree) e.getSource()).getLastSelectedPathComponent();
		if(selRow != -1) {
			if(e.getClickCount() == 1) {
				if (node != null) {
					if (QRGutils.isRightClick(e)) {
						makepopmenu(node, selPath, tree).show(tree, e.getX(), e.getY());
					} else if ((node instanceof Model) || ((node instanceof Definition) && ((Definition) node).getString(NAME).equalsIgnoreCase(((Definition) node).getString("FILE")))) {
						VModelStatusBar.showText(((Definition) node).getString(NOTES));
						int choice = JOptionPane.showConfirmDialog(null, "Do you want to open "+((Definition) node).name()+"?");
						if (choice == JOptionPane.YES_OPTION) {
			Model result = controller().makeModel();
			result.plist(result.copyKeyValuePairs((Definition) node).plist());
			result.connections(new Vector()); 
			result.connectors(new Vector()); 
			result.removeKey(CHILDINSTANCES);
			result.removeKey(PARENTINSTANCES);
			result.removeKey(INPUTS);
			result.removeKey(OUTPUTS);
			result.removeKey(CAUSALINPUTS);
			result.removeKey(CAUSALOUTPUTS);
			controller().addDefinition( result, (Definition) node, 0, 0,false, false );
			result.set("SAVEDONCE", true);
							selectedDefinition((Definition) node);
							selectedTree().clearSelection();
						} else {
							if ((controller() != null) && (controller().selectedWindow() != null) && (controller().selectedWindow().modelPane() != null))
								controller().selectedWindow().modelPane().deselectAll();
							selectedDefinition((Definition) node);
							VModelStatusBar.showText(((Definition) node).documentation());
						} // end if
					} // end if
				} // end if node
			} else if(e.getClickCount() == 2) {
			} else if(e.getClickCount() == 3) {
				//QRGutils.debug("VModelPeerOntology", "mouseTripleClicked selPath=" + selPath + " mod=" + KeyEvent.getKeyModifiersText(e.getModifiers()));
			} // end if clickCount
		} // end if selRow
	} // method mouseClicked
	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	public void mouseClicked(MouseEvent e) { }
	public void mouseReleased(MouseEvent e) { }

	public Librarian () {
		super(new BorderLayout());
		
		self(this);
		
//		currentWindowTree().addTreeSelectionListener(this);
		
		libraryButton().setBackground(DARKGREY);
		
		setBackground(DARKERGREY);
		libraryButtonPanel().setBackground(DARKERGREY);
		libraryEditButton().setIcon(ImageCache.getImage("edit.gif"));
		libraryNewEntityButton().setIcon(ImageCache.getImage("newEntity.gif"));
		libraryNewProcessButton().setIcon(ImageCache.getImage("newProcess.gif"));
		libraryNewModelButton().setIcon(ImageCache.getImage("newModel.gif"));
		libraryButtonPanelTop().add(libraryEditButton());
		libraryButtonPanelTop().add(libraryNewModelButton());
		libraryButtonPanelBottom().add(libraryNewProcessButton());
		libraryButtonPanelBottom().add(libraryNewEntityButton());
		libraryButtonPanel().add(libraryButtonPanelTop(), BorderLayout.NORTH);
		libraryButtonPanel().add(libraryButtonPanelBottom(), BorderLayout.SOUTH);
//		libraryNewProcessButton().setVisible(false);
//		libraryNewEntityButton().setVisible(false);
//		libraryScrollPanel().setViewportView(libraryJTree());
//		libraryTabPanel().add(libraryScrollPanel, "QP Ontology");
		libraryTabPanel().addChangeListener(this);
		add(libraryTabPanel(), BorderLayout.CENTER);
//		add(libraryButtonPanel(), BorderLayout.SOUTH);
		
		libraryEditButton().setEnabled(false);

	} // default constructor
	
	public Librarian (boolean sound) {
		this();
		sound(sound);
	} // constructor

	public static class OntologyRenderer extends DefaultTreeCellRenderer {
		public Component getTreeCellRendererComponent(JTree tree,
										Object value, boolean selected, 
										boolean expanded, boolean leaf,
										int row, boolean hasFocus) {
			Component result = super.getTreeCellRendererComponent(tree, value, selected,
											expanded, leaf, row, hasFocus);
//			QRGutils.debug("Librarian", "OntologyRenderer.getTreeCellRendererComponent");
			if (value instanceof Ontology) {
				String iconName =  ((Ontology) value).icon();
				if (! iconName.equals("")) {
					iconName =  ((Ontology) value).icon(expanded);
					ImageIcon iconImage = ImageCache.getImage(iconName);
					if (iconImage != null) setIcon(ImageCache.getImage(iconName));
				} // end if
				setToolTipText(null);
			} else if (value instanceof Definition) {
				Definition element = (Definition) value;
				setToolTipText(element.type());
//				if (element.typep(MODELFRAGMENT)) {
//					if (leaf) setIcon(ImageCache.getImage(element.icon()));
//					else setIcon(ImageCache.getImage(element.icon(expanded)));
//				} else {
//			QRGutils.debug("Librarian", "OntologyRenderer.getTreeCellRendererComponent", "element=" + element.toCML() + " icon=" + element.icon());
					setIcon(ImageCache.getImage(element.icon()));
//				} // end if else
			} else {
				setToolTipText(null);
			} // end if
//			QRGutils.debug("Librarian", "OntologyRenderer.getTreeCellRendererComponent", "EXIT");
			return(result);
		} // method getTreeCellRendererComponent
	} // innerclass InstanceTreeRenderer
	
} // class 

// -----------------------------------------------------------------------------
// End of File: Librarian.java       (c) 2001 Northwestern University