package edu.qrg.vmodel.controllers.common;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.Cloneable;
import java.lang.Object;
import java.lang.Runtime;
import java.lang.String;
import java.util.EventListener;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.Timer;
import javax.swing.border.BevelBorder;
import javax.swing.border.LineBorder;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/gui
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: VModelStatusBar.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: VModelStatusBar
* Purpose: Basic Status bar.
* ----------------------------------------------------------------------------
* </PRE> */
public class VModelStatusBar extends JPanel implements VModelConstants {
	protected static VModelStatusBar self = null;
	public static VModelStatusBar self () { return(self); }
	public static VModelStatusBar self (VModelStatusBar s) { return(self = s); }
	
	protected JTextArea textfield = null;
	public JTextArea textfield () { return(textfield); }
	public JTextArea textfield (JTextArea l) { return(textfield = l); }
	
	protected Timer timer = null;
	public Timer timer () { return(timer); }
	public Timer timer (Timer t) { return(timer = t); }
	
	protected Timer flashtimer = null;
	public Timer flashtimer () { return(flashtimer); }
	public Timer flashtimer (Timer t) { return(flashtimer = t); }
	
	protected boolean flashflag = true;
	protected int flashcount = 0;
	
	public void setText (String s) {
		timer().restart();
		flashtimer().restart();
		textfield().setText(s);
		textfield.invalidate();
		doLayout();
	} // method setText
	
	public static void displayText (String s) {
		if (self != null) {
			if (s == null) s = "";
			self.textfield().setText(s);
			self.textfield.invalidate();
			self.doLayout();
		} // end if
	} // method setText
	
	public static String showText (String s) {
		if (self != null) self.setText(s);
		return(s);
	} // method
	
	public VModelStatusBar () {
		setLayout(new BorderLayout());
		setBorder(new LineBorder(GREY, 2));
		
		//textfield(new JLabel());
		textfield(new JTextArea());
		textfield().setBorder(new BevelBorder(BevelBorder.LOWERED));
		textfield().setEditable(false);
		textfield().setLineWrap(true);
		textfield().setWrapStyleWord(true);
		textfield().setEnabled(false);
		textfield().setDisabledTextColor(Color.black);
		textfield().setOpaque(false);
		add(textfield(), BorderLayout.CENTER);
		
		timer(new Timer(8000, new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				textfield().setText(" ");
				timer().stop();
				flashtimer().stop();
			} })); // set new Timer
		
		flashtimer(new Timer(75, new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				textfield().setBackground(DARKGREY);
				textfield().setOpaque(flashflag);
				flashflag = !flashflag;
				flashcount++;
				if (flashcount > 7) {
					flashtimer().stop();
					flashcount = 0;
					textfield().setBackground(Color.white);
					textfield().setOpaque(false);
				} // end if
				textfield().repaint();
			} })); // set new Timer
		
		setVisible(true);
		setText(QRGutils.projectName() + " v" + QRGutils.projectVersion() + 
					" Copyright " + QRGutils.projectCopyright() + " " + 
					QRGutils.projectCopyrightAttribution() + "  Memory:" +
					Runtime.getRuntime().freeMemory() + "/" +
					Runtime.getRuntime().totalMemory());
		
		self(this);
	} // constructor StatusBar
} // class 

// -----------------------------------------------------------------------------
// End of File: VModelStatusBar.java       (c) 2001 Northwestern University