package edu.qrg.vmodel;

import edu.qrg.utils.*;

import java.io.Serializable;

import java.lang.Cloneable;
import java.lang.Object;
import java.lang.String;

import java.util.Vector;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/engine
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: PROJECT.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: PROJECT
* Purpose: Contains VModel project / assignment information.
* ----------------------------------------------------------------------------
* </PRE> */
public class PROJECT extends PREFERENCES 
	implements Cloneable, VModelConstants, Serializable, XMLio.XMLable {
	// Constructors
	// ------------------------------------------------------------------------
	public PROJECT() { super(); } // default constructor
	
	public PROJECT(String tag) {
		this();
		tag(tag);
	} // constructor
	
	public PROJECT (Vector keyValues, Vector children) {
		this("PROJECT");
		plist(keyValues);
		// We are not processing child preferences at this time.
		children(children);
	} // constructor
	
	// Properties & Accessors
	// ------------------------------------------------------------------------
	public String getFolder () {
		String result = getString("FOLDER");
		if (result == null) result = "";
		if (!result.endsWith("/")) {
			result += "/";
			set("FOLDER", result);
		} // end if
		return(result);
	} // method getFolder

	public String getBackground () {
		String result = getString("BACKGROUND");
		if (result == null) result = "";
		return(result);
	} // method getBackground

	// Cloning.
	// ------------------------------------------------------------------------
	public Object clone() {
		Object result = new PROJECT(new String(tag()));
		((PROJECT) result).copyKeyValuePairs(this);
		return(result);
	} // method clone
	
	// XMLio.XMLable methods	
	// ------------------------------------------------------------------------
	public String xmlDef () { 
		String result = 	"<!DOCTYPE PROJECT [\r\n" +
								"<!ELEMENT PROJECT EMPTY >\r\n" +
								"<!ATTLIST PROJECT CONTROLLER CDATA #REQUIRED >\r\n" +
								"]>";
		return(result); 
	} // method xmlDef
	public String xmlify () { return(this.toString()); }

} // class

// ---------------------------------------------------------------------------
// END OF FILE: PROJECT.java                     2003 Northwestern University