package edu.qrg.utils;

import java.awt.Color;
import java.awt.Font;
import java.lang.Cloneable;
import java.lang.String;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/utils
* ----------------------------------------------------------------------------
* 2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: QRGconstants.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
* Interface: QRGconstants
*   Purpose: Constants used by QRG. 
* ----------------------------------------------------------------------------
* </PRE> 
* @see QRGutils
*/
public interface QRGconstants extends Cloneable {
	// Target Platform
	public static final int PLATFORM_UNKNOWN = 0;
	public static final int WINDOWS = 1;
	public static final int UNIX = 2;
	public static final int MACINTOSH = 3;
	public static final String PLATFORM_NAMES[] = { "Unknown", "Windows", "Unix", "Macintosh" };
	public static final String [ ] EOLS = { "\r\n", "\r\n", "\n", "\r" };
	
	// Runtime Environment
	public static final boolean TESTRUN = true;
	public static final boolean SUPERUSER = false;
	public static final boolean DEVELOPER = false;

	// Debugging Constants
	public static final String DEFAULT_DEBUG_FILE = "debug.txt";
	public static final int DEFAULT_DEBUG_LIMIT = 25000;
	public static final boolean DEFAULT_DEBUG_FLAG = false;
	
	// Print Constants
	public static final int LANDSCAPE = 16;
	public static final int PORTRAIT = 17;
	public static final int PAGE_HEIGHT = 468; //612; // 468; // 768; //468; // 552
	public static final int PAGE_WIDTH = 648; //792; //648; // 1024; //648; // 720
	
	// Key Modifiers
	public static final int VKM_NONE = 0;
	public static final int VKM_SHIFT = 1;
	public static final int VKM_CONTROL = 2;
	public static final int VKM_COMMAND = 4;
	public static final int VKM_META = 4;
	public static final int VKM_OPTION = 8;
	public static final int VKM_ALT = 8;
	
	// Boolean Constants
	public static final boolean t = true;
	public static final boolean nil = false;
	
	// Screen Size Constants
	public static final int SIXbyFOUR = 0;
	public static final int EIGHTbySIX = 1;
	public static final int TENbySEVEN = 2;
	public static final int ELEVENbyEIGHT = 3;
	public static final int TWELVEbyTEN = 4;
	public static final int SIXTEENbyTWELVE = 5;
	
	// Fonts
	public static final Font SERIF_PLAIN_10 = new Font("Serif", Font.PLAIN, 10);
	
	// Colors
	public static final Color RED = Color.red;
	public static final Color DARKRED = new Color(153,0,0);
	public static final Color GREEN = Color.green;
	public static final Color GRASSGREEN = new Color(153,255,153);
	public static final Color DARKGRASSGREEN = new Color(51,205,51);
	public static final Color BRIGHTGREEN = new Color(0,255,0);
	public static final Color MEDIUMGREEN = new Color(0,204,0);
	public static final Color DARKGREEN = new Color(0,102,0);
	public static final Color BLUE = Color.blue;
	public static final Color SKYBLUE = new Color(204,255,255);
	public static final Color DARKSKYBLUE = new Color(0,204,255);
	public static final Color LIGHTBLUE = new Color(51,204,255);
	public static final Color ROYALBLUE = new Color(0,0,255);
	public static final Color PURPLE = new Color(153,0,204);
	public static final Color LIGHTYELLOW = new Color(255,255,204);
	public static final Color YELLOW = Color.yellow;
	public static final Color DARKYELLOW = new Color(255,255,0);
	public static final Color LIGHTPINK = new Color(255,204,204);
	public static final Color PINK = Color.pink;
	public static final Color DARKPINK = new Color(255,153,153);
	public static final Color ORANGE = Color.orange;
	public static final Color MAGENTA = Color.magenta;
	public static final Color CYAN = Color.cyan;
	public static final Color LAVENDER = new Color(255,204,255);
	public static final Color DARKLAVENDER = new Color(255,102,255);
	public static final Color PLUM = new Color(204,153,204);
	public static final Color DARKPLUM = new Color(204,102,153);
	public static final Color YUCKYPUCE = new Color(204,155,102);
	public static final Color DARKYUCKYPUCE = new Color(153,204,51);
	public static final Color LIGHTGRAY = Color.lightGray;
	public static final Color GRAY = Color.gray;
	public static final Color DARKGRAY = Color.darkGray;
	public static final Color LIGHTGREY = new Color(221,221,221);
	public static final Color GREY = new Color(200,200,200);
	public static final Color DARKGREY = new Color(170,170,170);
	public static final Color DARKERGREY = new Color(153,153,153);
	public static final Color GOLD = new Color(255,204,102);
	public static final Color DARKGOLD = new Color(255,153,0);
	public static final Color NUTBROWN = new Color(153,102,0);
	public static final Color LIGHTBROWN = new Color(204,153,0);
	public static final Color REDBROWN = new Color(153,51,51);
	public static final Color REDORANGE = new Color(255,102,51);
	public static final Color GREENBROWN = new Color(153,153,51);
	public static final Color WHITE = Color.white;
	public static final Color BLACK = Color.black;
	public static final Color SLATEGREY =new Color(47,79,79);
	
} // Interface 

// ---------------------------------------------------------------------------
// End of File: QRGconstants.java                2003 Northwestern University