package edu.qrg.utils;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.LayoutManager;
import java.lang.Cloneable;
import java.lang.Object;
import javax.swing.JComponent;
import javax.swing.JPanel;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/utils
* ----------------------------------------------------------------------------
* 2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: QRGpanel.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: QRGpanel
* Purpose: We need a standard panel that will exhibit certain standard 
*          properties such as easy printability.
* ----------------------------------------------------------------------------
* </PRE> */
public class QRGpanel extends JPanel implements QRGconstants {
	// Constructors
	// --------------------------------------------------------------------------
	/** General initialization.  Default to BorderLayout. */
	public QRGpanel () {
		super(new BorderLayout());
	} // constructor QRGpanel
	/** General initialization.  Specify Layout. */
	public QRGpanel (LayoutManager l) {
		super(l);
	} // constructor QRGpanel

	// Print Method
	// --------------------------------------------------------------------------
	/** Fixes print bug in Sun's code where transparent panels have the
	*          background filled anyway.
	* </PRE> */
	public void print (Graphics g) {
		if (isOpaque()) super.print(g); // Normal
		else printComponents(g); // Transparent - do not print background.
	} // method print
//	public void paint (Graphics g) {
//		if (isOpaque()) super.paint(g); // Normal
//		else paintComponents(g); // Transparent - do not print background.
//	} // method print
} // class QRGpanel

// ---------------------------------------------------------------------------
// END OF FILE: QRGpanel.java                    2003 Northwestern University